DROP PROCEDURE IF EXISTS `auth_delete`;
CREATE PROCEDURE  `auth_delete`(IN par_user_id TEXT)
begin

    set @strsql=concat(' delete from t_role_user where user_id in (',par_user_id,')');
  
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_delete_user`;
CREATE PROCEDURE  `auth_delete_user`(IN par_user_id TEXT)
begin

    set @strsql=concat(' delete from t_admin_group_user where user_id in (',par_user_id,')');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  set @strsql='';
  set @strsql=concat(' delete from t_admin where user_id in (',par_user_id,')');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  set @strsql='';
  set @strsql=concat(' delete from t_role_user where user_id in (',par_user_id,')');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  set @strsql='';
  set @strsql=concat(' delete from t_exam_marker where user_id in(
      select u.user_id from t_role r join t_role_user u on u.role_id=r.role_id
      and u.user_id in (',par_user_id,')',' and r.role_value not in(\'060305\',\'060306\'))');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_delete_user_role`;
CREATE PROCEDURE  `auth_delete_user_role`(IN par_user_id TEXT)
begin

  set @strsql='';
  set @strsql=concat(' delete from t_role_user where user_id in (',par_user_id,')');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  set @strsql='';
  set @strsql=concat(' delete from t_exam_marker where user_id in(
      select u.user_id from t_role r join t_role_user u on u.role_id=r.role_id
      and u.user_id in (',par_user_id,')',' and r.role_value not in(\'060305\',\'060306\'))');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_insert`;
CREATE PROCEDURE  `auth_insert`(IN par_user_id int(10)
,in par_role_id varchar(2000),IN par_create_user_id int(10),in par_arr_length int(10)
)
begin

    declare cur_string varchar(1000);
    DECLARE i INT(8) DEFAULT 0;

    delete from t_role_user where user_id =par_user_id;

    REPEAT SET i = i + 1;
      set cur_string=SUBSTRING_INDEX(SUBSTRING_INDEX(par_role_id, ',', i), ',', -1);

      if cur_string !='' then
        insert into t_role_user(user_id,role_id,create_tm,create_user_id)
        values(par_user_id,cur_string,sysdate(),par_create_user_id);
      end if;
        UNTIL i >= par_arr_length END REPEAT;

    set @strsql='';
    set @strsql=concat(' delete from t_exam_marker where user_id in(
      select u.user_id from t_role r join t_role_user u on u.role_id=r.role_id
      and u.user_id in (',par_user_id,')',' and r.role_value not in(\'060305\',\'060306\'))');
  
      prepare stmt from @strsql;
      execute stmt;
      deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_insert_user`;
CREATE PROCEDURE  `auth_insert_user`(IN par_user_id TEXT
,IN par_group_id int(10),IN par_group_pid int(10),IN par_create_user_id int(10),in par_arr_length int(10))
begin

    DECLARE i INT(8) DEFAULT 0;
    declare cur_string varchar(1000);

    REPEAT SET i = i + 1;
      set cur_string=SUBSTRING_INDEX(SUBSTRING_INDEX(par_user_id, ',', i), ',', -1);
      
      if trim(cur_string) !='' then
        replace into t_admin_group_user(user_id,group_id,group_pid,create_user_id,create_tm)
        values(cur_string,par_group_id,par_group_pid,par_create_user_id,sysdate());

        replace into t_admin(user_id,username,pwd)
        select user_id,username,pwd from t_user where user_id=cur_string;

      end if;
        UNTIL i >= par_arr_length END REPEAT;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_search_group_user`;
CREATE PROCEDURE  `auth_search_group_user`(IN par_group_id int(10),
IN par_group_pid int(10), IN par_real_name VARCHAR(20),
in par_page_idx INTEGER(10), in par_page_size INTEGER(10))
begin
  declare v_level int unsigned default 0;
  declare v_position int unsigned default 1;
  declare v_row_count int unsigned default 0;

 if par_group_id is not null then

  insert into tmp_group_tree(id,pid, level,position)
  values (par_group_id,par_group_pid,v_level,v_position);
  set v_row_count := row_count();

  while v_row_count != 0 do
    set @position := 0;
    insert into tmp_group_tree(id,pid,level,position)
    select g.group_id,g.group_pid,v_level + 1,@position := @position+1
    from t_group g inner join tmp_group_tree t on g.group_pid = t.id
    where t.level = v_level and g.group_id !='0' order by g.group_id;

    set v_row_count := row_count();
    set v_level := v_level + 1;
  end while;
  end if;

   set @strsql='select t.user_id,t.real_name,r.group_name,t.username from t_user t,t_admin_group_user g,t_group r';

   if par_group_id is not null then
        set @strsql=concat(@strsql,',tmp_group_tree m ');
   end if;

   set @strsql=concat(@strsql,' where r.group_id=g.group_id and g.user_id=t.user_id');

   if par_group_id is not null then
    set @strsql=concat(@strsql,' and m.pid=r.group_pid and m.id=r.group_id');
   end if;

   if par_real_name is not null then
        set @strsql=concat(@strsql,' and t.real_name like ','''',par_real_name,'%''');
   end if;

   set @strsql=concat(@strsql,' and not exists(select user_id from t_role_user r where r.user_id=t.user_id) order by t.real_name');


   call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
   prepare stmt from @mysql;
   execute stmt;
   deallocate prepare stmt;

   if par_group_id is not null then
     truncate table tmp_group_tree;
   end if;
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_select`;
CREATE PROCEDURE  `auth_select`(IN par_user_id int(10))
begin

    set @strsql='';
    set @strsql=concat(@strsql,' select role_id from t_role_user where user_id =',par_user_id);
 
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
    
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_select_group_user`;
CREATE PROCEDURE  `auth_select_group_user`(IN `par_group_id` int(10), IN `par_group_pid` int(10), IN `par_real_name` VARCHAR(20), IN `par_page_idx` INTEGER(10), IN `par_page_size` INTEGER(10))
begin
  declare v_level int unsigned default 0;
  declare v_position int unsigned default 1;
  declare v_row_count int unsigned default 0;

 if par_group_id is not null then
  insert into tmp_group_tree(id,pid, level,position)
  values (par_group_id,par_group_pid,v_level,v_position);
  set v_row_count := row_count();

  while v_row_count != 0 do
    set @position := 0;
    insert into tmp_group_tree(id,pid,level,position)
    select g.group_id,g.group_pid,v_level + 1,@position := @position+1
    from t_group g inner join tmp_group_tree t on g.group_pid = t.id
    where t.level = v_level and g.group_id !='0' order by g.group_id;

    set v_row_count := row_count();
    set v_level := v_level + 1;
  end while;
  end if;

   set @strsql='select t.user_id,t.real_name,r.group_name,t.username,t.gender,t.email,t.idcard,t.examcard,t.tel,t.mobiletel from t_user t,t_admin_group_user g,t_group r';

   if par_group_id is not null then
        set @strsql=concat(@strsql,',tmp_group_tree m ');
   end if;

   set @strsql=concat(@strsql,' where r.group_id=g.group_id and g.user_id=t.user_id');

   if par_group_id is not null then
    set @strsql=concat(@strsql,' and m.pid=r.group_pid and m.id=r.group_id');
   end if;

   if par_real_name is not null then
        set @strsql=concat(@strsql,' and t.real_name like ','''',par_real_name,'%''');
   end if;

   call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
  
   prepare stmt from @mysql;
   execute stmt;
   deallocate prepare stmt; if par_group_id is not null then
     truncate table tmp_group_tree;
   end if;    
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_select_no_role_group_user`;
CREATE PROCEDURE  `auth_select_no_role_group_user`(IN par_group_id int(10),
IN par_group_pid int(10), IN par_real_name VARCHAR(20),
in par_page_idx INTEGER(10), in par_page_size INTEGER(10))
begin
  declare v_level int unsigned default 0;
  declare v_position int unsigned default 1;
  declare v_row_count int unsigned default 0;

 if par_group_id is not null then

  insert into tmp_group_tree(id,pid, level,position)
  values (par_group_id,par_group_pid,v_level,v_position);
  set v_row_count := row_count();

  while v_row_count != 0 do
    set @position := 0;
    insert into tmp_group_tree(id,pid,level,position)
    select g.group_id,g.group_pid,v_level + 1,@position := @position+1
    from t_group g inner join tmp_group_tree t on g.group_pid = t.id
    where t.level = v_level and g.group_id !='0' order by g.group_id;

    set v_row_count := row_count();
    set v_level := v_level + 1;
  end while;
  end if;

   set @strsql='select t.user_id,t.real_name,r.group_name,t.username from t_user t 
   join t_admin_group_user g on g.user_id=t.user_id 
   join t_group r on r.group_id=g.group_id ';

   if par_group_id is not null then
        set @strsql=concat(@strsql,'join tmp_group_tree m on m.pid=r.group_pid and m.id=r.group_id');
   end if;

   set @strsql=concat(@strsql,' where not exists(select user_id from t_role_user r where r.user_id=g.user_id)');
   
   if par_real_name is not null then
        set @strsql=concat(@strsql,' and t.real_name like ','''',par_real_name,'%''');
   end if;
   
   set @strsql=concat(@strsql,' order by t.real_name');

   call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

   prepare stmt from @mysql;
   execute stmt;
   deallocate prepare stmt;

   if par_group_id is not null then
     truncate table tmp_group_tree;
   end if;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_select_user`;
CREATE PROCEDURE  `auth_select_user`(IN par_group_id int(10),
IN par_group_pid int(10), IN par_real_name VARCHAR(20),
in par_page_idx INTEGER(10), in par_page_size INTEGER(10))
begin
  declare v_level int unsigned default 0;
  declare v_position int unsigned default 1;
  declare v_row_count int unsigned default 0;

 if par_group_id is not null then

  insert into tmp_group_tree(id,pid, level,position)
  values (par_group_id,par_group_pid,v_level,v_position);
  set v_row_count := row_count();

  while v_row_count != 0 do
    set @position := 0;
    insert into tmp_group_tree(id,pid,level,position)
    select g.group_id,g.group_pid,v_level + 1,@position := @position+1
    from t_group g inner join tmp_group_tree t on g.group_pid = t.id
    where t.level = v_level and g.group_id !='0' order by g.group_id;

    set v_row_count := row_count();
    set v_level := v_level + 1;
  end while;
  end if;

   set @strsql='select distinct t.user_id,t.real_name,r.group_name,t.username from t_user t,t_admin_group_user g,t_group r,t_role_user ru';

   if par_group_id is not null then
        set @strsql=concat(@strsql,',tmp_group_tree m ');
   end if;

   set @strsql=concat(@strsql,' where r.group_id=g.group_id and g.user_id=t.user_id and ru.user_id=t.user_id ');

   if par_group_id is not null then
    set @strsql=concat(@strsql,' and m.pid=r.group_pid and m.id=r.group_id');
   end if;

   if par_real_name is not null then
        set @strsql=concat(@strsql,' and t.real_name like ','''',par_real_name,'%''');
   end if;
   set @strsql=concat(@strsql,' order by t.real_name'); call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

   prepare stmt from @mysql;
   execute stmt;
   deallocate prepare stmt;

   if par_group_id is not null then
     truncate table tmp_group_tree;
   end if;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_update`;
CREATE PROCEDURE  `auth_update`(IN par_user_id int(10),
in par_role_id varchar(2000),IN par_create_user_id int(10),in par_arr_length int(10))
begin
 
    call auth_insert(par_user_id,par_role_id,par_create_user_id,par_arr_length);
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_update_admin_pwd`;
CREATE PROCEDURE  `auth_update_admin_pwd`(IN par_user_id int(10),in par_pwd varchar(20))
begin
    update t_admin set pwd=password(par_pwd) where user_id=par_user_id;  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `auth_update_user`;
CREATE PROCEDURE  `auth_update_user`(IN par_user_id TEXT
,IN par_group_id int(10),IN par_group_pid int(10),IN par_create_user_id int(10),in par_arr_length int(10))
begin

    declare cur_string varchar(4000);
    declare uid varchar(20);
    DECLARE i INT(8) DEFAULT 0;

    REPEAT SET i = i + 1;
        set cur_string=SUBSTRING_INDEX(SUBSTRING_INDEX(par_user_id, ',', i), ',', -1);

        if trim(cur_string) !='' then
           replace t_admin_group_user (user_id,group_id,group_pid,create_user_id,create_tm)
           values(cur_string,par_group_id,par_group_pid,par_create_user_id,sysdate());
        end if;
    UNTIL i >= par_arr_length END REPEAT;

  
  
  
  
  
  
        
end



