DROP PROCEDURE IF EXISTS `page_exam_display_examing`;
CREATE PROCEDURE  `page_exam_display_examing`(IN par_user_id int(10),IN par_page_idx int(10),IN par_page_size int(10))
begin
    set @strsql=' select x.* from (select e.exam_id,e.exam_point,c.desc_cn exam_category,e.exam_name
                                ,e.exam_begin_tm,e.exam_total_tm,e.exam_passing_grade
                                from t_exam e
                                join t_common_cde c on c.c_cde=e.exam_category
                                where e.exam_end_tm >=sysdate() and e.exam_all_person=1 and e.exam_status=\'030301\' and e.exam_times is null';
    
    set @strsql=concat(@strsql,' union ');
    
    set @strsql=concat(@strsql,' select e.exam_id,e.exam_point,c.desc_cn exam_category,e.exam_name
                        ,e.exam_begin_tm,e.exam_total_tm,e.exam_passing_grade
                        from t_exam e
                        join t_common_cde c on c.c_cde=e.exam_category
                        where e.exam_end_tm >=sysdate() and e.exam_times is not null
                        and e.exam_all_person=1
            and e.exam_status=\'030301\'
                        and exists(
                        select t2.exam_times,t2.user_id,t2.exam_id from (
                            select count(*) exam_times,ue.user_id,ue.exam_id
                                from t_user_exam ue group by ue.user_id,ue.exam_id
                                ) t2 where t2.exam_id=e.exam_id and t2.exam_times<e.exam_times) ');

    set @strsql=concat(@strsql,' union ');
    
    set @strsql=concat(@strsql,' select e.exam_id,e.exam_point,c.desc_cn exam_category,e.exam_name
                        ,e.exam_begin_tm,e.exam_total_tm
                        ,e.exam_passing_grade
                         from t_exam e
                        join t_exam_group g on e.exam_id=g.exam_id
                        join t_user_group ug on ug.group_id=g.group_id and ug.user_id=',par_user_id,'
                        join t_common_cde c on c.c_cde=e.exam_category
                        where e.exam_end_tm >=sysdate() and e.exam_all_person=0
                        and e.exam_times is null
            and e.exam_status=\'030301\'
                        and not exists(select * from t_exam_exclude_user where
                        user_id=',par_user_id,' and user_id=ug.user_id) ');

    set @strsql=concat(@strsql,' union ');
    
    set @strsql=concat(@strsql,' select e.exam_id,e.exam_point,c.desc_cn exam_category,e.exam_name
                        ,e.exam_begin_tm,e.exam_total_tm
                        ,e.exam_passing_grade
                         from t_exam e
                        join t_exam_group g on e.exam_id=g.exam_id
                        join t_user_group ug on ug.group_id=g.group_id and ug.user_id=',par_user_id,'
                        join t_common_cde c on c.c_cde=e.exam_category
                        join (select count(*) exam_times,ue.user_id,ue.exam_id from t_user_exam ue
                        where ue.user_id=',par_user_id,' group by ue.user_id,ue.exam_id) t1
                        on e.exam_id=t1.exam_id
                        where e.exam_end_tm >=sysdate() and e.exam_times is not null
                        and t1.exam_times<e.exam_times
            and e.exam_status=\'030301\'
                        and not exists(select user_id from t_exam_exclude_user where
                        user_id=',par_user_id,' and user_id=ug.user_id) ');

  set @strsql=concat(@strsql,' ) x order by x.exam_begin_tm desc ');

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_exam_my_qsn_content`;
CREATE PROCEDURE  `page_exam_my_qsn_content`(IN par_user_id int(10),in par_qsn_id char (32),in par_qsn_sub_id char(32)
,in par_exam_id char(32),in par_exam_times int(10)
)
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
  set @mysql2='';

    insert into tmp_page_exam_my_qsn_tree(id,pid, level,position)
    values (par_qsn_id,par_qsn_sub_id,v_level,v_position);

set @strsql='
select
       x.qsn_id,
       x.qsn_sub_id,
       r.qsn_point,
       x.qsn_content,
       x.option_content,
       x.qsn_item_tag,
       x.qsn_item_id,
       a.qsn_answer,
         ua.user_answer,
         ua.remark,
       ua.exam_publish_answer_flg,
       x.qsn_guide,
       x.qsn_type,
       x.qsn_position,
       x.sub_qsn_flg
  from (select
               tp.qsn_id,
               tp.qsn_sub_id,
               tp.qsn_content,
               tp.option_content,
               tp.qsn_item_tag,
               case when tp.qsn_item_id is null then 1 else tp.qsn_item_id end qsn_item_id,
               tp.qsn_guide,
               tp.qsn_type,
               tp.qsn_position,
               NULL sub_qsn_flg
          from (select
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       o.option_content,
                       o.qsn_item_id,
                       o.qsn_item_tag,
                       q.qsn_type,case when p.qsn_position is not null then p.qsn_position else 0 end qsn_position
                  from
                  t_question q
                  left join t_qsn_sub_position p on p.qsn_id = q.qsn_id and p.qsn_sub_id = q.qsn_sub_id
                  left join t_option o on o.qsn_id = q.qsn_id and o.qsn_sub_id = q.qsn_sub_id and o.qsn_type=q.qsn_type';
                                      
if par_qsn_id is not null and par_qsn_sub_id is not null then
    set @strsql=concat(@strsql,' where q.qsn_id=','''',par_qsn_id,'''',' and q.qsn_sub_id=','''',par_qsn_sub_id,'''');
end if;
set @strsql=concat(@strsql,' )tp');
set @strsql=concat(@strsql,' union
        select
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.option_content,
               y.qsn_item_tag,
               case when y.qsn_item_id is null then 1 else y.qsn_item_id end qsn_item_id,
               y.qsn_guide,
               y.qsn_type,
               y.qsn_position,              
               y.flg sub_qsn_flg
          from (select
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       o.option_content,
                       o.qsn_item_tag,
                       o.qsn_item_id,
                       q.qsn_type,
                       q.qsn_position,                     
                       sp.flg
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               r.qsn_content,
                               r.qsn_type,
                               r.qsn_guide,
                               s.qsn_position
                          from tmp_page_exam_my_qsn_tree t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                       ) q
                  left join t_option o on q.qsn_id = o.qsn_id and q.qsn_sub_id = o.qsn_sub_id and o.qsn_type=q.qsn_type
                  left join (select distinct t1.qsn_id,case when t1.qsn_id is not null then 1 else 0 end flg
                              from t_qsn_sub_position t1
                              join tmp_page_exam_my_qsn_tree t2 on t2.id = t1.qsn_id) sp on sp.qsn_id =q.qsn_sub_id
                                                                        and q.qsn_type in(\'010105\',\'010106\')
                 ) y
        ) x
  left join (select r.qsn_id, r.qsn_sub_id,r.qsn_point
                       from tmp_page_exam_my_qsn_tree t, t_question r
                      where t.id = r.qsn_id and t.pid = r.qsn_sub_id
union
select r.qsn_id, r.qsn_sub_id,r.qsn_point
                       from tmp_page_exam_my_qsn_tree t, t_question r
                      where t.pid = r.qsn_id and t.id = r.qsn_sub_id
           ) r on x.qsn_id =r.qsn_id and x.qsn_sub_id =r.qsn_sub_id
left join (select t.qsn_id,
                    t.qsn_sub_id,
                    group_concat(t.qsn_answer SEPARATOR \'__\') qsn_answer
               from t_answer t where t.qsn_id=','''',par_qsn_id,'''',' and t.qsn_sub_id=','''',par_qsn_sub_id,'''','
              group by t.qsn_id, t.qsn_sub_id) a on a.qsn_id = x.qsn_id and a.qsn_sub_id =x.qsn_sub_id
left join (select t2.*,ui.remark,ee.exam_publish_answer_flg from (
select t.qsn_id,t.qsn_sub_id,group_concat(t.user_answer SEPARATOR \'__\') user_answer
from t_user_exam_answer t where ');

set @strsql=concat(@strsql,' t.user_id=','''',par_user_id,'''',' and t.exam_times=',par_exam_times,' and t.exam_id=','''',par_exam_id,'''',' and t.qsn_id=','''',par_qsn_id,'''',' and t.qsn_sub_id=','''',par_qsn_sub_id,'''');
set @strsql=concat(@strsql,'
              group by t.qsn_id, t.qsn_sub_id) t2
       join t_user_exam_info ui on ui.qsn_id=t2.qsn_id and ui.qsn_sub_id=t2.qsn_sub_id and ','ui.user_id=','''',par_user_id,'''',' and ui.exam_times=',par_exam_times,' and ui.exam_id=','''',par_exam_id,'''',
       ' and ui.qsn_id=','''',par_qsn_id,'''',' and ui.qsn_sub_id=','''',par_qsn_sub_id,'''',' join t_exam ee on ee.exam_id=ui.exam_id
              ) ua on ua.qsn_id =x.qsn_id and ua.qsn_sub_id =x.qsn_sub_id
             group by
        x.qsn_id,x.qsn_sub_id,r.qsn_point,x.qsn_content,x.option_content,x.qsn_item_tag,
       x.qsn_item_id,a.qsn_answer,ua.user_answer,ua.remark,x.qsn_guide,x.qsn_type,
       x.qsn_position,x.sub_qsn_flg
       order by x.qsn_position');

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_page_exam_my_qsn_tree;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_homepage_exam_list`;
CREATE PROCEDURE  `page_homepage_exam_list`(IN par_user_id int(10),IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin
   declare v_level int unsigned default 0;
   declare v_position int unsigned default 1;
   declare v_row_count int unsigned default 0;

   select g.group_id,g.group_pid into @gid,@gpid from t_user_group ug join t_group g on ug.group_id=g.group_id where user_id=par_user_id;

   insert into tmp_group_user_tree(id,pid, level,position)
   values (@gid,@gpid,v_level,v_position);

   set v_row_count := row_count();
   while v_row_count != 0 do
        set @position := 0;
        insert into tmp_group_user_tree(id,pid,level,position)
        select g.group_id,g.group_pid
        , v_level + 1
        , @position := @position+1
        from t_group g
        inner join tmp_group_user_tree t    on g.group_pid = t.id   where t.level = v_level and g.group_id !='0' order by g.group_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
   end while;

    set @strsql=concat('select e.exam_id,e.exam_name,e.exam_user_signup_flg,e.exam_begin_tm,e.exam_end_tm,e.exam_total_tm,
    e.exam_publish_result_flg,e.exam_full_screen_flg,e.exam_publish_result_tm,c2.desc_cn exam_category,g.group_name exam_create_dep,
    DATE_FORMAT(e.create_tm,','''','%Y-%m-%d','''',') create_tm,e.exam_ie_only_flg,e.exam_passing_again_flg,
    e.exam_qsn_random_flg,e.exam_paper_only_one_flg,ex.group_id,es.verify_status
    from t_exam e
    join t_common_cde c2 on e.exam_category=c2.c_cde
    join t_user u on u.user_id=e.create_user_id
    join t_user_group ug on ug.user_id=u.user_id
    join t_group g on g.group_id=ug.group_id
    left join (select eg.exam_id,eg.group_id from t_exam_group eg join tmp_group_user_tree tg on tg.id=eg.group_id
    ) ex on ex.exam_id=e.exam_id
    left join t_exam_user_signup es on es.exam_id=e.exam_id and es.user_id=',par_user_id,'
    where e.exam_end_tm >=sysdate() and exam_status=','''','030301','''',' and not exists(select * from t_exam_exclude_user eu where eu.user_id=',par_user_id,' and eu.exam_id=e.exam_id) '
    ,' order by e.create_tm desc');

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
    
    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    truncate table tmp_group_user_tree;
      
end

DROP PROCEDURE IF EXISTS `page_homepage_scoring_rank_list`;
CREATE PROCEDURE  `page_homepage_scoring_rank_list`()
begin
    select setting_value into @list_count from t_setting where user_id=0 and category_pname='data' and category_name='system'
    and setting_name='index_ranking_count' ;
    
    set @strsql=concat('select x.* from (
            select a.exam_name,a.exam_publish_result_flg,a.exam_user_count,a.username,a.user_exam_scoring,
            (select count( distinct user_exam_scoring ) from t_user_exam
            where user_exam_scoring >a.user_exam_scoring and exam_id=a.exam_id and exam_times=1 and papr_id=a.papr_id)+1 ranking
            from (select e.exam_name,e.exam_publish_result_flg,e.exam_user_count,u.username,ue.user_exam_scoring,e.exam_id,ep.papr_id
              from
              (select exam_user_count,exam_publish_result_flg,exam_id,exam_name from t_exam
              where exam_publish_result_flg !=0
              order by create_tm,exam_publish_result_tm desc limit 1) e
              join t_user_exam ue on ue.exam_id=e.exam_id
              join t_exam_papr ep on ep.papr_id=ue.papr_id
              join t_user u on ue.user_id=u.user_id
              where ue.exam_times=1 limit ',@list_count,') a
              order by ranking
            )x order by x.user_exam_scoring desc');

   prepare stmt from @strsql;
   execute stmt;
   deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_message_delete`;
CREATE PROCEDURE  `page_message_delete`(IN par_user_id int(10),IN par_msg_id text,in par_msg_box varchar(10))
begin
  if par_msg_box ='outbox' then
    set @strsql=concat('delete from t_message where sender_id=',par_user_id,' and msg_id in (',par_msg_id,') and msg_folder=','''',par_msg_box,'''');
  else
    set @strsql=concat('delete from t_message where recipients_id=',par_user_id,' and msg_id in (',par_msg_id,') and msg_folder=','''',par_msg_box,'''');
  end if;
  
  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_message_display_conent`;
CREATE PROCEDURE  `page_message_display_conent`(IN par_msg_id char(17),IN par_user_id int(10))
begin
    set @strsql=concat('select msg_id,msg_title,create_tm,u.username,m.msg_content from t_message m,t_user u
    where m.sender_id=u.user_id and m.recipients_id=',par_user_id,' and m.msg_id=','''',par_msg_id,'''');
 
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_message_display_list`;
CREATE PROCEDURE  `page_message_display_list`(IN par_user_id int(10),IN par_msg_box varchar(10),IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin
  if par_msg_box ='inbox' then
   set @strsql=concat('select m.msg_id,m.msg_title,m.create_tm,u.username,m.msg_content,m.recipients_id user_id,c.desc_cn msg_status
   from t_message m,t_user u,t_common_cde c
     where c.c_cde=m.msg_status and m.sender_id=u.user_id and m.recipients_id=',par_user_id,' and m.msg_folder=','''',par_msg_box,'''');
  elseif par_msg_box='outbox' then
   set @strsql=concat('select m.msg_id,m.msg_title,m.create_tm,u.username,m.msg_content,m.recipients_id user_id,c.desc_cn msg_status
   from t_message m,t_user u,t_common_cde c
     where c.c_cde=m.msg_status and m.recipients_id=u.user_id and m.sender_id=',par_user_id,' and m.msg_folder=','''',par_msg_box,'''');
  end if;

  call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
  
  prepare stmt from @mysql;
  execute stmt;
  deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_message_display_unread`;
CREATE PROCEDURE  `page_message_display_unread`(IN par_user_id int(10),IN par_page_idx int(10),IN par_page_size int(10))
begin
    set @strsql=concat('select msg_id,msg_title,create_tm,u.username,m.recipients_id user_id from t_message m,t_user u
    where m.sender_id=u.user_id and m.msg_folder=\'inbox\' and m.recipients_id=',par_user_id,' and m.msg_status=','''','040202','''');
    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_message_get_unread_count`;
CREATE PROCEDURE  `page_message_get_unread_count`(IN par_user_id int(10))
begin
    select count(*) unread_count from t_message
  where recipients_id =par_user_id and msg_status='040202' and msg_folder='inbox';

  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_message_send`;
CREATE PROCEDURE  `page_message_send`(IN par_msg_id char(17), IN par_msg_title VARCHAR(100),
IN par_msg_content varchar(2000),IN par_sender_id int(10),IN par_recipients varchar(200),
in par_arr_length int(10),OUT par_no_exists_user text)
begin

    declare cur_string varchar(1000);
    DECLARE i INT(8) DEFAULT 0;
    declare uid varchar(20);

    set @uname='';set @noexists='';

    REPEAT SET i = i + 1;
        set cur_string=SUBSTRING_INDEX(SUBSTRING_INDEX(par_recipients, ',', i), ',', -1);

        if trim(cur_string) !='' then
           select username into uid from t_user where username=cur_string;

           if uid !='' then
                        set @uname=concat(@uname,'''',uid,'''',',');
                   else
              set @noexists=concat(@noexists,cur_string,',');
                   end if;
           set uid='';
        end if;
    UNTIL i >= par_arr_length END REPEAT;

    set @noexists=substring(@noexists,1,char_length(@noexists)-1);
    set @uname=substring(@uname,1,char_length(@uname)-1);

    set par_no_exists_user=@noexists;

  if @uname !='' then
    set @strsql='insert into t_message(msg_id,msg_title,msg_content,msg_folder,msg_status,sender_id,recipients_id,create_tm) ';
      set @strsql=concat(@strsql,' select ','''',par_msg_id,'''',',','''',par_msg_title,'''',',','''',par_msg_content,'''',',','''','inbox','''',',','''','040202','''',',',par_sender_id,',u.user_id,sysdate()');

      if par_recipients is not null then
      set @strsql=concat(@strsql,' from t_user u where u.username in(',@uname,')');
      end if;

      prepare stmt from @strsql;
      execute stmt;
      deallocate prepare stmt;

      set @strsql='insert into t_message(msg_id,msg_title,msg_content,msg_folder,msg_status,sender_id,recipients_id,create_tm) ';
      set @strsql=concat(@strsql,' select ','''',par_msg_id,'''',',','''',par_msg_title,'''',',','''',par_msg_content,'''',',','''','outbox','''',',','''','040202','''',',',par_sender_id,',u.user_id,sysdate()');

      if par_recipients is not null then
      set @strsql=concat(@strsql,' from t_user u where u.username in(',@uname,')');
    end if;

      prepare stmt from @strsql;
      execute stmt;
      deallocate prepare stmt;
    end if;
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_message_update_status`;
CREATE PROCEDURE  `page_message_update_status`(IN par_msg_status_flg char(1),IN par_msg_id text,IN par_user_id int(10))
begin
    if par_msg_status_flg ='1' then
        set @strsql=concat('update t_message set msg_status=\'040201\' where msg_id in (',par_msg_id,')',' and recipients_id=',par_user_id);
    else
        set @strsql=concat('update t_message set msg_status=\'040202\' where msg_id in (',par_msg_id,')',' and recipients_id=',par_user_id);
    end if;
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_my_exam_count`;
CREATE PROCEDURE  `page_my_exam_count`(IN par_user_id int(10),
in par_exam_year varchar(10),in par_exam_month varchar(10),
in par_page_idx int(10),in par_page_size int(10))
begin
    set @strsql=concat('select count(*) exam_count,cde.desc_cn exam_category,year(ue.exam_tm) exam_year');
    
    if par_exam_year is not null then
        set @strsql=concat(@strsql,',month(ue.exam_tm) exam_month ');
    end if;
    set @strsql=concat(@strsql,' from t_user_exam ue  join t_exam e on e.exam_id=ue.exam_id
                        join t_common_cde cde  on cde.c_cde=e.exam_category where ');
    if par_user_id is not null then
        set @strsql=concat(@strsql,' ue.user_id=',par_user_id);
    end if;

    if par_exam_year is not null then
        set @strsql=concat(@strsql,' and year(ue.exam_tm)=',par_exam_year);
    end if;
    if par_exam_month is not null then
        set @strsql=concat(@strsql,' and month(ue.exam_tm)=',par_exam_month);
    end if;
    
    set @strsql=concat(@strsql,' group by cde.desc_cn,year(ue.exam_tm)');

    if par_exam_year is not null then
        set @strsql=concat(@strsql,',month(ue.exam_tm)');
    end if; 

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
 
    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_my_exam_error_qsn`;
CREATE PROCEDURE  `page_my_exam_error_qsn`(IN par_user_id int(10),
in par_exam_year varchar(10),in par_exam_month varchar(10),in par_page_idx int(10),in par_page_size int(10))
begin
    set @strsql=concat('select c.desc_cn exam_category,ui.exam_times,count(*) exam_error_count,year(ue.exam_tm) exam_year,
                            concat(round(count(*)/p.papr_all_qsn_count*100,2),\'%\') percent');
    
    if par_exam_year is not null then
        set @strsql=concat(@strsql,',month(ue.exam_tm) exam_month ');       
    end if;
    set @strsql=concat(@strsql,' from t_user_exam_info ui
                                join t_exam e on ui.exam_id=e.exam_id
                                join t_common_cde c on c.c_cde=e.exam_category
                                join t_exam_papr ep on e.exam_id=ep.exam_id
                                join t_paper p on p.papr_id=ep.papr_id
                                join t_user_exam ue on ue.exam_id=e.exam_id and ue.user_id=ui.user_id and ue.exam_times=ui.exam_times
                                where answer_status=0 ');
    
    if par_user_id is not null then
        set @strsql=concat(@strsql,' and ue.user_id=',par_user_id);
    end if;

    if par_exam_year is not null then
        set @strsql=concat(@strsql,' and year(ue.exam_tm)=',par_exam_year);
    end if;
    
    if par_exam_month is not null then
        set @strsql=concat(@strsql,' and month(ue.exam_tm)=',par_exam_month);
    end if;

    set @strsql=concat(@strsql,' group by c.desc_cn,ui.exam_times,year(ue.exam_tm)');
    
    if par_exam_year is not  null then
        set @strsql=concat(@strsql,',month(ue.exam_tm)');   
    end if; 
    
    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
  
    prepare stmt from @mysql;  
    execute stmt;
    deallocate prepare stmt;
    
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_my_exam_error_qsn_list`;
CREATE PROCEDURE  `page_my_exam_error_qsn_list`(IN par_user_id int(10),
in par_exam_bgn_tm varchar(20),in par_exam_end_tm varchar(20),in par_exam_name varchar(100),
in par_qsn_category varchar(20),in par_qsn_type varchar(20),in par_qsn_content varchar(1000),
in par_page_idx int(10),in par_page_size int(10))
begin
    set @strsql=concat('select e.exam_id,c.desc_cn exam_category,ui.exam_times,e.exam_name,q.qsn_id,q.qsn_sub_id,
w1.exam_people_count,w2.exam_error_people,ue.exam_tm,
q.qsn_content,c2.desc_cn qsn_category,q.qsn_point,c3.desc_cn qsn_type
,c4.desc_cn qsn_level,year(ue.exam_tm) exam_year,month(ue.exam_tm) exam_month
from t_user_exam_info ui
join t_exam e on ui.exam_id=e.exam_id
join t_exam_papr ep on e.exam_id=ep.exam_id
join t_paper p on p.papr_id=ep.papr_id
join t_common_cde c on c.c_cde=e.exam_category
join t_user_exam ue on ue.exam_id=e.exam_id and ue.user_id=ui.user_id and ue.exam_times=ui.exam_times and ep.papr_id=ue.papr_id
join t_question q on q.qsn_id=ui.qsn_id and q.qsn_sub_id=ui.qsn_sub_id
join t_common_cde c2 on c2.c_cde=q.qsn_category
join t_common_cde c3 on c3.c_cde=q.qsn_type
join t_common_cde c4 on c4.c_cde=q.qsn_level
left join (select count(*) exam_people_count, t1.exam_id,t1.exam_times,t1.papr_id
        from t_user_exam t1 ');

    if par_user_id is not null then
        set @strsql=concat(@strsql,' where t1.user_id=',par_user_id);
    end if;

  set @strsql=concat(@strsql,' group by t1.exam_id,t1.papr_id,t1.exam_times) w1
    on w1.exam_id=ue.exam_id and w1.exam_times=ue.exam_times and w1.papr_id=ue.papr_id
    left join (select count(*) exam_error_people,t2.exam_id,t2.exam_times,t2.qsn_id,t2.qsn_sub_id
        from t_user_exam_info t2 where t2.answer_status=0 and');

    if par_user_id is not null then
        set @strsql=concat(@strsql,' t2.user_id=',par_user_id);
    end if;

  set @strsql=concat(@strsql,' group by t2.exam_id,t2.exam_times,t2.qsn_id,t2.qsn_sub_id) w2 on
    w2.exam_id=ui.exam_id and w2.exam_times=ui.exam_times and w2.qsn_id=ui.qsn_id and w2.qsn_sub_id=ui.qsn_sub_id
  where ui.answer_status=0 and ');

    if par_user_id is not null then
        set @strsql=concat(@strsql,' ui.user_id=',par_user_id);
    end if;

    if par_exam_bgn_tm is not null  and par_exam_end_tm is not null then
        set @strsql=concat(@strsql,' and ue.exam_tm between ','''', par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
    end if;
    if par_exam_name is not null then
        set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
    end if;
    
    if par_qsn_category is not null then
        set @strsql=concat(@strsql,' and q.qsn_category = ','''',par_qsn_category,'''');
    end if;

    if par_qsn_type is not null then
        set @strsql=concat(@strsql,' and q.qsn_type=','''',par_qsn_type,'''');
    end if;

  if par_qsn_content is not null then
    set @strsql=concat(@strsql,' and q.qsn_content like ','''',par_qsn_content,'%''');
  end if;

  set @strsql=concat(@strsql,' order by ue.exam_tm desc');
    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

  prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_my_exam_list`;
CREATE PROCEDURE  `page_my_exam_list`(IN par_user_id int(10),
IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin
set @strsql=concat('select e.exam_name,cm.desc_cn exam_category,e.exam_id,p.papr_id,u.real_name,e.exam_publish_answer_flg,
e.exam_passing_grade,
gp.group_name,p.papr_name,ue.exam_tm,ue.exam_times,e.exam_point exam_point,
ue.user_exam_scoring,e.exam_total_tm exam_time,ue.exam_total_tm,
e.exam_begin_tm,e.exam_end_tm
,e.exam_user_count,t2.real_user_count
,ue.qsn_count
,q1.right_count,q1.part_right_count,q1.error_count,q1.null_count
,case when e.exam_publish_result_tm <sysdate() then 1 else 0 end exam_publish_result_flg
,(select count(*)
                  from t_user_exam u
                 where u.exam_id = ue.exam_id
                   and u.exam_times = ue.exam_times
                   and u.user_exam_scoring > ue.user_exam_scoring) + 1 pos
from
t_user_exam ue join t_exam e on e.exam_id=ue.exam_id and exam_status=','''','030301','''',' and ue.user_id=','''',par_user_id,'''','
join t_common_cde cm on cm.c_cde=e.exam_category
 left join (
select ue1.exam_id,ue1.user_id,ue1.exam_times,ue1.papr_id,ue1.error_count,ue1.right_count,ue1.part_right_count
,ue1.null_count
from t_user_exam ue1 ,t_user_exam_info uei where
 uei.exam_id=ue1.exam_id and uei.papr_id=ue1.papr_id and uei.user_id=ue1.user_id
and ue1.exam_times=uei.exam_times and ue1.user_id=','''',par_user_id,'''','
group by ue1.exam_id,ue1.user_id,ue1.exam_times,ue1.papr_id
) q1 on q1.exam_id=ue.exam_id and q1.papr_id=ue.papr_id and q1.user_id=ue.user_id and q1.exam_times=ue.exam_times
join t_user u on u.user_id=ue.user_id
join t_user_group g on u.user_id=g.user_id
join t_group gp on gp.group_id=g.group_id
join t_paper p on p.papr_id=ue.papr_id
join (select COUNT(*) real_user_count,e2.exam_id,e2.exam_times from t_user_exam e2
group by e2.exam_id,e2.exam_times) t2 on t2.exam_id=ue.exam_id and t2.exam_times=ue.exam_times
order by ue.exam_tm desc ');
call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_my_exam_scoring`;
CREATE PROCEDURE  `page_my_exam_scoring`(IN par_user_id int(10),
in par_exam_year varchar(10),in par_exam_month varchar(10),
in par_page_idx int(10),in par_page_size int(10))
begin
    set @strsql=concat('select ue.exam_times,cde.desc_cn exam_category,year(ue.exam_tm) exam_year');
    set @strsql=concat(@strsql,',round(avg(ue.user_exam_scoring),2) exam_avg_scoring,
              concat(round(t1.passing_count/t2.exam_user_count*100,2),\'%\') exam_passing_grade,
              e.exam_publish_score_flg');
    if par_exam_year is not null then
        set @strsql=concat(@strsql,',month(ue.exam_tm) exam_month ');
    end if;

    set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
                        join t_common_cde cde  on cde.c_cde=e.exam_category
                        join (select
                                count(*) passing_count,e.exam_category,tue.exam_times,tue.exam_id
                                from t_user_exam tue
                                join t_exam e on tue.exam_id=e.exam_id
                                where tue.user_exam_scoring >=e.exam_passing_grade  group by e.exam_category,tue.exam_times,tue.exam_id
                                ) t1 on t1.exam_category = e.exam_category and t1.exam_id =ue.exam_id and t1.exam_times=ue.exam_times ');

  set @strsql=concat(@strsql,' join (
                  select count(t.user_id) exam_user_count,t.exam_times,t.exam_id from t_user_exam t
                  group by t.exam_times,t.exam_id
                ) t2 on t2.exam_id=ue.exam_id and t2.exam_times=ue.exam_times ');

  set @strsql=concat(@strsql,' where 1=1 ');

    if par_exam_year is not null then
        set @strsql=concat(@strsql,' and year(ue.exam_tm)=',par_exam_year);
    end if;

    if par_exam_month is not null then
        set @strsql=concat(@strsql,' and month(ue.exam_tm)=',par_exam_month);
    end if;

    set @strsql=concat(@strsql,' group by cde.desc_cn,ue.exam_times,year(ue.exam_tm)');

    if par_exam_year is not  null then
        set @strsql=concat(@strsql,',month(ue.exam_tm)');
    end if;

  call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_my_exam_sort`;
CREATE PROCEDURE  `page_my_exam_sort`(IN par_user_id int(10),
in par_exam_year varchar(10),in par_exam_month varchar(10)
,in par_page_idx int(10),in par_page_size int(10))
begin
    set @strsql=concat('select ue.exam_times,cde.desc_cn exam_category,year(ue.exam_tm) exam_year');
    
    set @strsql=concat(@strsql,',e.exam_publish_score_flg,e.exam_publish_result_flg,e.exam_user_count exam_sum_people,t1.ucount exam_real_people,(select count(*)
                  from t_user_exam u
                 where u.exam_id = ue.exam_id
                   and u.exam_times = ue.exam_times
                   and u.user_exam_scoring > ue.user_exam_scoring) + 1 pos');
    
    if par_exam_year is not null then
        set @strsql=concat(@strsql,',month(ue.exam_tm) exam_month ');       
    end if;

    set @strsql=concat(@strsql,' from t_user_exam ue  join t_exam e on e.exam_id=ue.exam_id
                        join t_common_cde cde  on cde.c_cde=e.exam_category 
                        join (
select count(*) ucount,exam_times,exam_id
 from t_user_exam
group by exam_id,exam_times
) t1 on t1.exam_id=ue.exam_id and t1.exam_times=ue.exam_times
                        where ');
    
    if par_user_id is not null then
        set @strsql=concat(@strsql,' ue.user_id=',par_user_id);
    end if;
    
    if par_exam_year is not null then
        set @strsql=concat(@strsql,' and year(ue.exam_tm)=',par_exam_year);
    end if;
    if par_exam_month is not null then
        set @strsql=concat(@strsql,' and month(ue.exam_tm)=',par_exam_month);
    end if;
    
    set @strsql=concat(@strsql,' group by cde.desc_cn,ue.exam_times,year(ue.exam_tm)');
    
    if par_exam_year is not  null then
        set @strsql=concat(@strsql,',month(ue.exam_tm)');
    end if;

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

  prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
    
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `page_notice_display_list`;
CREATE PROCEDURE  `page_notice_display_list`(IN par_user_id INT(10),IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin

  DECLARE roles TEXT;
  DECLARE gid INT(10) DEFAULT 0;

  SELECT GROUP_CONCAT(r.role_value),ug.group_id INTO roles, gid
  FROM t_user u
  JOIN t_role_user ru ON u.user_id = ru.user_id
  JOIN t_role r ON ru.role_id = r.role_id
  LEFT JOIN t_user_group ug ON u.user_id = ug.user_id
  WHERE u.user_id = par_user_id;

  IF POSITION('060404' IN roles) > 0 THEN
    SET @strsql = 'SELECT n.notice_id,
      n.notice_title,
      n.notice_content,
      n.create_tm,
      u.username
    FROM t_notice n
    LEFT JOIN t_user u ON n.update_user_id = u.user_id
    WHERE n.notice_status = \'040102\'
    ORDER BY n.create_tm DESC';
  ELSEIF POSITION('060403' IN roles) > 0 OR POSITION('060402' IN roles) > 0 THEN
    SET @strsql = CONCAT('SELECT n.notice_id,
      n.notice_title,
      n.notice_content,
      n.create_tm,
      u.username
    FROM t_notice n
    INNER JOIN (
      SELECT usr.user_id,
        usr.username
      FROM t_user usr
      INNER JOIN t_user_group ug ON usr.user_id = ug.user_id
      INNER JOIN t_role_user ru ON usr.user_id = ru.user_id
      INNER JOIN t_role r ON ru.role_id = r.role_id
      WHERE ug.group_id = ',gid,' OR r.role_value LIKE \'%060404%\'
    ) u ON n.create_user_id = u.user_id
    WHERE n.notice_status = \'040102\'
    ORDER BY n.create_tm DESC');
  ELSE
    SET @strsql = 'SELECT n.notice_id,
      n.notice_title,
      n.notice_content,
      n.create_tm,
      u.username
    FROM t_notice n
    INNER JOIN (
      SELECT usr.user_id,
        usr.username
      FROM t_user usr
      INNER JOIN t_role_user ru ON usr.user_id = ru.user_id
      INNER JOIN t_role r ON ru.role_id = r.role_id
      WHERE r.role_value LIKE \'%060404%\'
    ) u ON n.create_user_id = u.user_id
    WHERE n.notice_status = \'040102\'
    ORDER BY n.create_tm DESC';
  END IF;


  CALL pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

  PREPARE stmt from @mysql;
  EXECUTE stmt;
  DEALLOCATE PREPARE stmt;
  
  
  
  
  
  
  
        
end



