DROP TABLE IF EXISTS `t_exam`;
CREATE TABLE `t_exam` (
  `exam_id` char(32) NOT NULL,
  `exam_name` varchar(1000) NOT NULL,
  `exam_notice` text,
  `exam_status` varchar(20) NOT NULL,
  `exam_category` varchar(20) DEFAULT NULL,
  `exam_total_tm` int(11) unsigned DEFAULT NULL,
  `exam_begin_tm` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `exam_end_tm` datetime NOT NULL DEFAULT '0000-00-00 23:59:59',
  `exam_mode` varchar(20) DEFAULT NULL,
  `exam_times` int(11) unsigned DEFAULT NULL,
  `exam_point_type` varchar(20) DEFAULT NULL,
  `exam_point` float unsigned DEFAULT NULL,
  `exam_passing_grade` float unsigned DEFAULT NULL,
  `exam_manual` tinyint(1) unsigned DEFAULT NULL,
  `exam_all_person` tinyint(1) unsigned NOT NULL,
  `exam_publish_result_tm` datetime DEFAULT NULL,
  `exam_user_count` int(10) unsigned DEFAULT NULL,
  `exam_recovery_time` int(10) unsigned DEFAULT NULL,
  `exam_allow_ip` text,
  `create_user_id` int(10) NOT NULL,
  `create_tm` datetime NOT NULL,
  `update_user_id` int(10) DEFAULT NULL,
  `update_tm` datetime DEFAULT NULL,
  `exam_time_consistency_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_cloze_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_publish_score_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_publish_answer_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_publish_result_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_blank_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_full_screen_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_mouse_right_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_disable_paste_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_submit_display_result` tinyint(1) unsigned DEFAULT NULL,
  `exam_ie_only_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_paper_only_one_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_passing_again_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_qsn_random_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_disable_monitor_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_recovery_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_user_verify_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_user_signup_flg` tinyint(1) unsigned DEFAULT NULL,
  `exam_disable_minute` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`exam_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_exam_broadcast`;
CREATE TABLE `t_exam_broadcast` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `exam_id` char(32) NOT NULL,
  `broadcast_content` varchar(2000) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_exam_exclude_user`;
CREATE TABLE `t_exam_exclude_user` (
  `exam_id` char(32) NOT NULL,
  `user_id` int(10) NOT NULL,
  `papr_id` char(32) DEFAULT NULL,
  PRIMARY KEY (`exam_id`,`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_exam_group`;
CREATE TABLE `t_exam_group` (
  `exam_id` char(32) NOT NULL,
  `group_id` int(10) NOT NULL,
  `group_pid` int(10) NOT NULL,
  `papr_id` char(32) NOT NULL,
  PRIMARY KEY (`exam_id`,`group_id`,`group_pid`,`papr_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_exam_marker`;
CREATE TABLE `t_exam_marker` (
  `exam_id` char(32) NOT NULL,
  `user_id` int(10) NOT NULL,
  PRIMARY KEY (`exam_id`,`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_exam_papr`;
CREATE TABLE `t_exam_papr` (
  `exam_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  PRIMARY KEY (`exam_id`,`papr_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_exam_papr_answer`;
CREATE TABLE `t_exam_papr_answer` (
  `exam_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_item_id` int(10) NOT NULL,
  `qsn_item_count` int(10) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) unsigned NOT NULL,
  `qsn_position` int(10) unsigned NOT NULL,
  `qsn_point` float NOT NULL,
  `qsn_answer` text NOT NULL,
  `create_tm` datetime DEFAULT NULL,
  `create_user_id` int(10) DEFAULT NULL,
  `update_tm` datetime DEFAULT NULL,
  `update_user_id` int(10) DEFAULT NULL,
  PRIMARY KEY (`exam_id`,`papr_id`,`qsn_id`,`qsn_sub_id`,`qsn_item_id`) USING BTREE,
  KEY `exam_papr_answer_idx` (`exam_id`,`papr_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_exam_user_signup`;
CREATE TABLE `t_exam_user_signup` (
  `exam_id` char(32) NOT NULL,
  `user_id` int(10) NOT NULL,
  `verify_status` varchar(20) NOT NULL,
  `signup_tm` datetime NOT NULL,
  `verify_user_id` int(10) DEFAULT NULL,
  `verify_tm` datetime DEFAULT NULL,
  PRIMARY KEY (`exam_id`,`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



