DROP TABLE IF EXISTS `t_user`;
CREATE TABLE `t_user` (
  `user_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id2` varchar(50) DEFAULT NULL,
  `username` varchar(20) DEFAULT NULL,
  `nickname` varchar(100) DEFAULT NULL,
  `real_name` varchar(100) DEFAULT NULL,
  `pwd` varchar(50) DEFAULT NULL,
  `email` varchar(50) DEFAULT NULL,
  `status` varchar(10) DEFAULT '070101',
  `icon` varchar(255) DEFAULT NULL,
  `introduction` varchar(500) DEFAULT NULL,
  `gender` tinyint(1) unsigned DEFAULT NULL,
  `birthday` date DEFAULT NULL,
  `idcard` varchar(30) DEFAULT NULL,
  `examcard` varchar(30) DEFAULT NULL,
  `tel` varchar(30) DEFAULT NULL,
  `mobiletel` varchar(30) DEFAULT NULL,
  `position` varchar(30) DEFAULT NULL,
  `reg_ip` varchar(15) DEFAULT NULL,
  `reg_tm` datetime DEFAULT NULL,
  `update_tm` datetime DEFAULT NULL,
  `login_count` int(10) unsigned DEFAULT NULL,
  `last_login_tm` datetime DEFAULT NULL,
  `last_login_ip` varchar(15) DEFAULT NULL,
  `study_point` int(4) unsigned DEFAULT '0',
  `study_day_answer_point` int(4) unsigned DEFAULT '0',
  PRIMARY KEY (`user_id`),
  KEY `idx_username` (`username`),
  KEY `Idx_email` (`email`),
  KEY `idx_idcard` (`idcard`),
  KEY `idx_examcard` (`examcard`)
) ENGINE=InnoDB   DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_exam`;
CREATE TABLE `t_user_exam` (
  `exam_id` char(32) NOT NULL,
  `user_id` int(10) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exam_times` smallint(6) NOT NULL,
  `exam_tm` datetime NOT NULL,
  `user_exam_scoring` float NOT NULL,
  `exam_point` float DEFAULT NULL,
  `exam_total_tm` time DEFAULT NULL,
  `right_count` smallint(6) DEFAULT NULL,
  `part_right_count` smallint(6) DEFAULT NULL,
  `error_count` smallint(6) DEFAULT NULL,
  `qsn_count` smallint(6) DEFAULT NULL,
  `null_count` smallint(6) DEFAULT NULL,
  `ip_address` varchar(15) DEFAULT NULL,
  PRIMARY KEY (`exam_id`,`user_id`,`exam_times`,`papr_id`),
  KEY `Index_u_exam` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_exam_answer`;
CREATE TABLE `t_user_exam_answer` (
  `user_id` int(10) NOT NULL,
  `exam_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exam_times` smallint(6) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_item_id` smallint(6) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) NOT NULL,
  `user_answer` text,
  PRIMARY KEY (`qsn_id`,`user_id`,`exam_id`,`qsn_sub_id`,`papr_id`,`qsn_item_id`,`exam_times`),
  KEY `Index_usr_exam_a_qtype` (`qsn_type`) USING BTREE,
  KEY `Index_usr_exam_a_pos` (`qsn_type_position`) USING BTREE,
  KEY `Index_user_exam_a_u` (`user_id`) USING BTREE,
  KEY `index_usr_exam_a_qid` (`qsn_id`,`qsn_sub_id`) USING BTREE,
  KEY `index_usr_exam_answer` (`user_id`,`exam_id`,`papr_id`,`exam_times`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_exam_answer_storage`;
CREATE TABLE `t_user_exam_answer_storage` (
  `user_id` int(10) NOT NULL,
  `exam_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exam_times` smallint(6) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_item_id` smallint(6) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) NOT NULL,
  `user_answer` text,
  PRIMARY KEY (`qsn_id`,`user_id`,`exam_id`,`qsn_sub_id`,`papr_id`,`qsn_item_id`,`exam_times`),
  KEY `index_usr_exam_a_s_qtype` (`qsn_type`) USING BTREE,
  KEY `index_usr_exam_a_s_pos` (`qsn_type_position`) USING BTREE,
  KEY `index_usr_exam_a_s` (`exam_id`,`papr_id`,`exam_times`,`user_id`) USING BTREE,
  KEY `index_usr_exam_a_s_u` (`user_id`) USING BTREE,
  KEY `index_usr_exam_a_s_qid` (`qsn_id`,`qsn_sub_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_exam_info`;
CREATE TABLE `t_user_exam_info` (
  `user_id` int(10) NOT NULL,
  `exam_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exam_times` smallint(6) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) NOT NULL,
  `answer_status` char(1) NOT NULL,
  `scoring` float DEFAULT NULL,
  `remark` varchar(4000) DEFAULT NULL,
  `marker_id` int(10) DEFAULT NULL,
  `mark_tm` datetime DEFAULT NULL,
  PRIMARY KEY (`user_id`,`papr_id`,`exam_id`,`exam_times`,`qsn_id`,`qsn_sub_id`),
  KEY `Index_exam_info_type` (`qsn_type`) USING BTREE,
  KEY `index_exam_info_qid` (`qsn_id`,`qsn_sub_id`) USING BTREE,
  KEY `index_uexaminfo` (`user_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_exam_storage`;
CREATE TABLE `t_user_exam_storage` (
  `exam_id` char(32) NOT NULL,
  `user_id` int(10) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exam_times` smallint(6) NOT NULL,
  `exam_tm` datetime DEFAULT NULL,
  `user_exam_scoring` float DEFAULT NULL,
  `exam_point` float DEFAULT NULL,
  `exam_total_tm` time DEFAULT NULL,
  `right_count` smallint(6) DEFAULT NULL,
  `part_right_count` smallint(6) DEFAULT NULL,
  `error_count` smallint(6) DEFAULT NULL,
  `qsn_count` smallint(6) DEFAULT NULL,
  `null_count` smallint(6) DEFAULT NULL,
  PRIMARY KEY (`exam_id`,`user_id`,`exam_times`,`papr_id`),
  KEY `Index_u_exam_storage` (`user_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_exercise`;
CREATE TABLE `t_user_exercise` (
  `exercise_id` char(32) NOT NULL,
  `user_id` int(10) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exercise_times` smallint(6) NOT NULL,
  `exercise_tm` datetime NOT NULL,
  `user_exercise_scoring` float NOT NULL,
  `exercise_point` float DEFAULT NULL,
  `exercise_total_tm` time DEFAULT NULL,
  `right_count` smallint(6) DEFAULT NULL,
  `part_right_count` smallint(6) DEFAULT NULL,
  `error_count` smallint(6) DEFAULT NULL,
  `qsn_count` smallint(6) DEFAULT NULL,
  `null_count` smallint(6) DEFAULT NULL,
  PRIMARY KEY (`exercise_id`,`user_id`,`exercise_times`,`papr_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_exercise_answer`;
CREATE TABLE `t_user_exercise_answer` (
  `user_id` int(10) NOT NULL,
  `exercise_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exercise_times` smallint(6) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_item_id` smallint(6) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) NOT NULL,
  `user_answer` text,
  PRIMARY KEY (`qsn_id`,`user_id`,`exercise_id`,`qsn_sub_id`,`papr_id`,`qsn_item_id`,`exercise_times`),
  KEY `Index_usr_exercise_a_qtype` (`qsn_type`) USING BTREE,
  KEY `Index_usr_exercise_a_pos` (`qsn_type_position`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_exercise_info`;
CREATE TABLE `t_user_exercise_info` (
  `user_id` int(10) NOT NULL,
  `exercise_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `exercise_times` smallint(6) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) NOT NULL,
  `answer_status` char(1) NOT NULL,
  `scoring` float DEFAULT NULL,
  `remark` varchar(4000) DEFAULT NULL,
  `marker_id` int(10) DEFAULT NULL,
  `mark_tm` datetime DEFAULT NULL,
  PRIMARY KEY (`user_id`,`papr_id`,`exercise_id`,`exercise_times`,`qsn_id`,`qsn_sub_id`),
  KEY `Index_exercise_info_type` (`qsn_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_group`;
CREATE TABLE `t_user_group` (
  `user_id` int(10) NOT NULL,
  `group_id` int(10) NOT NULL,
  PRIMARY KEY (`user_id`,`group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_homework`;
CREATE TABLE `t_user_homework` (
  `homework_id` char(32) NOT NULL,
  `user_id` int(10) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `homework_times` smallint(6) NOT NULL,
  `homework_tm` datetime NOT NULL,
  `user_homework_scoring` float NOT NULL,
  `homework_point` float DEFAULT NULL,
  `homework_total_tm` time DEFAULT NULL,
  `right_count` smallint(6) DEFAULT NULL,
  `part_right_count` smallint(6) DEFAULT NULL,
  `error_count` smallint(6) DEFAULT NULL,
  `qsn_count` smallint(6) DEFAULT NULL,
  `null_count` smallint(6) DEFAULT NULL,
  PRIMARY KEY (`homework_id`,`user_id`,`homework_times`,`papr_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_homework_answer`;
CREATE TABLE `t_user_homework_answer` (
  `user_id` int(10) NOT NULL,
  `homework_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `homework_times` smallint(6) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_item_id` smallint(6) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) NOT NULL,
  `user_answer` text,
  PRIMARY KEY (`qsn_id`,`user_id`,`homework_id`,`qsn_sub_id`,`papr_id`,`qsn_item_id`,`homework_times`),
  KEY `Index_usr_homework_a_qtype` (`qsn_type`) USING BTREE,
  KEY `Index_usr_homework_a_pos` (`qsn_type_position`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_user_homework_info`;
CREATE TABLE `t_user_homework_info` (
  `user_id` int(10) NOT NULL,
  `homework_id` char(32) NOT NULL,
  `papr_id` char(32) NOT NULL,
  `homework_times` smallint(6) NOT NULL,
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_type` varchar(20) NOT NULL,
  `qsn_type_position` int(10) NOT NULL,
  `answer_status` char(1) NOT NULL,
  `scoring` float DEFAULT NULL,
  `remark` varchar(4000) DEFAULT NULL,
  `marker_id` int(10) DEFAULT NULL,
  `mark_tm` datetime DEFAULT NULL,
  PRIMARY KEY (`user_id`,`papr_id`,`homework_id`,`homework_times`,`qsn_id`,`qsn_sub_id`),
  KEY `Index_homework_info_type` (`qsn_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



