<?php

/**
 *    	(C)2009-2011 Orivon Inc.
 *      author @tiger
 */

if(!defined('Orivon')) {
	exit('Access Denied');
}
function show_msg($error_no, $error_msg = 'ok', $success = 1, $quit = TRUE) {
	if(VIEW_OFF) {
		$error_code = $success ? 0 : constant(strtoupper($error_no));
		$error_msg = empty($error_msg) ? $error_no : $error_msg;
		$error_msg = str_replace('"', '\"', $error_msg);
		$str = "<root>\n";
		$str .= "\t<error errorCode=\"$error_code\" errorMessage=\"$error_msg\" />\n";
		$str .= "</root>";
		echo $str;
		exit;
	} else {
		show_header();
		global $step;

		$title = lang($error_no);
		$comment = lang($error_no.'_comment', false);
		$errormsg = '';

		if($error_msg) {
			if(!empty($error_msg)) {
				foreach ((array)$error_msg as $k => $v) {
					if(is_numeric($k)) {
						$comment .= "<li><em class=\"red\">".lang($v)."</em></li>";
					}
				}
			}
		}

		echo "
				<div class=\"right_2\"></div>
				<div class=\"right_3\">
				<div><b>$title</b></div>
				<ul style=\"line-height: 200%; margin-left: 30px;\">$comment</ul>
					
			";
		
		if($quit) {
			echo '<p><br /><br /><span class="red">'.lang('error_quit_msg').'</span></p>';
		}

		echo '	</div>
				<div class="right_4">
				<p>
				<img src="images/button_3.gif" style="cursor: pointer;" onclick="history.back();"  />
				</p>
				</div>
			';
		echo "</div>";
		echo  "<div class=\"clear\"></div>";
		echo "</div>";

		$quit && show_footer();
	}
}

function check_db($dbhost, $dbuser, $dbpw, $dbname, $tablepre) {
	if(!function_exists('mysql_connect')) {
		show_msg('undefine_func', 'mysql_connect', 0);
	}
	if(!@mysql_connect($dbhost, $dbuser, $dbpw)) {
		$errno = mysql_errno();
		$error = mysql_error();
		if($errno == 1045) {
			show_msg('database_errno_1045', $error, 0);
		} elseif($errno == 2003) {
			show_msg('database_errno_2003', $error, 0);
		}elseif($errno == 2013 ){//数据库服务器端口错误
			show_msg('database_errno_2013 ', $error, 0);
		}
		else {
			show_msg('database_connect_error', $error, 0);
		}
	} else {		
			$query = mysql_query('select * from '.$dbname.'.t_common_cde ');
			if(!$query || mysql_num_rows($query) ==0){
				return false;
			}
	}
	return true;
}

function dirfile_check(&$dirfile_items) {
	foreach($dirfile_items as $key => $item) {
		$item_path = $item['path'];
		if($item['type'] == 'dir') {
			if(!dir_writeable(ROOT_PATH.$item_path)) {
				if(is_dir(ROOT_PATH.$item_path)) {
					$dirfile_items[$key]['status'] = 0;
					$dirfile_items[$key]['current'] = '+r';
				} else {
					$dirfile_items[$key]['status'] = -1;
					$dirfile_items[$key]['current'] = 'nodir';
				}
			} else {
				$dirfile_items[$key]['status'] = 1;
				$dirfile_items[$key]['current'] = '+r+w';
			}
		} else {
			if(file_exists(ROOT_PATH.$item_path)) {
				if(is_writable(ROOT_PATH.$item_path)) {
					$dirfile_items[$key]['status'] = 1;
					$dirfile_items[$key]['current'] = '+r+w';
				} else {
					$dirfile_items[$key]['status'] = 0;
					$dirfile_items[$key]['current'] = '+r';
				}
			} else {
				if(dir_writeable(dirname(ROOT_PATH.$item_path))) {
					$dirfile_items[$key]['status'] = 1;
					$dirfile_items[$key]['current'] = '+r+w';
				} else {
					$dirfile_items[$key]['status'] = -1;
					$dirfile_items[$key]['current'] = 'nofile';
				}
			}
		}
	}
}

function env_check(&$env_items) {
	foreach($env_items as $key => $item) {
		if($key == 'php') {
			$env_items[$key]['current'] = PHP_VERSION;
		} elseif($key == 'attachmentupload') {
			$env_items[$key]['current'] = @ini_get('file_uploads') ? ini_get('upload_max_filesize') : 'unknow';
		} elseif($key == 'gdversion') {
			$tmp = function_exists('gd_info') ? gd_info() : array();
			$env_items[$key]['current'] = empty($tmp['GD Version']) ? 'noext' : $tmp['GD Version'];
			unset($tmp);
		} elseif($key == 'diskspace') {
			if(function_exists('disk_free_space')) {
				$env_items[$key]['current'] = floor(disk_free_space(ROOT_PATH) / (1024*1024)).'M';
			} else {
				$env_items[$key]['current'] = 'unknow';
			}
		} elseif(isset($item['c'])) {
			$env_items[$key]['current'] = constant($item['c']);
		}

		$env_items[$key]['status'] = 1;
		if($item['r'] != 'notset' && strcmp($env_items[$key]['current'], $item['r']) < 0) {
			$env_items[$key]['status'] = 0;
		}
	}
}

function ioncube_check(&$ioncube_items){	

	require_once ROOT_PATH.'./install/include/loader_wizard.php';

	if(!is_supported_php_version){
			show_msg('php_unsupport_ioncube',$error,0);	
	}
	foreach($ioncube_items as $key => $item) {
		if($key == 'ioncube') {
			$ioncube_items[$key]['path'] = get_loader_location_from_ini();
			switch(PHP_OS){					
				case 'WINNT':
					$ioncube_items[$key]['c']=end(explode('\\',	$ioncube_items[$key]['path']));
					break;
				case 'Linux':
					$ioncube_items[$key]['c']=end(explode('/',	$ioncube_items[$key]['path']));
					break;
					}
			$ioncube_items[$key]['c']=end(explode('/',	$ioncube_items[$key]['c']));
			$ioncube_items[$key]['r'] =get_loader_name();
			if($ioncube_items[$key]['c']!=$ioncube_items[$key]['r']){
				switch(PHP_OS){					
					case 'WINNT':
						show_msg('win_ioncube_error', $error, $error_code);
						break;
					case 'Linux':
						show_msg('lin_ioncube_error', $error, $error_code);
						break;

				}
			}else{
				$ioncube_items[$key]['support']=1;
			}		
		}
	}
}

function function_check(&$func_items) {
	foreach($func_items as $item) {
		function_exists($item) or show_msg('undefine_func', $item, 0);
	}
}

function show_env_result(&$env_items, &$ioncube_items,&$dirfile_items, &$func_items) {

	$env_str = $file_str = $dir_str = $func_str = '';
	$error_code = 0;

	foreach($env_items as $key => $item) {
		if($key == 'php' && strcmp($item['current'], $item['r']) < 0) {
			show_msg('php_version_too_low', $item['current'], 0);
		}
		$status = 1;
		if($item['r'] != 'notset') {
			if(intval($item['current']) && intval($item['r'])) {
				if(intval($item['current']) < intval($item['r'])) {
					$status = 0;
					$error_code = ENV_CHECK_ERROR;
				}
			} else {
				if(strcmp($item['current'], $item['r']) < 0) {
					$status = 0;
					$error_code = ENV_CHECK_ERROR;
				}
			}
		}
		if(VIEW_OFF) {
			$env_str .= "\t\t<runCondition name=\"$key\" status=\"$status\" Require=\"$item[r]\" Best=\"$item[b]\" Current=\"$item[current]\"/>\n";
		} else {
			$env_str .= "<tr>\n";
			$env_str .= "<td>".lang($key)."</td>\n";
			$env_str .= "<td class=\"padleft\">".lang($item['r'])."</td>\n";
			$env_str .= "<td class=\"padleft\">".lang($item['b'])."</td>\n";
			$env_str .= ($status ? "<td class=\"w pdleft1\">" : "<td class=\"nw pdleft1\">").$item['current']."</td>\n";
			$env_str .= "</tr>\n";
		}
	}

	foreach($dirfile_items as $key => $item) {
		$tagname = $item['type'] == 'file' ? 'File' : 'Dir';
		$variable = $item['type'].'_str';

		if(VIEW_OFF) {
			if($item['status'] == 0) {
				$error_code = ENV_CHECK_ERROR;
			}
			$$variable .= "\t\t\t<File name=\"$item[path]\" status=\"$item[status]\" requirePermisson=\"+r+w\" currentPermisson=\"$item[current]\" />\n";
		} else {
			$$variable .= "<tr>\n";
			$$variable .= "<td>$item[path]</td><td class=\"w pdleft1\">".lang('writeable')."</td>\n";
			if($item['status'] == 1) {
				$$variable .= "<td class=\"w pdleft1\">".lang('writeable')."</td>\n";
			} elseif($item['status'] == -1) {
				$error_code = ENV_CHECK_ERROR;
				$$variable .= "<td class=\"nw pdleft1\">".lang('nodir')."</td>\n";
			} else {
				$error_code = ENV_CHECK_ERROR;
				$$variable .= "<td class=\"nw pdleft1\">".lang('unwriteable')."</td>\n";
			}
			$$variable .= "</tr>\n";
		}
	}

	if(VIEW_OFF) {
		$str = "<root>\n";
		$str .= "\t<runConditions>\n";
		$str .= $env_str;
		$str .= "\t</runConditions>\n";
		$str .= "\t<FileDirs>\n";
		$str .= "\t\t<Dirs>\n";
		$str .= $dir_str;
		$str .= "\t\t</Dirs>\n";
		$str .= "\t\t<Files>\n";
		$str .= $file_str;
		$str .= "\t\t</Files>\n";
		$str .= "\t</FileDirs>\n";
		$str .= "\t<error errorCode=\"$error_code\" errorMessage=\"\" />\n";
		$str .= "</root>";
		echo $str;
		exit;

	} else {
		show_header();
		echo "<div class=\"right_2\"><p>文件目录权限检查</p></div>";
		echo "<div class=\"right_3\">";
			echo "<h2 class=\"title\">".lang('env_check')."</h2>\n";
			echo "<table class=\"tb\" style=\"margin:20px 0 20px 76px;\">\n";
			echo "<tr>\n";
			echo "\t<th>".lang('project')."</th>\n";
			echo "\t<th class=\"padleft\">".lang('required')."</th>\n";
			echo "\t<th class=\"padleft\">".lang('best')."</th>\n";
			echo "\t<th class=\"padleft\">".lang('curr_server')."</th>\n";
			echo "</tr>\n";
			echo $env_str;
			echo "</table>\n";
			
			echo "<h2 class=\"title\">".lang('ioncube_check')."</h2>\n";
			echo "<table class=\"tb\" style=\"margin:20px 0 20px 20px;\">\n";

			echo "\t<tr>\n";
			echo "\t<td><th>".lang('ioncube_require')."</th></td>\n";
			echo "\t<td class=\"padleft\"  width=\"290\">".$ioncube_items['ioncube']['r']."</td>\n";
			echo "\t</tr>\n";
			
			echo "\t<tr>\n";
			echo "\t<td><th>".lang('ioncube_version')."</th></td>\n";
			echo "\t<td class=\"padleft\"  width=\"290\">".$ioncube_items['ioncube']['c']."</td>\n";
			echo "\t</tr>\n";
			
			echo "\t<tr>\n";
			echo "\t<td><th>".lang('ioncube_path')."</th></td>\n";
			echo "\t<td class=\"padleft\"  width=\"290\">".$ioncube_items['ioncube']['path']."</td>\n";
			echo "\t</tr>\n";
			
			echo "\t<tr>\n";
			echo "\t<td class=\"padleft\"><th>".lang('ioncube_status')."</th></td>\n";
			if($ioncube_items['ioncube']['support'] == 1) {
				echo "<td class=\"w pdleft1\">".lang('supportted')."</td>\n";
			} elseif($ioncube_items['ioncube']['support']  == 0) {
				echo "<td class=\"nw pdleft1\">".lang('unsupportted')."</td>\n";
				$error_code = ENV_CHECK_ERROR;
			} 		
			echo "\t</tr>\n";
			echo "</td>\n";		
			echo "</table>\n"; 
		
			echo "<h2 class=\"title\">".lang('priv_check')."</h2>\n";
			echo "<table class=\"tb\" style=\"margin:20px 0 20px 50px;\" width=\"75%\">\n";
			echo "\t<tr>\n";
			echo "\t<th>".lang('step1_file')."</th>\n";
			echo "\t<th class=\"padleft\">".lang('step1_need_status')."</th>\n";
			echo "\t<th class=\"padleft\">".lang('step1_status')."</th>\n";
			echo "</tr>\n";
			echo $file_str;
			echo $dir_str;
			echo "</table>\n";

			foreach($func_items as $item) {
				$status = function_exists($item);
				$func_str .= "<tr>\n";
				$func_str .= "<td>$item()</td>\n";
				if($status) {
					$func_str .= "<td class=\"w pdleft1\">".lang('supportted')."</td>\n";
					$func_str .= "<td class=\"padleft\">".lang('none')."</td>\n";
				} else {
					$error_code = ENV_CHECK_ERROR;
					$func_str .= "<td class=\"nw pdleft1\">".lang('unsupportted')."</td>\n";
					$func_str .= "<td><font color=\"red\">".lang('advice_'.$item)."</font></td>\n";
				}
			}
			echo "<h2 class=\"title\">".lang('func_depend')."</h2>\n";
			echo "<table class=\"tb\" style=\"margin:20px 0 20px 50px;\"  width=\"75%\">\n";
			echo "<tr>\n";
			echo "\t<th>".lang('func_name')."</th>\n";
			echo "\t<th class=\"padleft\">".lang('check_result')."</th>\n";
			echo "\t<th class=\"padleft\">".lang('suggestion')."</th>\n";
			echo "</tr>\n";
			echo $func_str;
			echo "</table>\n";
		echo "</div>";
		
		show_next_step(2, $error_code);
		echo "</div>";
		echo  "<div class=\"clear\"></div>";
		echo "</div>";
		show_footer();
	}

}

function show_next_step($step, $error_code) {
	if($error_code == 0) {
		 echo "<div class=\"right_4\">
			<p>
				<a href=\"javascript:history.back();\"><img src=\"images/button_3.gif\"  style=\"cursor: pointer;\"  /></a>
				<a href=\"index.php?step=$step\"><img src=\"images/button_2.gif\"   style=\"cursor: pointer;\" /></a>
			</p>
			</div>";

	} else {
		 echo "<div class=\"right_4\">
			<p>
				<a href=\"javascript:history.back();\"><img src=\"images/button_3.gif\"  style=\"cursor: pointer;\"  /></a>
			</p>
			</div>";
	}
}

function show_form(&$form_items, $error_msg) {
	global $step;
	if(empty($form_items) || !is_array($form_items)) {
		return;
	}
	show_header();
	echo "<div class=\"right_2\"><p>填写配置信息</p></div>";
	echo "<div class=\"right_3\">";
		
	show_setting('start');
	show_setting('hidden', 'step', $step);
	$is_first = 1;
	foreach($form_items as $key => $items) {
		global ${'error_'.$key};
		if($is_first == 0) {
			echo '</table>';
		}

		echo '<table class="tb2">';
		foreach($items as $k => $v) {
			$value = '';
			if(!empty($error_msg)) {
				$value = isset($_POST[$key][$k]) ? $_POST[$key][$k] : '';
			}
			if(empty($value)) {
				if(isset($v['value']) && is_array($v['value'])) {
					if($v['value']['type'] == 'constant') {
						$value = defined($v['value']['var']) ? constant($v['value']['var']) : $v['value']['var'];
					} else {
						$value = $GLOBALS[$v['value']['var']];
					}
				} else {
					$value = '';
				}
			}
			show_setting($k, $key.'['.$k.']', $value, $v['type'], isset($error_msg[$key][$k]) ? $key.'_'.$k.'_invalid' : '');
		}

		if($is_first) {
			$is_first = 0;
		}
	}
	echo '</table>';
	echo '</div>';
	show_setting('', 'submitname', '', 'submit');
	show_setting('end');
	echo "</div>";
	echo  "<div class=\"clear\"></div>";
	echo "</div>";	
	show_footer();
}

function show_license() {
	global $self, $step;
	$next = $step + 1;
	if(VIEW_OFF) {
		show_msg('license_contents', lang('license'), 1);
	} else {
		show_header();
		$license = str_replace('  ', '&nbsp;&nbsp; ', lang('license'));
		echo <<<EOT
				<div class="right_2">
					<p>授权协议</p>
				</div>
				<div class="right_3">
					<div class="license">$license</div>
				</div>
				<div class="right_4"><p><a href="index.php?step=1"><img src="images/button_1.gif" /></a></p></div>				
				</div>
				<div class="clear"></div>
				</div>		
EOT;
		show_footer();
	}
}

function createtable($sql) {
	$type = strtoupper(preg_replace("/^\s*CREATE TABLE\s+.+\s+\(.+?\).*(ENGINE|TYPE)\s*=\s*([a-z]+?).*$/isU", "\\2", $sql));
	$type = in_array($type, array('MYISAM', 'HEAP', 'MEMORY','INNODB')) ? $type : 'MYISAM';
	return preg_replace("/^\s*(CREATE TABLE\s+.+\s+\(.+?\)).*$/isU", "\\1", $sql).
	(mysql_get_server_info() > '4.1' ? " ENGINE=$type DEFAULT CHARSET=".DBCHARSET : " TYPE=$type");
}

function dir_writeable($dir) {
	$writeable = 0;
	if(!is_dir($dir)) {
		@mkdir($dir, 0777);
	}
	if(is_dir($dir)) {
		if($fp = @fopen("$dir/test.txt", 'w')) {
			@fclose($fp);
			@unlink("$dir/test.txt");
			$writeable = 1;
		} else {
			$writeable = 0;
		}
	}
	return $writeable;
}

function dir_clear($dir) {
	global $lang;
	showjsmessage($lang['clear_dir'].' '.str_replace(ROOT_PATH, '', $dir));
	if($directory = @dir($dir)) {
		while($entry = $directory->read()) {
			$filename = $dir.'/'.$entry;
			if(is_file($filename)) {
				@unlink($filename);
			}
		}
		$directory->close();
		@touch($dir.'/index.htm');
	}
}

function show_header() {
	global $step,$option;
	$softname=SOFT_NAME;
	$version = VERSION;
	$release = RELEASE;
	$install_lang = lang(INSTALL_LANG);	
	switch($option){
		case 'install_ots':
			$title = lang('title_install');
			break;
		case 'update_ots':
			$title = lang('title_update');
			break;
		case 'install_oes':
			$title = lang('title_install');
			break;
		case 'update_oes':
			$title = lang('title_update');	
			break;
		default:
			exit;
	}
	$charset = CHARSET;
	
	echo <<<EOT
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>$title</title>
<link href="images/style.css" rel="stylesheet" type="text/css" />
</head>

<body>
<div class="box">
	<div class="top">
		<div class="clear"></div>
	</div>
	<div class="main">
EOT;
	 show_step($step);	 
        echo <<<EOT
		<div class="right">
        	<div class="right_1">
		<p><span>欢迎使用&nbsp;</span><b>$title</b><br />
		<rv>版本：$softname $version $install_lang&nbsp;</rv></p>
		</div>
EOT;

}

function show_footer($quit = true) {
	echo <<<EOT
			<div class="bottom">2008 - 2010 Orivon Inc.</div>
		</div>
	</body>
</html>

EOT;
	$quit && exit();
}

function showjsmessage($message) {
	if(VIEW_OFF) return;
	echo '<script type="text/javascript">showmessage(\''.addslashes($message).' \');</script>'."\r\n";
	flush();
	ob_flush();
}

function redirect($url) {

	echo "<script>".
		"function redirect() {window.location.replace('$url');}\n".
		"setTimeout('redirect();', 0);\n".
		"</script>";
	exit();

}

function show_install() {
	if(VIEW_OFF) return;
?>
<script type="text/javascript">
function showmessage(message) {
	document.getElementById('notice').innerHTML += message + '<br />';
	document.getElementById('notice').scrollTop = 100000000;
}
function initinput() {
	window.location='../';
}
</script>

		<div class="right_2"><p>正在安装数据库</p></div>
		<div class="right_3">
		<div class="btnbox"><div id="notice"></div></div>
		</div>
		<div class="right_4">
		<p id="showinfo"></p>
		</div>
		</div>
		<div class="clear"></div>
		</div>
			<div class="bottom">2008 - 2010 Orivon Inc.</div>
	</div>
</body>
</html>

<?php
}

function install_run_error($runobj,$fname){
	$errno = mysql_errno();
	$error = mysql_error();
	if($errno != 0) {
	switch ($runobj){
		case 'runquery':
			showjsmessage(lang('create_table').' '.$fname.' ... '.lang('failed'));
			break;
		case 'runprocedure':
			showjsmessage(lang('create_procedure').' '.$fname.' ... '.lang('failed'));
			break;
		case 'install_load_data':
			showjsmessage(lang('load_data').' '.$fname.' ... '.lang('failed'));
			break;
		case 'load_demo_data':
			showjsmessage(lang('load_demo_data').' '.$fname.' ... '.lang('failed'));
			break;
		case 'delete_demo_data':
			showjsmessage(lang('delete_demo_data').' '.$fname.' ... '.lang('failed'));
			break;	
		case 'addadmin':
			showjsmessage(lang('addadmin').' '.$fname.' ... '.lang('failed'));
			break;	
		case 'dropproc':
			showjsmessage(lang('dropproc').' '.$fname.' ... '.lang('failed'));
			break;				
	}
	
	echo '	
			<script type="text/javascript">				
				document.getElementById("showinfo").innerHTML="<input type=\"button\"  onclick=\"history.back();\" style=\"cursor: pointer;background:url(images/button_3.gif);background-repeat:no-repeat;border-style:none; width:136px; height:29px; \" />";
				document.getElementById("attention").innerHTML="<p class=\"att\">'.lang('install_failed').'</p>";
			</script>
		';			
		
	exit;
	}

}

 function runquery($sql) {
	global $lang, $otsdbcharset, $otstablepre, $otstablepre, $db, $otsdbcharset;
	$ret = array();
	$num = 0;
	foreach(explode(";\n", trim($sql)) as $query) {
		$queries = explode("\n", trim($query));
		foreach($queries as $query) {
			$ret[$num] .= $query[0] == '#' || $query[0].$query[1] == '--' ? '' : $query;
		}
		$num++;
	}
	unset($sql);
	
	foreach($ret as $query) {
		$query = trim($query);
		if($query) {
			if(strstr(strtoupper($query),'CREATE TABLE')) {
				$db->query(createtable($query));
				$name=explode('`',$query);
				install_run_error('runquery',$name[1]);
				showjsmessage(lang('create_table').' '.$name[1].' ... '.lang('succeed'));	
			} 
			else {
				$db->query($query);
				install_run_error('runquery',$query);
			}
		}
	}
}

 function runprocedure($sql) {
	global $lang, $otsdbcharset, $otstablepre, $otstablepre, $db, $otsdbcharset;
	$ret = array();
	$num = 0;
	$str_q='';
	$flg_c=0;
	
	foreach(explode("\n", $sql) as $query) {
		$queries = explode(";\n", $query);			
		foreach($queries as $query) {
			if(strtoupper(substr($query,0,4))=='DROP'){
				$ret[$num]= $query;
			}elseif(strstr(strtoupper($query),'CREATE DEFINER')){
				$flg_c=1;
				$str_q.= $query;				
			}elseif(strtoupper(substr($query,0,3))== 'END' && strlen(trim($query))==3){
				$ret[$num+1]=$str_q."\nend";				
				$str_q='';
				$flg_c=0;
			}elseif ($query !=''){
				if(strtoupper($query)=="BEGIN"){
					$str_q.="\n".$query."\n ";
				}else{
					$str_q.= $query;		
				}				
			}			
		}
		$num++;
	}
	unset($sql);

	foreach($ret as $query) {

		if($query) {
			if(strstr(strtoupper($query),'CREATE ')) {			
				$s=$query;
				$db->query($s);		
				$name=explode('`',$s);
				install_run_error('runprocedure',$name[1]);	
				showjsmessage(lang('create_procedure').' '.$name[1].' ... '.lang('succeed'));
			}
			else {
				$db->query($query);
			}
		}
	}
 }

function install_load_data(){
	global $lang, $otsdbcharset, $otstablepre, $otstablepre, $db, $otsdbcharset;
	
	$root=str_replace('\\','/',ROOT_PATH);
	$root.='/install/data/';
	$data_dir = 'data/'; //数据库安装文件存放路径
	$res_dir = opendir($data_dir);
	$arr_files=array();
	while(false != ($file=readdir($res_dir))){
			if($file=='.' || $file=='..') continue;
			if(!in_array('demo', explode('.', $file)) && in_array('data', explode('.', $file))) 
			array_push($arr_files,$file);
			}

	foreach($arr_files as $f){
		if(file_exists($root.$f)){
			$fname=explode('.',$f);		
			$sql='load data local infile "'.$root.$f.'" into table '.$fname[0];
			$db->query($sql);
			install_run_error('install_load_data',$fname[0]);
			showjsmessage(lang('load_data').' '.$fname[0].' ... '.lang('succeed'));
		}
	}
}

function load_demo_data(){
	
	global $lang, $otsdbcharset, $otstablepre, $otstablepre, $db, $otsdbcharset;
	$root=str_replace('\\','/',ROOT_PATH);
	$root.='/install/data/demo/';
	$data_dir = 'data/demo/'; //数据库安装文件存放目录
	$res_dir = opendir($data_dir);
	$arr_files=array();
	while(false != ($file=readdir($res_dir))){
			if($file=='.' || $file=='..') continue;
			if(!in_array('demo', explode('.', $file)) && in_array('data', explode('.', $file))) 
			array_push($arr_files,$file);
			}
	foreach($arr_files as $f){
		if(file_exists($root.$f)){
			$fname=explode('.',$f);		
			$sql='load data local infile "'.$root.$f.'" into table '.$fname[0];
			$db->query($sql);
			install_run_error('load_demo_data',$fname[0]);			
			showjsmessage(lang('load_demo_data').' '.$fname[0].' ... '.lang('succeed'));
		}
	}
}

function charcovert($string) {
	if(!get_magic_quotes_gpc()) {
		$string = str_replace('\'', '\\\'', $string);
	} else {
		$string = str_replace('\"', '"', $string);
	}
	return $string;
}

function getgpc($k, $t='GP') {
	$t = strtoupper($t);
	switch($t) {
		case 'GP' : isset($_POST[$k]) ? $var = &$_POST : $var = &$_GET; break;
		case 'G': $var = &$_GET; break;
		case 'P': $var = &$_POST; break;
		case 'C': $var = &$_COOKIE; break;
		case 'R': $var = &$_REQUEST; break;
	}
	return isset($var[$k]) ? $var[$k] : null;
}

function var_to_hidden($k, $v) {
	return "<input type=\"hidden\" name=\"$k\" value=\"$v\" />\n";
}

function show_error($type, $errors = '', $quit = false) {

	global $lang, $step;
	$title = lang($type);
	$comment = lang($type.'_comment', false);
	$errormsg = '';
	if($errors) {
		if(!empty($errors)) {
			foreach ((array)$errors as $k => $v) {
				if(is_numeric($k)) {
					$comment .= "<li><em class=\"red\">".lang($v)."</em></li>";
				}
			}
		}
	}

	if($step > 0) {
		echo "<div class=\"desc\"><b>$title</b><ul>$comment</ul>";
	} else {
		echo "</div><div class=\"main\" style=\"margin-top: -123px;\"><b>$title</b><ul style=\"line-height: 200%; margin-left: 30px;\">$comment</ul>";
	}

	if($quit) {
		echo '<br /><span class="red">'.$lang['error_quit_msg'].'</span><br /><br /><br /><br /><br /><br />';
	}
	echo '</div>';
	$quit && show_footer();
}

function show_setting($setname, $varname = '', $value = '', $type = 'text|password|checkbox', $error = '') {
	if($setname == 'start') {
		echo "<form method=\"post\" action=\"index.php\">\n";
		return;
	} elseif($setname == 'end') {
		echo "\n</table>\n</form>\n";
		return;
	} elseif($setname == 'hidden') {
		echo "<input type=\"hidden\" name=\"$varname\" value=\"$value\">\n";
		return;
	}
	if($type == 'text' || $type == 'password') {
		$value = htmlspecialchars($value);
		echo "\n".'<tr><th class="tbopt'.($error ? ' red' : '').'">&nbsp;'.(empty($setname) ? '' : lang($setname).':')."</th>\n<td>";	
		echo "<input type=\"$type\" name=\"$varname\" value=\"$value\" size=\"35\" class=\"txt\">";
	} elseif($type == 'submit') {
		echo '<div class="right_4">
				<p>
					<input type="submit"  style="cursor: pointer;background:url(images/button_2.gif);background-repeat:no-repeat;border-style:none; width:136px; height:29px; " name='.$varname.' value='.lang($value).'>
				</p>
			</div>		
			';
		return;
	} elseif($type == 'checkbox') {
		if(!is_array($varname) && !is_array($value)) {
			echo "\n".'<tr><th class="tbopt'.($error ? ' red' : '').'">&nbsp;'.(empty($setname) ? '' : lang($setname).':')."</th>\n<td>";
			echo "<label style=\"cursor: pointer;\"><input type=\"checkbox\"  name=\"$varname\" value=\"1\"".($value ? 'checked="checked"' : '')."style=\"border: 0\">".lang($setname.'_check_label')."</label>\n";
		}
	} else {
		echo $value;
	}
	echo "</td>\n</tr><tr><td></td><td>";
	if($error) {
		$comment = '<span class="red">'.(is_string($error) ? lang($error) : lang($setname.'_error')).'</span>';
	} else {
		$comment = lang($setname.'_comment', false);
	}
	 echo "$comment</td></tr>\n";
	return true;
}

function show_step($step) {
	echo <<<EOT
	<div class="left">		
		<div class="left_1"> 
				<p id="step1" class=""><b>1</b><span>授权协议</span></p>
		</div>
		
		<div class="left_2">
				<p id="step2" class=""><span>环境检查</span><b>2</b></p>
		</div>
		
		<div class="left_1" style="top:280px;">
				<p id="step3" class=""><b>3</b><span>填写配置</span></p>
		</div>
		
		<div class="left_2" style="top:350px;">
				<p id="step4" class=""><span>开始安装</span><b>4</b></p>
		</div>
	</div>
	
EOT;

	switch ($step){
		case '0':
			echo '	
				<script type="text/javascript">
					document.getElementById("step1").className="hover";
				</script>
			';
			break;
		case '1':
			echo '	
				<script type="text/javascript">
					document.getElementById("step2").className="hover";
				</script>
			';
			break;
		case '2':
			echo '	
				<script type="text/javascript">
					document.getElementById("step3").className="hover";
				</script>
			';
			break;
		
		case '3':
			echo '	
				<script type="text/javascript">
					document.getElementById("step4").className="hover";
				</script>
			';
			break;
	
	}

}

function lang($lang_key, $force = true) {
	return isset($GLOBALS['lang'][$lang_key]) ? $GLOBALS['lang'][$lang_key] : ($force ? $lang_key : '');
}

function dropproc(){
	global $lang, $db;
	$list_file='data/procedure.list';				
	$proc_list = file_get_contents($list_file);
	
	$list_arr =  explode(',', $proc_list);
	foreach($list_arr as $arr){
		if(!empty($arr)){
			$sql="drop procedure if exists ".$arr;
			$db->query($sql);		
			install_run_error('dropproc',$arr);
		}
	}		
}

function file_copy($source, $destination, $child){
	if(!is_dir($source)){
		echo("Error:the $source is not a direction!");
		return 0;
	}
	if(!is_dir($destination)){
		mkdir($destination,0777);
	}
	$handle=dir($source);
	while($entry=$handle->read()) {
		if(($entry!=".")&&($entry!="..")){
		    if(is_dir($source."/".$entry)){
			if($child){    
					file_copy($source."/".$entry,$destination."/".$entry,$child);
				}
			}else{
					copy($source."/".$entry,$destination."/".$entry);
			}
		}
	}
    return true;
}

function file_delete($del_dir, $child){

	$handle=dir($del_dir);
	while($entry=$handle->read()) {
		if(($entry!=".")&&($entry!="..")){
			    if(is_dir($del_dir."/".$entry)){
				if($child)    
					file_delete($del_dir."/".$entry,$child);					
			    }else{
				unlink($del_dir."/".$entry);
			    }
		}
    }
    return true;
}
function delete_attachment(){
	global $lang, $db,$dbname;
	$rs=$db->query('select * from '.$dbname.'.t_qsn_attachments');
	while($arr= mysql_fetch_assoc($rs)) {
		unlink(ROOT_PATH.'./'.$arr['attachment']);
		showjsmessage(lang('delete_attachment').'/'.$arr['attachment'] .lang('succeed'));
	}
	return true;
}

function clean_demo_data(){
	global $lang, $db,$dbname,$table_demo;
	
	// clean db according to t_demo 
	// check table t_demo according to pk for insert or delete
	// table t_demo struct below:
	//	|+column+|
	//	|+ id1 +|+id2+|+ id3 +|+id4 +| ....|+id10 +|+table_name+|
	
	$sql="SELECT DISTINCT table_name FROM  ".$dbname.".".$table_demo;
	$rs=$db->query($sql);
	
	while($rows = mysql_fetch_assoc($rs)) {
		
		// get demo data table's primary key
		 $rs_pk=$db->query("SHOW INDEX FROM  ".$rows['table_name']." FROM ".$dbname."  where Key_name='PRIMARY'");
		$pk_arr=array();
		while($pk = mysql_fetch_assoc($rs_pk)) {
			array_push($pk_arr,$pk['Column_name']);
		}
		// var_dump($pk_arr[10]);
		$del_sql='';
		$del_id='';
		$sel_id='';
		//make delete sql 		
		if(isset($pk_arr[0])){
			$sel_id.=' a.id1 ';
			$del_id.=' a.id1='.$pk_arr[0];
			
		}
		if(isset($pk_arr[1])){
			$sel_id.=' , a.id2 ';
			$del_id.=' and a.id2='.$pk_arr[1];
		}
		if(isset($pk_arr[2])){
			$sel_id.=', a.id3 ';
			$del_id.=' and a.id3='.$pk_arr[2];
		}
		if(isset($pk_arr[3])){
			$sel_id.=' , a.id4 ';
			$del_id.=' and a.id4='.$pk_arr[3];
		}
		if(isset($pk_arr[4])){
			$sel_id.=' , a.id5 ';
			$del_id.=' and a.id5='.$pk_arr[4];
		}
		if(isset($pk_arr[5])){
			$sel_id.=' , a.id6 ';
			$del_id.=' and a.id6='.$pk_arr[5];
		}
		if(isset($pk_arr[6])){
			$sel_id.=' , a.id7 ';
			$del_id.=' and a.id7='.$pk_arr[6];
		}
		if(isset($pk_arr[7])){
			$sel_id.=' , a.id8 ';
			$del_id.=' and a.id8='.$pk_arr[7];
		}
		if(isset($pk_arr[8])){
			$sel_id.=' , a.id9 ';
			$del_id.=' and a.id9='.$pk_arr[8];
		}
		if(isset($pk_arr[9])){
			$sel_id.=' , a.id10 ';
			$del_id.=' and a.id10='.$pk_arr[9];
		}

		$del_sql=	'delete from '.$dbname.'.'.$rows['table_name'].
						' where exists(
						select  ' .$sel_id.
						'  from  '.$table_demo.
						' a where '.$del_id.
											')
						';
		$db->query($del_sql);
		install_run_error('delete_demo_data',$del_sql);
	}
	return true;

}

