DROP PROCEDURE IF EXISTS `group_select_group_user`;
CREATE PROCEDURE  `group_select_group_user`(IN par_group_id INT(10))
begin
    set @strsql=concat('select group_id,user_id from t_user_group where group_id=','''',par_group_id,'''');
    prepare stmt from @strsql;
    execute stmt;

    deallocate prepare stmt;






          
end

DROP PROCEDURE IF EXISTS `group_single_info`;
CREATE PROCEDURE  `group_single_info`(IN par_group_id INT(10))
BEGIN
  set @strSQL=concat('select t.group_id,t.group_pid,t.group_name,t.group_desc from t_group t where t.group_id =','''',par_group_id,'''');
  prepare stmt from @strSQL;
  execute stmt;
  DEALLOCATE PREPARE stmt;






          
end

DROP PROCEDURE IF EXISTS `group_tree_select`;
CREATE PROCEDURE  `group_tree_select`(IN par_group_id INT(10), IN par_group_pid INT(10),IN par_search_flg TINYINT,IN par_user_id INT
)
begin

    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

  if par_search_flg =2 then
    select g.group_id,g.group_pid into @gid,@gpid
    from t_admin_group_user ug join t_group g on g.group_id=ug.group_id
    where ug.user_id=par_user_id;
    else
        set @gid=par_group_id;
    set @gpid=par_group_pid;
    end if;

    insert into tmp_group_tree(id,pid, level,position)
    values (@gid,@gpid,v_level,v_position);

    set v_row_count := row_count();

    while v_row_count != 0 do
        set @position := 0;
        insert into tmp_group_tree(id,pid,level,position)
        select g.group_id,g.group_pid,v_level + 1,@position := @position+1
        from t_group g inner join tmp_group_tree t on g.group_pid = t.id
        where t.level = v_level and g.group_id !='0' order by g.group_id;

        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;select r.group_id,r.group_pid,r.group_name  from
  (select distinct id,pid from tmp_group_tree) t,t_group r
            where t.pid=r.group_pid and t.id=r.group_id;

  truncate table tmp_group_tree;






          
end

DROP PROCEDURE IF EXISTS `group_user_select`;
CREATE PROCEDURE  `group_user_select`(IN par_group_id INT(10), IN par_group_pid INT(10),
IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin
  declare v_level int unsigned default 0;
  declare v_position int unsigned default 1;
  declare v_row_count int unsigned default 0;

insert into tmp_group_user_tree(id,pid,level,position)
values (par_group_id,par_group_pid,v_level,v_position);

set v_row_count := row_count();

while v_row_count != 0 do
  set @position := 0;
  insert into tmp_group_user_tree(id,pid,level,position)
  select g.group_id,g.group_pid, v_level + 1, @position := @position+1
  from t_group g
  inner join tmp_group_user_tree t on g.group_pid = t.id where t.level = v_level and g.group_id !='0' order by g.group_id;
  set v_row_count := row_count();
  set v_level := v_level + 1;
end while;

set @sql='select u.user_id,u.real_name,u.username,g.group_name,u.reg_tm,u.status
         from tmp_group_user_tree t join t_user_group r on t.id=r.group_id join t_user u on u.user_id=r.user_id
         join t_group g on g.group_id=r.group_id';

call pdo_pagination(@sql,par_page_idx,par_page_size,@mysql);

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;

truncate table tmp_group_user_tree;






          
end

DROP PROCEDURE IF EXISTS `group_user_select_page`;
CREATE PROCEDURE  `group_user_select_page`(
IN par_group_id INT(10),
IN par_group_pid INT(10),
IN par_search_flg TINYINT,
IN par_user_id INT(10),
IN par_page_idx int(10),
IN par_page_size int(10),
IN par_dept_name VARCHAR(50)
)
begin

	declare v_level int unsigned default 0;
	declare v_position int unsigned default 1;
	declare v_row_count int unsigned default 0;

  if par_search_flg =2 then
    select g.group_id,g.group_pid into @gid,@gpid
    from t_admin_group_user ug join t_group g on g.group_id=ug.group_id
    where ug.user_id=par_user_id;
	else
		set @gid=par_group_id;
    set @gpid=par_group_pid;
	end if;

	insert into tmp_group_tree(id,pid, level,position)
	values (@gid,@gpid,v_level,v_position);

	set v_row_count := row_count();

	while v_row_count != 0 do
		set @position := 0;
		insert into tmp_group_tree(id,pid,level,position)
		select g.group_id,g.group_pid,v_level + 1,@position := @position+1
		from t_group g inner join tmp_group_tree t on g.group_pid = t.id
		where t.level = v_level and g.group_id !='0' order by g.group_id;

		set v_row_count := row_count();
		set v_level := v_level + 1;
	end while;

	set @strsql=concat('select r.group_id,r.group_pid,r.group_name
						          from (select distinct id,pid from tmp_group_tree) t,t_group r
						          where t.pid=r.group_pid and t.id=r.group_id');

  if par_dept_name is not null then
	   	set @strsql=concat(@strsql,' and r.group_name like ','''%',par_dept_name,'%''');
	end if;

  call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

	prepare stmt from @mysql;
	execute stmt;
	deallocate prepare stmt;

	truncate table tmp_group_tree;





          
end

DROP PROCEDURE IF EXISTS `group_user_tree`;
CREATE PROCEDURE  `group_user_tree`(IN par_group_id INT(10), IN par_group_pid INT(10))
begin
declare v_level int unsigned default 0;
declare v_position int unsigned default 1;
declare v_row_count int unsigned default 0;

insert into tmp_group_user_tree2(id,pid, level,position)
values (par_group_id,par_group_pid,v_level,v_position);
set v_row_count := row_count();
while v_row_count != 0 do
    set @position := 0;
    insert into tmp_group_user_tree2(id,pid,level,position)
    select g.group_id,g.group_pid
    , v_level + 1
    , @position := @position+1
    from t_group g inner join tmp_group_user_tree2 t on g.group_pid = t.id
    where t.level = v_level and g.group_id !='0' order by g.group_id;
    set v_row_count := row_count();
    set v_level := v_level + 1;
end while;
select group_id,group_pid,group_name from (
select
g.group_id,g.group_pid,g.group_name
from tmp_group_user_tree2 t
left join t_user_group r on t.id=r.group_id
left join t_group g on g.group_pid=t.pid and g.group_id=t.id
union
select
concat('_',trim(u.user_id)),r.group_id,u.real_name
from tmp_group_user_tree2 t
left join t_user_group r on t.id=r.group_id
 join t_user u on u.user_id=r.user_id) x where x.group_id is not null ;
truncate table tmp_group_user_tree2;






          
end



