DROP PROCEDURE IF EXISTS `message_add`;
CREATE PROCEDURE  `message_add`(IN par_msg_id char(17), IN par_msg_title VARCHAR(100),
IN par_msg_content varchar(2000),IN par_sender_id int(10),IN par_recipients text,IN par_group_id INT(10),
IN par_group_pid INT(10),
IN par_arr_length int(10),OUT par_no_exists_user text
)
begin

  declare cur_string varchar(4000);
  declare uid varchar(20);
  declare i int(8) default 0;
  declare v_level int unsigned default 0;
  declare v_position int unsigned default 1;
  declare v_row_count int unsigned default 0;

  set @strsql='insert into t_message(msg_id,msg_title,msg_content,msg_folder,msg_status,sender_id,recipients_id,create_tm) ';
  set @strsql=concat(@strsql,' select ','''',par_msg_id,'''',',','''',par_msg_title,'''',',','''',par_msg_content,'''',',','''','inbox','''',',','''','040202','''',',','''',par_sender_id,'''',',u.user_id,sysdate()');

    if par_recipients is null then

        insert into tmp_group_user_tree(id,pid, level,position)
        values (par_group_id,par_group_pid,v_level,v_position);
        
        set v_row_count := row_count();
        while v_row_count != 0 do
          set @position := 0;
          insert into tmp_group_user_tree(id,pid,level,position)
          select g.group_id,g.group_pid
                , v_level + 1
            , @position := @position+1
          from t_group g
          inner join tmp_group_user_tree t  on g.group_pid = t.id   where t.level = v_level and g.group_id !='0'order by g.group_id;
          set v_row_count := row_count();
          set v_level := v_level + 1;
        end while;

        set @strsql=concat(@strsql,' from tmp_group_user_tree t,t_user_group r,t_user u where t.id=r.group_id and u.user_id=r.user_id  ');

    prepare stmt from @strsql;
        execute stmt;
        deallocate prepare stmt;
    truncate table tmp_group_user_tree;
    else
        if par_recipients is not null then
        set @uname='';set @noexists='';

              REPEAT SET i = i + 1;
                      set uid='';
                      set cur_string=SUBSTRING_INDEX(SUBSTRING_INDEX(par_recipients, ',', i), ',', -1);

                      if cur_string !='' then
                          select user_id into uid from t_user where username=cur_string;

              if trim(uid) !='' then
                              set @uname=concat(@uname,'''',cur_string,'''',',');
                          else
                              set @noexists=concat(@noexists,cur_string,',');
                          end if;
                      end if;
              UNTIL i >= par_arr_length END REPEAT;

            set @noexists=substring(@noexists,1,char_length(@noexists)-1);
            set par_no_exists_user=@noexists;

            set @uname=substring(@uname,1,char_length(@uname)-1);
            set @strsql=concat(@strsql,' from t_user u where u.username in(',@uname,')');

            if @uname !='' then
                prepare stmt from @strsql;
                execute stmt;
                deallocate prepare stmt;
            end if;
        end if;
    end if;

  
  
  
  
          
end

DROP PROCEDURE IF EXISTS `message_clear`;
CREATE PROCEDURE  `message_clear`(IN par_msg_clear_all varchar(10)
,IN par_msg_user_name text,IN par_msg_days int(10),
IN par_search_flg TINYINT,IN par_user_id INT(10),
IN par_msg_search_txt VARCHAR(100),IN par_msg_search_flg TINYINT(1),in par_arr_length int(10)
,OUT par_no_exists_user text)
L_END: begin

    declare cur_string varchar(4000);
    declare uid varchar(20);
    DECLARE i INT(8) DEFAULT 0;

    if par_msg_clear_all =1 then
            truncate table t_message;
    else
        set @strsql='delete from t_message where 1=1 and ';

        set @strsql3='';set @strsql4='';set @strsql5='';

        if par_msg_days is not null then
            set @strsql3=concat(' create_tm < concat(date_sub(curdate(),interval  ',par_msg_days,' day),\' 23:59:59\') and ');
        end if;

        if par_msg_user_name is not null  then
      set @uname='';set @noexists='';

      REPEAT SET i = i + 1;
        set cur_string=SUBSTRING_INDEX(SUBSTRING_INDEX(par_msg_user_name, ',', i), ',', -1);

        if trim(cur_string) !='' then
           select username into uid from t_user where username=cur_string;

           if uid is not null then
                        set @uname=concat(@uname,'''',uid,'''',',');
                   else
              set @noexists=concat(@noexists,cur_string,',');
                   end if;
        end if;
      UNTIL i >= par_arr_length END REPEAT;

            set @noexists=substring(@noexists,1,char_length(@noexists)-1);
            set par_no_exists_user=@noexists;

      if par_no_exists_user != '' then
        leave L_END;
      end if;

            set @uname=substring(@uname,1,char_length(@uname)-1);

            if @uname !='' then
                  set @strsql4=concat(' exists(select user_id from t_user u where (sender_id=u.user_id or recipients_id=u.user_id) and u.username in(',@uname,')) and ');
      else
        leave L_END;
      end if;
        end if;

        if par_msg_search_flg is not null and trim(par_msg_search_txt) is not null then
            if par_msg_search_flg =1 then
                    set @strsql5=concat(' msg_title like ','''',par_msg_search_txt,'%''',' and ');
                elseif par_msg_search_flg =2 then
                    set @strsql5=concat(' (msg_content like ','''',par_msg_search_txt,'%''',' or msg_title like ','''',par_msg_search_txt,'%''',') and ');
                end if;
        end if;

        set @strsql=concat(@strsql,@strsql3,@strsql4,@strsql5);         
        set @strsql=substring(@strsql,1,length(@strsql)-4);

    if par_search_flg =1 then
            set @strsql=concat(@strsql,' and sender_id =',par_user_id);
    elseif par_search_flg =2 then
            set @strsql=concat(@strsql,' and sender_id in(select user_id
                                                from t_user_group ug where group_id in(select group_id from t_user_group
                                            where user_id=',par_user_id,'))');
    end if;

      prepare stmt from @strsql;
    execute stmt;
      deallocate prepare stmt;
    end if;
  
  
  
  
          
end

DROP PROCEDURE IF EXISTS `message_delete`;
CREATE PROCEDURE  `message_delete`(IN par_msg_id char(17),IN par_recipients_id int(20),IN par_sender_id int(20),IN par_msg_folder varchar(20),IN par_msg_status varchar(20))
begin
set @strsql='delete from t_message where 1=1 ';

  if par_msg_id is not null then
            set @strsql=concat(@strsql,' and msg_id=',par_msg_id);
  end if;

  if par_recipients_id is not null then
            set @strsql=concat(@strsql,' and recipients_id=',par_recipients_id);
  end if;

  if par_sender_id is not null then
            set @strsql=concat(@strsql,' and sender_id=',par_sender_id);
  end if;

  if par_msg_folder is not null then
            set @strsql=concat(@strsql,' and msg_folder=','''',par_msg_folder,'''');
  end if;

  if par_msg_status is not null then
            set @strsql=concat(@strsql,' and msg_status=','''',par_msg_status,'''');
  end if;

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
          
end

DROP PROCEDURE IF EXISTS `message_preview`;
CREATE PROCEDURE  `message_preview`(IN par_msg_id char(17),IN par_recipients_id int(20),IN par_sender_id int(20),IN par_msg_folder varchar(20))
begin       
   select t.msg_title,t.create_tm,u1.username sender,u2.username recipients,t.msg_content,c.desc_cn status from t_message t,t_user u1,t_user u2,t_common_cde c
     where t.msg_id=par_msg_id and u1.user_id=t.sender_id and u2.user_id=t.recipients_id and t.msg_status=c.c_cde
           and t.recipients_id=par_recipients_id and t.sender_id=par_sender_id and msg_folder=par_msg_folder;  
  
  
  
  
          
end

DROP PROCEDURE IF EXISTS `message_search`;
CREATE PROCEDURE  `message_search`(IN par_msg_title varchar(100), IN par_msg_content text, 
IN par_msg_begin_tm VARCHAR(20),IN par_msg_end_tm varchar(20),
IN par_search_flg TINYINT,IN par_user_id INT(10),
IN par_page_idx int(11),IN par_page_size int(11))
begin
      declare v_level int unsigned default 0;
      declare v_position int unsigned default 1;
      declare v_row_count int unsigned default 0;

    set @strsql='select m.recipients_id,m.sender_id,m.msg_folder,m.msg_id,m.msg_title,m.msg_content,u1.username sender,
            u2.username recipients,m.create_tm,c.desc_cn status
            from t_message m join t_user u1 on u1.user_id=m.sender_id
            join t_user u2  on u2.user_id=m.recipients_id
            join t_common_cde c on c.c_cde=m.msg_status ';

        if par_search_flg =1 then
            set @strsql=concat(@strsql,' where m.sender_id =',par_user_id);
        elseif par_search_flg =2 then
      select g.group_id,g.group_pid into @gid,@gpid
      from t_admin_group_user ug join t_group g on g.group_id=ug.group_id
      where ug.user_id=par_user_id;

      insert into tmp_msg_group_tree(id,pid, level,position)
      values (@gid,@gpid,v_level,v_position);

      set v_row_count := row_count();

      while v_row_count != 0 do
          set @position := 0;
          insert into tmp_msg_group_tree(id,pid,level,position)
          select g.group_id,g.group_pid,v_level + 1,@position := @position+1
          from t_group g inner join tmp_msg_group_tree t on g.group_pid = t.id
          where t.level = v_level and g.group_id !='0' order by g.group_id;

          set v_row_count := row_count();
          set v_level := v_level + 1;
    end while;

          set @strsql=concat(@strsql,' where m.sender_id in(select user_id
          from t_admin_group_user ag join (select distinct id,pid from tmp_msg_group_tree) t1 on t1.id=ag.group_id)');

    else
      set @strsql=concat(@strsql,' where 1=1 ');
        end if;
            
        if par_msg_title is not null then
            set @strsql=concat(@strsql,' and m.msg_title like ','''',par_msg_title,'%''');
        end if;

        if par_msg_content is not null then
            set @strsql=concat(@strsql,' and m.msg_content like ','''',par_msg_content,'%''');
        end if;

        if par_msg_begin_tm is not null and par_msg_end_tm is not null then         
            set @strsql=concat(@strsql,' and m.create_tm between ','''',par_msg_begin_tm,'''',' and ','''',par_msg_end_tm,'''');
        end if;

        set @strsql=concat(@strsql,' order by m.create_tm desc');

        call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

        prepare stmt from @mysql;
        execute stmt;
        deallocate prepare stmt;

    if par_search_flg =2 then
      truncate table tmp_msg_group_tree;
    end if;
  
  
  
  
          
end



