DROP PROCEDURE IF EXISTS `monitor_broadcast_exam`;
CREATE PROCEDURE  `monitor_broadcast_exam`(IN par_exam_id char(32),IN par_content varchar(2000))
begin

  insert into t_exam_broadcast(exam_id,broadcast_content)values(par_exam_id,par_content);

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_exam_clear`;
CREATE PROCEDURE  `monitor_exam_clear`()
begin       
   update t_session set exam_id=null,exam_time=0,exam_cmd=null,exam_start_tm=0
   where exam_id is not null and exam_cmd !=1 and sysdate() > DATE_ADD(from_unixtime(exam_start_tm),INTERVAL exam_time*60 SECOND) and exam_time is not null;

   update t_session set exam_id=null,exam_time=0,exam_cmd=null,exam_start_tm=0
   where exam_id is not null  and sysdate() > DATE_ADD(from_unixtime(exam_start_tm),INTERVAL 24 HOUR) and exam_time is null;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_exam_search`;
CREATE PROCEDURE  `monitor_exam_search`(IN par_exam_name VARCHAR(1000),
IN par_exam_category VARCHAR(20),IN par_exam_bgn_tm datetime, IN par_exam_end_tm datetime,IN par_page_idx int(10),IN par_page_size int(10))
begin

    set @strsql=concat('select distinct e.exam_id,e.exam_name,c.desc_cn exam_category,e.exam_begin_tm,e.exam_end_tm,
                                        e.exam_total_tm,e.exam_user_count,t1.real_user_count,t2.submit_user,t3.exam_cmd
                                        from t_exam e
                    join t_session s on s.exam_id=e.exam_id
                                        left join (select count(*) real_user_count,s.exam_id
                                        from t_session s join t_exam e1 on s.exam_id is not null and s.exam_id=e1.exam_id
                                        group by s.exam_id) t1 on t1.exam_id=e.exam_id
                                        left join (select count(*) submit_user,ue.exam_id
                                        from t_user_exam ue join t_exam e1 on ue.exam_id=e1.exam_id
                                        group by ue.exam_id) t2 on t2.exam_id=e.exam_id
                                        join t_common_cde c on c.c_cde=e.exam_category
                    left join (select distinct exam_id,exam_cmd,sid from t_session) t3 on t3.exam_id=e.exam_id and t3.sid=s.sid
                                        where e.exam_status=','''','030301','''',' and e.exam_disable_monitor_flg =1');

    if par_exam_name is not null then
        set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
    end if;

    if par_exam_category is not null then
        set @strsql=concat(@strsql,' and e.exam_category=',par_exam_category);
    end if;

    if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
        set @strsql=concat(@strsql,' and e.exam_begin_tm >= ','''',par_exam_bgn_tm,'''',' and e.exam_end_tm <=','''',par_exam_end_tm,'''');
    else
        set @strsql=concat(@strsql,' and e.exam_begin_tm <=sysdate() and e.exam_end_tm >=sysdate()');
    end if;

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
  
    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_exam_user`;
CREATE PROCEDURE  `monitor_exam_user`(in par_exam_id char (32),in par_page_idx integer(10),in par_page_size integer(10))
begin
    set @strsql=concat('select u.user_id,u.username,u.real_name,g.group_name from
      t_user u
      left join t_user_group ug on ug.user_id=u.user_id
      left join t_group g on g.group_id=ug.group_id
      left join t_exam_group eg on eg.group_id=g.group_id and eg.exam_id=','''',par_exam_id,'''');

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_exam_user_examed`;
CREATE PROCEDURE  `monitor_exam_user_examed`(
in par_exam_id char (32),in par_page_idx integer(10),in par_page_size integer(10)
)
begin
    set @strsql=concat(' select u.user_id,u.username,u.real_name,g.group_name from t_user u
                                      join t_user_group ug on ug.user_id=u.user_id
                                      join t_group g on g.group_id=ug.group_id
                                      join t_user_exam s on s.user_id=u.user_id
                    and s.exam_id=','''',par_exam_id,'''');

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_exam_user_examing`;
CREATE PROCEDURE  `monitor_exam_user_examing`(
in par_exam_id char (32),in par_page_idx integer(10),in par_page_size integer(10)
)
begin
    set @strsql=concat(' select u.user_id,u.username,u.real_name,g.group_name,s.ip from t_user u
                                      join t_user_group ug on ug.user_id=u.user_id
                                      join t_group g on g.group_id=ug.group_id
                                      join t_session s on s.user_id=u.user_id
                                      where s.exam_id=','''',par_exam_id,'''');
    
    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_restart_exam`;
CREATE PROCEDURE  `monitor_restart_exam`(IN par_exam_id char(32))
begin

  update t_session set exam_cmd=null where exam_id=par_exam_id;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_restart_exam_user`;
CREATE PROCEDURE  `monitor_restart_exam_user`(IN par_exam_id char(32),IN par_user_id int(10),IN par_sid varchar(50))
begin

  update t_session set exam_cmd=null where exam_id=par_exam_id and user_id=par_user_id and sid=par_sid;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_stop_exam`;
CREATE PROCEDURE  `monitor_stop_exam`(IN par_exam_id char(32))
begin

  update t_session set exam_cmd='1' where exam_id=par_exam_id;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_stop_exam_user`;
CREATE PROCEDURE  `monitor_stop_exam_user`(IN par_exam_id char(32),IN par_user_id int(10),IN par_sid varchar(50))
begin

  update t_session set exam_cmd='1' where exam_id=par_exam_id and user_id= par_user_id and sid=par_sid;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_submit_exam`;
CREATE PROCEDURE  `monitor_submit_exam`(IN par_exam_id char(32))
begin

  update t_session set exam_cmd='0' where exam_id=par_exam_id;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_submit_exam_user`;
CREATE PROCEDURE  `monitor_submit_exam_user`(IN par_exam_id char(32),IN par_user_id int(10),IN par_sid varchar(50))
begin

  update t_session set exam_cmd=0 where exam_id=par_exam_id and user_id=par_user_id and sid=par_sid;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `monitor_user_search`;
CREATE PROCEDURE  `monitor_user_search`(IN par_exam_name VARCHAR(1000),
IN par_exam_category VARCHAR(20),IN par_exam_bgn_tm datetime,IN par_exam_end_tm datetime,IN par_real_name varchar(20)
,IN par_page_idx int(10),IN par_page_size int(10))
begin  

    set @strsql=concat('select  e.exam_id,e.exam_name,u.user_id,u.real_name,c.desc_cn exam_category,e.exam_begin_tm,e.exam_end_tm,
                                        e.exam_total_tm,t3.exam_cmd,s.ip,s.sid
                                        from t_exam e
                                        join t_session s on s.exam_id=e.exam_id
                    join t_user u on u.user_id=s.user_id
                                        join t_common_cde c on c.c_cde=e.exam_category
                    left join (select distinct exam_id,exam_cmd,sid from t_session) t3 on t3.exam_id=e.exam_id and t3.sid=s.sid
                                        where e.exam_status=','''','030301','''',' and e.exam_disable_monitor_flg =1');

    if par_exam_name is not null then
        set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
    end if;

    if par_exam_category is not null then
        set @strsql=concat(@strsql,' and e.exam_category=',par_exam_category);
    end if;

    if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
        set @strsql=concat(@strsql,' and e.exam_begin_tm >= ',par_exam_bgn_tm,' and e.exam_end_tm <=',par_exam_end_tm);
  else
    set @strsql=concat(@strsql,' and e.exam_begin_tm <=sysdate() and e.exam_end_tm >=sysdate()');
    end if;

    if par_real_name is not null  then
        set @strsql=concat(@strsql,' and u.real_name like ','''',par_real_name,'%''');
    end if;

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

  
  
  
  
  
  
        
end



