DROP PROCEDURE IF EXISTS `notice_add`;
CREATE PROCEDURE  `notice_add`(IN par_notice_status varchar(20), IN par_notice_title VARCHAR(100),IN par_notice_content text, IN par_create_user_id int(10))
begin  
    select group_id into @group_id from t_user_group t where t.user_id=par_create_user_id;
    insert into t_notice(notice_status,notice_title,notice_content,group_id,create_user_id,create_tm)
    values(par_notice_status,par_notice_title,par_notice_content,@group_id,par_create_user_id,sysdate());

  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `notice_delete`;
CREATE PROCEDURE  `notice_delete`(IN par_notice_id text)
begin
  set @strsql='delete from t_notice where notice_id in ';
  if par_notice_id is not null then
                set @strsql=concat(@strsql,'(',par_notice_id,')');
  end if;
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `notice_preview`;
CREATE PROCEDURE  `notice_preview`(IN par_notice_id char(17))
begin
    select notice_title,notice_id into @n_notice_title,@n_notice_id from t_notice where notice_id >par_notice_id and notice_status='040102' limit 1;
    select notice_title,notice_id into @p_notice_title,@p_notice_id from t_notice where notice_id <par_notice_id and notice_status='040102' order by notice_id desc limit 1;

    select notice_title,create_tm,u.username,notice_content,notice_click,
    @n_notice_title n_notice_title,@n_notice_id n_notice_id,@p_notice_title p_notice_title,@p_notice_id p_notice_id
    from t_notice t,t_user u where t.notice_id=par_notice_id and u.user_id=t.create_user_id;
    update t_notice set notice_click=notice_click+1 where notice_id=par_notice_id;


  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `notice_search`;
CREATE PROCEDURE  `notice_search`(IN par_notice_title varchar(100), 
IN par_notice_content text, IN par_notice_begin_tm varchar(20),IN par_notice_end_tm varchar(20),
IN par_notice_status VARCHAR(20),
IN par_search_flg TINYINT,IN par_user_id int(10),
IN par_page_idx int(11),IN par_page_size int(11))
begin       

    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

    set @strsql='select n.notice_id,n.notice_title,u.username,n.create_tm,c.desc_cn notice_status
            from t_notice n join t_user u on u.user_id=n.create_user_id
            join t_common_cde c on c.c_cde=n.notice_status ';
        
    if par_search_flg =1 then
            set @strsql=concat(@strsql,' where n.create_user_id =',par_user_id);
    elseif par_search_flg =2 then
      select g.group_id,g.group_pid into @gid,@gpid
      from t_admin_group_user ug join t_group g on g.group_id=ug.group_id
      where ug.user_id=par_user_id;

      insert into tmp_qsn_group_tree(id,pid, level,position)
      values (@gid,@gpid,v_level,v_position);

      set v_row_count := row_count();

        while v_row_count != 0 do
            set @position := 0;
            insert into tmp_qsn_group_tree(id,pid,level,position)
            select g.group_id,g.group_pid,v_level + 1,@position := @position+1
            from t_group g inner join tmp_qsn_group_tree t on g.group_pid = t.id
            where t.level = v_level and g.group_id !='0' order by g.group_id;

            set v_row_count := row_count();
            set v_level := v_level + 1;
      end while;

          set @strsql=concat(@strsql,' where n.create_user_id in(select user_id
          from t_admin_group_user ag join (select distinct id,pid from tmp_qsn_group_tree) t1 on t1.id=ag.group_id)');
    else
      set @strsql=concat(@strsql,' where 1=1 ');
        end if;

        if par_notice_title is not null then
            set @strsql=concat(@strsql,' and n.notice_title like ','''%',par_notice_title,'%''');
        end if;
    
        if par_notice_content is not null then
            set @strsql=concat(@strsql,' and n.notice_content like ','''%',par_notice_content,'%''');
        end if;

        if par_notice_begin_tm is not null and par_notice_end_tm is not null then
          set @strsql=concat(@strsql,' and n.create_tm between ','''',par_notice_begin_tm,'''',' and ','''',par_notice_end_tm,'''');
        end if;
        
        if par_notice_status is not null then
            set @strsql=concat(@strsql,' and n.notice_status =','''',par_notice_status,'''');
        end if;
        
        set @strsql=concat(@strsql,' order by n.create_tm desc');
        
    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    if par_search_flg =2 then
      truncate table tmp_qsn_group_tree;
    end if;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `notice_select_edit`;
CREATE PROCEDURE  `notice_select_edit`(IN par_notice_id char(17))
begin       
    select notice_title,notice_id,notice_content from t_notice where notice_id=par_notice_id;
 
  
  
  
  
  
  
  
      
end

DROP PROCEDURE IF EXISTS `notice_update`;
CREATE PROCEDURE  `notice_update`(IN par_notice_id char(17),IN par_notice_status varchar(20), IN par_notice_title VARCHAR(100),IN par_notice_content text, IN par_update_user_id int(10))
begin
    select group_id into @group_id from t_user_group t where t.user_id=par_update_user_id;
  if par_notice_status ='040102' then
    update t_notice set notice_title=par_notice_title,
    notice_status=par_notice_status,notice_content=par_notice_content,
    group_id=@group_id,update_user_id=par_update_user_id
    ,create_tm=sysdate()
    ,update_tm=sysdate() where notice_id=par_notice_id;
  else
    update t_notice set notice_title=par_notice_title,
    notice_status=par_notice_status,notice_content=par_notice_content,
    group_id=@group_id,update_user_id=par_update_user_id
    ,update_tm=sysdate() where notice_id=par_notice_id;
  end if;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `notice_update_status`;
CREATE PROCEDURE  `notice_update_status`(IN par_notice_id char(17), IN par_update_user_id int(10), IN par_notice_status varchar(20))
begin
  if par_notice_status ='040102' then
    update t_notice set notice_status=par_notice_status,
    update_user_id=par_update_user_id,create_tm=sysdate() where notice_id=par_notice_id;
  else
    update t_notice set notice_status=par_notice_status,
    update_user_id=par_update_user_id where notice_id=par_notice_id;
  end if;
 
  
  
  
  
  
  
        
end



