DROP PROCEDURE IF EXISTS `papr_add_paper`;
CREATE PROCEDURE  `papr_add_paper`(IN par_papr_id CHAR(32), IN par_papr_type VARCHAR(20),
IN par_papr_name VARCHAR(200), IN par_papr_point SMALLINT(6), IN par_papr_category VARCHAR(20),
 IN par_papr_des VARCHAR(4000), IN par_papr_qsn_count TINYINT(10), IN par_papr_status VARCHAR(20),
  IN par_create_user_id int(10))
begin

    insert into t_paper(papr_id,papr_type,papr_name,papr_point,papr_qsn_count,
        papr_status,papr_category,papr_des,create_tm,create_user_id)
    values(par_papr_id,par_papr_type,par_papr_name,par_papr_point,par_papr_qsn_count,par_papr_status,par_papr_category,
        par_papr_des,sysdate(),par_create_user_id);

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_add_paper_content`;
CREATE PROCEDURE  `papr_add_paper_content`(in par_papr_id char(32), in par_qsn_id char(32), in par_qsn_sub_id char(32), in par_qsn_point smallint(6), in par_qsn_type varchar(20),
in par_qsn_type_position int(4),in par_qsn_type_position_old int(4))
begin
declare e int(10) default 0;
declare p int(10) default 0;

select count(*) into e from t_papr_content t where t.qsn_sub_id =par_qsn_id and t.papr_id=par_papr_id;
select t.qsn_position into p from t_papr_content t where t.papr_id=par_papr_id and t.qsn_type_position=par_qsn_type_position order by t.qsn_position desc limit 1;

if e =0 then
set @strsql=concat('insert into t_papr_content(papr_id,qsn_id,qsn_sub_id,qsn_point,qsn_type,qsn_type_position
,qsn_type_position_old,create_tm,qsn_position) values(','''',par_papr_id,'''',',','''',par_qsn_id,'''',',','''',par_qsn_sub_id,'''',',',par_qsn_point,',','''',par_qsn_type,'''',
',',par_qsn_type_position,',',par_qsn_type_position_old,',sysdate(),',p+1,')');

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
call papr_update_qsn_count_point(par_papr_id);
end if;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_add_paper_qsn_type`;
CREATE PROCEDURE  `papr_add_paper_qsn_type`(in par_data text)
begin        
  set @strsql=concat('insert into t_papr_qsn_type(papr_id,qsn_point,qsn_type,qsn_type_title,qsn_type_label,
  qsn_type_position,qsn_type_position_old)  values ',par_data,'');
  prepare stmt from @strsql;  
  execute stmt;                 
  deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_add_paper_random_content`;
CREATE PROCEDURE  `papr_add_paper_random_content`(in par_papr_id char(32), in par_qsn_point smallint(6),
in par_qsn_type varchar(20), in par_qsn_type_position tinyint(4),in par_qsn_category varchar(20)
,in par_count int(10)
,in par_qsn_level varchar(20),
in par_qsn_level_count int(10),in par_qsn_status varchar(20),in par_qsn_type_position_old tinyint(4))
begin
set  @strsql=concat('insert into t_papr_content(papr_id,qsn_id,qsn_sub_id,qsn_point,qsn_type,qsn_type_position,qsn_type_position_old,create_tm)
select ','''',par_papr_id,'''',',','q.qsn_id,q.qsn_sub_id',',',par_qsn_point,',q.qsn_type,',par_qsn_type_position,',',par_qsn_type_position_old,
',sysdate() from t_question q where q.qsn_type=','''',par_qsn_type,'''',' and q.qsn_category=','''',par_qsn_category,'''');
set @strsql=concat(@strsql,' and q.qsn_status=','''',par_qsn_status,'''');

set @strsql=concat(@strsql,' and not exists(select * from t_papr_content pc where pc.papr_id=','''',par_papr_id,'''',' and pc.qsn_id=q.qsn_id and pc.qsn_sub_id=q.qsn_sub_id)');

if par_count =0 then
    set @strsql=concat(@strsql,' and q.qsn_level=','''',par_qsn_level,'''',' and q.qsn_sub_flg is null order by rand() limit ',par_qsn_level_count);
else
    set @strsql=concat(@strsql,' and q.qsn_sub_flg is null order by rand() limit ',par_count);
end if;

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
call papr_update_qsn_count_point(par_papr_id);
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_add_qsn_type`;
CREATE PROCEDURE  `papr_add_qsn_type`(in par_data text)
begin        
  set @strsql=concat('insert into t_papr_qsn_type(papr_id,qsn_point,qsn_type,qsn_type_title,qsn_type_label,
  qsn_type_position)  values ',par_data,'');
  prepare stmt from @strsql;  
  execute stmt;                 
  deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_analysis_paper`;
CREATE PROCEDURE  `papr_analysis_paper`(in par_exam_name varchar (200),
in par_papr_name varchar(200),
in par_exam_category varchar (20),IN par_exam_group_id int(10),IN par_exam_group_pid int(10),
in par_exam_bgn_tm varchar (20),
in par_exam_end_tm varchar (20),in par_page_idx int(10),in par_page_size int(10)
)
begin

    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
        
    if par_exam_group_id is not null and par_exam_group_pid is not null then
        
        insert into tmp_papr_analysis_paper_tree(id,pid, level,position)
        values (par_exam_group_id,par_exam_group_pid,v_level,v_position);

        set v_row_count := row_count();
        while v_row_count != 0 do
            set @position := 0;
            insert into tmp_papr_analysis_paper_tree(id,pid,level,position)
            select g.group_id,g.group_pid
            , v_level + 1
            , @position := @position+1
            from t_group g
            inner join tmp_papr_analysis_paper_tree t  on g.group_pid = t.id    where t.level = v_level and g.group_id !='0' order by g.group_id;

            set v_row_count := row_count();
            set v_level := v_level + 1;
        end while;

    end if;

set @strsql=concat('select e.exam_name,e.exam_id,p.papr_id,c.desc_cn exam_category,p.papr_name,concat(e.exam_begin_tm,\'--\',e.exam_end_tm) exam_tm
          from t_exam e join t_exam_papr ep on ep.exam_id=e.exam_id join t_paper p on p.papr_id=ep.papr_id');

if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''%',par_exam_name,'%''');
end if;
if par_papr_name is not null then
        set @strsql=concat(@strsql,' and p.papr_name like ','''%',par_papr_name,'%''');
end if;

set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category
                join t_user_exam ue on ue.exam_id=e.exam_id join t_user_group ug on ue.user_id=ug.user_id ');

if par_exam_group_id is not null then
        set @strsql=concat(@strsql,' join tmp_papr_analysis_paper_tree t on t.id=ug.group_id  ');
end if;

set @strsql=concat(@strsql,' group by e.exam_id,ep.papr_id,c.c_cde');

call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;

truncate table tmp_papr_analysis_paper_tree;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_analysis_paper_info`;
CREATE PROCEDURE  `papr_analysis_paper_info`(in par_papr_id char (32)
,in par_exam_id char(32)
)
begin
set @strsql=concat('select c.desc_cn papr_category,p.papr_qsn_count,q.qsn_level,c2.desc_cn qsn_level_name,
count(*) cnt,null qsn_type,null qsn_type_label,null exam_times,p.papr_name
from t_paper p
join t_common_cde c on c.c_cde=p.papr_category
join t_papr_content pc on pc.papr_id=p.papr_id');
if par_papr_id is not null then
    set @strsql=concat(@strsql,' and pc.papr_id=','''',par_papr_id,'''');
end if;
set @strsql=concat(@strsql,' join t_question q on q.qsn_id=pc.qsn_id and q.qsn_sub_id=pc.qsn_sub_id
join t_common_cde c2 on c2.c_cde=q.qsn_level
group by c.desc_cn,p.papr_qsn_count,q.qsn_level');
set @strsql=concat(@strsql, ' union ');
set @strsql=concat(@strsql,' select null papr_category,null papr_qsn_count,null qsn_level,null qsn_level_name,null cnt
,concat(pq.qsn_type,\'_\',pq.qsn_type_position) qsn_type,pq.qsn_type_label,null exam_times,p.papr_name
from t_paper p
join t_papr_qsn_type pq on pq.papr_id=p.papr_id');
if par_papr_id is not null then
    set @strsql=concat(@strsql,' and p.papr_id=','''',par_papr_id,'''');
end if;
set @strsql=concat(@strsql,' union select distinct null papr_category,null papr_qsn_count,null qsn_level,null qsn_level_name,null cnt
,null qsn_type,null qsn_type_label,u.exam_times,null papr_name from t_user_exam u ');
if par_papr_id is not null or par_exam_id is not null then
  set @strsql=concat(@strsql,' where ');
  if par_papr_id is not null then
    set @strsql=concat(@strsql,' u.papr_id=','''',par_papr_id,'''',' and ');
  end if;
  if par_exam_id is not null then
    set @strsql=concat(@strsql,' u.exam_id=','''',par_exam_id,'''',' and ');
  end if;
end if;
set @strsql=substr(@strsql,1,length(@strsql)-4);

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_analysis_qsn`;
CREATE PROCEDURE  `papr_analysis_qsn`(in par_exam_id char(32),in par_exam_times integer(10),in par_papr_id char (32)
,in par_qsn_label varchar(200),in par_qsn_type_position integer(10),in par_qsn_level varchar(20),in par_right_rate varchar(10),in par_pright_rate varchar(10),in par_error_rate varchar(10)
,in par_page_idx int(10),in par_page_size int(10))
begin


  declare v_level int unsigned default 0;
  declare v_position int unsigned default 1;
  declare v_row_count int unsigned default 0;

  insert into tmp_qsn_display_content_tree(id,pid, level,position)
  select qsn_id,
    qsn_sub_id,
    v_level,
    v_position
  from t_papr_content
  where papr_id = par_papr_id and qsn_type = '010107';

  set v_row_count := row_count();
  while v_row_count != 0 do
    set @position := 0;
    insert into tmp_qsn_display_content_tree(id,pid,level,position)
    select q.qsn_id,
      q.qsn_sub_id,
      v_level + 1,
      @position := @position+1
    from t_question q
    inner join tmp_qsn_display_content_tree t on q.qsn_id = t.pid
    where t.level = v_level;
    set v_row_count := row_count();
    set v_level := v_level + 1;
  end while;


    select count(*) into @cnt from t_user_exam i where i.exam_id=par_exam_id and i.papr_id=par_papr_id and i.exam_times=par_exam_times;

    set @strsql=concat('    select c.desc_cn qsn_type_name,t.qsn_type,
    pqt.qsn_type_label,q.qsn_id,q.qsn_sub_id,t.qsn_content_edit,concat(round(r1.r_cnt/',@cnt,',2)*100,\'%\') r_rate,
  concat(round(r3.pr_cnt/',@cnt,',2)*100,\'%\') pr_rate,concat(round(r2.e_cnt/',@cnt,',2)*100,\'%\') e_rate
    from t_user_exam_info q join t_question t on q.qsn_id=t.qsn_id and q.qsn_sub_id=t.qsn_sub_id and ');

    if par_qsn_label is not null and par_qsn_label !='010107' then
        set @strsql=concat(@strsql,' t.qsn_type =','''',par_qsn_label,'''',' and ');
    end if;

    if par_qsn_level is not null then
        set @strsql=concat(@strsql,' t.qsn_level=','''',par_qsn_level,'''',' and ');
    end if;

    if par_exam_times is not null then
    set @strsql=concat(@strsql,' q.exam_times=','''',par_exam_times,'''',' and ');
  end if;

    set @strsql=concat(@strsql,'    q.exam_id=','''',par_exam_id,'''',' and q.papr_id=','''',par_papr_id,'''',
    'left join t_papr_qsn_type pqt on pqt.papr_id=','''',par_papr_id,'''',' and q.qsn_type=pqt.qsn_type ');

  if par_qsn_type_position !=0 then
    set @strsql=concat(@strsql,' and pqt.qsn_type_position=',par_qsn_type_position);
  end if;

  set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=q.qsn_type ');

    set @strsql=concat(@strsql,'    left join
    (select count(*) r_cnt,i.qsn_id,i.qsn_sub_id from
    t_user_exam_info i where i.exam_id=','''',par_exam_id,'''',' and i.papr_id=','''',par_papr_id,'''',' and i.exam_times=','''',par_exam_times,'''','
    and i.answer_status=1 group by i.qsn_id,i.qsn_sub_id) r1 on r1.qsn_id=q.qsn_id and r1.qsn_sub_id=q.qsn_sub_id
    left join
    (select count(*) e_cnt,i.qsn_id,i.qsn_sub_id from
    t_user_exam_info i where i.exam_id=','''',par_exam_id,'''',' and i.papr_id=','''',par_papr_id,'''',' and i.exam_times=','''',par_exam_times,'''','
    and i.answer_status=0 group by i.qsn_id,i.qsn_sub_id
    ) r2
    on r2.qsn_id=q.qsn_id and r2.qsn_sub_id=q.qsn_sub_id
    left join 
    (select count(*) pr_cnt,i.qsn_id,i.qsn_sub_id from
    t_user_exam_info i where i.exam_id=','''',par_exam_id,'''',' and i.papr_id=','''',par_papr_id,'''',' and i.exam_times=',par_exam_times,'
    and i.answer_status=2 group by i.qsn_id,i.qsn_sub_id
    ) r3    on r3.qsn_id=q.qsn_id and r3.qsn_sub_id=q.qsn_sub_id');

  SET @strsql_temp = 'SELECT id, pid FROM tmp_qsn_display_content_tree WHERE q.qsn_id = id AND q.qsn_sub_id = pid';
  IF par_qsn_label = '010107' THEN
    SET @strsql = CONCAT(@strsql,' where exists(',@strsql_temp ,') group by q.qsn_id,q.qsn_sub_id');
  ELSE
    SET @strsql = CONCAT(@strsql, ' where not exists(',@strsql_temp ,') group by q.qsn_id,q.qsn_sub_id');
  END IF;

    if par_right_rate is not null then
        if par_right_rate =1 then
            set @strsql=concat(@strsql,' order by r_rate desc');
        else
            set @strsql=concat(@strsql,' order by r_rate');
        end if;
    end if;
    
    if par_pright_rate is not null then
        if par_pright_rate =1 then
            set @strsql=concat(@strsql,' order by pr_rate desc');
        else
            set @strsql=concat(@strsql,' order by pr_rate');
        end if;
    end if;

    if par_error_rate is not null then
        if par_error_rate =1 then
                set @strsql=concat(@strsql,' order by e_rate desc');
            else            
                set @strsql=concat(@strsql,' order by e_rate');
        end if;
    end if;

call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_qsn_display_content_tree;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_delete_paper`;
CREATE PROCEDURE  `papr_delete_paper`(IN par_papr_id TEXT)
begin
    
    set @strsql=concat('delete from t_paper where papr_id in (',par_papr_id,')');
    
    prepare stmt from @strsql;  
    execute stmt;
     deallocate prepare stmt;
     
    set @strsql1=concat('delete from t_papr_content where papr_id in (',par_papr_id,')');
    
    prepare stmt1 from @strsql1;  
    execute stmt1;
    deallocate prepare stmt1; 
            
    call papr_delete_qsn_type(par_papr_id);
     
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_delete_paper_content`;
CREATE PROCEDURE  `papr_delete_paper_content`(IN par_papr_id char(32), IN par_qsn_id TEXT, IN par_qsn_count TINYINT(4))
begin
    declare xsql varchar(200);
    declare sql_len integer(3);
    declare sql_pos tinyint(5);
    declare i tinyint(4);
    declare str_qsn_id char(32);
    
    set sql_len=length(par_qsn_id);
    set i=0;
    
    while i<par_qsn_count do
        set sql_pos=locate(',',par_qsn_id);
        
        if sql_pos !=0 then
            set @strsql=concat('delete from t_papr_content where papr_id=','''',par_papr_id,'''',' and ','qsn_id=','''',substring(par_qsn_id,1,sql_pos-1),'''');
            
            prepare stmt from @strsql;
            execute stmt;
        else            
            set @strsql=concat('delete from t_papr_content where papr_id=','''',par_papr_id,'''',' and ','qsn_id=','''',par_qsn_id,'''');
            
            prepare stmt from @strsql;
            execute stmt;
        end if;
        set par_qsn_id=substring(par_qsn_id,sql_pos+1,sql_len-sql_pos);
        set i=i+1;
    end while;
    
  deallocate prepare stmt;   
     
  call papr_update_qsn_count_point(par_papr_id);
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_delete_paper_qsn_type`;
CREATE PROCEDURE  `papr_delete_paper_qsn_type`(IN par_papr_id TEXT)
begin
    set @strsql=concat('delete from t_papr_qsn_type where papr_id in (',par_papr_id,')');
    
    prepare stmt from @strsql;  
    execute stmt;
     deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_delete_qsn_answer`;
CREATE PROCEDURE  `papr_delete_qsn_answer`(IN par_qsn_id CHAR(32),IN par_qsn_sub_id CHAR(32))
BEGIN

    set @strsql=concat('delete from t_answer where qsn_id=','''',par_qsn_id,'''',' and qsn_sub_id=','''',par_qsn_sub_id,'''');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_delete_qsn_type`;
CREATE PROCEDURE  `papr_delete_qsn_type`(IN par_papr_id TEXT)
begin
  set @strsql=concat('delete from t_papr_qsn_type where papr_id in (',par_papr_id,')');

    prepare stmt from @strsql;
    execute stmt;
  deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_display_exam_paper`;
CREATE PROCEDURE  `papr_display_exam_paper`(in par_exam_id char(32),in par_papr_id char (32),IN par_exam_times INTEGER(10), IN par_user_id int(10))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
    declare v_point_type varchar(20);

    select exam_point_type,exam_point into @v_point_type,@exam_point from t_exam where exam_id=par_exam_id;

    select count(*) into @s_cnt from t_user_exam_answer_storage
    where user_id=par_user_id and exam_id=par_exam_id and papr_id=par_papr_id and exam_times=par_exam_times;

    insert into tmp_papr_display_exam_papr_tree(id,pid,level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id and qsn_sub_id !='0';

    set v_row_count := row_count();

    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_papr_display_exam_papr_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_papr_display_exam_papr_tree t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

  if @scnt =0 then

    set @mysql='select x.papr_name,x.papr_des,x.papr_status,x.papr_point,x.papr_qsn_count,x.qsn_id,
       x.qsn_sub_id,r.qsn_point,x.qsn_content,x.option_content,null user_answer,x.qsn_item_tag,x.qsn_item_id,x.qsn_item_sub_id,
       x.qsn_type,x.qsn_type_title,x.qsn_type_label,x.qsn_type_position,x.pos,x.qsn_position,x.create_tm,x.sub_qsn_flg
       from (select tp.papr_name,tp.papr_des,
               tp.papr_status,
               tp.papr_point,
               tp.papr_qsn_count,
               tp.qsn_id,
               tp.qsn_sub_id,
               tp.qsn_content,
               tp.option_content,
               tp.qsn_item_tag,
               tp.qsn_item_id,
               tp.qsn_item_sub_id,
               tp.qsn_type,
               tp.qsn_type_title,
               tp.qsn_type_label,
               tp.qsn_type_position,
                         tp.qsn_position,
               tp.pos,
               tp.create_tm,
               NULL sub_qsn_flg from ( select t.papr_name,t.papr_des,
               t.papr_status,
               t.papr_point,
               t.papr_qsn_count,
               q.qsn_id,
               q.qsn_sub_id,
               q.qsn_content,
               o.option_content,
               o.qsn_item_tag,
               case
                 when o.qsn_item_id is null then
                  1
                 else
                  o.qsn_item_id
               end qsn_item_id,
               o.qsn_item_sub_id,
               p.qsn_type,
               p.qsn_type_title,p.qsn_type_label,';

              set @mysql= concat(@mysql,'concat(p.qsn_type_position,\'-\',q.qsn_sub_id)');
              set @mysql=concat(@mysql,' qsn_type_position,
               p.qsn_type_position pos,c.qsn_position,
               q.create_tm
          from t_paper t
          join t_papr_qsn_type p on t.papr_id = p.papr_id
          join t_papr_content c on p.papr_id = c.papr_id
                               and c.qsn_type_position = p.qsn_type_position
          join t_question q on c.qsn_id = q.qsn_id
                           and c.qsn_sub_id = q.qsn_sub_id
          left join t_option o on o.qsn_id = q.qsn_id   and o.qsn_sub_id=q.qsn_sub_id
          where t.papr_id=','''',par_papr_id,'''',') tp');
          set @mysql=concat(@mysql,' union
        select y.papr_name,null papr_des,y.papr_status,y.papr_point,y.papr_qsn_count,y.qsn_id,
               y.qsn_sub_id,y.qsn_content,y.option_content,y.qsn_item_tag,y.qsn_item_id,y.qsn_item_sub_id,
               y.qsn_type,y.qsn_type_title,y.qsn_type_label,');
          set @mysql= concat(@mysql,'concat(y.qsn_type_position,\'-\',y.qsn_id,\'-\',y.qsn_position) qsn_type_position,');
          set @mysql=concat(@mysql,'y.qsn_type_position pos,y.papr_qsn_position qsn_position,
               y.create_tm,
               y.flg sub_qsn_flg
               from (select null papr_name,null papr_des,null papr_status,
                       null papr_point,null papr_qsn_count,q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       o.option_content,
                       o.qsn_item_tag,
                       case
                         when o.qsn_item_id is null then
                          1
                         else
                          o.qsn_item_id
                       end qsn_item_id,
                       o.qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                                         cc.papr_qsn_position,
                       q.create_tm,
                     sp.flg
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_papr_display_exam_papr_tree t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id) q
                  left join (select c.qsn_type_position,c.qsn_position papr_qsn_position
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_papr_display_exam_papr_tree t
                              join t_papr_content c on t.id = c.qsn_id 
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                  left join t_option o on q.qsn_id = o.qsn_id and q.qsn_sub_id=o.qsn_sub_id
                left join (select distinct t1.qsn_id
            , case when t1.qsn_id is not null then 1 else 0 end flg from t_qsn_sub_position t1
            join tmp_papr_display_exam_papr_tree t2 on t2.id=t1.qsn_id
             ) sp on sp.qsn_id=q.qsn_sub_id and q.qsn_type in(\'010105\',\'010106\')
                 where cc.qsn_type_position is not null) y');
                 
    set @mysql=concat(@mysql,'  union
        select y.papr_name,y.papr_des,
               y.papr_status,
               y.papr_point,
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.option_content,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,
               y.qsn_type_label,
               tm.qsn_type_position,
               tm.pos,
                         tm.qsn_position,
               y.create_tm,
               NULL sub_qsn_flg
          from (select null papr_name,null papr_des,
                       null papr_status,
                       null papr_point,
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       null option_content,
                       null qsn_item_tag,
                       null qsn_item_id,
                       null qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_papr_display_exam_papr_tree t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                           and not exists(select o.qsn_id from t_option o where o.qsn_id=t.pid and o.qsn_sub_id=t.id)
                           ) q
                  left join (select c.qsn_type_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_papr_display_exam_papr_tree t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                  ) y,');
                  
        set @mysql=concat(@mysql,'(
               select n.qsn_sub_id,
                       concat(c1.qsn_type_position,
                              \'-\',
                              q1.qsn_id,
                              \'-\',
                              s1.qsn_position,
                              \'-\',
                              s2.qsn_position) as qsn_type_position,
                       c1.qsn_type_position pos,c1.qsn_position,
                       q1.create_tm
                  from t_question q1
                  join (select q.qsn_id, q.qsn_sub_id
                         from (select r.qsn_id,
                                      r.qsn_sub_id,
                                      t.id,
                                      r.qsn_content,
                                      r.qsn_type,
                                      s.qsn_position
                                 from tmp_papr_display_exam_papr_tree          t,
                                      t_question         r,
                                      t_qsn_sub_position s
                                where t.pid = r.qsn_id
                                  and t.id = r.qsn_sub_id
                                  and r.qsn_id = s.qsn_id
                                  and r.qsn_sub_id = s.qsn_sub_id) q
                         left join (select c.qsn_type_position,
                                          c.papr_id,
                                          c.qsn_sub_id
                                     from tmp_papr_display_exam_papr_tree t
                                     join t_papr_content c on t.id = c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                                     cc.qsn_sub_id
                        where cc.qsn_type_position is null) n on n.qsn_id =
                                                                 q1.qsn_sub_id
                  join t_papr_content c1 on c1.qsn_sub_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
                  join t_qsn_sub_position s1 on s1.qsn_id = q1.qsn_id
                                            and s1.qsn_sub_id = n.qsn_id
                  join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id');
                  
        set @mysql=concat(@mysql,' union
            select n.qsn_sub_id,
            concat(c1.qsn_type_position,\'-\',q1.qsn_sub_id,\'-\',s2.qsn_position,\'-1\') as qsn_type_position,
            c1.qsn_type_position pos,c1.qsn_position,q1.create_tm
            from t_question q1 join (
            select q.qsn_id,q.qsn_sub_id
            from (
                select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_content,r.qsn_type,s.qsn_position
                from tmp_papr_display_exam_papr_tree t,t_question r,t_qsn_sub_position s
                where t.pid=r.qsn_id and t.id=r.qsn_sub_id and r.qsn_id=s.qsn_id and r.qsn_sub_id=s.qsn_sub_id) q
                left join
                (select c.qsn_type_position,c.papr_id,c.qsn_sub_id  from tmp_papr_display_exam_papr_tree t
                join t_papr_content c on t.id=c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id=cc.qsn_sub_id
               join t_option o on o.qsn_id=q.qsn_id and o.qsn_sub_id=q.qsn_sub_id
                ) n on n.qsn_id=q1.qsn_sub_id
                join t_papr_content c1 on c1.qsn_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
            left join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id
                              ) tm
                     where y.qsn_sub_id = tm.qsn_sub_id
                     ) x ');

  else
    set @mysql='select x.papr_name,x.papr_des,x.papr_status,x.papr_point,x.papr_qsn_count,x.qsn_id,
       x.qsn_sub_id,r.qsn_point,x.qsn_content,x.option_content,x.user_answer,x.qsn_item_tag,x.qsn_item_id,x.qsn_item_sub_id,
       x.qsn_type,x.qsn_type_title,x.qsn_type_label,x.qsn_type_position,x.pos,x.qsn_position,x.create_tm,x.sub_qsn_flg
       from (select tp.papr_name,tp.papr_des,
               tp.papr_status,
               tp.papr_point,
               tp.papr_qsn_count,
               tp.qsn_id,
               tp.qsn_sub_id,
               tp.qsn_content,
               tp.option_content,
               tp.user_answer,
               tp.qsn_item_tag,
               tp.qsn_item_id,
               tp.qsn_item_sub_id,
               tp.qsn_type,
               tp.qsn_type_title,
               tp.qsn_type_label,
               tp.qsn_type_position,
               tp.pos,
                         tp.qsn_position,
               tp.create_tm,
               NULL sub_qsn_flg from (';

    set @mysql=concat(@mysql,'
    select t.papr_name,t.papr_des,
               t.papr_status,
               t.papr_point,
               t.papr_qsn_count,
               q.qsn_id,
               q.qsn_sub_id,
               q.qsn_content,
               s.user_answer,
               o.option_content,
               o.qsn_item_tag,
               case
                 when o.qsn_item_id is null then
                  1
                 else
                  o.qsn_item_id
               end qsn_item_id,
               o.qsn_item_sub_id,
               p.qsn_type,
               p.qsn_type_title,p.qsn_type_label,concat(p.qsn_type_position,\'-\',q.qsn_sub_id) qsn_type_position,
               p.qsn_type_position pos,c.qsn_position,
               q.create_tm
          from t_paper t
          join t_papr_qsn_type p on t.papr_id = p.papr_id
          join t_papr_content c on p.papr_id = c.papr_id
                               and c.qsn_type_position = p.qsn_type_position
          join t_question q on c.qsn_id = q.qsn_id and c.qsn_sub_id = q.qsn_sub_id and q.qsn_type =\'010102\'
                    left join t_option o on o.qsn_id = q.qsn_id   and o.qsn_sub_id=q.qsn_sub_id
                    left join t_user_exam_answer_storage s on s.exam_id=','''',par_exam_id,'''',' and s.papr_id=t.papr_id and s.exam_times=',par_exam_times,'
                                        and s.qsn_id=q.qsn_id and s.qsn_sub_id=q.qsn_sub_id and o.qsn_item_id=s.qsn_item_id and s.user_id=',par_user_id,'
          
          where t.papr_id=','''',par_papr_id,'''');
          
    set @mysql=concat(@mysql,' union ');
    set @mysql=concat(@mysql,' select t.papr_name,t.papr_des,
               t.papr_status,
               t.papr_point,
               t.papr_qsn_count,
               q.qsn_id,
               q.qsn_sub_id,
               q.qsn_content,
               s.user_answer,
               o.option_content,
               o.qsn_item_tag,
               case
                 when o.qsn_item_id is null then
                  1
                 else
                  o.qsn_item_id
               end qsn_item_id,
               o.qsn_item_sub_id,
               p.qsn_type,
               p.qsn_type_title,p.qsn_type_label,concat(p.qsn_type_position,\'-\',q.qsn_sub_id) qsn_type_position,
               p.qsn_type_position pos,c.qsn_position,
               q.create_tm
          from t_paper t
          join t_papr_qsn_type p on t.papr_id = p.papr_id
          join t_papr_content c on p.papr_id = c.papr_id
                               and c.qsn_type_position = p.qsn_type_position
          join t_question q on c.qsn_id = q.qsn_id and c.qsn_sub_id = q.qsn_sub_id and q.qsn_type !=\'010102\'
                    left join t_option o on o.qsn_id = q.qsn_id   and o.qsn_sub_id=q.qsn_sub_id
                    left join t_user_exam_answer_storage s on s.exam_id=','''',par_exam_id,'''',' and s.papr_id=t.papr_id and s.exam_times=',par_exam_times,'
                                        and s.qsn_id=q.qsn_id and s.qsn_sub_id=q.qsn_sub_id and s.qsn_item_id=o.qsn_item_id and s.user_id=',par_user_id,'           
          where t.papr_id=','''',par_papr_id,'''',') tp');
          
          set @mysql=concat(@mysql,' union
        select y.papr_name,null papr_des,y.papr_status,y.papr_point,y.papr_qsn_count,y.qsn_id,
               y.qsn_sub_id,y.qsn_content,y.option_content,y.user_answer,y.qsn_item_tag,y.qsn_item_id,y.qsn_item_sub_id,
               y.qsn_type,y.qsn_type_title,y.qsn_type_label,');
          set @mysql= concat(@mysql,'concat(y.qsn_type_position,\'-\',y.qsn_id,\'-\',y.qsn_position) qsn_type_position,');
          set @mysql=concat(@mysql,'y.qsn_type_position pos,y.papr_qsn_position qsn_position,
               y.create_tm,
               y.flg sub_qsn_flg
               from (select null papr_name,null papr_des,null papr_status,
                       null papr_point,null papr_qsn_count,q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       o.option_content,
                                         s.user_answer,
                       o.qsn_item_tag,
                       case
                         when o.qsn_item_id is null then
                          1
                         else
                          o.qsn_item_id
                       end qsn_item_id,
                       o.qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,cc.papr_qsn_position,
                       q.create_tm,
                     sp.flg
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_papr_display_exam_papr_tree t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id) q                                                      
                  left join (select c.qsn_type_position,c.qsn_position papr_qsn_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_papr_display_exam_papr_tree t
                              join t_papr_content c on t.id = c.qsn_id 
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                  left join t_option o on q.qsn_id = o.qsn_id and q.qsn_sub_id=o.qsn_sub_id
                                left join t_user_exam_answer_storage s on s.exam_id=','''',par_exam_id,'''',' and s.papr_id=cc.papr_id and s.exam_times=',par_exam_times,'
                                                          and s.qsn_id=q.qsn_id and s.qsn_sub_id=q.qsn_sub_id and o.qsn_item_id=s.qsn_item_id and s.user_id=',par_user_id,'
                left join (select distinct t1.qsn_id
            , case when t1.qsn_id is not null then 1 else 0 end flg from t_qsn_sub_position t1
            join tmp_papr_display_exam_papr_tree t2 on t2.id=t1.qsn_id
             ) sp on sp.qsn_id=q.qsn_sub_id and q.qsn_type in(\'010105\',\'010106\')
                 where cc.qsn_type_position is not null) y');
                 
    set @mysql=concat(@mysql,'  union
        select y.papr_name,y.papr_des,
               y.papr_status,
               y.papr_point,
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,                           
               y.option_content,
                         y.user_answer,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,
               y.qsn_type_label,
               tm.qsn_type_position,
               tm.pos,tm.qsn_position,
               y.create_tm,
               NULL sub_qsn_flg
          from (select null papr_name,null papr_des,
                       null papr_status,
                       null papr_point,
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                                         s.user_answer,
                       null option_content,
                       null qsn_item_tag,
                       null qsn_item_id,
                       null qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_papr_display_exam_papr_tree t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                           and not exists(select o.qsn_id from t_option o where o.qsn_id=t.pid and o.qsn_sub_id=t.id)
                           ) q
                  left join (select c.qsn_type_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_papr_display_exam_papr_tree t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                                    left join t_user_exam_answer_storage s on s.exam_id=','''',par_exam_id,'''',' and s.papr_id=cc.papr_id and s.exam_times=',par_exam_times,'
                                                          and s.qsn_id=q.qsn_id and s.qsn_sub_id=q.qsn_sub_id and s.user_id=',par_user_id,'
                                                                             
                  ) y,');
                  
        set @mysql=concat(@mysql,'(
               select n.qsn_sub_id,
                       concat(c1.qsn_type_position,
                              \'-\',
                              q1.qsn_id,
                              \'-\',
                              s1.qsn_position,
                              \'-\',
                              s2.qsn_position) as qsn_type_position,
                       c1.qsn_type_position pos,c1.qsn_position,
                       q1.create_tm
                  from t_question q1
                  join (select q.qsn_id, q.qsn_sub_id
                         from (select r.qsn_id,
                                      r.qsn_sub_id,
                                      t.id,
                                      r.qsn_content,
                                      r.qsn_type,
                                      s.qsn_position
                                 from tmp_papr_display_exam_papr_tree          t,
                                      t_question         r,
                                      t_qsn_sub_position s
                                where t.pid = r.qsn_id
                                  and t.id = r.qsn_sub_id
                                  and r.qsn_id = s.qsn_id
                                  and r.qsn_sub_id = s.qsn_sub_id) q
                         left join (select c.qsn_type_position,
                                          c.papr_id,
                                          c.qsn_sub_id
                                     from tmp_papr_display_exam_papr_tree t
                                     join t_papr_content c on t.id = c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                                     cc.qsn_sub_id
                        where cc.qsn_type_position is null) n on n.qsn_id =
                                                                 q1.qsn_sub_id
                  join t_papr_content c1 on c1.qsn_sub_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
                  join t_qsn_sub_position s1 on s1.qsn_id = q1.qsn_id
                                            and s1.qsn_sub_id = n.qsn_id
                  join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id');
                  
        set @mysql=concat(@mysql,' union
            select n.qsn_sub_id,
            concat(c1.qsn_type_position,\'-\',q1.qsn_sub_id,\'-\',s2.qsn_position,\'-1\') as qsn_type_position,
            c1.qsn_type_position pos,c1.qsn_position,q1.create_tm
            from t_question q1 join (
            select q.qsn_id,q.qsn_sub_id
            from (
                select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_content,r.qsn_type,s.qsn_position
                from tmp_papr_display_exam_papr_tree t,t_question r,t_qsn_sub_position s
                where t.pid=r.qsn_id and t.id=r.qsn_sub_id and r.qsn_id=s.qsn_id and r.qsn_sub_id=s.qsn_sub_id) q
                left join
                (select c.qsn_type_position,c.papr_id,c.qsn_sub_id  from tmp_papr_display_exam_papr_tree t
                join t_papr_content c on t.id=c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id=cc.qsn_sub_id
               join t_option o on o.qsn_id=q.qsn_id and o.qsn_sub_id=q.qsn_sub_id
                ) n on n.qsn_id=q1.qsn_sub_id
                join t_papr_content c1 on c1.qsn_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
            left join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id
                              ) tm
                     where y.qsn_sub_id = tm.qsn_sub_id
                     ) x ');

  end if;

    if @v_point_type='030202' then
        set @mysql2=' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                               from tmp_papr_display_exam_papr_tree t, t_question r, t_qsn_sub_position s
                              where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ';
        set @mysql2=concat(@mysql2,') q');
                              
        set @mysql2=concat(@mysql2,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_papr_display_exam_papr_tree t  join t_papr_content c on t.id = c.qsn_id');

        if par_papr_id is not null then
            set @mysql2=concat(@mysql2,' where c.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql2=concat(@mysql2,' ) cc on q.qsn_id =cc.qsn_sub_id');
        set @mysql2=concat(@mysql2,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
                            from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
        if par_papr_id is not null then
            set @mysql2=concat(@mysql2,' and t.papr_id=','''',par_papr_id,'''');
        end if;
    elseif @v_point_type='030201' then
        set @mysql2=concat('left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_papr_display_exam_papr_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_papr_display_exam_papr_tree t,t_qsn_sub_position s
            where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_papr_display_exam_papr_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_papr_display_exam_papr_tree t,t_qsn_sub_position s
            where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_papr_display_exam_papr_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_papr_display_exam_papr_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_papr_display_exam_papr_tree t,t_qsn_sub_position s
            where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_papr_display_exam_papr_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_papr_display_exam_papr_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
        union
        select r.qsn_id, r.qsn_sub_id, p.qsn_point
           from t_papr_content t
           join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type=p.qsn_type and t.qsn_type_position=p.qsn_type_position
           join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
           where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'');
           
    elseif @v_point_type='030203' then
        select a.papr_qsn_count into @qsn_count from t_exam e
        join t_exam_papr p on e.exam_id=p.exam_id and e.exam_id=par_exam_id
        join t_paper a on a.papr_id=p.papr_id;

        set @q_point=round(@exam_point/@qsn_count,2);

        set @mysql2=concat('left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_papr_display_exam_papr_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_papr_display_exam_papr_tree t,t_qsn_sub_position s
            where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_papr_display_exam_papr_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_papr_display_exam_papr_tree t,t_qsn_sub_position s
            where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_papr_display_exam_papr_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_papr_display_exam_papr_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_papr_display_exam_papr_tree t,t_qsn_sub_position s
            where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_papr_display_exam_papr_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_papr_display_exam_papr_tree t,t_qsn_sub_position s
            where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
                     union
                    select r.qsn_id, r.qsn_sub_id, @q_point
           from t_papr_content t
           join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type=p.qsn_type and t.qsn_type_position=p.qsn_type_position
           join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
           where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'');

    end if;

  set @mysql2=concat(@mysql2,') r on x.qsn_id=r.qsn_id and x.qsn_sub_id=r.qsn_sub_id');
  set @mysql=concat(@mysql,@mysql2);
  set @mysql=concat(@mysql,' order by x.pos,x.qsn_type_position,cast(x.qsn_position as unsigned)');
  
  prepare stmt from @mysql;
  execute stmt;
  deallocate prepare stmt;
  truncate table tmp_papr_display_exam_papr_tree;

  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_display_full_answer`;
CREATE PROCEDURE  `papr_display_full_answer`(IN par_papr_id CHAR(32))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
    declare v_point_type varchar(20);
    set @mysql2='';

    insert into tmp_papr_answer(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id and qsn_sub_id !='0';

    set v_row_count := row_count();

    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_papr_answer(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_papr_answer t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

set @mysql='select x.papr_name,x.papr_des,x.papr_status,
       x.papr_qsn_count,
       x.qsn_id,
       x.qsn_sub_id,
       r.qsn_point,
       x.qsn_content,
       x.qsn_guide,
       x.option_content,
       x.qsn_item_tag,
       x.qsn_item_id,
       x.qsn_item_sub_id,
       x.qsn_type,
       x.qsn_type_title,
       x.qsn_type_label,
       x.qsn_type_position,
       x.pos,
       x.qsn_position,
       x.create_tm,
       a.qsn_answer,
       x.sub_qsn_flg
  from (
  select
tp.papr_name,tp.papr_des,
               tp.papr_status,              
               tp.papr_qsn_count,
               tp.qsn_id,
               tp.qsn_sub_id,
               tp.qsn_content,
               tp.qsn_guide,
               tp.option_content,
               tp.qsn_item_tag,
               tp.qsn_item_id,
               tp.qsn_item_sub_id,
               tp.qsn_type,
               tp.qsn_type_title,
               tp.qsn_type_label,
               tp.qsn_type_position,
               tp.pos,
               tp.qsn_position,
               tp.create_tm,
           NULL sub_qsn_flg from (
select t.papr_name,t.papr_des,
               t.papr_status,             
               t.papr_qsn_count,
               q.qsn_id,
               q.qsn_sub_id,
               q.qsn_content_edit qsn_content,
               q.qsn_guide,
               o.option_content_edit option_content,
               o.qsn_item_tag,
               case
                 when o.qsn_item_id is null then
                  1
                 else
                  o.qsn_item_id
               end qsn_item_id,
               o.qsn_item_sub_id,
               p.qsn_type,
               p.qsn_type_title,p.qsn_type_label,';
              set @mysql= concat(@mysql,'concat(p.qsn_type_position,\'-\',q.qsn_sub_id) qsn_type_position,');
              set @mysql=concat(@mysql,'
               p.qsn_type_position pos,c.qsn_position,
               q.create_tm
          from t_paper t                   
          join t_papr_qsn_type p on t.papr_id = p.papr_id
          join t_papr_content c on p.papr_id = c.papr_id
                               and p.qsn_type = c.qsn_type
                               and c.qsn_type_position = p.qsn_type_position
          join t_question q on c.qsn_id = q.qsn_id
                           and c.qsn_sub_id = q.qsn_sub_id
          left join t_option o on o.qsn_id = q.qsn_id   and o.qsn_sub_id=q.qsn_sub_id
          where t.papr_id=','''',par_papr_id,'''','
           ) tp  ');
          set @mysql=concat(@mysql,' union
        select y.papr_name,y.papr_des,
               y.papr_status,              
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.qsn_guide,
               y.option_content,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,y.qsn_type_label,');
          set @mysql= concat(@mysql,'concat(y.qsn_type_position,\'-\',y.qsn_id,\'-\',y.qsn_position) qsn_type_position,');
          set @mysql=concat(@mysql,'y.qsn_type_position pos,y.qsn_position,
               y.create_tm
               ,y.flg sub_qsn_flg
               from (select null papr_name,null papr_des,
                       null papr_status,                     
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       o.option_content_edit option_content,
                       o.qsn_item_tag,
                       case
                         when o.qsn_item_id is null then
                          1
                         else
                          o.qsn_item_id
                       end qsn_item_id,
                       o.qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm
                    ,sp.flg
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content_edit qsn_content,
                               r.qsn_guide,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_papr_answer t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id) q
                  left join (select c.qsn_type_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_papr_answer t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                  left join t_option o on q.qsn_id = o.qsn_id and q.qsn_sub_id=o.qsn_sub_id             
                left join (select distinct t1.qsn_id
            , case when t1.qsn_id is not null then 1 else 0 end flg from t_qsn_sub_position t1
            join tmp_papr_answer t2 on t2.id=t1.qsn_id
             ) sp on sp.qsn_id=q.qsn_sub_id and q.qsn_type in(\'010105\',\'010106\')
                 where cc.qsn_type_position is not null) y');
    set @mysql=concat(@mysql,'  union
        select y.papr_name,y.papr_des,
               y.papr_status,            
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.qsn_guide,
               y.option_content,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,y.qsn_type_label,
               tm.qsn_type_position,
               tm.pos,
               tm.qsn_position,
               y.create_tm
               ,NULL sub_qsn_flg
          from (select null papr_name,null papr_des,
                       null papr_status,                     
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       null option_content,
                       null qsn_item_tag,
                       null qsn_item_id,
                       null qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm                       
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content_edit qsn_content,
                               r.qsn_guide,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_papr_answer t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                           and not exists(select o.qsn_id from t_option o where o.qsn_id=t.pid and o.qsn_sub_id=t.id)
                           ) q
                  left join (select c.qsn_type_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_papr_answer t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =cc.qsn_sub_id) y,');
        set @mysql=concat(@mysql,'(
               select n.qsn_sub_id,
                       concat(c1.qsn_type_position,
                              \'-\',
                              q1.qsn_id,
                              \'-\',
                              s1.qsn_position,
                              \'-\',
                              s2.qsn_position) as qsn_type_position,
                       c1.qsn_type_position pos,c1.qsn_position,
                       q1.create_tm
                  from t_question q1
                  join (select q.qsn_id, q.qsn_sub_id
                         from (select r.qsn_id,
                                      r.qsn_sub_id,
                                      t.id,
                                      r.qsn_content_edit qsn_content,
                                      r.qsn_type,
                                      s.qsn_position
                                 from tmp_papr_answer          t,
                                      t_question         r,
                                      t_qsn_sub_position s
                                where t.pid = r.qsn_id
                                  and t.id = r.qsn_sub_id
                                  and r.qsn_id = s.qsn_id
                                  and r.qsn_sub_id = s.qsn_sub_id) q
                         left join (select c.qsn_type_position,
                                          c.papr_id,
                                          c.qsn_sub_id
                                     from tmp_papr_answer t
                                     join t_papr_content c on t.id = c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                                     cc.qsn_sub_id
                        where cc.qsn_type_position is null) n on n.qsn_id =
                                                                 q1.qsn_sub_id
                  join t_papr_content c1 on c1.qsn_sub_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
                  join t_qsn_sub_position s1 on s1.qsn_id = q1.qsn_id
                                            and s1.qsn_sub_id = n.qsn_id
                  join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id');
        set @mysql=concat(@mysql,' union
                    select n.qsn_sub_id,
                    concat(c1.qsn_type_position,\'-\',q1.qsn_sub_id,\'-\',s2.qsn_position,\'-1\') as qsn_type_position,
                    c1.qsn_type_position pos,c1.qsn_position,q1.create_tm
                    from t_question q1 join (
                    select q.qsn_id,q.qsn_sub_id
                    from
                        (
                        select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_content_edit qsn_content,r.qsn_type,s.qsn_position
                        from tmp_papr_answer t,t_question r,t_qsn_sub_position s
                        where t.pid=r.qsn_id and t.id=r.qsn_sub_id and r.qsn_id=s.qsn_id and r.qsn_sub_id=s.qsn_sub_id) q
                        left join
                        (select c.qsn_type_position,c.papr_id,c.qsn_sub_id  from tmp_papr_answer t
                        join t_papr_content c on t.id=c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id=cc.qsn_sub_id
                       join t_option o on o.qsn_id=q.qsn_id and o.qsn_sub_id=q.qsn_sub_id
                        ) n on n.qsn_id=q1.qsn_sub_id
                        join t_papr_content c1 on c1.qsn_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
                    left join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id
                                      ) tm
         where y.qsn_sub_id = tm.qsn_sub_id

         ) x  ');

    set @mysql=concat(@mysql,' left join (
        select t.qsn_id,t.qsn_sub_id,group_concat(t.qsn_answer SEPARATOR \'__\') qsn_answer
        from t_answer t
        left join t_papr_content pc
        on pc.qsn_id=t.qsn_id and pc.qsn_sub_id=t.qsn_sub_id and pc.papr_id=','''',par_papr_id,'''',' group by t.qsn_id,t.qsn_sub_id
        ) a on a.qsn_id = x.qsn_id and a.qsn_sub_id = x.qsn_sub_id');

set @mysql2=concat(' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id
and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

union
select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
from (
select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
)p7 join tmp_papr_answer p8 on p8.id=p7.qsn_id
group by p8.pid,p8.id

union

select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
(
select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
) pp
join tmp_papr_answer p3  on p3.pid=pp.qsn_sub_id
join (
select s.qsn_id,count(*) cnt from tmp_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

             union
            select r.qsn_id, r.qsn_sub_id, p.qsn_point
   from t_papr_content t
   join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type=p.qsn_type
   and p.qsn_type_position=t.qsn_type_position
   join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
   where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'');

    set @mysql2=concat(@mysql2,') r on r.qsn_id=x.qsn_id and r.qsn_sub_id=x.qsn_sub_id');

    set @mysql=concat(@mysql,@mysql2);

    set @mysql=concat(@mysql,' group by x.papr_name,x.papr_status,x.papr_qsn_count,x.qsn_id,x.qsn_sub_id,r.qsn_point,
           x.qsn_content,x.qsn_item_id,x.qsn_item_sub_id,x.option_content,x.qsn_item_tag,x.qsn_type,x.qsn_type_title,x.qsn_type_position,
           x.pos,x.create_tm,x.sub_qsn_flg');

    set @mysql=concat(@mysql,' order by x.pos,x.qsn_type_position,cast(x.qsn_position as unsigned)');

  prepare stmt from @mysql;
  execute stmt;
  deallocate prepare stmt;
  truncate table tmp_papr_answer;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_display_paper`;
CREATE PROCEDURE  `papr_display_paper`(in par_papr_id char (32))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

  set @mysql2='';

    insert into tmp_preview_papr(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id;

    set v_row_count := row_count();

    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_preview_papr(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_preview_papr t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

set @mysql='';
set @mysql=concat(@mysql,'select x.papr_name,x.papr_des,
       x.papr_status,
       x.papr_point,
       x.papr_qsn_count,
       x.qsn_id,
       x.qsn_sub_id,
       r.qsn_point,
       x.qsn_content,
       x.option_content,
       x.qsn_item_tag,
       x.qsn_item_id,
       x.qsn_item_sub_id,
       x.qsn_type,
       x.qsn_type_title,
       x.qsn_type_label,
       x.qsn_type_position,
       x.pos,
       x.qsn_position,
       x.create_tm,
       x.sub_qsn_flg
  from (
  select
tp.papr_name,tp.papr_des,
               tp.papr_status,
               tp.papr_point,
               tp.papr_qsn_count,
               tp.qsn_id,
               tp.qsn_sub_id,
               tp.qsn_content,
               tp.option_content,
               tp.qsn_item_tag,
               tp.qsn_item_id,
               tp.qsn_item_sub_id,
               tp.qsn_type,
               tp.qsn_type_title,
               tp.qsn_type_label,
               tp.qsn_type_position,
               tp.pos,
               tp.qsn_position,
               tp.create_tm,
          NULL sub_qsn_flg from (
select t.papr_name,t.papr_des,
               t.papr_status,
               t.papr_point,
               t.papr_qsn_count,
               q.qsn_id,
               q.qsn_sub_id,
               q.qsn_content,
               o.option_content,
               o.qsn_item_tag,
               case
                 when o.qsn_item_id is null then
                  1
                 else
                  o.qsn_item_id
               end qsn_item_id,
               o.qsn_item_sub_id,
               p.qsn_type,
               p.qsn_type_title,p.qsn_type_label,');
              set @mysql= concat(@mysql,'concat(p.qsn_type_position,\'-\',q.qsn_sub_id)');
              set @mysql=concat(@mysql,' qsn_type_position,
               p.qsn_type_position pos,
               c.qsn_position,
               q.create_tm
          from t_paper t
          join t_papr_qsn_type p on t.papr_id = p.papr_id
          join t_papr_content c on p.papr_id = c.papr_id and c.qsn_type_position = p.qsn_type_position
          join t_question q on c.qsn_id = q.qsn_id
                           and c.qsn_sub_id = q.qsn_sub_id
          left join t_option o on o.qsn_id = q.qsn_id   and o.qsn_sub_id=q.qsn_sub_id
          where t.papr_id=','''',par_papr_id,'''',') tp');
          set @mysql=concat(@mysql,' union
        select y.papr_name,null papr_des,
               y.papr_status,
               y.papr_point,
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.option_content,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,y.qsn_type_label,');
          set @mysql= concat(@mysql,'concat(y.qsn_type_position,\'-\',y.qsn_id,\'-\',y.qsn_position) qsn_type_position,');
          set @mysql=concat(@mysql,'y.qsn_type_position pos,y.qsn_position,
               y.create_tm,
               y.flg sub_qsn_flg
               from (select null papr_name,null papr_des,
                       null papr_status,
                       null papr_point,
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       o.option_content,
                       o.qsn_item_tag,
                       case
                         when o.qsn_item_id is null then
                          1
                         else
                          o.qsn_item_id
                       end qsn_item_id,
                       o.qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm,
                     sp.flg
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_preview_papr t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id) q
                  left join (select c.qsn_type_position,c.qsn_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_preview_papr t
                              join t_papr_content c on t.id = c.qsn_id 
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                  left join t_option o on q.qsn_id = o.qsn_id and q.qsn_sub_id=o.qsn_sub_id
                left join (select distinct t1.qsn_id
            , case when t1.qsn_id is not null then 1 else 0 end flg from t_qsn_sub_position t1
            join tmp_preview_papr t2 on t2.id=t1.qsn_id
             ) sp on sp.qsn_id=q.qsn_sub_id and q.qsn_type in(\'010105\',\'010106\')
                 where cc.qsn_type_position is not null) y');
    set @mysql=concat(@mysql,'  union
        select y.papr_name,y.papr_des,
               y.papr_status,
               y.papr_point,
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.option_content,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,
               y.qsn_type_label,
               tm.qsn_type_position,
               tm.pos,
               tm.qsn_position,
               y.create_tm,
               NULL sub_qsn_flg
          from (select null papr_name,null papr_des,
                       null papr_status,
                       null papr_point,
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       null option_content,
                       null qsn_item_tag,
                       null qsn_item_id,
                       null qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_preview_papr t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                           and not exists(select o.qsn_id from t_option o where o.qsn_id=t.pid and o.qsn_sub_id=t.id)
                           ) q
                  left join (select c.qsn_type_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_preview_papr t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                  ) y,');
        set @mysql=concat(@mysql,'(
               select n.qsn_sub_id,
                       concat(c1.qsn_type_position,
                              \'-\',
                              q1.qsn_id,
                              \'-\',
                              s1.qsn_position,
                              \'-\',
                              s2.qsn_position) as qsn_type_position,
                       c1.qsn_type_position pos,
                       c1.qsn_position,
                       q1.create_tm
                  from t_question q1
                  join (select q.qsn_id, q.qsn_sub_id
                         from (select r.qsn_id,
                                      r.qsn_sub_id,
                                      t.id,
                                      r.qsn_content,
                                      r.qsn_type,
                                      s.qsn_position
                                 from tmp_preview_papr          t,
                                      t_question         r,
                                      t_qsn_sub_position s
                                where t.pid = r.qsn_id
                                  and t.id = r.qsn_sub_id
                                  and r.qsn_id = s.qsn_id
                                  and r.qsn_sub_id = s.qsn_sub_id) q
                         left join (select c.qsn_type_position,
                                          c.papr_id,
                                          c.qsn_sub_id
                                     from tmp_preview_papr t
                                     join t_papr_content c on t.id = c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                                     cc.qsn_sub_id
                        where cc.qsn_type_position is null) n on n.qsn_id =
                                                                 q1.qsn_sub_id
                  join t_papr_content c1 on c1.qsn_sub_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
                  join t_qsn_sub_position s1 on s1.qsn_id = q1.qsn_id
                                            and s1.qsn_sub_id = n.qsn_id
                  join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id');
        set @mysql=concat(@mysql,' union
select n.qsn_sub_id,
concat(c1.qsn_type_position,\'-\',q1.qsn_sub_id,\'-\',s2.qsn_position,\'-1\') as qsn_type_position,
c1.qsn_type_position pos,c1.qsn_position,q1.create_tm
from t_question q1 join (
select q.qsn_id,q.qsn_sub_id
from
    (
    select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_content,r.qsn_type,s.qsn_position
    from tmp_preview_papr t,t_question r,t_qsn_sub_position s
    where t.pid=r.qsn_id and t.id=r.qsn_sub_id and r.qsn_id=s.qsn_id and r.qsn_sub_id=s.qsn_sub_id) q
    left join
    (select c.qsn_type_position,c.papr_id,c.qsn_sub_id  from tmp_preview_papr t
    join t_papr_content c on t.id=c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id=cc.qsn_sub_id
   join t_option o on o.qsn_id=q.qsn_id and o.qsn_sub_id=q.qsn_sub_id
    ) n on n.qsn_id=q1.qsn_sub_id
    join t_papr_content c1 on c1.qsn_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
left join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id
                  ) tm
         where y.qsn_sub_id = tm.qsn_sub_id
         ) x ');

set @mysql2=concat(@mysql2,'left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id
and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_preview_papr p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_preview_papr t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

union
select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
from (
select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_preview_papr p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_preview_papr t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
)p7 join tmp_preview_papr p8 on p8.id=p7.qsn_id
group by p8.pid,p8.id

union

select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
(
select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_preview_papr p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_preview_papr t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
) pp
join tmp_preview_papr p3  on p3.pid=pp.qsn_sub_id
join (
select s.qsn_id,count(*) cnt from tmp_preview_papr t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

             union
            select r.qsn_id, r.qsn_sub_id, p.qsn_point
   from t_papr_content t
   join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type=p.qsn_type
   and p.qsn_type_position=t.qsn_type_position
   join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
   where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'');

set @mysql2=concat(@mysql2,') r on x.qsn_id=r.qsn_id and x.qsn_sub_id=r.qsn_sub_id');

set @mysql=concat(@mysql,@mysql2);
set @mysql=concat(@mysql,' order by x.pos,x.qsn_type_position,cast(x.qsn_position as unsigned)');

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_preview_papr;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_display_paper_user_answer`;
CREATE PROCEDURE  `papr_display_paper_user_answer`(IN par_exam_id char(32),IN par_papr_id CHAR(32), IN par_exam_times INTEGER(10), IN par_user_id int(10))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
    declare v_point_type varchar(20);
    set @mysql2='';
    select exam_point_type,exam_point into @v_point_type,@exam_point from t_exam e where e.exam_id=par_exam_id;

if @v_point_type='030202' then
    set @mysql2=concat(@mysql2,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                           from tmp_usr_papr_answer t, t_question r, t_qsn_sub_position s
                          where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id) q');

    set @mysql2=concat(@mysql2,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_papr_answer t  join t_papr_content c on t.id = c.qsn_id');

    if par_papr_id is not null then
        set @mysql2=concat(@mysql2,' where c.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql2=concat(@mysql2,' ) cc on q.qsn_id =cc.qsn_sub_id');
    set @mysql2=concat(@mysql2,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
                        from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
    if par_papr_id is not null then
        set @mysql2=concat(@mysql2,' and t.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql2=concat(@mysql2,') r on r.qsn_id=x.qsn_id and r.qsn_sub_id=x.qsn_sub_id');
elseif @v_point_type='030201' then
set @mysql2=concat(@mysql2,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_usr_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_usr_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

union
select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
from (
select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_usr_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_usr_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
)p7 join tmp_usr_papr_answer p8 on p8.id=p7.qsn_id
group by p8.pid,p8.id
union
select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
(
select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_usr_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_usr_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
) pp
join tmp_usr_papr_answer p3  on p3.pid=pp.qsn_sub_id
join (
select s.qsn_id,count(*) cnt from tmp_usr_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

             union
            select r.qsn_id, r.qsn_sub_id, p.qsn_point
   from t_papr_content t
   join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type=p.qsn_type and t.qsn_type_position=p.qsn_type_position
   join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
   where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') r on r.qsn_id=x.qsn_id and r.qsn_sub_id=x.qsn_sub_id');
   
elseif @v_point_type='030203' then
select a.papr_qsn_count into @qsn_count
from t_exam e join t_exam_papr p on e.exam_id=p.exam_id and e.exam_id=par_exam_id
join t_paper a on a.papr_id=p.papr_id;
set @q_point=round(@exam_point/@qsn_count,2);

set @mysql2=concat(@mysql2,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_usr_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_usr_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

union
select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
from (
select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
from (
select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_usr_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_usr_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
)p7 join tmp_usr_papr_answer p8 on p8.id=p7.qsn_id
group by p8.pid,p8.id
union
select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
(
select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_usr_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_usr_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
) pp
join tmp_usr_papr_answer p3  on p3.pid=pp.qsn_sub_id
join (
select s.qsn_id,count(*) cnt from tmp_usr_papr_answer t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
             union
            select r.qsn_id, r.qsn_sub_id, @q_point
   from t_papr_content t
   join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type=p.qsn_type and t.qsn_type_position=p.qsn_type_position
   join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
   where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') r on r.qsn_id=x.qsn_id and r.qsn_sub_id=x.qsn_sub_id');

end if;

    insert into tmp_usr_papr_answer(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id and qsn_sub_id !='0';
    
    set v_row_count := row_count();
    
    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_usr_papr_answer(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_usr_papr_answer t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;
   
set @mysql='';
set @mysql=concat(@mysql,'select x.papr_name,x.papr_des,
       x.papr_status,
       x.exam_point,
       x.exam_total_tm,
       ue.user_exam_scoring,
       x.papr_qsn_count,
       x.qsn_id,
       x.qsn_sub_id,
       r.qsn_point,
       x.qsn_content,
       x.qsn_guide,
       x.option_content,
       x.qsn_item_tag,
       x.qsn_item_id,
       x.qsn_item_sub_id,
       x.qsn_type,
       x.qsn_type_title,
       x.qsn_type_label,
       x.qsn_type_position,
       x.pos,
       x.qsn_position,
       x.create_tm,
       a.qsn_answer,
       ua.user_answer,
       uei.answer_status,
       uei.scoring,
       uei.remark,
       x.sub_qsn_flg
  from (
  select
tp.papr_name,tp.papr_des,
               tp.papr_status,
               tp.exam_point,
               tp.exam_total_tm,
               tp.papr_qsn_count,
               tp.qsn_id,
               tp.qsn_sub_id,
               tp.qsn_content,
               tp.qsn_guide,
               tp.option_content,
               tp.qsn_item_tag,
               tp.qsn_item_id,
               tp.qsn_item_sub_id,
               tp.qsn_type,
               tp.qsn_type_title,
               tp.qsn_type_label,
               tp.qsn_type_position,
               tp.pos,
               tp.qsn_position,
               tp.create_tm,
           NULL sub_qsn_flg from (
select t.papr_name,t.papr_des,
               t.papr_status,
               e.exam_point,
               e.exam_total_tm,
               t.papr_qsn_count,
               q.qsn_id,
               q.qsn_sub_id,
               q.qsn_content,
               q.qsn_guide,
               o.option_content,
               o.qsn_item_tag,
               case
                 when o.qsn_item_id is null then
                  1
                 else
                  o.qsn_item_id
               end qsn_item_id,
               o.qsn_item_sub_id,
               p.qsn_type,
               p.qsn_type_title,p.qsn_type_label,');
              set @mysql= concat(@mysql,'concat(p.qsn_type_position,\'-\',q.qsn_sub_id) qsn_type_position,');
              set @mysql=concat(@mysql,'
               p.qsn_type_position pos,c.qsn_position,
               q.create_tm
          from t_paper t
          join t_exam_papr ep on ep.papr_id=t.papr_id
          join t_exam e on e.exam_id=ep.exam_id and
          e.exam_id=','''',par_exam_id,'''','
          join t_papr_qsn_type p on t.papr_id = p.papr_id
          join t_papr_content c on p.papr_id = c.papr_id
                               and p.qsn_type = c.qsn_type
                               and c.qsn_type_position = p.qsn_type_position
          join t_question q on c.qsn_id = q.qsn_id
                           and c.qsn_sub_id = q.qsn_sub_id
          left join t_option o on o.qsn_id = q.qsn_id and o.qsn_sub_id=q.qsn_sub_id and o.qsn_type=q.qsn_type
          where t.papr_id=','''',par_papr_id,'''','
           ) tp  ');
          set @mysql=concat(@mysql,' union
        select y.papr_name,y.papr_des,
               y.papr_status,
               y.exam_point,
               y.exam_total_tm,
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.qsn_guide,
               y.option_content,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,y.qsn_type_label,');
          set @mysql= concat(@mysql,'concat(y.qsn_type_position,\'-\',y.qsn_id,\'-\',y.qsn_position) qsn_type_position,');
          set @mysql=concat(@mysql,'y.qsn_type_position pos,y.qsn_position,
               y.create_tm
               ,y.flg sub_qsn_flg
               from (select null papr_name,null papr_des,
                       null papr_status,
                       null exam_point,
                       null exam_total_tm,
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       o.option_content,
                       o.qsn_item_tag,
                       case
                         when o.qsn_item_id is null then
                          1
                         else
                          o.qsn_item_id
                       end qsn_item_id,
                       o.qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm
                    ,sp.flg
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_guide,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_usr_papr_answer t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id) q
                  left join (select c.qsn_type_position,c.qsn_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_usr_papr_answer t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                  left join t_option o on q.qsn_id = o.qsn_id and q.qsn_sub_id=o.qsn_sub_id and o.qsn_type=q.qsn_type
                left join (select distinct t1.qsn_id
            , case when t1.qsn_id is not null then 1 else 0 end flg from t_qsn_sub_position t1
            join tmp_usr_papr_answer t2 on t2.id=t1.qsn_id
             ) sp on sp.qsn_id=q.qsn_sub_id and q.qsn_type in(\'010105\',\'010106\')
                 where cc.qsn_type_position is not null) y');
    set @mysql=concat(@mysql,'  union
        select y.papr_name,y.papr_des,
               y.papr_status,
               y.exam_point,
               y.exam_total_tm,
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.qsn_guide,
               y.option_content,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,y.qsn_type_label,
               tm.qsn_type_position,
               tm.pos,
               tm.qsn_position,
               y.create_tm
               ,NULL sub_qsn_flg
          from (select null papr_name,null papr_des,
                       null papr_status,
                       null exam_point,
                       null exam_total_tm,
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       null option_content,
                       null qsn_item_tag,
                       null qsn_item_id,
                       null qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm                       
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_guide,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_usr_papr_answer t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                           and not exists(select o.qsn_id from t_option o where o.qsn_id=t.pid and o.qsn_sub_id=t.id and o.qsn_type=r.qsn_type)
                           ) q
                  left join (select c.qsn_type_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_usr_papr_answer t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =cc.qsn_sub_id) y,');
        set @mysql=concat(@mysql,'(
               select n.qsn_sub_id,
                       concat(c1.qsn_type_position,
                              \'-\',
                              q1.qsn_id,
                              \'-\',
                              s1.qsn_position,
                              \'-\',
                              s2.qsn_position) as qsn_type_position,
                       c1.qsn_type_position pos,c1.qsn_position,
                       q1.create_tm
                  from t_question q1
                  join (select q.qsn_id, q.qsn_sub_id
                         from (select r.qsn_id,
                                      r.qsn_sub_id,
                                      t.id,
                                      r.qsn_content,
                                      r.qsn_type,
                                      s.qsn_position
                                 from tmp_usr_papr_answer          t,
                                      t_question         r,
                                      t_qsn_sub_position s
                                where t.pid = r.qsn_id
                                  and t.id = r.qsn_sub_id
                                  and r.qsn_id = s.qsn_id
                                  and r.qsn_sub_id = s.qsn_sub_id) q
                         left join (select c.qsn_type_position,
                                          c.papr_id,
                                          c.qsn_sub_id
                                     from tmp_usr_papr_answer t
                                     join t_papr_content c on t.id = c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                                     cc.qsn_sub_id
                        where cc.qsn_type_position is null) n on n.qsn_id =
                                                                 q1.qsn_sub_id
                  join t_papr_content c1 on c1.qsn_sub_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
                  join t_qsn_sub_position s1 on s1.qsn_id = q1.qsn_id
                                            and s1.qsn_sub_id = n.qsn_id
                  join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id');
        set @mysql=concat(@mysql,' union
select n.qsn_sub_id,
concat(c1.qsn_type_position,\'-\',q1.qsn_sub_id,\'-\',s2.qsn_position,\'-1\') as qsn_type_position,
c1.qsn_type_position pos,c1.qsn_position,q1.create_tm
from t_question q1 join (
select q.qsn_id,q.qsn_sub_id
from
    (
    select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_content,r.qsn_type,s.qsn_position
    from tmp_usr_papr_answer t,t_question r,t_qsn_sub_position s
    where t.pid=r.qsn_id and t.id=r.qsn_sub_id and r.qsn_id=s.qsn_id and r.qsn_sub_id=s.qsn_sub_id) q
    left join
    (select c.qsn_type_position,c.papr_id,c.qsn_sub_id  from tmp_usr_papr_answer t
    join t_papr_content c on t.id=c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id=cc.qsn_sub_id
   join t_option o on o.qsn_id=q.qsn_id and o.qsn_sub_id=q.qsn_sub_id and o.qsn_type=q.qsn_type
    ) n on n.qsn_id=q1.qsn_sub_id
    join t_papr_content c1 on c1.qsn_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
left join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id
                  ) tm
         where y.qsn_sub_id = tm.qsn_sub_id

         ) x  left join t_user_exam_info uei  on uei.qsn_id=x.qsn_id and uei.qsn_sub_id=x.qsn_sub_id and uei.papr_id=','''',par_papr_id,'''','
         and uei.user_id=',par_user_id,' and uei.exam_times=',par_exam_times,' and uei.exam_id=','''',par_exam_id,'''','
         ');
set @mysql=concat(@mysql,' left join (
select t.qsn_id,t.qsn_sub_id,group_concat(t.qsn_answer SEPARATOR \'__\') qsn_answer
from t_answer t
left join t_papr_content pc
on pc.qsn_id=t.qsn_id and pc.qsn_sub_id=t.qsn_sub_id and pc.papr_id=','''',par_papr_id,'''',' group by t.qsn_id,t.qsn_sub_id
) a on a.qsn_id = x.qsn_id and a.qsn_sub_id = x.qsn_sub_id');

set @mysql=concat(@mysql,' join t_user_exam ue on ue.exam_id=','''',par_exam_id,'''',' and ue.exam_times=',par_exam_times,' and ue.user_id=',par_user_id,' and ue.papr_id=','''',par_papr_id,'''');

set @mysql=concat(@mysql,' left join (select t.qsn_id,t.qsn_sub_id,t.user_id,t.qsn_item_id,group_concat(t.user_answer SEPARATOR \'__\') user_answer
               from t_user_exam_answer t where t.user_id=',par_user_id,' and t.papr_id= ','''',par_papr_id,'''',' and t.exam_id=','''',par_exam_id,'''',' and t.exam_times=',par_exam_times,
               ' group by t.qsn_id, t.qsn_sub_id, t.user_id) ua on ua.qsn_id =x.qsn_id and ua.qsn_sub_id =x.qsn_sub_id');

set @mysql=concat(@mysql,@mysql2);

set @mysql=concat(@mysql,' group by x.papr_name,x.papr_status,x.exam_point,x.papr_qsn_count,x.qsn_id,x.qsn_sub_id,r.qsn_point,
       x.qsn_content,x.qsn_item_id,x.qsn_item_sub_id,x.option_content,x.qsn_item_tag,x.qsn_type,x.qsn_type_title,x.qsn_type_position,
       x.pos,x.create_tm,uei.answer_status,
       x.sub_qsn_flg');

set @mysql=concat(@mysql,' order by x.pos,x.qsn_type_position,cast(x.qsn_position as unsigned)');

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_usr_papr_answer;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_export_analysis_qsn`;
CREATE PROCEDURE  `papr_export_analysis_qsn`(in par_exam_id char(32),in par_exam_times integer(10),in par_papr_id char (32)
,in par_qsn_label varchar(200),in par_qsn_type_position integer(10),in par_qsn_level varchar(20),in par_right_rate varchar(10),in par_pright_rate varchar(10),in par_error_rate varchar(10))
begin

    select count(*) into @cnt from t_user_exam i where i.exam_id=par_exam_id and i.papr_id=par_papr_id and i.exam_times=par_exam_times;

    set @strsql=concat('    select c.desc_cn qsn_type_name,t.qsn_type,
    pqt.qsn_type_label,q.qsn_id,q.qsn_sub_id,t.qsn_content_edit,concat(round(r1.r_cnt/',@cnt,',2)*100,\'%\') r_rate,
  concat(round(r3.pr_cnt/',@cnt,',2)*100,\'%\') pr_rate,concat(round(r2.e_cnt/',@cnt,',2)*100,\'%\') e_rate
    from t_user_exam_info q join t_question t on q.qsn_id=t.qsn_id and q.qsn_sub_id=t.qsn_sub_id and ');

    if par_qsn_label is not null and par_qsn_label !='010107' then
        set @strsql=concat(@strsql,' t.qsn_type =','''',par_qsn_label,'''',' and ');
    end if;

    if par_qsn_level is not null then
        set @strsql=concat(@strsql,' t.qsn_level=','''',par_qsn_level,'''',' and ');
    end if;

    if par_exam_times is not null then
    set @strsql=concat(@strsql,' q.exam_times=','''',par_exam_times,'''',' and ');
  end if;

    set @strsql=concat(@strsql,'    q.exam_id=','''',par_exam_id,'''',' and q.papr_id=','''',par_papr_id,'''',
    'left join t_papr_qsn_type pqt on pqt.papr_id=','''',par_papr_id,'''',' and q.qsn_type=pqt.qsn_type ');

  if par_qsn_type_position !=0 then
    set @strsql=concat(@strsql,' and pqt.qsn_type_position=',par_qsn_type_position);
  end if;

  set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=q.qsn_type ');

    set @strsql=concat(@strsql,'    left join
    (select count(*) r_cnt,i.qsn_id,i.qsn_sub_id from
    t_user_exam_info i where i.exam_id=','''',par_exam_id,'''',' and i.papr_id=','''',par_papr_id,'''',' and i.exam_times=','''',par_exam_times,'''','
    and i.answer_status=1 group by i.qsn_id,i.qsn_sub_id) r1 on r1.qsn_id=q.qsn_id and r1.qsn_sub_id=q.qsn_sub_id
    left join 
    (select count(*) e_cnt,i.qsn_id,i.qsn_sub_id from
    t_user_exam_info i where i.exam_id=','''',par_exam_id,'''',' and i.papr_id=','''',par_papr_id,'''',' and i.exam_times=','''',par_exam_times,'''','
    and i.answer_status=0 group by i.qsn_id,i.qsn_sub_id
    ) r2
    on r2.qsn_id=q.qsn_id and r2.qsn_sub_id=q.qsn_sub_id
    left join
    (select count(*) pr_cnt,i.qsn_id,i.qsn_sub_id from
    t_user_exam_info i where i.exam_id=','''',par_exam_id,'''',' and i.papr_id=','''',par_papr_id,'''',' and i.exam_times=',par_exam_times,'
    and i.answer_status=2 group by i.qsn_id,i.qsn_sub_id
    ) r3    on r3.qsn_id=q.qsn_id and r3.qsn_sub_id=q.qsn_sub_id group by q.qsn_id,q.qsn_sub_id');

    if par_right_rate is not null then
        if par_right_rate =1 then
            set @strsql=concat(@strsql,' order by r_rate desc');
        else
            set @strsql=concat(@strsql,' order by r_rate');
        end if;
    end if;
    
    if par_pright_rate is not null then
        if par_pright_rate =1 then
            set @strsql=concat(@strsql,' order by pr_rate desc');
        else
            set @strsql=concat(@strsql,' order by pr_rate');
        end if;
    end if;

    if par_error_rate is not null then
        if par_error_rate =1 then
                set @strsql=concat(@strsql,' order by e_rate desc');
            else            
                set @strsql=concat(@strsql,' order by e_rate');
        end if;
    end if;

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_print_paper`;
CREATE PROCEDURE  `papr_print_paper`(in par_papr_id char (32))
begin

    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

  set @mysql2='';

    insert into tmp_print_papr(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id;

    set v_row_count := row_count();

    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_print_papr(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_print_papr t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;


set @mysql='';
set @mysql=concat(@mysql,'select x.papr_name,x.papr_des,
       x.papr_status,
       x.papr_point,
       x.papr_qsn_count,
       x.qsn_id,
       x.qsn_sub_id,
       r.qsn_point,
       x.qsn_content,
       x.qsn_content_edit,
       x.option_content,
       x.qsn_item_tag,
       x.qsn_item_id,
       x.qsn_item_sub_id,
       x.qsn_type,
       x.qsn_type_title,
       x.qsn_type_label,
       x.qsn_type_position,
       x.pos,
       x.qsn_position,
       x.create_tm,
       x.sub_qsn_flg
  from (
  select
tp.papr_name,tp.papr_des,
               tp.papr_status,
               tp.papr_point,
               tp.papr_qsn_count,
               tp.qsn_id,
               tp.qsn_sub_id,
               tp.qsn_content,
               tp.qsn_content_edit,
               tp.option_content,
               tp.qsn_item_tag,
               tp.qsn_item_id,
               tp.qsn_item_sub_id,
               tp.qsn_type,
               tp.qsn_type_title,
               tp.qsn_type_label,
               tp.qsn_type_position,
               tp.pos,
               tp.qsn_position,
               tp.create_tm,
          NULL sub_qsn_flg from (
select t.papr_name,t.papr_des,
               t.papr_status,
               t.papr_point,
               t.papr_qsn_count,
               q.qsn_id,
               q.qsn_sub_id,
               q.qsn_content,
               q.qsn_content_edit,
               o.option_content,
               o.qsn_item_tag,
               case
                 when o.qsn_item_id is null then
                  1
                 else
                  o.qsn_item_id
               end qsn_item_id,
               o.qsn_item_sub_id,
               p.qsn_type,
               p.qsn_type_title,p.qsn_type_label,');
              set @mysql= concat(@mysql,'concat(p.qsn_type_position,\'-\',q.qsn_sub_id)');
              set @mysql=concat(@mysql,' qsn_type_position,
               p.qsn_type_position pos,
               c.qsn_position,
               q.create_tm
          from t_paper t
          join t_papr_qsn_type p on t.papr_id = p.papr_id
          join t_papr_content c on p.papr_id = c.papr_id and c.qsn_type_position = p.qsn_type_position
          join t_question q on c.qsn_id = q.qsn_id
                           and c.qsn_sub_id = q.qsn_sub_id
          left join t_option o on o.qsn_id = q.qsn_id   and o.qsn_sub_id=q.qsn_sub_id
          where t.papr_id=','''',par_papr_id,'''',') tp');
          set @mysql=concat(@mysql,' union
        select y.papr_name,null papr_des,
               y.papr_status,
               y.papr_point,
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.qsn_content_edit,
               y.option_content,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,y.qsn_type_label,');
          set @mysql= concat(@mysql,'concat(y.qsn_type_position,\'-\',y.qsn_id,\'-\',y.qsn_position) qsn_type_position,');
          set @mysql=concat(@mysql,'y.qsn_type_position pos,y.qsn_position,
               y.create_tm,
               y.flg sub_qsn_flg
               from (select null papr_name,null papr_des,
                       null papr_status,
                       null papr_point,
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_content_edit,
                       o.option_content,
                       o.qsn_item_tag,
                       case
                         when o.qsn_item_id is null then
                          1
                         else
                          o.qsn_item_id
                       end qsn_item_id,
                       o.qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm,
                     sp.flg
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_content_edit,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_print_papr t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id) q
                  left join (select c.qsn_type_position,c.qsn_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_print_papr t
                              join t_papr_content c on t.id = c.qsn_id 
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                  left join t_option o on q.qsn_id = o.qsn_id and q.qsn_sub_id=o.qsn_sub_id
                left join (select distinct t1.qsn_id
            , case when t1.qsn_id is not null then 1 else 0 end flg from t_qsn_sub_position t1
            join tmp_print_papr t2 on t2.id=t1.qsn_id
             ) sp on sp.qsn_id=q.qsn_sub_id and q.qsn_type in(\'010105\',\'010106\')
                 where cc.qsn_type_position is not null) y');
    set @mysql=concat(@mysql,'  union
        select y.papr_name,y.papr_des,
               y.papr_status,
               y.papr_point,
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.qsn_content_edit,
               y.option_content,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,
               y.qsn_type_label,
               tm.qsn_type_position,
               tm.pos,
               tm.qsn_position,
               y.create_tm,
               NULL sub_qsn_flg
          from (select null papr_name,null papr_des,
                       null papr_status,
                       null papr_point,
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_content_edit,
                       null option_content,
                       null qsn_item_tag,
                       null qsn_item_id,
                       null qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_content_edit,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_print_papr t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                           and not exists(select o.qsn_id from t_option o where o.qsn_id=t.pid and o.qsn_sub_id=t.id)
                           ) q
                  left join (select c.qsn_type_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_print_papr t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                  ) y,');
        set @mysql=concat(@mysql,'(
               select n.qsn_sub_id,
                       concat(c1.qsn_type_position,
                              \'-\',
                              q1.qsn_id,
                              \'-\',
                              s1.qsn_position,
                              \'-\',
                              s2.qsn_position) as qsn_type_position,
                       c1.qsn_type_position pos,
                       c1.qsn_position,
                       q1.create_tm
                  from t_question q1
                  join (select q.qsn_id, q.qsn_sub_id
                         from (select r.qsn_id,
                                      r.qsn_sub_id,
                                      t.id,
                                      r.qsn_content,
                                      r.qsn_content_edit,
                                      r.qsn_type,
                                      s.qsn_position
                                 from tmp_print_papr          t,
                                      t_question         r,
                                      t_qsn_sub_position s
                                where t.pid = r.qsn_id
                                  and t.id = r.qsn_sub_id
                                  and r.qsn_id = s.qsn_id
                                  and r.qsn_sub_id = s.qsn_sub_id) q
                         left join (select c.qsn_type_position,
                                          c.papr_id,
                                          c.qsn_sub_id
                                     from tmp_print_papr t
                                     join t_papr_content c on t.id = c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                                     cc.qsn_sub_id
                        where cc.qsn_type_position is null) n on n.qsn_id =
                                                                 q1.qsn_sub_id
                  join t_papr_content c1 on c1.qsn_sub_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
                  join t_qsn_sub_position s1 on s1.qsn_id = q1.qsn_id
                                            and s1.qsn_sub_id = n.qsn_id
                  join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id');
        set @mysql=concat(@mysql,' union
select n.qsn_sub_id,
concat(c1.qsn_type_position,\'-\',q1.qsn_sub_id,\'-\',s2.qsn_position,\'-1\') as qsn_type_position,
c1.qsn_type_position pos,c1.qsn_position,q1.create_tm
from t_question q1 join (
select q.qsn_id,q.qsn_sub_id
from
    (
    select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_content,r.qsn_content_edit,r.qsn_type,s.qsn_position
    from tmp_print_papr t,t_question r,t_qsn_sub_position s
    where t.pid=r.qsn_id and t.id=r.qsn_sub_id and r.qsn_id=s.qsn_id and r.qsn_sub_id=s.qsn_sub_id) q
    left join
    (select c.qsn_type_position,c.papr_id,c.qsn_sub_id  from tmp_print_papr t
    join t_papr_content c on t.id=c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id=cc.qsn_sub_id
   join t_option o on o.qsn_id=q.qsn_id and o.qsn_sub_id=q.qsn_sub_id
    ) n on n.qsn_id=q1.qsn_sub_id
    join t_papr_content c1 on c1.qsn_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
left join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id
                  ) tm
         where y.qsn_sub_id = tm.qsn_sub_id
         ) x ');

set @mysql2=concat(@mysql2,'left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id
and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_print_papr p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_print_papr t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

union
select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
from (
select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_print_papr p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_print_papr t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
)p7 join tmp_print_papr p8 on p8.id=p7.qsn_id
group by p8.pid,p8.id

union

select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
(
select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_print_papr p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_print_papr t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
) pp
join tmp_print_papr p3  on p3.pid=pp.qsn_sub_id
join (
select s.qsn_id,count(*) cnt from tmp_print_papr t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

             union
            select r.qsn_id, r.qsn_sub_id, p.qsn_point
   from t_papr_content t
   join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type=p.qsn_type
   and p.qsn_type_position=t.qsn_type_position
   join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
   where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'');

set @mysql2=concat(@mysql2,') r on x.qsn_id=r.qsn_id and x.qsn_sub_id=r.qsn_sub_id');

set @mysql=concat(@mysql,@mysql2);
set @mysql=concat(@mysql,' order by x.pos,x.qsn_type_position,cast(x.qsn_position as unsigned)');

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_print_papr;
        
end

DROP PROCEDURE IF EXISTS `papr_search`;
CREATE PROCEDURE  `papr_search`(IN `par_papr_name` VARCHAR(200), IN `par_papr_status` VARCHAR(10), IN `par_papr_begin_point` INTEGER(10), IN `par_papr_end_point` INTEGER(10), IN `par_qsn_begin_count` INTEGER(10), IN `par_qsn_end_count` INTEGER(10), IN `par_papr_category` VARCHAR(10), IN `par_papr_des` VARCHAR(4000), IN `par_search_flg` TINYINT, IN `par_user_id` int(10), IN `par_page_idx` INTEGER(10), IN `par_page_size` INTEGER(10))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
  declare mysql text;

    set @strsql='';
    set @strsql=concat('select t.papr_id,t.papr_name,c3.desc_cn papr_type,c1.desc_cn papr_category,
                                c2.desc_cn papr_status,t.papr_point,t.papr_qsn_count
                        from t_paper t join t_common_cde c1 on t.papr_category=c1.c_cde
                            join t_common_cde c2 on t.papr_status=c2.c_cde
                            join t_common_cde c3 on t.papr_type=c3.c_cde ');

    if par_search_flg =1 then
        set @strsql=concat(@strsql,' where t.create_user_id =',par_user_id);
    elseif par_search_flg =2 then
    select g.group_id,g.group_pid into @gid,@gpid
    from t_admin_group_user ug join t_group g on g.group_id=ug.group_id
    where ug.user_id=par_user_id;

      insert into tmp_papr_group_tree(id,pid, level,position)
      values (@gid,@gpid,v_level,v_position);

      set v_row_count := row_count();

      while v_row_count != 0 do
          set @position := 0;
          insert into tmp_papr_group_tree(id,pid,level,position)
          select g.group_id,g.group_pid,v_level + 1,@position := @position+1
          from t_group g inner join tmp_papr_group_tree t on g.group_pid = t.id
          where t.level = v_level and g.group_id !='0' order by g.group_id;

          set v_row_count := row_count();
          set v_level := v_level + 1;
    end while;

        set @strsql=concat(@strsql,' where t.create_user_id in(select user_id
        from t_admin_group_user ag join (select distinct id,pid from tmp_papr_group_tree) t1 on t1.id=ag.group_id)');
  else
      set @strsql=concat(@strsql,' where 1=1 ');
    end if;

    if par_papr_name is not null then
       set @strsql=concat(@strsql,' and t.papr_name like ','''%',par_papr_name,'%''');
    end if;

    if par_papr_status is not null then
        set @strsql=concat(@strsql,' and t.papr_status=','''',par_papr_status,'''');
    end if;

    if par_papr_begin_point is not null and par_papr_end_point is not null then
        set @strsql=concat(@strsql,' and t.papr_point between ',par_papr_begin_point,' and ',par_papr_end_point);
    end if;

    if par_qsn_begin_count is not null and par_qsn_end_count is not null then
        set @strsql=concat(@strsql,'  and t.papr_qsn_count between ',par_qsn_begin_count,' and ',par_qsn_end_count);
    end if;

    if par_papr_category is not null then
        set @strsql=concat(@strsql,' and t.papr_category=','''',par_papr_category,'''');
    end if;

    if par_papr_des is not null then
        set @strsql=concat(@strsql,' and t.papr_des like ','''%',par_papr_des,'%''');
    end if;

    set @strsql=concat(@strsql,' order by t.create_tm desc');

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
    
    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

  if par_search_flg =2 then
    truncate table tmp_papr_group_tree;
  end if;
  
      
end

DROP PROCEDURE IF EXISTS `papr_search_add_paper_content`;
CREATE PROCEDURE  `papr_search_add_paper_content`(IN par_qsn_data TEXT, IN par_papr_id CHAR(32),IN par_qsn_type_position INT(10))
begin
  set @p=0;
  select t.qsn_position into @p from t_papr_content t where t.papr_id=par_papr_id and t.qsn_type_position=par_qsn_type_position order by t.qsn_position desc limit 1;

  set @strsql=concat('insert into t_papr_content(papr_id,qsn_id,qsn_sub_id,qsn_point,qsn_type,
  qsn_type_position,qsn_type_position_old,create_tm,qsn_position) values ',par_qsn_data);

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;

  call papr_update_qsn_count_point(par_papr_id);

  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_search_by_examid`;
CREATE PROCEDURE  `papr_search_by_examid`(in par_exam_id char(32))
begin    
      
set @strsql=concat('select t.papr_id, t.papr_name,c3.desc_cn papr_type,c1.desc_cn papr_category,c2.desc_cn papr_status,t.papr_point,t.papr_qsn_count 
  from t_paper t left join t_common_cde c1 on t.papr_category=c1.c_cde
  left join  t_common_cde c2 on t.papr_status=c2.c_cde
  left join  t_common_cde c3 on t.papr_type=c3.c_cde
  left join t_exam_papr pr on pr.papr_id=t.papr_id
  where pr.exam_id=','''',par_exam_id,'''');

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_search_by_id`;
CREATE PROCEDURE  `papr_search_by_id`(in par_papr_id char(32))
begin
    
set @strsql=concat('select t.papr_id, t.papr_name,c3.desc_cn papr_type,c1.desc_cn papr_category,c2.desc_cn papr_status,t.papr_point,t.papr_qsn_count 
  from t_paper t,t_common_cde c1,t_common_cde c2,t_common_cde c3 where  t.papr_category=c1.c_cde and t.papr_status=c2.c_cde and t.papr_type=c3.c_cde ');
set @strsql=concat(@strsql,' and t.papr_id = ','''',par_papr_id,'''');  
prepare stmt from @strsql;  
execute stmt;
deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_search_delete_paper_content`;
CREATE PROCEDURE  `papr_search_delete_paper_content`(IN par_papr_id CHAR(32), IN par_qsn_type VARCHAR(20), in par_qsn_type_position INTEGER(10))
begin
    
    set @strsql=concat('delete from t_papr_content where papr_id=','''',par_papr_id,'''',' and qsn_type=','''',par_qsn_type,'''',' and qsn_type_position=','''',par_qsn_type_position,'''');
    prepare stmt from @strsql;
    execute stmt;       
    
    set @strsql=concat('delete from t_papr_qsn_type where papr_id=','''',par_papr_id,'''',' and qsn_type=','''',par_qsn_type,'''',' and qsn_type_position=','''',par_qsn_type_position,'''');
    
    prepare stmt from @strsql;
    execute stmt;   
    
    deallocate prepare stmt;    
    call papr_update_qsn_count_point(par_papr_id); 
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_search_edit_paper_content`;
CREATE PROCEDURE  `papr_search_edit_paper_content`(IN par_papr_id CHAR(32),
IN par_qsn_type VARCHAR(20),IN par_qsn_type_position int(10), IN par_page_idx TINYINT(4), IN par_page_size TINYINT(4))
begin

  set @strsql='select c1.desc_cn qsn_type,c2.desc_cn qsn_category, p.qsn_point,p.papr_id,
    p.qsn_id,p.qsn_sub_id,q.qsn_content_edit qsn_content
    from t_papr_content p join t_common_cde c1 on p.qsn_type=c1.c_cde
    join t_question q on q.qsn_id=p.qsn_id and q.qsn_sub_id=p.qsn_sub_id
    join t_common_cde c2 on q.qsn_category=c2.c_cde
    join t_papr_qsn_type t on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position';

    set @strsql=concat(@strsql,' where  p.papr_id=','''',par_papr_id,'''',
    ' and t.qsn_type_position=',par_qsn_type_position,' order by p.create_tm');

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

end

DROP PROCEDURE IF EXISTS `papr_search_qsn_for_add`;
CREATE PROCEDURE  `papr_search_qsn_for_add`(IN par_papr_id char(32),
IN par_qsn_type VARCHAR(20),IN par_qsn_category VARCHAR(20), IN par_qsn_level VARCHAR(20), IN par_qsn_point VARCHAR(20),
IN par_qsn_source VARCHAR(20), IN par_qsn_content VARCHAR(200),IN par_qsn_input_person varchar(20),
IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin

   set @strsql='select q.qsn_id,q.qsn_sub_id,q.qsn_type qsn_type_id,c1.desc_cn qsn_type,c2.desc_cn qsn_category, c3.desc_cn qsn_level,q.qsn_point,q.qsn_limit_tm,c5.desc_cn qsn_source,q.qsn_content_edit qsn_content,c4.desc_cn qsn_status,uu.username
                      from t_question q join t_common_cde c1 on q.qsn_type=c1.c_cde
                      join t_common_cde c2 on q.qsn_category=c2.c_cde
                      join t_common_cde c3 on q.qsn_level=c3.c_cde
                      join t_common_cde c4 on q.qsn_status=c4.c_cde
                      join t_common_cde c5 on q.qsn_source=c5.c_cde
            join t_user uu on q.create_user_id=uu.user_id ';

   set @strsql=concat(@strsql,' where not exists(select qsn_id from t_papr_content where papr_id=','''',par_papr_id,'''',' and qsn_id=q.qsn_id and qsn_sub_id=q.qsn_sub_id',' and q.qsn_type=','''',par_qsn_type,'''',')');

   if par_qsn_category is not null then
      set @strsql=concat(@strsql,' and q.qsn_category=','''',par_qsn_category,'''');
   end if; if par_qsn_level is not null then
      set @strsql=concat(@strsql,' and q.qsn_level=','''',par_qsn_level,'''');
   end if;

   if par_qsn_point is not null then
      set @strsql=concat(@strsql,' and q.qsn_point=',par_qsn_point);
   end if;

   if par_qsn_source is not null then
      set @strsql=concat(@strsql,' and q.qsn_source=','''',par_qsn_source,'''');
   end if;

   if par_qsn_content is not null then
      set @strsql=concat(@strsql,' and q.qsn_content like ','''%',par_qsn_content,'%''');
   end if;

   if par_qsn_input_person is not null then
    set @strsql=concat(@strsql,' and q.create_user_id in(select user_id
                                            from t_user where username like ','''%',par_qsn_input_person,'%''',')');
   end if;

   set @strsql=concat(@strsql,'and q.qsn_type=','''',par_qsn_type,'''',' and q.qsn_sub_flg is null order by q.create_tm desc');

   call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
   prepare stmt from @mysql;
   execute stmt;
   deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_search_qsn_for_sort`;
CREATE PROCEDURE  `papr_search_qsn_for_sort`(IN par_papr_id char(32),IN par_qsn_type_position INTEGER(10))
begin

   set @strsql='select q.qsn_id,q.qsn_sub_id,q.qsn_content,p.qsn_position
            from t_papr_content p
                        join t_question q on q.qsn_id=p.qsn_id and q.qsn_sub_id=p.qsn_sub_id';

   set @strsql=concat(@strsql,' where p.papr_id=','''',par_papr_id,'''',' and p.qsn_type_position=',par_qsn_type_position,' order by p.qsn_position');
  
   prepare stmt from @strsql;
   execute stmt;
   deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_search_select_paper_content`;
CREATE PROCEDURE  `papr_search_select_paper_content`(IN par_papr_id char(32),IN par_qsn_type VARCHAR(20), IN par_qsn_category VARCHAR(20), IN par_qsn_level VARCHAR(20), IN par_qsn_point VARCHAR(20), IN par_qsn_status VARCHAR(20), IN par_qsn_source VARCHAR(20), IN par_qsn_content VARCHAR(200), IN par_page_idx TINYINT(10), IN par_page_size TINYINT(10))
begin
    declare mysql text;
     
   set @strsql=concat('select q.qsn_id,q.qsn_sub_id,c1.desc_cn qsn_type,c2.desc_cn qsn_category, c3.desc_cn qsn_level,q.qsn_point,q.qsn_limit_tm,c5.desc_cn qsn_source,q.qsn_content,c4.desc_cn qsn_status
  from t_question q,t_common_cde c1,t_common_cde c2,t_common_cde c3,t_common_cde c4,t_common_cde c5
  where q.qsn_type=c1.c_cde and q.qsn_category=c2.c_cde and q.qsn_source=c5.c_cde
  and q.qsn_level=c3.c_cde  and q.qsn_status=c4.c_cde and not exists(select t.qsn_id from t_papr_content t where t.qsn_id=q.qsn_id and t.qsn_sub_id=q.qsn_sub_id and t.papr_id=','''',par_papr_id,'''',') ');
    if par_qsn_type is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_type=','''',par_qsn_type,'''');
   end if;
      
   if par_qsn_category is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_category=','''',par_qsn_category,'''');
   end if;
   
   if par_qsn_level is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_level=','''',par_qsn_level,'''');
   end if;
   
   if par_qsn_point is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_point=',par_qsn_point);
   end if;
   
    if par_qsn_status is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_status=','''',par_qsn_status,'''');
   end if;
   
    if par_qsn_source is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_source=','''',par_qsn_source,'''');
   end if;
   
   if par_qsn_content is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_content like ','''',par_qsn_content,'%''');
   end if;
   set @strsql=concat(@strsql,' and q.qsn_sub_flg is null');
   set @strsql=concat(@strsql,' order by q.create_tm desc');
   call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

   prepare stmt from @mysql;
   execute stmt;
   deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_select_attachments`;
CREATE PROCEDURE  `papr_select_attachments`(in par_papr_id char (32))
begin
declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
    
    insert into tmp_papr_select_atta_tree(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content 
    where papr_id=par_papr_id and qsn_sub_id !='0';
    set v_row_count := row_count();
    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_papr_select_atta_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_papr_select_atta_tree t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

  set @strsql=CONCAT('select a.a_id attachment_id,t.id qsn_id,t.pid qsn_sub_id,concat(a.a_id,"/",a.file_name) attachment_name,a.des attachment_des,a.attachment from
                tmp_papr_select_atta_tree t
                left join  t_qsn_attachments a on a.qsn_id=t.id
                where a.attachment is not null ');

  set @strsql =concat(@strsql, 'union select
    a.a_id attachment_id,q.qsn_id,q.qsn_sub_id,concat(a.a_id,"/",a.file_name) attachment_name,a.des attachment_des,a.attachment
    from
     t_papr_content c
    join t_question q on c.qsn_id=q.qsn_id and c.qsn_sub_id=q.qsn_sub_id
    left join t_qsn_attachments a on a.qsn_id=c.qsn_id
    where c.papr_id=','''',par_papr_id,'''',' and a.attachment is not null');

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_papr_select_atta_tree;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_select_exam_part_qsn_answer`;
CREATE PROCEDURE  `papr_select_exam_part_qsn_answer`(IN par_papr_id CHAR(32), IN par_exam_count INTEGER(10), IN par_user_id int(10))
begin  
select
tp.qsn_id,
tp.qsn_sub_id,
tp.qsn_item_id,
tp.qsn_item_sub_id,
tp.qsn_type,
a.qsn_answer,
ua.user_answer 
from (
select 
q.qsn_id,
q.qsn_sub_id,   
case when o.qsn_item_id is null then 1
else o.qsn_item_id  end qsn_item_id,
o.qsn_item_sub_id,
p.qsn_type                  
from t_paper t
join t_papr_qsn_type p on t.papr_id = p.papr_id and p.qsn_type='010108'
join t_papr_content c on p.papr_id = c.papr_id
             and p.qsn_type = c.qsn_type
             and c.qsn_type_position = p.qsn_type_position and c.qsn_type='010108'
join t_question q on c.qsn_id = q.qsn_id
         and c.qsn_sub_id = q.qsn_sub_id and q.qsn_type ='010108'
left join t_option o on o.qsn_id = q.qsn_id      
where t.papr_id=par_papr_id 
           ) tp             
left join t_answer a on a.qsn_id=tp.qsn_id  and tp.qsn_item_id=a.qsn_item_id      
left join t_user_exam_answer ua on ua.qsn_id=tp.qsn_id and ua.qsn_item_id=tp.qsn_item_id and ua.user_id=par_user_id
and ua.papr_id= par_papr_id and ua.exam_count=par_exam_count
union
          
select
tp2.qsn_id,
tp2.qsn_sub_id,
tp2.qsn_item_id,
tp2.qsn_item_sub_id,
tp2.qsn_type,
a.qsn_answer,
ua.user_answer 
from (          
select 
q.qsn_id,
q.qsn_sub_id,
a.qsn_item_id,
'' qsn_item_sub_id,
p.qsn_type,'' qsn_an ,a.qsn_answer                 
from t_paper t
join t_papr_qsn_type p on t.papr_id = p.papr_id 
join t_papr_content c on p.papr_id = c.papr_id
             and p.qsn_type = c.qsn_type
             and c.qsn_type_position = p.qsn_type_position and c.qsn_type='010104'
join t_question q on c.qsn_id = q.qsn_id
         and c.qsn_sub_id = q.qsn_sub_id and q.qsn_type ='010104'
left join t_answer a on a.qsn_id=q.qsn_id and a.qsn_type ='010104'
where t.papr_id=par_papr_id 
           ) tp2                  
left join t_answer a on a.qsn_id=tp2.qsn_id  and tp2.qsn_item_id=a.qsn_item_id      
left join t_user_exam_answer ua on ua.qsn_id=tp2.qsn_id and ua.qsn_item_id=tp2.qsn_item_id and ua.user_id=par_user_id
and ua.papr_id= par_papr_id and ua.exam_count=par_exam_count;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_select_mgr_edit`;
CREATE PROCEDURE  `papr_select_mgr_edit`( in par_papr_id char ( 32 ))
begin

  set @strsql=concat('select
p.papr_id,p.papr_category,cde2.desc_cn papr_category_name,p.papr_des
,p.papr_name,p.papr_status,t.qsn_point,t.qsn_type,cde.desc_cn qsn_type_name,
t.qsn_type_title,t.qsn_type_label,t.qsn_type_position,
case when c.qsn_type_position_old is not null then c.qsn_type_position_old else
(select max(t1.qsn_type_position_old)+1 from t_papr_content t1 where t1.papr_id=','''',par_papr_id,'''',')
end qsn_type_position_old,c.qsn_count
from t_paper p left join t_papr_qsn_type t on p.papr_id=t.papr_id
left join t_common_cde cde on t.qsn_type=cde.c_cde
left join t_common_cde cde2 on p.papr_category=cde2.c_cde
left join
(select count(*) qsn_count,papr_id,qsn_type_position,qsn_type_position_old from
t_papr_content where papr_id=','''',par_papr_id,'''','
group by papr_id,qsn_type_position
) c  on p.papr_id=c.papr_id and t.qsn_type_position=c.qsn_type_position
where p.papr_id=','''',par_papr_id,'''','
order by t.qsn_type_position');

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
  
  
  
  
  
  
  
  
  
    
end

DROP PROCEDURE IF EXISTS `papr_select_mgr_list`;
CREATE PROCEDURE  `papr_select_mgr_list`(in par_page_idx integer(10), in par_page_size integer(10))
begin
  declare mysql text;
  declare rcount integer(11);

  set @strsql='select p.papr_id,p.papr_qsn_count,c5.desc_cn papr_type,c2.desc_cn papr_category,p.papr_point,left(p.papr_name,102 ) papr_name,c4.desc_cn papr_status
          from t_paper p,t_common_cde c2,t_common_cde c4,t_common_cde c5
          where  p.papr_category=c2.c_cde and p.papr_type=c5.c_cde
          and p.papr_status=c4.c_cde order by p.create_tm desc ';

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
  
    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_select_qsn_level`;
CREATE PROCEDURE  `papr_select_qsn_level`(in par_qsn_type varchar(20),in par_qsn_category varchar(20))
begin
          set @strsql=concat('select  count(*) qsn_cnt,t.qsn_category,t.qsn_type,t.qsn_level from t_question t group by t.qsn_category,t.qsn_type,t.qsn_level');
          prepare stmt from @strsql;
          execute stmt;
          deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_status_update`;
CREATE PROCEDURE  `papr_status_update`(IN par_papr_id text, 
IN par_papr_status VARCHAR(20),IN par_update_user_id int(10))
begin   
    set @strsql=concat('update t_paper set papr_status=','''',par_papr_status,'''',',update_user_id=',par_update_user_id,',update_tm=sysdate() where papr_id in (',par_papr_id,')');    
      prepare stmt from @strsql;  
execute stmt;
deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_update_content_qsn_position`;
CREATE PROCEDURE  `papr_update_content_qsn_position`(
in par_papr_id char(32),in par_qsn_type int(10),
in par_qsn_type_position int(10),in par_qsn_type_position_old int(10))
begin
  if par_qsn_type_position_old is not null || par_qsn_type_position_old !='' then
    update t_papr_content set qsn_type_position=par_qsn_type_position
    where qsn_type_position_old=par_qsn_type_position_old and papr_id=par_papr_id;
  end if;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_update_paper`;
CREATE PROCEDURE  `papr_update_paper`(IN par_papr_id CHAR(32), IN par_papr_name VARCHAR(200),
IN par_papr_point SMALLINT(6), IN par_papr_category VARCHAR(20),
IN par_papr_des VARCHAR(4000), IN par_papr_qsn_count TINYINT(10),
IN par_papr_status VARCHAR(20), IN par_update_user_id int(10),IN par_qsn_type_data text)
begin
set @strsql=concat('update t_paper set papr_name=','''',par_papr_name,'''',',',
  'papr_point=',par_papr_point,',',
  'papr_status=','''',par_papr_status,'''',',',
  'papr_category=','''',par_papr_category,'''',',',
  'papr_des=','''',par_papr_des,'''',',',
  'update_tm=','sysdate()',',',
  'papr_qsn_count=',par_papr_qsn_count,',',
  'update_user_id=','''',par_update_user_id,'''',
  ' where papr_id=','''',par_papr_id,'''');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  set @papr_id=concat('''',par_papr_id,'''');

  call papr_delete_qsn_type(@papr_id);
  call papr_add_qsn_type(par_qsn_type_data);
  call papr_update_qsn_point(par_papr_id);
  call papr_update_qsn_count_point(par_papr_id);
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_update_paper_content_position`;
CREATE PROCEDURE  `papr_update_paper_content_position`( in par_papr_id char ( 32 ))
begin    
    
    declare q_type_position integer(10);
    
    declare q_type varchar(20);

    declare _done int default 0;
    declare mycur cursor for select qsn_type_position,qsn_type from t_papr_qsn_type q where q.papr_id=par_papr_id;
    declare continue handler for sqlstate '02000' set _done = 1;

    open mycur;
        repeat
          fetch mycur into q_type_position, q_type;
          if not _done then
            update t_papr_content t set t.qsn_type_position=q_type_position where papr_id=par_papr_id and qsn_type=q_type;
          end if;
        until _done end repeat;
    close mycur;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_update_qsn`;
CREATE PROCEDURE  `papr_update_qsn`(
IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32),
IN par_qsn_point INTEGER(3),IN par_qsn_content TEXT,IN par_qsn_content_edit TEXT, IN par_qsn_guide TEXT,IN par_update_user_id int(10))
begin
      set @strsql=concat('update t_question set qsn_point=',par_qsn_point,
        ',qsn_content=','''',par_qsn_content,'''',',qsn_content_edit=','''',par_qsn_content_edit,'''','
                ,update_tm=sysdate(),update_user_id=',par_update_user_id,' where
                qsn_id=','''',par_qsn_id,'''',' and qsn_sub_id=','''',par_qsn_sub_id, '''');

      prepare stmt from @strsql;
      execute stmt;
      deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_update_qsn_answer`;
CREATE PROCEDURE  `papr_update_qsn_answer`(IN par_qsn_id CHAR(32),IN par_qsn_sub_id CHAR(32),IN par_qsn_answer TEXT)
BEGIN

    delete from t_answer where qsn_id=par_qsn_id and qsn_sub_id=par_qsn_sub_id;

      set @strsql=concat('insert into t_answer(qsn_id,qsn_sub_id,qsn_item_id,qsn_type,qsn_answer,create_tm,create_user_id)',' values ',par_qsn_answer);
    
      prepare stmt from @strsql;
      execute stmt;
      deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_update_qsn_count_point`;
CREATE PROCEDURE  `papr_update_qsn_count_point`( in par_papr_id char (32))
begin

    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

  set @mysql2='';

    insert into tmp_papr_update_qsn_count_point_tree(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id;

    set v_row_count := row_count();

    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_papr_update_qsn_count_point_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_papr_update_qsn_count_point_tree t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

  select sum(x.qsn_cnt) all_qsn_count into @all_qsn_count from (
          select count(t.id) qsn_cnt
          from tmp_papr_update_qsn_count_point_tree t join t_question r on
                          t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_type !='010107'
          union

          select count(t.id) qsn_cnt
                 from tmp_papr_update_qsn_count_point_tree t
                 join t_papr_content c on  t.id = c.qsn_id  and c.qsn_type !='010107'
                 where c.papr_id=par_papr_id
      ) x;

  set @strsql=concat('update t_paper t,(select  count(*) qsn_count, sum(c.qsn_point) papr_point,c.papr_id
from t_papr_content c where  c.papr_id=','''',par_papr_id,'''','  group by c.papr_id) x
set t.papr_point=x.papr_point,t.papr_qsn_count=x.qsn_count,t.papr_all_qsn_count=',@all_qsn_count,'
where t.papr_id=x.papr_id and x.papr_id=','''',par_papr_id,'''');

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;

  truncate table tmp_papr_update_qsn_count_point_tree;

  select count(*) into @cnt from t_papr_content where papr_id=par_papr_id;
  if @cnt =0 then
    update t_paper set papr_point=0,papr_qsn_count=0 where papr_id=par_papr_id;
  end if;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_update_qsn_option`;
CREATE PROCEDURE  `papr_update_qsn_option`(IN par_option_content TEXT)
BEGIN

    set @strsql=concat('replace t_option(qsn_id, qsn_sub_id, qsn_item_id,
            qsn_item_sub_id,qsn_item_tag,qsn_type, option_content,option_content_edit,create_tm, create_user_id) values ',par_option_content);

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_update_qsn_point`;
CREATE PROCEDURE  `papr_update_qsn_point`(IN par_papr_id CHAR(32))
begin
     
  set @strsql=concat('update t_papr_content p,(select t.qsn_point,t.papr_id,t.qsn_type,t.qsn_type_position from t_papr_qsn_type t
        where t.papr_id=','''',par_papr_id,'''',') x set p.qsn_point=x.qsn_point where x.papr_id=p.papr_id and x.qsn_type=p.qsn_type and x.qsn_type_position=p.qsn_type_position');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;  
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_update_qsn_position`;
CREATE PROCEDURE  `papr_update_qsn_position`(IN par_papr_id  char(32),IN par_qsn_id  char(32),IN par_qsn_sub_id  char(32),IN par_qsn_position  integer(10))
begin

   set @strsql=concat('update t_papr_content set qsn_position=',par_qsn_position,' where papr_id=','''',par_papr_id,'''',' and qsn_id=','''',par_qsn_id,'''',' and qsn_sub_id=','''',par_qsn_sub_id,'''');

   prepare stmt from @strsql;
   execute stmt;
   deallocate prepare stmt;


  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `papr_update_qsn_type_position`;
CREATE PROCEDURE  `papr_update_qsn_type_position`(
in par_papr_id char(32),in par_qsn_point int(10),in par_qsn_type int(10),
in par_qsn_type_title varchar(1000),in par_qsn_type_label varchar(200),
in qsn_type_position int(10),in qsn_type_position_old int(10))
begin        
    
  update t_papr_qsn_type set qsn_type_position=qsn_type_position 
  where qsn_type_position_old=qsn_type_position_old and qsn_type=par_qsn_type and papr_id=par_papr_id;update t_papr_content set qsn_type_position=qsn_type_position
  where qsn_type_position=qsn_type_position_old and qsn_type=par_qsn_type and papr_id=par_papr_id;
 
  
  
  
  
  
  
        
end



