DROP PROCEDURE IF EXISTS `qsn_add_answer`;
CREATE PROCEDURE  `qsn_add_answer`(IN par_qsn_id CHAR(32),IN par_qsn_sub_id CHAR(32), IN par_qsn_item_id VARCHAR(20), IN par_qsn_type VARCHAR(20), IN par_qsn_answer TEXT, IN par_create_user_id int(10))
BEGIN
  insert into t_answer(qsn_id,qsn_sub_id,qsn_item_id,qsn_type,qsn_answer,create_tm,create_user_id)
  values(par_qsn_id,par_qsn_sub_id,par_qsn_item_id,par_qsn_type,par_qsn_answer,sysdate(),par_create_user_id);
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_add_attachment`;
CREATE PROCEDURE  `qsn_add_attachment`(IN par_info text)
begin
    set @strsql=concat('insert into t_qsn_attachments(qsn_id,qsn_sub_id,a_id,
    qsn_item_id,create_user_id,file_name,des,file_type,file_size,attachment,isimage,create_tm)
     values ',par_info);
    set @date=concat('',sysdate(),'');
    set @strsql=replace(@strsql,'sysdate',@date);

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_add_option`;
CREATE PROCEDURE  `qsn_add_option`(IN `par_qsn_id` CHAR(32), IN `par_qsn_sub_id` CHAR(32), IN `par_qsn_item_id` INTEGER(5), IN `par_qsn_item_sub_id` INTEGER(5), IN `par_qsn_item_tag` VARCHAR(3), IN `par_qsn_type` VARCHAR(20), IN `par_option_content` TEXT, IN `par_option_content_edit` TEXT, IN `par_create_user_id` VARCHAR(20))
BEGIN       

   insert into t_option (qsn_id,qsn_sub_id,qsn_item_id,qsn_item_sub_id,qsn_item_tag,qsn_type,option_content,option_content_edit,create_tm,create_user_id)
   values (par_qsn_id,par_qsn_sub_id,par_qsn_item_id,par_qsn_item_sub_id,par_qsn_item_tag,par_qsn_type,par_option_content,par_option_content_edit,sysdate(),par_create_user_id);

   update t_question set qsn_option_count=par_qsn_item_id where qsn_id=par_qsn_id and qsn_sub_id=par_qsn_sub_id;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_add_question`;
CREATE PROCEDURE  `qsn_add_question`(IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32), IN par_qsn_sub_flg CHAR(1),IN par_qsn_type VARCHAR(20), IN par_qsn_level VARCHAR(20), IN par_qsn_point INTEGER(3), IN par_qsn_time VARCHAR(20), IN par_qsn_source VARCHAR(20), IN par_qsn_status VARCHAR(20), IN par_qsn_content TEXT,IN par_qsn_content_edit TEXT, IN par_option_count SMALLINT(4), IN par_qsn_guide TEXT, IN par_qsn_category VARCHAR(20), IN par_create_user_id int(10))
BEGIN

  insert into t_question (qsn_id,qsn_sub_id,qsn_sub_flg,qsn_type,qsn_level,qsn_point,qsn_limit_tm,qsn_source,qsn_status,qsn_content,qsn_content_edit,qsn_option_count,qsn_guide,qsn_category,create_tm,create_user_id)
  values(par_qsn_id,par_qsn_sub_id,par_qsn_sub_flg,par_qsn_type,par_qsn_level,par_qsn_point,par_qsn_time,par_qsn_source,par_qsn_status,par_qsn_content,par_qsn_content_edit,par_option_count,par_qsn_guide,par_qsn_category,sysdate(),par_create_user_id);
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_add_sub_position`;
CREATE PROCEDURE  `qsn_add_sub_position`(in par_data text)
begin
    set @strsql=concat('insert into t_qsn_sub_position(qsn_id,qsn_sub_id,qsn_position) values ',par_data);
    prepare stmt from @strsql;  
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_analysis_type`;
CREATE PROCEDURE  `qsn_analysis_type`(in par_exam_name varchar (200),in par_qsn_type varchar(20),
in par_exam_category varchar (20),IN par_exam_group_id int(10),in par_exam_bgn_tm varchar (20),in par_exam_end_tm varchar (20),in par_page_idx int(10),in par_page_size int(10)
)
begin
set @strsql=concat('
 select e.exam_id,e.exam_name,p.papr_name,cde.desc_cn exam_category,gp.group_name,po.qsn_type_label,
 y.exam_times,e.exam_begin_tm,e.exam_end_tm,y.right_count,y.error_count,
 cde2.desc_cn qsn_type_name,po.qsn_type_point,round(po.qsn_type_point/e.exam_point*100,2) qsn_type_rate
from t_exam e
join t_exam_papr ep on ep.exam_id=e.exam_id
join t_paper p on p.papr_id=ep.papr_id
left join (
select rst.exam_id,rst.group_id,rst.exam_times,rst.papr_id,rst.right_count,rst.error_count,rst.pright_count,rst.qsn_type
from (
select e2.exam_id, g.group_id,e2.exam_times,e2.papr_id,count(*) right_count,null error_count,null pright_count,e2.qsn_type
from t_user_exam_info e2
join t_user_group g on g.user_id = e2.user_id ');
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_question q on q.qsn_id=e2.qsn_id and q.qsn_sub_flg is null ');
if par_qsn_type is not null then
    set @strsql=concat(@strsql,' and q.qsn_type=','''',par_qsn_type,'''');
end if;
set @strsql=concat(@strsql,' where e2.answer_status =1 group by e2.exam_id,e2.papr_id,e2.exam_times,g.group_id,e2.qsn_type');
set @strsql=concat(@strsql,' union all
select e2.exam_id, g.group_id,e2.exam_times,e2.papr_id,null right_count,count(*)error_count,null pright_count,e2.qsn_type
from t_user_exam_info e2
join t_question q on q.qsn_id=e2.qsn_id and q.qsn_sub_flg is null ');
if par_qsn_type is not null then
    set @strsql=concat(@strsql,' and q.qsn_type=','''',par_qsn_type,'''');
end if;
set @strsql=concat(@strsql,' join t_user_group g on g.user_id = e2.user_id ');
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' where e2.answer_status =0 group by e2.exam_id,e2.papr_id,e2.exam_times,g.group_id,e2.qsn_type
) rst group by rst.exam_id,rst.papr_id,rst.exam_times,rst.group_id,rst.qsn_type
) y on e.exam_id =y.exam_id and y.papr_id=ep.papr_id
join t_common_cde cde on cde.c_cde = e.exam_category
join t_common_cde cde2 on cde2.c_cde=y.qsn_type
join t_group gp on gp.group_id = y.group_id');
set @strsql=concat(@strsql,' left join (
            select e.exam_id,ep.papr_id,t.qsn_type,t.qsn_point qsn_type_point,t.qsn_type_label
            from t_papr_qsn_type t join t_exam_papr ep on ep.papr_id=t.papr_id ');
if par_qsn_type is not null then
    set @strsql=concat(@strsql,' and t.qsn_type=','''',par_qsn_type,'''');
end if;
set @strsql=concat(@strsql,'    join t_exam e on e.exam_id=ep.exam_id and e.exam_point_type=\'030201\'');
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exan_name like ','''',par_exam_name,'%''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_bgn_tm is not null and par_exam_end_tm then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
set @strsql=concat(@strsql,'    union all
                select e.exam_id,ep.papr_id,r.qsn_type,sum(r.qsn_point) qsn_type_point,null qsn_type_label
                 from t_question r join t_papr_content c on c.qsn_id=r.qsn_id ');
if par_qsn_type is not null then
    set @strsql=concat(@strsql,' and r.qsn_type=','''',par_qsn_type,'''');
end if;
set @strsql=concat(@strsql,' join t_exam_papr ep on ep.papr_id=c.papr_id
                 join t_exam e on e.exam_id=ep.exam_id and e.exam_point_type=\'030202\'');
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exan_name like ','''',par_exam_name,'%''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_bgn_tm is not null and par_exam_end_tm then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
set @strsql=concat(@strsql,'    group by e.exam_id,ep.papr_id,r.qsn_type ');
set @strsql=concat(@strsql,'    union all ');
set @strsql=concat(@strsql,'
            select x.exam_id,x.papr_id,x.qsn_type,x.qsn_type_point,null qsn_type_label from (
                select t2.exam_id,t2.papr_id,c.qsn_type,sum(t2.exam_point/a.papr_qsn_count) qsn_type_point
                from t_papr_content c join
                (select t1.exam_point,t1.exam_times,ep.papr_id,t1.exam_id from  t_exam_papr ep
                join t_exam t1 on ep.exam_id=t1.exam_id and t1.exam_point_type=\'030203\'');
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and t1.exan_name like ','''',par_exam_name,'%''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and t1.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_bgn_tm is not null and par_exam_end_tm then
    set @strsql=concat(@strsql,' and t1.exam_begin_tm between','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
set @strsql=concat(@strsql,' ) t2 on c.papr_id=t2.papr_id join t_paper a on a.papr_id=c.papr_id ');
if par_qsn_type is not null then
    set @strsql=concat(@strsql,' and c.qsn_type=','''',par_qsn_type,'''');
end if;
set @strsql=concat(@strsql,' group by c.qsn_type) x ) po on po.exam_id=y.exam_id and po.papr_id=y.papr_id and po.qsn_type=y.qsn_type ');
set @strsql=concat(@strsql,' where ');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''',' and ');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' e.exam_category=','''',par_exam_category,'''',' and ');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' e.exam_name like ','''',par_exam_name,'%''');
end if;
if par_exam_bgn_tm is null and par_exam_end_tm is null and par_exam_category is null and par_exam_name is null then
    set @strsql=substr(@strsql,1,length(@strsql)-6);
else
    if par_exam_name is null then
                set @strsql=substr(@strsql,1,length(@strsql)-4);
    end if;
end if;
set @strsql=concat(@strsql,'    group by e.exam_name,p.papr_name,cde.desc_cn,gp.group_name,y.exam_times,y.qsn_type ');
call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_delete_all_attachment`;
CREATE PROCEDURE  `qsn_delete_all_attachment`(in par_qsn_id char(32))
begin
    delete from t_qsn_attachments where qsn_id=par_qsn_id;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_delete_answer`;
CREATE PROCEDURE  `qsn_delete_answer`(in par_qsn_id char(32),in par_qsn_sub_id char(32))
begin
  delete from t_answer where qsn_id=par_qsn_id and qsn_sub_id=par_qsn_sub_id ;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_delete_attachment`;
CREATE PROCEDURE  `qsn_delete_attachment`(IN par_a_id text)
begin
    set @strsql=concat('delete from t_qsn_attachments where a_id in ',par_a_id);
      prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_delete_compounding`;
CREATE PROCEDURE  `qsn_delete_compounding`(in par_qsn_id char(32), in par_qsn_sub_id char(32))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
    
    insert into tmp_qsn_delete_compounding_tree(id,pid, level,position)
    values (par_qsn_sub_id,par_qsn_id,v_level,v_position);
    set v_row_count := row_count();  
    while v_row_count != 0 do
    set @position := 0;
    insert into tmp_qsn_delete_compounding_tree(
    id,pid,level,position
    )
    select q.qsn_sub_id,q.qsn_id
    , v_level + 1
    , @position := @position+1
    from t_question q
    inner join tmp_qsn_delete_compounding_tree t
    on q.qsn_id = t.id
    where t.level = v_level
    and q.qsn_sub_id !='0'
    order by q.qsn_sub_id;
    set v_row_count := row_count();
    set v_level := v_level + 1;
    end while;
        
    delete from t_question  where exists(
    select t.id,t.pid 
    from tmp_qsn_delete_compounding_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
     
    delete from t_answer where exists(
    select t.id,t.pid 
    from tmp_qsn_delete_compounding_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
    delete from t_option where exists(
    select t.id,t.pid
    from tmp_qsn_delete_compounding_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
    delete from t_qsn_attachments where exists(
    select t.id,t.pid
    from tmp_qsn_delete_compounding_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
    delete from t_qsn_sub_position where exists(
    select t.id,t.pid
    from tmp_qsn_delete_compounding_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
     
    truncate table tmp_qsn_delete_compounding_tree;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_delete_option`;
CREATE PROCEDURE  `qsn_delete_option`(IN par_qsn_id CHAR(32),IN par_qsn_sub_id CHAR(32))
BEGIN
   delete from t_option where qsn_id=par_qsn_id and qsn_sub_id=par_qsn_sub_id;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_delete_question`;
CREATE PROCEDURE  `qsn_delete_question`(IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32))
BEGIN
  declare _id char(32);
  declare _sub_id char(32);
  declare _done int default 0;
  declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
    
    insert into tmp_qsn_delete_tree(id,pid, level,position)
    values (par_qsn_sub_id,par_qsn_id,v_level,v_position);
    set v_row_count := row_count();
    while v_row_count != 0 do
      set @position := 0;
      insert into tmp_qsn_delete_tree(id,pid,level,position)
      select q.qsn_sub_id,q.qsn_id,v_level + 1, @position := @position+1
      from t_question q inner join tmp_qsn_delete_tree t on q.qsn_id = t.id
      where t.level = v_level and q.qsn_sub_id !='0'
     order by q.qsn_sub_id;
      set v_row_count := row_count();
      set v_level := v_level + 1;
    end while;
  delete from t_question  where exists(
  select t.id,t.pid from tmp_qsn_delete_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
    delete from t_answer where exists(
  select t.id,t.pid from tmp_qsn_delete_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
  delete from t_option where exists(
  select t.id,t.pid from tmp_qsn_delete_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
  delete from t_qsn_attachments where exists(
  select t.id,t.pid from tmp_qsn_delete_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
  delete from t_qsn_sub_position where exists(
  select t.id,t.pid from tmp_qsn_delete_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
  truncate table tmp_qsn_delete_tree;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_delete_sub_answer`;
CREATE PROCEDURE  `qsn_delete_sub_answer`(in par_qsn_id text)
begin
  set @strsql=concat('delete from t_answer where qsn_sub_id in ',par_qsn_id) ;
  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_delete_sub_position`;
CREATE PROCEDURE  `qsn_delete_sub_position`(in par_qsn_id char(32),in par_qsn_sub_id char(32))
begin
    if par_qsn_sub_id !=null then
        set @strsql=concat('delete from t_qsn_sub_position where qsn_id=','''',par_qsn_id,'''',' and qsn_sub_id=','''',par_qsn_sub_id,'''');
    else
        set @strsql=concat('delete from t_qsn_sub_position where qsn_id=','''',par_qsn_id,'''');
    end if;
    prepare stmt from @strsql;  
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_delete_sub_qsn_answer`;
CREATE PROCEDURE  `qsn_delete_sub_qsn_answer`(in par_qsn_sub_id char(32))
begin
declare done int default 0;
declare qid2 char(32);
declare cur2 cursor for select q.qsn_sub_id from t_question q where q.qsn_id=par_qsn_sub_id;
declare continue handler for sqlstate '02000' set done = 1;
open cur2;
repeat
    fetch cur2 into qid2;   
    if not done then
       if qid2 is not null then
          delete from t_answer  where  qsn_sub_id=qid2;                         
       end if;
    end if;
until done end repeat;
close cur2;    
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_delete_sub_qsn_option`;
CREATE PROCEDURE  `qsn_delete_sub_qsn_option`(in par_qsn_sub_id char(32))
begin   
declare done int default 0;
declare qid2 char(32); 
declare cur2 cursor for select q.qsn_sub_id from t_question q where q.qsn_id=par_qsn_sub_id;
declare continue handler for sqlstate '02000' set done = 1;
open cur2;
repeat
    fetch cur2 into qid2;   
    if not done then
       if qid2 is not null then
          delete from t_option  where  qsn_sub_id=qid2;
       end if;
    end if;
until done end repeat;
close cur2;    
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_delete_sub_question`;
CREATE PROCEDURE  `qsn_delete_sub_question`(in par_qsn_id text,in par_qsn_sub_id text)
begin
    set @strsql=concat('delete from t_qsn_sub_position where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
    set @strsql=concat('delete from t_question where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  set @strsql=concat('delete from t_answer where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;      
    
  set @strsql=concat('delete from t_option where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  set @strsql=concat('delete from t_option where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  set @strsql=concat('delete from t_qsn_attachments where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_display_content`;
CREATE PROCEDURE  `qsn_display_content`(in par_qsn_id char(32),in par_qsn_sub_id char(32),in par_qsn_type varchar(20))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
  set @mysql2='';

    insert into tmp_qsn_display_content_tree(id,pid, level,position)
    values (par_qsn_id,par_qsn_sub_id,v_level,v_position);

    set v_row_count := row_count();

    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_qsn_display_content_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_qsn_display_content_tree t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

set @strsql='
select
       x.qsn_id,
       x.qsn_sub_id,
       r.qsn_point,
       x.qsn_content,
       x.option_content,
       x.qsn_item_tag,
       x.qsn_item_id,
       x.qsn_item_sub_id,
       a.qsn_answer,
       x.qsn_guide,
       x.qsn_type,
       x.qsn_position,
       x.sub_qsn_flg
  from (select
               tp.qsn_id,
               tp.qsn_sub_id,
               tp.qsn_content,
               tp.option_content,
               tp.qsn_item_tag,
               case when tp.qsn_item_id is null then 1 else tp.qsn_item_id end qsn_item_id,
               tp.qsn_item_sub_id,
               tp.qsn_guide,
               tp.qsn_type,
               tp.qsn_position,
               NULL sub_qsn_flg
          from (select
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       o.option_content,
                       o.qsn_item_id,
                       o.qsn_item_sub_id,
                       o.qsn_item_tag,
                       q.qsn_type,
                       case when p.qsn_position is not null then
                             p.qsn_position
                       else
                            0
                       end  qsn_position
                  from
                  t_question q
                  left join t_qsn_sub_position p on p.qsn_id = q.qsn_id and p.qsn_sub_id = q.qsn_sub_id
                  left join t_option o on o.qsn_id = q.qsn_id and o.qsn_sub_id = q.qsn_sub_id and o.qsn_type=q.qsn_type ';

if par_qsn_id is not null and par_qsn_sub_id is not null then
    set @strsql=concat(@strsql,' where q.qsn_id=','''',par_qsn_id,'''',' and q.qsn_sub_id=','''',par_qsn_sub_id,'''');
end if;

set @strsql=concat(@strsql,' )tp');
set @strsql=concat(@strsql,' union
        select
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.option_content,
               y.qsn_item_tag,
               case when y.qsn_item_id is null then 1 else y.qsn_item_id end qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_guide,
               y.qsn_type,
               y.qsn_position,              
               y.flg sub_qsn_flg
          from (select
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       o.option_content,
                       o.qsn_item_tag,
                       o.qsn_item_id,
                       o.qsn_item_sub_id,
                       q.qsn_type,
                       q.qsn_position,                     
                       sp.flg
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               r.qsn_content,
                               r.qsn_type,
                               r.qsn_guide,
                               s.qsn_position
                          from tmp_qsn_display_content_tree t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                       ) q
                  left join t_option o on q.qsn_id = o.qsn_id and q.qsn_sub_id = o.qsn_sub_id and o.qsn_type=q.qsn_type
                  left join (select distinct t1.qsn_id,
                                            case
                                              when t1.qsn_id is not null then
                                               1
                                              else
                                               0
                                            end flg
                              from t_qsn_sub_position t1
                              join tmp_qsn_display_content_tree t2 on t2.id = t1.qsn_id) sp on sp.qsn_id =q.qsn_sub_id
                                                                        and q.qsn_type in(\'010105\',\'010106\')
                 ) y
        ) x
  left join (select r.qsn_id, r.qsn_sub_id,r.qsn_point
                       from tmp_qsn_display_content_tree t, t_question r
                      where t.id = r.qsn_id and t.pid = r.qsn_sub_id
union
select r.qsn_id, r.qsn_sub_id,r.qsn_point
                       from tmp_qsn_display_content_tree t, t_question r
                      where t.pid = r.qsn_id and t.id = r.qsn_sub_id
           ) r on x.qsn_id =r.qsn_id and x.qsn_sub_id =r.qsn_sub_id
left join (select t.qsn_id,t.qsn_sub_id,group_concat(t.qsn_answer SEPARATOR \'__\') qsn_answer
               from t_answer t where exists(select id,pid from tmp_qsn_display_content_tree where (id=t.qsn_id and pid=t.qsn_sub_id) or (id=t.qsn_sub_id and pid=t.qsn_id))
              group by t.qsn_id, t.qsn_sub_id

          ) a on a.qsn_id = x.qsn_id and a.qsn_sub_id = x.qsn_sub_id ');

set @strsql=concat(@strsql,' group by
        x.qsn_id,x.qsn_sub_id,r.qsn_point,x.qsn_content,x.option_content,x.qsn_item_tag,
       x.qsn_item_id,x.qsn_item_sub_id,a.qsn_answer,x.qsn_guide,x.qsn_type,x.qsn_position,x.sub_qsn_flg
       order by x.qsn_position');

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_qsn_display_content_tree;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_export_analysis_type`;
CREATE PROCEDURE  `qsn_export_analysis_type`(in par_exam_name varchar (200),in par_qsn_type varchar(20),
in par_exam_category varchar (20),IN par_exam_group_id int(10),in par_exam_bgn_tm varchar (20),in par_exam_end_tm varchar (20))
begin
set @strsql=concat('
 select e.exam_id,e.exam_name,p.papr_name,cde.desc_cn exam_category,gp.group_name,po.qsn_type_label,
 y.exam_times,e.exam_begin_tm,e.exam_end_tm,y.right_count,y.error_count,
 cde2.desc_cn qsn_type_name,po.qsn_type_point,round(po.qsn_type_point/e.exam_point*100,2) qsn_type_rate
from t_exam e
join t_exam_papr ep on ep.exam_id=e.exam_id
join t_paper p on p.papr_id=ep.papr_id
left join (
select rst.exam_id,rst.group_id,rst.exam_times,rst.papr_id,rst.right_count,rst.error_count,rst.pright_count,rst.qsn_type
from (
select e2.exam_id, g.group_id,e2.exam_times,e2.papr_id,count(*) right_count,null error_count,null pright_count,e2.qsn_type
from t_user_exam_info e2
join t_user_group g on g.user_id = e2.user_id ');
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_question q on q.qsn_id=e2.qsn_id and q.qsn_sub_flg is null ');
if par_qsn_type is not null then
    set @strsql=concat(@strsql,' and q.qsn_type=','''',par_qsn_type,'''');
end if;
set @strsql=concat(@strsql,' where e2.answer_status =1 group by e2.exam_id,e2.papr_id,e2.exam_times,g.group_id,e2.qsn_type');
set @strsql=concat(@strsql,' union all
select e2.exam_id, g.group_id,e2.exam_times,e2.papr_id,null right_count,count(*)error_count,null pright_count,e2.qsn_type
from t_user_exam_info e2
join t_question q on q.qsn_id=e2.qsn_id and q.qsn_sub_flg is null ');
if par_qsn_type is not null then
    set @strsql=concat(@strsql,' and q.qsn_type=','''',par_qsn_type,'''');
end if;
set @strsql=concat(@strsql,' join t_user_group g on g.user_id = e2.user_id ');
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' where e2.answer_status =0 group by e2.exam_id,e2.papr_id,e2.exam_times,g.group_id,e2.qsn_type
) rst group by rst.exam_id,rst.papr_id,rst.exam_times,rst.group_id,rst.qsn_type
) y on e.exam_id =y.exam_id and y.papr_id=ep.papr_id
join t_common_cde cde on cde.c_cde = e.exam_category
join t_common_cde cde2 on cde2.c_cde=y.qsn_type
join t_group gp on gp.group_id = y.group_id');
set @strsql=concat(@strsql,' left join (
            select e.exam_id,ep.papr_id,t.qsn_type,t.qsn_point qsn_type_point,t.qsn_type_label
            from t_papr_qsn_type t join t_exam_papr ep on ep.papr_id=t.papr_id ');
if par_qsn_type is not null then
    set @strsql=concat(@strsql,' and t.qsn_type=','''',par_qsn_type,'''');
end if;
set @strsql=concat(@strsql,'    join t_exam e on e.exam_id=ep.exam_id and e.exam_point_type=\'030201\'');
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exan_name like ','''',par_exam_name,'%''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_bgn_tm is not null and par_exam_end_tm then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
set @strsql=concat(@strsql,'    union all
                select e.exam_id,ep.papr_id,r.qsn_type,sum(r.qsn_point) qsn_type_point,null qsn_type_label
                 from t_question r join t_papr_content c on c.qsn_id=r.qsn_id ');
if par_qsn_type is not null then
    set @strsql=concat(@strsql,' and r.qsn_type=','''',par_qsn_type,'''');
end if;
set @strsql=concat(@strsql,' join t_exam_papr ep on ep.papr_id=c.papr_id
                 join t_exam e on e.exam_id=ep.exam_id and e.exam_point_type=\'030202\'');
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exan_name like ','''',par_exam_name,'%''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_bgn_tm is not null and par_exam_end_tm then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
set @strsql=concat(@strsql,'    group by e.exam_id,ep.papr_id,r.qsn_type ');
set @strsql=concat(@strsql,'    union all ');
set @strsql=concat(@strsql,'
            select x.exam_id,x.papr_id,x.qsn_type,x.qsn_type_point,null qsn_type_label from (
                select t2.exam_id,t2.papr_id,c.qsn_type,sum(t2.exam_point/a.papr_qsn_count) qsn_type_point
                from t_papr_content c join
                (select t1.exam_point,t1.exam_times,ep.papr_id,t1.exam_id from  t_exam_papr ep
                join t_exam t1 on ep.exam_id=t1.exam_id and t1.exam_point_type=\'030203\'');
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and t1.exan_name like ','''',par_exam_name,'%''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and t1.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_bgn_tm is not null and par_exam_end_tm then
    set @strsql=concat(@strsql,' and t1.exam_begin_tm between','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
set @strsql=concat(@strsql,' ) t2 on c.papr_id=t2.papr_id join t_paper a on a.papr_id=c.papr_id ');
if par_qsn_type is not null then
    set @strsql=concat(@strsql,' and c.qsn_type=','''',par_qsn_type,'''');
end if;
set @strsql=concat(@strsql,' group by c.qsn_type) x ) po on po.exam_id=y.exam_id and po.papr_id=y.papr_id and po.qsn_type=y.qsn_type ');
set @strsql=concat(@strsql,' where ');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''',' and ');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' e.exam_category=','''',par_exam_category,'''',' and ');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' e.exam_name like ','''',par_exam_name,'%''');
end if;
if par_exam_bgn_tm is null and par_exam_end_tm is null and par_exam_category is null and par_exam_name is null then
    set @strsql=substr(@strsql,1,length(@strsql)-6);
else
    if par_exam_name is null then
                set @strsql=substr(@strsql,1,length(@strsql)-4);
    end if;
end if;
set @strsql=concat(@strsql,'    group by e.exam_name,p.papr_name,cde.desc_cn,gp.group_name,y.exam_times,y.qsn_type ');

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_export_question`;
CREATE PROCEDURE  `qsn_export_question`(in par_qsn_id char(32),in par_qsn_sub_id char(32),in par_qsn_type varchar(20))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
    set @mysql2='';

    insert into tmp_qsn_display_content_tree(id,pid, level,position)
    values (par_qsn_id,par_qsn_sub_id,v_level,v_position);

    set v_row_count := row_count();

    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_qsn_display_content_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_qsn_display_content_tree t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

set @strsql='
select
       x.qsn_id,
       x.qsn_sub_id,
       r.qsn_point,
       x.qsn_content,
       x.qsn_content_edit,
       x.option_content,
       x.qsn_item_tag,
       x.qsn_item_id,
       x.qsn_item_sub_id,
       a.qsn_answer,
       x.qsn_guide,
       x.qsn_type,
       x.qsn_position,
       x.sub_qsn_flg
  from (select
               tp.qsn_id,
               tp.qsn_sub_id,
               tp.qsn_content,
               tp.qsn_content_edit,
               tp.option_content,
               tp.qsn_item_tag,
               case when tp.qsn_item_id is null then 1 else tp.qsn_item_id end qsn_item_id,
               tp.qsn_item_sub_id,
               tp.qsn_guide,
               tp.qsn_type,
               tp.qsn_position,
               NULL sub_qsn_flg
          from (select
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_content_edit,
                       q.qsn_guide,
                       o.option_content,
                       o.qsn_item_id,
                       o.qsn_item_sub_id,
                       o.qsn_item_tag,
                       q.qsn_type,
                       case when p.qsn_position is not null then
                             p.qsn_position
                       else
                            0
                       end  qsn_position
                  from
                  t_question q
                  left join t_qsn_sub_position p on p.qsn_id = q.qsn_id and p.qsn_sub_id = q.qsn_sub_id
                  left join t_option o on o.qsn_id = q.qsn_id and o.qsn_sub_id = q.qsn_sub_id and o.qsn_type=q.qsn_type ';

if par_qsn_id is not null and par_qsn_sub_id is not null then
    set @strsql=concat(@strsql,' where q.qsn_id=','''',par_qsn_id,'''',' and q.qsn_sub_id=','''',par_qsn_sub_id,'''');
end if;

set @strsql=concat(@strsql,' )tp');
set @strsql=concat(@strsql,' union
        select
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.qsn_content_edit,
               y.option_content,
               y.qsn_item_tag,
               case when y.qsn_item_id is null then 1 else y.qsn_item_id end qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_guide,
               y.qsn_type,
               y.qsn_position,
               y.flg sub_qsn_flg
          from (select
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_content_edit,
                       q.qsn_guide,
                       o.option_content,
                       o.qsn_item_tag,
                       o.qsn_item_id,
                       o.qsn_item_sub_id,
                       q.qsn_type,
                       q.qsn_position,                     
                       sp.flg
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               r.qsn_content,
                               r.qsn_content_edit,
                               r.qsn_type,
                               r.qsn_guide,
                               s.qsn_position
                          from tmp_qsn_display_content_tree t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                       ) q
                  left join t_option o on q.qsn_id = o.qsn_id and q.qsn_sub_id = o.qsn_sub_id and o.qsn_type=q.qsn_type
                  left join (select distinct t1.qsn_id,
                                            case
                                              when t1.qsn_id is not null then
                                               1
                                              else
                                               0
                                            end flg
                              from t_qsn_sub_position t1
                              join tmp_qsn_display_content_tree t2 on t2.id = t1.qsn_id) sp on sp.qsn_id =q.qsn_sub_id
                                                                        and q.qsn_type in(\'010105\',\'010106\')
                 ) y
        ) x
  left join (select r.qsn_id, r.qsn_sub_id,r.qsn_point
                       from tmp_qsn_display_content_tree t, t_question r
                      where t.id = r.qsn_id and t.pid = r.qsn_sub_id
union
select r.qsn_id, r.qsn_sub_id,r.qsn_point
                       from tmp_qsn_display_content_tree t, t_question r
                      where t.pid = r.qsn_id and t.id = r.qsn_sub_id
           ) r on x.qsn_id =r.qsn_id and x.qsn_sub_id =r.qsn_sub_id
left join (select t.qsn_id,t.qsn_sub_id,group_concat(t.qsn_answer SEPARATOR \'__\') qsn_answer
               from t_answer t where exists(select id,pid from tmp_qsn_display_content_tree where (id=t.qsn_id and pid=t.qsn_sub_id) or (id=t.qsn_sub_id and pid=t.qsn_id))
              group by t.qsn_id, t.qsn_sub_id

          ) a on a.qsn_id = x.qsn_id and a.qsn_sub_id = x.qsn_sub_id ');

set @strsql=concat(@strsql,' group by
        x.qsn_id,x.qsn_sub_id,r.qsn_point,x.qsn_content,x.option_content,x.qsn_item_tag,
       x.qsn_item_id,x.qsn_item_sub_id,a.qsn_answer,x.qsn_guide,x.qsn_type,x.qsn_position,x.sub_qsn_flg
       order by x.qsn_position');

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_qsn_display_content_tree;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_export_question_select`;
CREATE PROCEDURE  `qsn_export_question_select`(IN par_qsn_source VARCHAR(20), IN par_qsn_type VARCHAR(20), IN par_qsn_level VARCHAR(20), IN par_qsn_status VARCHAR(20), IN par_qsn_point FLOAT(10,2), IN par_qsn_content TEXT, IN par_qsn_input_person INT(10))
begin

SET @strsql = 'SELECT q.qsn_id, q.qsn_sub_id
FROM t_question q WHERE q.qsn_sub_flg IS NULL';

IF par_qsn_source IS NOT NULL AND par_qsn_source <> '' THEN
  SET @strsql = CONCAT(@strsql, ' AND q.qsn_source=','''',par_qsn_source,'''');
END IF;

IF par_qsn_type IS NOT NULL AND par_qsn_type <> '' THEN
  SET @strsql = CONCAT(@strsql, ' AND q.qsn_type=','''',par_qsn_type,'''');
END IF;

IF par_qsn_level IS NOT NULL AND par_qsn_level <> '' THEN
  SET @strsql = CONCAT(@strsql, ' AND q.qsn_level=','''',par_qsn_level,'''');
END IF;

IF par_qsn_status IS NOT NULL AND par_qsn_status <> '' THEN
  SET @strsql = CONCAT(@strsql, ' AND q.qsn_status=','''',par_qsn_status,'''');
END IF;

IF par_qsn_point IS NOT NULL AND par_qsn_point <> 0 THEN
  SET @strsql = CONCAT(@strsql, ' AND q.qsn_point=',par_qsn_point);
END IF;

IF par_qsn_content IS NOT NULL AND par_qsn_content <> '' THEN
  SET @strsql = CONCAT(@strsql, ' AND q.qsn_content LIKE ','''%',par_qsn_content,'%''');
END IF;

IF par_qsn_input_person IS NOT NULL AND par_qsn_input_person <> 0 THEN
  SET @strsql = CONCAT(@strsql, ' AND q.qsn_input_person=',par_qsn_input_person);
END IF;

SET @strsql = CONCAT(@strsql, ' ORDER BY q.qsn_type');

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;


end

DROP PROCEDURE IF EXISTS `qsn_import_add_answer`;
CREATE PROCEDURE  `qsn_import_add_answer`(IN par_qsn_id CHAR(32),IN par_qsn_sub_id CHAR(32), IN par_qsn_item_id VARCHAR(20), IN par_qsn_type VARCHAR(20), IN par_qsn_answer TEXT, IN par_create_user_id int(10))
BEGIN  
   insert into t_answer_import(qsn_id,qsn_sub_id,qsn_item_id,qsn_type,qsn_answer,create_tm,create_user_id)  values(par_qsn_id,par_qsn_sub_id,par_qsn_item_id,par_qsn_type,par_qsn_answer,sysdate(),par_create_user_id);                  
end

DROP PROCEDURE IF EXISTS `qsn_import_add_option`;
CREATE PROCEDURE  `qsn_import_add_option`(IN `par_qsn_id` CHAR(32), IN `par_qsn_sub_id` CHAR(32), IN `par_qsn_item_id` INTEGER(5), IN `par_qsn_item_sub_id` INTEGER(5), IN `par_qsn_item_tag` VARCHAR(3), IN `par_qsn_type` VARCHAR(20), IN `par_option_content` TEXT, IN `par_option_content_edit` TEXT, IN `par_create_user_id` VARCHAR(20))
BEGIN
insert into t_option_import (qsn_id,qsn_sub_id,qsn_item_id,qsn_item_sub_id,qsn_item_tag,qsn_type,option_content,option_content_edit,create_tm,create_user_id)   values (par_qsn_id,par_qsn_sub_id,par_qsn_item_id,par_qsn_item_sub_id,par_qsn_item_tag,par_qsn_type,par_option_content,par_option_content_edit,sysdate(),par_create_user_id);
update t_question_import set qsn_option_count=par_qsn_item_id where qsn_id=par_qsn_id and qsn_sub_id=par_qsn_sub_id;                      
end

DROP PROCEDURE IF EXISTS `qsn_import_add_question`;
CREATE PROCEDURE  `qsn_import_add_question`(IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32), IN par_qsn_sub_flg CHAR(1),IN par_qsn_type VARCHAR(20), IN par_qsn_level VARCHAR(20), IN par_qsn_point INTEGER(3), IN par_qsn_time VARCHAR(20), IN par_qsn_source VARCHAR(20), IN par_qsn_status VARCHAR(20), IN par_qsn_content TEXT,IN par_qsn_content_edit TEXT, IN par_option_count SMALLINT(4), IN par_qsn_guide TEXT, IN par_qsn_category VARCHAR(20), IN par_create_user_id int(10))
BEGIN  
   insert into t_question_import (qsn_id,qsn_sub_id,qsn_sub_flg,qsn_type,qsn_level,qsn_point,qsn_limit_tm,qsn_source,qsn_status,qsn_content,qsn_content_edit,qsn_option_count,qsn_guide,qsn_category,create_tm,create_user_id)  values(par_qsn_id,par_qsn_sub_id,par_qsn_sub_flg,par_qsn_type,par_qsn_level,par_qsn_point,par_qsn_time,par_qsn_source,par_qsn_status,par_qsn_content,par_qsn_content_edit,par_option_count,par_qsn_guide,par_qsn_category,sysdate(),par_create_user_id);                  
end

DROP PROCEDURE IF EXISTS `qsn_import_add_sub_position`;
CREATE PROCEDURE  `qsn_import_add_sub_position`(in par_data text)
begin  
     set @strsql=concat('insert into t_qsn_sub_position_import(qsn_id,qsn_sub_id,qsn_position) values ',par_data);
     prepare stmt from @strsql;
     execute stmt;
     deallocate prepare stmt;                      
end

DROP PROCEDURE IF EXISTS `qsn_import_batch_update`;
CREATE PROCEDURE  `qsn_import_batch_update`(IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32), IN par_qsn_level VARCHAR(20), IN par_qsn_source VARCHAR(20), IN par_qsn_category VARCHAR(20), IN par_update_user_id INT(10))
BEGIN  
     SET @str_where = " WHERE 1=1";
     IF par_qsn_id IS NOT NULL AND par_qsn_id != '' THEN
     SET @str_where = CONCAT(@str_where, " AND qsn_id='", par_qsn_id, "'");
     END IF;
     IF par_qsn_sub_id IS NOT NULL AND par_qsn_sub_id != '' THEN
     SET @str_where = CONCAT(@str_where, " AND qsn_sub_id='", par_qsn_sub_id, "'");
     END IF;
     SET @str_set = "";
     IF par_qsn_level IS NOT NULL AND par_qsn_level != '' THEN
     SET @str_set = CONCAT(@str_set, " qsn_level='", par_qsn_level, "',");
     END IF;    IF par_qsn_source IS NOT NULL AND par_qsn_source != '' THEN
     SET @str_set = CONCAT(@str_set, " qsn_source='", par_qsn_source, "',");
     END IF;    IF par_qsn_category IS NOT NULL AND par_qsn_category != '' THEN
     SET @str_set = CONCAT(@str_set, " qsn_category='", par_qsn_category, "',");
     END IF;
     IF par_update_user_id IS NOT NULL AND par_update_user_id != '' AND par_update_user_id != 0 THEN
     SET @str_set = CONCAT(@str_set, " update_user_id=", par_update_user_id, ",");
     END IF;    SET @str_set = CONCAT(@str_set, "update_tm='", SYSDATE(), "',");
     IF @str_set IS NOT NULL AND @str_set != '' THEN
     SET @str_set = substring(@str_set FROM 1 FOR CHAR_LENGTH(@str_set)-1);
     END IF;    SET @str_sql = CONCAT("UPDATE t_question_import SET ");
     SET @str_sql = CONCAT(@str_sql, @str_set, @str_where);
     PREPARE stmt FROM @str_sql;
     EXECUTE stmt;
     DEALLOCATE PREPARE stmt;  
end

DROP PROCEDURE IF EXISTS `qsn_import_delete_answer`;
CREATE PROCEDURE  `qsn_import_delete_answer`(in par_qsn_id char(32),in par_qsn_sub_id char(32))
begin  
   delete from t_answer_import where qsn_id=par_qsn_id and qsn_sub_id=par_qsn_sub_id ;                     
end

DROP PROCEDURE IF EXISTS `qsn_import_delete_option`;
CREATE PROCEDURE  `qsn_import_delete_option`(IN par_qsn_id CHAR(32),IN par_qsn_sub_id CHAR(32))
BEGIN  
    delete from t_option_import where qsn_id=par_qsn_id and qsn_sub_id=par_qsn_sub_id;                      
end

DROP PROCEDURE IF EXISTS `qsn_import_delete_question`;
CREATE PROCEDURE  `qsn_import_delete_question`(IN par_flag CHAR(10), IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32))
BEGIN  
     declare _id char(32);
     declare _sub_id char(32);
     declare _done int default 0;
     declare v_level int unsigned default 0;
     declare v_position int unsigned default 1;
     declare v_row_count int unsigned default 0;
     IF par_flag = 'part' THEN
     insert into tmp_qsn_delete_tree(id,pid, level,position)    values (par_qsn_sub_id,par_qsn_id,v_level,v_position);
     set v_row_count := row_count();
     while v_row_count != 0 do
     set @position := 0;
     insert into tmp_qsn_delete_tree(id,pid,level,position)
     select q.qsn_sub_id,q.qsn_id,v_level + 1, @position := @position+1
     from t_question_import q inner join tmp_qsn_delete_tree t on q.qsn_id = t.id
     where t.level = v_level and q.qsn_sub_id !='0'
     order by q.qsn_sub_id;
     set v_row_count := row_count();
     set v_level := v_level + 1;
     end while;
     delete from t_question_import  where exists(
     select t.id,t.pid from tmp_qsn_delete_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
     delete from t_answer_import where exists(
     select t.id,t.pid from tmp_qsn_delete_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
     delete from t_option_import where exists(
     select t.id,t.pid from tmp_qsn_delete_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
     delete from t_qsn_sub_position_import where exists(
     select t.id,t.pid from tmp_qsn_delete_tree t where t.pid=qsn_id and t.id=qsn_sub_id);
     truncate table tmp_qsn_delete_tree;
     ELSE
     TRUNCATE TABLE t_question_import;
     TRUNCATE TABLE t_option_import;
     TRUNCATE TABLE t_answer_import;
     TRUNCATE TABLE t_qsn_sub_position_import;
     END IF;
end

DROP PROCEDURE IF EXISTS `qsn_import_delete_sub_answer`;
CREATE PROCEDURE  `qsn_import_delete_sub_answer`(in par_qsn_id text)
begin  
   set @strsql=concat('delete from t_answer_import where qsn_sub_id in ',par_qsn_id) ;
   prepare stmt from @strsql;
   execute stmt;
   deallocate prepare stmt;                     
end

DROP PROCEDURE IF EXISTS `qsn_import_delete_sub_question`;
CREATE PROCEDURE  `qsn_import_delete_sub_question`(in par_qsn_id text,in par_qsn_sub_id text)
begin  
     set @strsql=concat('delete from t_qsn_sub_position_import where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
     prepare stmt from @strsql;
     execute stmt;
     deallocate prepare stmt;
     set @strsql=concat('delete from t_question_import where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
     prepare stmt from @strsql;
     execute stmt;
     deallocate prepare stmt;
     set @strsql=concat('delete from t_answer_import where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
     prepare stmt from @strsql;    execute stmt;    deallocate prepare stmt;
     set @strsql=concat('delete from t_option_import where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
     prepare stmt from @strsql;
     execute stmt;
     deallocate prepare stmt;
     set @strsql=concat('delete from t_option_import where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
     prepare stmt from @strsql;
     execute stmt;
     deallocate prepare stmt;
     set @strsql=concat('delete from t_qsn_attachments where qsn_id in ',par_qsn_id,' and qsn_sub_id in ',par_qsn_sub_id);
     prepare stmt from @strsql;
     execute stmt;
     deallocate prepare stmt;
end

DROP PROCEDURE IF EXISTS `qsn_import_display_content`;
CREATE PROCEDURE  `qsn_import_display_content`(in par_qsn_id char(32),in par_qsn_sub_id char(32),in par_qsn_type varchar(20))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
  set @mysql2='';

    insert into tmp_qsn_display_content_tree(id,pid, level,position)
    values (par_qsn_id,par_qsn_sub_id,v_level,v_position);

    set v_row_count := row_count();

    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_qsn_display_content_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question_import q
        inner join tmp_qsn_display_content_tree t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

set @strsql='
select
       x.qsn_id,
       x.qsn_sub_id,
       r.qsn_point,
       x.qsn_content,
       x.option_content,
       x.qsn_item_tag,
       x.qsn_item_id,
       x.qsn_item_sub_id,
       a.qsn_answer,
       x.qsn_guide,
       x.qsn_type,
       x.qsn_position,
       x.sub_qsn_flg
  from (select
               tp.qsn_id,
               tp.qsn_sub_id,
               tp.qsn_content,
               tp.option_content,
               tp.qsn_item_tag,
               case when tp.qsn_item_id is null then 1 else tp.qsn_item_id end qsn_item_id,
               tp.qsn_item_sub_id,
               tp.qsn_guide,
               tp.qsn_type,
               tp.qsn_position,
               NULL sub_qsn_flg
          from (select
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       o.option_content,
                       o.qsn_item_id,
                       o.qsn_item_sub_id,
                       o.qsn_item_tag,
                       q.qsn_type,
                       case when p.qsn_position is not null then
                             p.qsn_position
                       else
                            0
                       end  qsn_position
                  from
                  t_question_import q
                  left join t_qsn_sub_position_import p on p.qsn_id = q.qsn_id and p.qsn_sub_id = q.qsn_sub_id
                  left join t_option_import o on o.qsn_id = q.qsn_id and o.qsn_sub_id = q.qsn_sub_id and o.qsn_type=q.qsn_type ';

if par_qsn_id is not null and par_qsn_sub_id is not null then
    set @strsql=concat(@strsql,' where q.qsn_id=','''',par_qsn_id,'''',' and q.qsn_sub_id=','''',par_qsn_sub_id,'''');
end if;

set @strsql=concat(@strsql,' )tp');
set @strsql=concat(@strsql,' union
        select
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.option_content,
               y.qsn_item_tag,
               case when y.qsn_item_id is null then 1 else y.qsn_item_id end qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_guide,
               y.qsn_type,
               y.qsn_position,              
               y.flg sub_qsn_flg
          from (select
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       o.option_content,
                       o.qsn_item_tag,
                       o.qsn_item_id,
                       o.qsn_item_sub_id,
                       q.qsn_type,
                       q.qsn_position,                     
                       sp.flg
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               r.qsn_content,
                               r.qsn_type,
                               r.qsn_guide,
                               s.qsn_position
                          from tmp_qsn_display_content_tree t, t_question_import r, t_qsn_sub_position_import s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                       ) q
                  left join t_option_import o on q.qsn_id = o.qsn_id and q.qsn_sub_id = o.qsn_sub_id and o.qsn_type=q.qsn_type
                  left join (select distinct t1.qsn_id,
                                            case
                                              when t1.qsn_id is not null then
                                               1
                                              else
                                               0
                                            end flg
                              from t_qsn_sub_position_import t1
                              join tmp_qsn_display_content_tree t2 on t2.id = t1.qsn_id) sp on sp.qsn_id =q.qsn_sub_id
                                                                        and q.qsn_type in(\'010105\',\'010106\')
                 ) y
        ) x
  left join (select r.qsn_id, r.qsn_sub_id,r.qsn_point
                       from tmp_qsn_display_content_tree t, t_question_import r
                      where t.id = r.qsn_id and t.pid = r.qsn_sub_id
union
select r.qsn_id, r.qsn_sub_id,r.qsn_point
                       from tmp_qsn_display_content_tree t, t_question_import r
                      where t.pid = r.qsn_id and t.id = r.qsn_sub_id
           ) r on x.qsn_id =r.qsn_id and x.qsn_sub_id =r.qsn_sub_id
left join (select t.qsn_id,t.qsn_sub_id,group_concat(t.qsn_answer SEPARATOR \'__\') qsn_answer
               from t_answer_import t where exists(select id,pid from tmp_qsn_display_content_tree where (id=t.qsn_id and pid=t.qsn_sub_id) or (id=t.qsn_sub_id and pid=t.qsn_id))
              group by t.qsn_id, t.qsn_sub_id

          ) a on a.qsn_id = x.qsn_id and a.qsn_sub_id = x.qsn_sub_id ');

set @strsql=concat(@strsql,' group by
        x.qsn_id,x.qsn_sub_id,r.qsn_point,x.qsn_content,x.option_content,x.qsn_item_tag,
       x.qsn_item_id,x.qsn_item_sub_id,a.qsn_answer,x.qsn_guide,x.qsn_type,x.qsn_position,x.sub_qsn_flg
       order by x.qsn_position');

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_qsn_display_content_tree;
  
  
  
  
  
  
  
      
end

DROP PROCEDURE IF EXISTS `qsn_import_move_to_question`;
CREATE PROCEDURE  `qsn_import_move_to_question`(IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32))
BEGIN                                               
 IF par_qsn_id IS NULL AND par_qsn_sub_id IS NULL OR par_qsn_id = '' AND par_qsn_sub_id = '' OR par_qsn_id = '0' AND par_qsn_sub_id = '0' THEN
 REPLACE INTO t_question SELECT * FROM t_question_import;
 TRUNCATE TABLE t_question_import;
 REPLACE INTO t_option SELECT * FROM t_option_import;
 TRUNCATE TABLE t_option_import;
 REPLACE INTO t_answer SELECT * FROM t_answer_import;
 TRUNCATE TABLE t_answer_import;
 REPLACE INTO t_qsn_sub_position SELECT * FROM t_qsn_sub_position_import;
 TRUNCATE TABLE t_qsn_sub_position_import;
 ELSE
 SET @str_sql_1 = CONCAT("SELECT q1.* FROM t_question_import AS q1 WHERE q1.qsn_id = '", par_qsn_id, "' AND q1.qsn_sub_id = '", par_qsn_sub_id, "'");
 SET @str_sql_2 = '';
 SET @str_sql = '';
 IF par_qsn_sub_id IS NOT NULL AND par_qsn_sub_id != '' AND par_qsn_sub_id != '0' THEN
 SET @str_sql_2 = CONCAT("SELECT q2.* FROM t_question_import AS q2 WHERE q2.qsn_id = '", par_qsn_sub_id, "'");
 END IF;
 IF @str_sql_2 = '' THEN
 SET @str_sql = CONCAT("REPLACE INTO t_question ", @str_sql_1);
 ELSE
 SET @str_sql = CONCAT("REPLACE INTO t_question SELECT v.* FROM (", @str_sql_1, " UNION ", @str_sql_2, ") AS v");
 END IF;
 PREPARE stmt FROM @str_sql;
 EXECUTE stmt;
 DEALLOCATE PREPARE stmt;
 SET @str_sql = CONCAT("SELECT o1.* FROM t_option_import AS o1 WHERE o1.qsn_id = '", par_qsn_id, "' AND o1.qsn_sub_id = '", par_qsn_sub_id, "'");
 SET @str_sql = CONCAT("REPLACE INTO t_option SELECT v.* FROM (", @str_sql, ") AS v");
 PREPARE stmt FROM @str_sql;
 EXECUTE stmt;
 DEALLOCATE PREPARE stmt;
 SET @str_sql_1 = CONCAT("SELECT a1.* FROM t_answer_import AS a1 WHERE a1.qsn_id = '", par_qsn_id, "' AND a1.qsn_sub_id = '", par_qsn_sub_id, "'");
 SET @str_sql_2 = '';
 SET @str_sql = '';
 IF par_qsn_sub_id IS NOT NULL AND par_qsn_sub_id != '' AND par_qsn_sub_id != '0' THEN
 SET @str_sql_2 = CONCAT("SELECT a2.* FROM t_answer_import AS a2 WHERE a2.qsn_id = '", par_qsn_sub_id, "'");
 END IF;
 IF @str_sql_2 = '' THEN
 SET @str_sql = CONCAT("REPLACE INTO t_answer ", @str_sql_1);
 ELSE
 SET @str_sql = CONCAT("REPLACE INTO t_answer SELECT v.* FROM (", @str_sql_1, " UNION ", @str_sql_2, ") AS v");
 END IF;
 PREPARE stmt FROM @str_sql;
 EXECUTE stmt;
 DEALLOCATE PREPARE stmt;
 SET @str_sql_1 = CONCAT("SELECT p1.* FROM t_qsn_sub_position_import AS p1 WHERE p1.qsn_id = '", par_qsn_sub_id, "' AND p1.qsn_sub_id = '", par_qsn_id, "'");
 SET @str_sql_2 = '';
 SET @str_sql = '';
 IF par_qsn_sub_id IS NOT NULL AND par_qsn_sub_id != '' AND par_qsn_sub_id != '0' THEN
 SET @str_sql_2 = CONCAT("SELECT p2.* FROM t_qsn_sub_position_import AS p2 WHERE p2.qsn_id = '", par_qsn_sub_id, "'");
 END IF;
 IF @str_sql_2 = '' THEN
 SET @str_sql = CONCAT("REPLACE INTO t_qsn_sub_position ", @str_sql_1);
 ELSE
 SET @str_sql = CONCAT("REPLACE INTO t_qsn_sub_position SELECT v.* FROM (", @str_sql_1, " UNION ", @str_sql_2, ") AS v");
 END IF;
 PREPARE stmt FROM @str_sql;
 EXECUTE stmt;
 DEALLOCATE PREPARE stmt;
 CALL qsn_import_delete_question('part', par_qsn_id, par_qsn_sub_id);
 END IF;
 
 
 
end

DROP PROCEDURE IF EXISTS `qsn_import_select`;
CREATE PROCEDURE  `qsn_import_select`(IN par_qsn_content VARCHAR(200),
IN par_search_flg TINYINT,IN par_user_id int(10), IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;


   set @strsql='select q.qsn_id,q.qsn_sub_id,q.qsn_type qsn_type_id,c1.desc_cn qsn_type,c2.desc_cn qsn_category, c3.desc_cn qsn_level,q.qsn_point,q.qsn_limit_tm,c5.desc_cn qsn_source,q.qsn_content_edit qsn_content,c4.desc_cn qsn_status,uu.username

  from t_question_import q join t_common_cde c1 on q.qsn_type=c1.c_cde
  join t_common_cde c2 on q.qsn_category=c2.c_cde
  join t_common_cde c3 on q.qsn_level=c3.c_cde
  join t_common_cde c4 on q.qsn_status=c4.c_cde
  join t_common_cde c5 on q.qsn_source=c5.c_cde
  join t_user uu on q.create_user_id=uu.user_id ';

    if par_search_flg =1 then
        set @strsql=concat(@strsql,' where q.create_user_id =',par_user_id);
    elseif par_search_flg =2 then

    select g.group_id,g.group_pid into @gid,@gpid
    from t_admin_group_user ug join t_group g on g.group_id=ug.group_id
    where ug.user_id=par_user_id;

      insert into tmp_qsn_group_tree(id,pid, level,position)
      values (@gid,@gpid,v_level,v_position);

      set v_row_count := row_count();

      while v_row_count != 0 do
          set @position := 0;
          insert into tmp_qsn_group_tree(id,pid,level,position)
          select g.group_id,g.group_pid,v_level + 1,@position := @position+1
          from t_group g inner join tmp_qsn_group_tree t on g.group_pid = t.id
          where t.level = v_level and g.group_id !='0' order by g.group_id;

          set v_row_count := row_count();
          set v_level := v_level + 1;
    end while;

        set @strsql=concat(@strsql,' where q.create_user_id in(select user_id
        from t_admin_group_user ag join (select distinct id,pid from tmp_qsn_group_tree) t1 on t1.id=ag.group_id)');
  else
    set @strsql=concat(@strsql,' where 1=1 ');
    end if;

   if par_qsn_content is not null then
      set @strsql=concat(@strsql,' and q.qsn_content like ','''%',par_qsn_content,'%''');
   end if;


   set @strsql=concat(@strsql,' and q.qsn_sub_flg is null order by q.qsn_type, q.create_tm desc');

   call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
   
   prepare stmt from @mysql;
   execute stmt;
   deallocate prepare stmt;

  if par_search_flg =2 then
     truncate table tmp_qsn_group_tree;
  end if;


  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_import_select_attachments`;
CREATE PROCEDURE  `qsn_import_select_attachments`(in par_qsn_id char (32),in par_qsn_sub_id char(32))
begin  
 declare v_level int unsigned default 0;
 declare v_position int unsigned default 1;
 declare v_row_count int unsigned default 0;
 insert into tmp_qsn_atta_tree(id,pid, level,position)    values(par_qsn_id,par_qsn_sub_id,v_level,v_position);
 set v_row_count := row_count();
 while v_row_count != 0 DO
 set @position := 0;
 insert into tmp_qsn_atta_tree(id,pid,level,position)
 select q.qsn_sub_id,q.qsn_id, v_level + 1, @position := @position+1
 from t_question_import q
 inner join tmp_qsn_atta_tree t on q.qsn_id = t.id
 where t.level = v_level and q.qsn_sub_id !='0'
 order by q.qsn_sub_id;
 set v_row_count := row_count();
 set v_level := v_level + 1;
 end while;
 set @strsql='select a.a_id attachment_id,t.id qsn_id,t.pid qsn_sub_id,a.qsn_item_id,a.file_name attachment_name,a.file_size attachment_size,  a.des attachment_des,a.create_tm attachment_date,a.attachment attachment_path,a.attachment
 from tmp_qsn_atta_tree t
 left join t_qsn_attachments a on a.qsn_id=t.id
 where a.attachment is not null
 union
 select a.a_id attachment_id,t.pid qsn_id,t.id qsn_sub_id,a.qsn_item_id,a.file_name attachment_name,a.file_size attachment_size,  a.des attachment_des,a.create_tm attachment_date,a.attachment attachment_path,a.attachment
 from tmp_qsn_atta_tree t
 left join  t_qsn_attachments a on a.qsn_id=t.pid and a.qsn_sub_id=t.id
 where a.attachment is not null ';
 prepare stmt from @strsql;
 execute stmt;
 deallocate prepare stmt;
 truncate table tmp_qsn_atta_tree;
end

DROP PROCEDURE IF EXISTS `qsn_import_select_edit`;
CREATE PROCEDURE  `qsn_import_select_edit`(IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32), IN par_qsn_compounding_flg VARCHAR(10))
begin
  if par_qsn_compounding_flg !='0' then
      select t.qsn_id,t.qsn_sub_id,t.qsn_level,t.qsn_limit_tm,t.qsn_point,t.qsn_source,t.qsn_status
     ,t.qsn_type,t.qsn_content_edit,t.qsn_option_count
     ,t.qsn_guide,t.qsn_category,c.desc_cn qsn_category_name,t.qsn_expire,o.option_content_edit qsn_option_content_edit,o.qsn_item_tag,o.qsn_item_id,a.qsn_answer
      from t_question_import t left join t_option_import o on t.qsn_id=o.qsn_id and t.qsn_sub_id=o.qsn_sub_id
      left join t_answer_import a on o.qsn_id=a.qsn_id and o.qsn_item_id=a.qsn_item_id and o.qsn_sub_id=a.qsn_sub_id
      left join t_common_cde c on c.c_cde=t.qsn_category
      where
      t.qsn_id=par_qsn_id and t.qsn_sub_id=par_qsn_sub_id;
  else
      set @strsql=concat('select
a.qsn_id,a.qsn_sub_id,a.qsn_level,a.qsn_limit_tm,a.qsn_point,a.qsn_source,a.qsn_status
,a.qsn_type,a.qsn_content_edit,a.qsn_option_count
,a.qsn_guide,a.qsn_category,a.qsn_category_name,a.qsn_expire,
a.qsn_option_content_edit,a.qsn_item_tag,
case when a.qsn_item_id is not null then a.qsn_item_id else b.qsn_item_id end qsn_item_id,
case when a.qsn_answer is not null then a.qsn_answer else b.qsn_answer end qsn_answer,');

    if par_qsn_sub_id !='0' then
      set @strsql=concat(@strsql,'(select count(t.qsn_id) from t_qsn_sub_position_import t
        where t.qsn_id=','''',par_qsn_sub_id,'''',') sub_qsn_count');
    else
      set @strsql=concat(@strsql,'0 sub_qsn_count');
    end if;

    set @strsql=concat(@strsql,' from (
select t.qsn_id,t.qsn_sub_id,t.qsn_level,t.qsn_limit_tm,t.qsn_point,t.qsn_source,t.qsn_status
        ,t.qsn_type,t.qsn_content_edit,t.qsn_option_count
        ,t.qsn_guide,t.qsn_category,c.desc_cn qsn_category_name,t.qsn_expire,
    o.option_content_edit qsn_option_content_edit,o.qsn_item_tag,o.qsn_item_id,a.qsn_answer
      from t_question_import t left join t_option_import o on t.qsn_id=o.qsn_id and t.qsn_sub_id=o.qsn_sub_id
        left join t_answer_import a on o.qsn_id=a.qsn_id and o.qsn_sub_id=a.qsn_sub_id and o.qsn_item_id=a.qsn_item_id
        left join t_common_cde c on c.c_cde=t.qsn_category where ');
        
set @strsql=concat(@strsql,'t.qsn_id=','''',par_qsn_id,'''',' and t.qsn_sub_id=','''',par_qsn_sub_id,'''',')a');

set @strsql=concat(@strsql,' left join (select
            t.qsn_id,t.qsn_sub_id,t.qsn_level,t.qsn_limit_tm,t.qsn_point,t.qsn_source,t.qsn_status
                    ,t.qsn_type,t.qsn_content_edit,t.qsn_option_count
          ,t.qsn_guide,t.qsn_category,d.desc_cn qsn_category_name,t.qsn_expire,
          null qsn_option_content_edit,null qsn_item_tag,a.qsn_item_id,a.qsn_answer
                from t_question_import t  left join t_answer_import a on t.qsn_id=a.qsn_id and t.qsn_sub_id=a.qsn_sub_id
                left join t_common_cde d on d.c_cde=t.qsn_category
                where t.qsn_id=','''',par_qsn_id,'''',' and t.qsn_sub_id=','''',par_qsn_sub_id,'''',') b
      on a.qsn_id=b.qsn_id and a.qsn_sub_id=b.qsn_sub_id and case when a.qsn_item_id is null then b.qsn_item_id else a.qsn_item_id end=b.qsn_item_id
');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  end if;
  
  
  
  
  
  
  
      
end

DROP PROCEDURE IF EXISTS `qsn_import_select_sub_question_answer`;
CREATE PROCEDURE  `qsn_import_select_sub_question_answer`(IN par_qsn_id CHAR(32))
begin
select * from (
select x.qsn_id,x.qsn_sub_id,x.qsn_point,x.qsn_content_edit qsn_content,a.qsn_answer,a.qsn_item_id
 from t_question_import x inner join t_answer_import a on a.qsn_id=x.qsn_id
 and a.qsn_sub_id=x.qsn_sub_id where x.qsn_id =par_qsn_id
union all
select x.qsn_id,x.qsn_sub_id,x.qsn_point,x.qsn_content_edit qsn_content,a.qsn_answer,a.qsn_item_id
 from t_question_import x inner join t_answer_import a on a.qsn_id=x.qsn_id
 and a.qsn_sub_id=x.qsn_sub_id where x.qsn_sub_id =par_qsn_id
) y
order by y.qsn_item_id;
  
  
  
  
  
  
  
      
end

DROP PROCEDURE IF EXISTS `qsn_import_update_question`;
CREATE PROCEDURE  `qsn_import_update_question`(IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32),IN par_qsn_type VARCHAR(20), IN par_qsn_level VARCHAR(20), IN par_qsn_point INTEGER(3), IN par_qsn_time VARCHAR(20),IN par_qsn_source VARCHAR(20), IN par_qsn_status VARCHAR(20), IN par_qsn_content TEXT,IN par_qsn_content_edit TEXT, IN par_qsn_guide TEXT,IN par_qsn_category VARCHAR(20), IN par_update_user_id int(10))
BEGIN
update t_question_import set qsn_type=par_qsn_type,qsn_level=par_qsn_level,qsn_point=par_qsn_point,   qsn_limit_tm=par_qsn_time,qsn_source=par_qsn_source,qsn_status=par_qsn_status,qsn_content=par_qsn_content,qsn_content_edit=par_qsn_content_edit,   qsn_guide=par_qsn_guide,qsn_category=par_qsn_category,update_tm=sysdate(),update_user_id=par_update_user_id   where qsn_id=par_qsn_id and qsn_sub_id=par_qsn_sub_id;                      
end

DROP PROCEDURE IF EXISTS `qsn_search`;
CREATE PROCEDURE  `qsn_search`(IN par_qsn_type VARCHAR(20),
IN par_qsn_category VARCHAR(20), IN par_qsn_level VARCHAR(20), IN par_qsn_point VARCHAR(20),
IN par_qsn_status VARCHAR(20), IN par_qsn_source VARCHAR(20), IN par_qsn_content VARCHAR(200), 
IN par_search_flg TINYINT,IN par_user_id int(10),IN par_qsn_input_person varchar(20),
IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

   set @strsql='select q.qsn_id,q.qsn_sub_id,q.qsn_type qsn_type_id,c1.desc_cn qsn_type,c2.desc_cn qsn_category, c3.desc_cn qsn_level,q.qsn_point,q.qsn_limit_tm,c5.desc_cn qsn_source,q.qsn_content_edit qsn_content,c4.desc_cn qsn_status,uu.username
  from t_question q join t_common_cde c1 on q.qsn_type=c1.c_cde
  join t_common_cde c2 on q.qsn_category=c2.c_cde
  join t_common_cde c3 on q.qsn_level=c3.c_cde
  join t_common_cde c4 on q.qsn_status=c4.c_cde
  join t_common_cde c5 on q.qsn_source=c5.c_cde
  join t_user uu on q.create_user_id=uu.user_id ';

    if par_search_flg =1 then
        set @strsql=concat(@strsql,' where q.create_user_id =',par_user_id);
    elseif par_search_flg =2 then
    select g.group_id,g.group_pid into @gid,@gpid
    from t_admin_group_user ug join t_group g on g.group_id=ug.group_id
    where ug.user_id=par_user_id;

      insert into tmp_qsn_group_tree(id,pid, level,position)
      values (@gid,@gpid,v_level,v_position);

      set v_row_count := row_count();

      while v_row_count != 0 do
          set @position := 0;
          insert into tmp_qsn_group_tree(id,pid,level,position)
          select g.group_id,g.group_pid,v_level + 1,@position := @position+1
          from t_group g inner join tmp_qsn_group_tree t on g.group_pid = t.id
          where t.level = v_level and g.group_id !='0' order by g.group_id;

          set v_row_count := row_count();
          set v_level := v_level + 1;
    end while;

        set @strsql=concat(@strsql,' where q.create_user_id in(select user_id
        from t_admin_group_user ag join (select distinct id,pid from tmp_qsn_group_tree) t1 on t1.id=ag.group_id)');
  else
    set @strsql=concat(@strsql,' where 1=1 ');
    end if;

   if par_qsn_type is not null then
      set @strsql=concat(@strsql,' and q.qsn_type=','''',par_qsn_type,'''');
   end if;

   if par_qsn_category is not null then
      set @strsql=concat(@strsql,' and q.qsn_category=','''',par_qsn_category,'''');
   end if;

   if par_qsn_level is not null then
      set @strsql=concat(@strsql,' and q.qsn_level=','''',par_qsn_level,'''');
   end if;

   if par_qsn_point is not null then
      set @strsql=concat(@strsql,' and q.qsn_point=',par_qsn_point);
   end if;

   if par_qsn_status is not null then
      set @strsql=concat(@strsql,' and q.qsn_status=','''',par_qsn_status,'''');
   end if;

   if par_qsn_source is not null then
      set @strsql=concat(@strsql,' and q.qsn_source=','''',par_qsn_source,'''');
   end if;

   if par_qsn_content is not null then
      set @strsql=concat(@strsql,' and q.qsn_content like ','''%',par_qsn_content,'%''');
   end if;

   if par_qsn_input_person is not null then
    set @strsql=concat(@strsql,' and q.create_user_id in(select user_id from t_user where username like ','''%',par_qsn_input_person,'%''',')');
   end if;

   set @strsql=concat(@strsql,' and q.qsn_sub_flg is null order by q.qsn_type, q.create_tm desc'); 

   call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
   
   prepare stmt from @mysql;
   execute stmt;
   deallocate prepare stmt;

  if par_search_flg =2 then
     truncate table tmp_qsn_group_tree;
  end if;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_search_sub_question`;
CREATE PROCEDURE  `qsn_search_sub_question`(in par_qsn_sub_id char(32), in par_qsn_type varchar(20), in par_qsn_category varchar(20), in par_qsn_level varchar(20), in par_qsn_point varchar(20), in par_qsn_state varchar(20), in par_qsn_source varchar(20), in par_qsn_content varchar(200), in par_page_idx tinyint(10), in par_page_size tinyint(10))
begin
 declare rcount tinyint(11);
  declare mysql text;
  set @strsql=concat('select q.qsn_id, c1.desc_cn qsn_type,c2.desc_cn qsn_category, c3.desc_cn qsn_level,q.qsn_point,q.qsn_limit_tm,c5.desc_cn qsn_source,q.qsn_content,c4.desc_cn qsn_state
  from t_question q,t_common_cde c1,t_common_cde c2,t_common_cde c3,t_common_cde c4,t_common_cde c5
  where q.qsn_type=c1.c_cde and q.qsn_category=c2.c_cde and q.qsn_source=c5.c_cde 
  and q.qsn_level=c3.c_cde  and q.qsn_state=c4.c_cde and 
  not exists(select t.qsn_id from t_question t where t.qsn_id=q.qsn_sub_id  and t.qsn_id =','''',par_qsn_sub_id,'''',') ');set @strsql=concat(@strsql,' and exists(select q2.qsn_id from t_question q2 where q2.qsn_id=q.qsn_sub_id) ');if par_qsn_type is not null then       
    set @strsql=concat(@strsql,' and ',' q.qsn_type=','''',par_qsn_type,'''');
  end if;
      
  if par_qsn_category is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_category=','''',par_qsn_category,'''');
  end if;if par_qsn_level is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_level=','''',par_qsn_level,'''');
  end if;
   
   if par_qsn_point is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_point=',par_qsn_point);
   end if;
   
   if par_qsn_state is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_state=','''',par_qsn_state,'''');
   end if;
   
   if par_qsn_source is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_source=','''',par_qsn_source,'''');
   end if;
   
   if par_qsn_content is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_content like ','''',par_qsn_content,'%''');
   end if;
    
  set @strsql=CONCAT(@strsql,' union '); 
    
  set @strsql=concat(@strsql,'select q.qsn_id, c1.desc_cn qsn_type,c2.desc_cn qsn_category, c3.desc_cn qsn_level,q.qsn_point,q.qsn_limit_tm,c5.desc_cn qsn_source,left(q.qsn_content,102 ) qsn_content,c4.desc_cn qsn_state
  from t_question q,t_common_cde c1,t_common_cde c2,t_common_cde c3,t_common_cde c4,t_common_cde c5
  where q.qsn_type=c1.c_cde and q.qsn_category=c2.c_cde and q.qsn_source=c5.c_cde 
  and q.qsn_level=c3.c_cde  and q.qsn_state=c4.c_cde and q.qsn_sub_id=','''',0,''''); 
      
  if par_qsn_type is not null then       
        set @strsql=concat(@strsql,' and ',' q.qsn_type=','''',par_qsn_type,'''');
  end if;
      
  if par_qsn_category is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_category=','''',par_qsn_category,'''');
  end if;if par_qsn_level is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_level=','''',par_qsn_level,'''');
  end if;
   
   if par_qsn_point is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_point=',par_qsn_point);
   end if;
   
   if par_qsn_state is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_state=','''',par_qsn_state,'''');
   end if;
   
   if par_qsn_source is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_source=','''',par_qsn_source,'''');
   end if;
   
   if par_qsn_content is not null then
    set @strsql=concat(@strsql,' and ',' q.qsn_content like ','''',par_qsn_content,'%''');
   end if;    
     
  call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
 
  prepare stmt from @mysql;
  execute stmt;
  deallocate prepare stmt; 
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_select_attachments`;
CREATE PROCEDURE  `qsn_select_attachments`(in par_qsn_id char (32),in par_qsn_sub_id char(32))
begin
declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

    insert into tmp_qsn_atta_tree(id,pid, level,position)
    values(par_qsn_id,par_qsn_sub_id,v_level,v_position);
    
    set v_row_count := row_count();
    
    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_qsn_atta_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_qsn_atta_tree t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

  set @strsql='select a.a_id attachment_id,t.id qsn_id,t.pid qsn_sub_id,a.qsn_item_id,a.file_name attachment_name,a.file_size attachment_size,
  a.des attachment_des,a.create_tm attachment_date,a.attachment attachment_path,a.attachment from
                tmp_qsn_atta_tree t
                left join  t_qsn_attachments a on a.qsn_id=t.id
                where a.attachment is not null
  union
  select a.a_id attachment_id,t.pid qsn_id,t.id qsn_sub_id,a.qsn_item_id,a.file_name attachment_name,a.file_size attachment_size,
  a.des attachment_des,a.create_tm attachment_date,a.attachment attachment_path,a.attachment from
                tmp_qsn_atta_tree t
                left join  t_qsn_attachments a on a.qsn_id=t.pid and a.qsn_sub_id=t.id
                where a.attachment is not null ';

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;
  truncate table tmp_qsn_atta_tree;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_select_compounding_edit`;
CREATE PROCEDURE  `qsn_select_compounding_edit`(IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32))
begin
select r.qsn_id,r.qsn_sub_id,r.qsn_level,r.qsn_limit_tm,r.qsn_point,r.qsn_source,r.qsn_status,
c1.desc_cn qsn_type,r.qsn_type qsn_type_id,r.qsn_content_edit,r.qsn_option_count
,r.qsn_guide,r.qsn_category,c.desc_cn qsn_category_name,r.qsn_expire,r.create_tm
from t_question r join t_common_cde c on c.c_cde=r.qsn_category
join t_common_cde c1 on c1.c_cde=r.qsn_type
where r.qsn_id=par_qsn_id and r.qsn_sub_id=par_qsn_sub_id

union

select y.qsn_id,y.qsn_sub_id,y.qsn_level,y.qsn_limit_tm,
y.qsn_point,y.qsn_source,y.qsn_status,y.qsn_type,y.qsn_type_id,y.qsn_content_edit,y.qsn_option_count
,y.qsn_guide,y.qsn_category,y.qsn_category_name,y.qsn_expire,y.create_tm from (
    select x.qsn_id,x.qsn_sub_id,'' qsn_level,'' qsn_limit_tm,x.qsn_point,'' qsn_source,
    x.qsn_type,x.qsn_type_id,
  x.qsn_status
  ,x.qsn_content_edit,'' qsn_option_count,'' qsn_guide,x.qsn_category,x.qsn_category_name,'' qsn_expire
    ,x.create_tm from (

select
    q.qsn_id,q.qsn_sub_id,c1.desc_cn qsn_type,q.qsn_type qsn_type_id,
  c3.c_cde qsn_status,
  c2.desc_cn qsn_category_name,q.qsn_category,q.qsn_point,
    q.qsn_content_edit,q.create_tm,p.qsn_position
from t_question q
    join t_common_cde c1 on q.qsn_type=c1.c_cde
    join t_common_cde c2 on q.qsn_category=c2.c_cde
  join t_common_cde c3 on q.qsn_status=c3.c_cde
    left join t_qsn_sub_position p on q.qsn_sub_id=p.qsn_sub_id
    where q.qsn_id=par_qsn_sub_id

 union

 select
  q.qsn_id,q.qsn_sub_id,c1.desc_cn qsn_type,q.qsn_type qsn_type_id,
  c3.c_cde qsn_status,
  c2.desc_cn qsn_category_name,c2.c_cde qsn_category,q.qsn_point,
    q.qsn_content_edit,q.create_tm,p.qsn_position
 from
 t_qsn_sub_position p join t_question q on q.qsn_id=p.qsn_sub_id
 join t_common_cde c1 on q.qsn_type=c1.c_cde
 join t_common_cde c2 on q.qsn_category=c2.c_cde
 join t_common_cde c3 on q.qsn_status=c3.c_cde
 where p.qsn_id=par_qsn_sub_id  and
  not exists(select q2.qsn_id from t_question q2  where q2.qsn_sub_id=q.qsn_id)
    ) x

  order by x.qsn_position+0

) y;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_select_deleteattachmentpath`;
CREATE PROCEDURE  `qsn_select_deleteattachmentpath`(in par_qsn_id char(32), in par_qsn_sub_id char(32), in par_qsn_flg tinyint(1))
begin     
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
        
        insert into tmp_qsn_delete_att_tree(id,pid, level,position)
        values (par_qsn_sub_id,par_qsn_id,v_level,v_position);
        
        set v_row_count := row_count();
        
        while v_row_count != 0 do
            set @position := 0;
            insert into tmp_qsn_delete_att_tree(id,pid,level,position)
            select c.qsn_sub_id,c.qsn_id,v_level + 1,@position := @position+1
            from t_question c inner join tmp_qsn_delete_att_tree t on c.qsn_id = t.id
            where t.level = v_level  order by c.qsn_sub_id;
            set v_row_count := row_count();
            set v_level := v_level + 1;
        end while;

      select a.attachment from t_qsn_attachments a join tmp_qsn_delete_att_tree m where a.qsn_id=m.pid and a.qsn_sub_id=m.id;

    truncate table tmp_qsn_delete_att_tree;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_select_edit`;
CREATE PROCEDURE  `qsn_select_edit`(IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32), IN par_qsn_compounding_flg VARCHAR(10))
begin
  if par_qsn_compounding_flg !='0' then
      select t.qsn_id,t.qsn_sub_id,t.qsn_level,t.qsn_limit_tm,t.qsn_point,t.qsn_source,t.qsn_status
     ,t.qsn_type,t.qsn_content_edit,t.qsn_option_count
     ,t.qsn_guide,t.qsn_category,c.desc_cn qsn_category_name,t.qsn_expire,o.option_content_edit qsn_option_content_edit,o.qsn_item_tag,o.qsn_item_id,a.qsn_answer
      from t_question t left join t_option o on t.qsn_id=o.qsn_id and t.qsn_sub_id=o.qsn_sub_id
      left join t_answer a on o.qsn_id=a.qsn_id and o.qsn_item_id=a.qsn_item_id and o.qsn_sub_id=a.qsn_sub_id
      left join t_common_cde c on c.c_cde=t.qsn_category
      where
      t.qsn_id=par_qsn_id and t.qsn_sub_id=par_qsn_sub_id;
  else
      set @strsql=concat('select
a.qsn_id,a.qsn_sub_id,a.qsn_level,a.qsn_limit_tm,a.qsn_point,a.qsn_source,a.qsn_status
,a.qsn_type,a.qsn_content_edit,a.qsn_option_count
,a.qsn_guide,a.qsn_category,a.qsn_category_name,a.qsn_expire,
a.qsn_option_content_edit,a.qsn_item_tag,
case when a.qsn_item_id is not null then a.qsn_item_id else b.qsn_item_id end qsn_item_id,
case when a.qsn_answer is not null then a.qsn_answer else b.qsn_answer end qsn_answer,');

    if par_qsn_sub_id !='0' then
      set @strsql=concat(@strsql,'(select count(t.qsn_id) from t_qsn_sub_position t
        where t.qsn_id=','''',par_qsn_sub_id,'''',') sub_qsn_count');
    else
      set @strsql=concat(@strsql,'0 sub_qsn_count');
    end if;

    set @strsql=concat(@strsql,' from (
select t.qsn_id,t.qsn_sub_id,t.qsn_level,t.qsn_limit_tm,t.qsn_point,t.qsn_source,t.qsn_status
        ,t.qsn_type,t.qsn_content_edit,t.qsn_option_count
        ,t.qsn_guide,t.qsn_category,c.desc_cn qsn_category_name,t.qsn_expire,
    o.option_content_edit qsn_option_content_edit,o.qsn_item_tag,o.qsn_item_id,a.qsn_answer
      from t_question t left join t_option o on t.qsn_id=o.qsn_id and t.qsn_sub_id=o.qsn_sub_id
        left join t_answer a on o.qsn_id=a.qsn_id and o.qsn_sub_id=a.qsn_sub_id and o.qsn_item_id=a.qsn_item_id
        left join t_common_cde c on c.c_cde=t.qsn_category where ');
        
set @strsql=concat(@strsql,'t.qsn_id=','''',par_qsn_id,'''',' and t.qsn_sub_id=','''',par_qsn_sub_id,'''',')a');

set @strsql=concat(@strsql,' left join (select
            t.qsn_id,t.qsn_sub_id,t.qsn_level,t.qsn_limit_tm,t.qsn_point,t.qsn_source,t.qsn_status
                    ,t.qsn_type,t.qsn_content_edit,t.qsn_option_count
          ,t.qsn_guide,t.qsn_category,d.desc_cn qsn_category_name,t.qsn_expire,
          null qsn_option_content_edit,null qsn_item_tag,a.qsn_item_id,a.qsn_answer
                from t_question t  left join t_answer a on t.qsn_id=a.qsn_id and t.qsn_sub_id=a.qsn_sub_id
                left join t_common_cde d on d.c_cde=t.qsn_category
                where t.qsn_id=','''',par_qsn_id,'''',' and t.qsn_sub_id=','''',par_qsn_sub_id,'''',') b
      on a.qsn_id=b.qsn_id and a.qsn_sub_id=b.qsn_sub_id and case when a.qsn_item_id is null then b.qsn_item_id else a.qsn_item_id end=b.qsn_item_id
');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  end if;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_select_random_category_level`;
CREATE PROCEDURE  `qsn_select_random_category_level`(in par_qsn_category text,in par_qsn_status varchar(20))
begin
    set @strsql=concat('select count(*) AS qsn_cnt,t.qsn_category AS qsn_category,t.qsn_type AS qsn_type,t.qsn_level AS qsn_level
  from t_question t where t.qsn_category in (',par_qsn_category,') and t.qsn_sub_flg is null
  and t.qsn_status=','''',par_qsn_status,'''',' group by t.qsn_category,t.qsn_type,t.qsn_level');
    prepare stmt from @strsql;
    execute stmt;
  deallocate prepare stmt;
     
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_select_self_attachments`;
CREATE PROCEDURE  `qsn_select_self_attachments`(in par_qsn_id char (32),in par_qsn_sub_id char(32))
begin
    
  set @strsql=concat('select a.a_id attachment_id,a.qsn_id,a.qsn_sub_id,a.qsn_item_id,a.file_name attachment_name,a.file_size attachment_size,
  a.des attachment_des,a.create_tm attachment_date,a.attachment attachment_path,a.attachment from
    t_qsn_attachments a where a.qsn_id=','''',par_qsn_id,'''',' and a.qsn_sub_id=','''',par_qsn_sub_id,'''');

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_select_sub_list`;
CREATE PROCEDURE  `qsn_select_sub_list`(IN par_qsn_id CHAR(32))
begin

select
x.qsn_id,x.qsn_sub_id,x.qsn_type,x.qsn_type_id,x.qsn_category,x.qsn_point,
x.qsn_content_edit qsn_content,x.qsn_status,x.create_tm
from (
   select q.qsn_id,q.qsn_sub_id,c1.desc_cn qsn_type,q.qsn_type qsn_type_id,c2.desc_cn qsn_category,q.qsn_point,
    q.qsn_content_edit,c3.desc_cn qsn_status,q.create_tm,p.qsn_position
    from t_question q
    join t_common_cde c1 on q.qsn_type=c1.c_cde
    join t_common_cde c2 on q.qsn_category=c2.c_cde
    join t_common_cde c3 on q.qsn_status=c3.c_cde
    left join t_qsn_sub_position p on q.qsn_id=p.qsn_sub_id
    where  q.qsn_id=par_qsn_id
  union all
select
  q.qsn_id,q.qsn_sub_id,c1.desc_cn qsn_type,q.qsn_type qsn_type_id,c2.desc_cn qsn_category,q.qsn_point,
    q.qsn_content_edit,c3.desc_cn qsn_status,q.create_tm,p.qsn_position
 from
 t_qsn_sub_position p join t_question q on q.qsn_id=p.qsn_sub_id
 join t_common_cde c1 on q.qsn_type=c1.c_cde
 join t_common_cde c2 on q.qsn_category=c2.c_cde
 join t_common_cde c3 on q.qsn_status=c3.c_cde
  where
  p.qsn_id=par_qsn_id and not exists(select q2.qsn_id from t_question q2  where q2.qsn_sub_id=q.qsn_id)
 ) x
  join t_qsn_sub_position xp on xp.qsn_id=x.qsn_id and xp.qsn_sub_id=x.qsn_sub_id
  order by xp.qsn_position;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_select_sub_position`;
CREATE PROCEDURE  `qsn_select_sub_position`(in par_qsn_id char(32))
begin
    set @strsql=concat('select max(qsn_position) qsn_position from t_qsn_sub_position where  qsn_id=','''',par_qsn_id,'''');
    prepare stmt from @strsql;  
    execute stmt;
    deallocate prepare stmt; 
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_select_sub_question`;
CREATE PROCEDURE  `qsn_select_sub_question`(in par_qsn_sub_id char(32))
begin      select q.qsn_id,q.qsn_sub_id,q.qsn_type qsn_type_id, c1.desc_cn qsn_type,c2.desc_cn qsn_category, c3.desc_cn qsn_level,q.qsn_point,q.qsn_limit_tm,c5.desc_cn qsn_source,q.qsn_content,c4.desc_cn qsn_staus
  from t_question q,t_common_cde c1,t_common_cde c2,t_common_cde c3,t_common_cde c4,t_common_cde c5
  where q.qsn_type=c1.c_cde and q.qsn_category=c2.c_cde and q.qsn_source=c5.c_cde 
  and q.qsn_level=c3.c_cde  and q.qsn_status=c4.c_cde and  q.qsn_sub_id=par_qsn_sub_id;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_select_sub_question_answer`;
CREATE PROCEDURE  `qsn_select_sub_question_answer`(IN par_qsn_id CHAR(32))
begin
select * from (
select x.qsn_id,x.qsn_sub_id,x.qsn_point,x.qsn_content_edit qsn_content,a.qsn_answer,a.qsn_item_id
 from t_question x inner join t_answer a on a.qsn_id=x.qsn_id
 and a.qsn_sub_id=x.qsn_sub_id where x.qsn_id =par_qsn_id
union all
select x.qsn_id,x.qsn_sub_id,x.qsn_point,x.qsn_content_edit qsn_content,a.qsn_answer,a.qsn_item_id
 from t_question x inner join t_answer a on a.qsn_id=x.qsn_id
 and a.qsn_sub_id=x.qsn_sub_id where x.qsn_sub_id =par_qsn_id
) y
order by y.qsn_item_id;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_select_sub_question_count`;
CREATE PROCEDURE  `qsn_select_sub_question_count`(IN par_qsn_id char(32))
begin   
    select count(*) sub_qsn_count from t_question where qsn_id =par_qsn_id ;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_status_update`;
CREATE PROCEDURE  `qsn_status_update`(IN par_qsn_id text, IN par_qsn_sub_id text,
IN par_qsn_status VARCHAR(20),IN par_update_user_id int(10))
begin   
    set @strsql=concat('update t_question set qsn_status=','''',par_qsn_status,'''',',update_user_id=',par_update_user_id,',update_tm=sysdate() where qsn_id in (',par_qsn_id,') and qsn_sub_id in(',par_qsn_sub_id,')');   
      prepare stmt from @strsql;  
execute stmt;
deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_update_answer`;
CREATE PROCEDURE  `qsn_update_answer`(IN par_qsn_id CHAR(32),IN par_qsn_sub_id CHAR(32),IN par_qsn_item_id VARCHAR(20), IN par_qsn_type VARCHAR(20), IN par_qsn_answer TEXT, IN par_update_user_id int(10))
BEGIN      update t_answer set  qsn_type=par_qsn_type,qsn_answer=par_qsn_answer,update_tm=sysdate(),
  update_user_id=par_update_user_id where qsn_id=par_qsn_id and qsn_sub_id=par_qsn_sub_id and qsn_item_id=par_qsn_item_id ;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_update_attachment`;
CREATE PROCEDURE  `qsn_update_attachment`(IN par_a_id VARCHAR(20), IN par_a_des VARCHAR(400))
begin    
    update t_qsn_attachments set des=par_a_des where a_id=par_a_id ;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_update_batch_all`;
CREATE PROCEDURE  `qsn_update_batch_all`(
IN par_qsn_type VARCHAR(20), 
IN par_qsn_category VARCHAR(20), IN par_qsn_level VARCHAR(20), IN par_qsn_point VARCHAR(20), 
IN par_qsn_status VARCHAR(20), IN par_qsn_source VARCHAR(20), IN par_qsn_limit VARCHAR(20),IN par_qsn_content VARCHAR(200),
IN par_update_qsn_category VARCHAR(20),
IN par_update_qsn_level VARCHAR(20),IN par_update_qsn_point VARCHAR(20),
IN par_update_qsn_status VARCHAR(20),IN par_update_qsn_source VARCHAR(20),IN par_update_qsn_limit VARCHAR(20),
IN par_update_user_id int(10)
)
BEGIN
  set @strsql=concat('update t_question  set  update_user_id=',par_update_user_id,',update_tm=sysdate() ');
  if par_update_qsn_category is not null then
    set @strsql=concat(@strsql,',qsn_category=','''',par_update_qsn_category,'''');
  end if; if par_update_qsn_level is not null then
    set @strsql=concat(@strsql,',qsn_level=','''',par_update_qsn_level,'''');
  end if;if par_update_qsn_point is not null then
    set @strsql=concat(@strsql,',qsn_point=','''',par_update_qsn_point,'''');
  end if; if par_update_qsn_status is not null then
    set @strsql=concat(@strsql,',qsn_status=','''',par_update_qsn_status,'''');
  end if; if par_update_qsn_source is not null then
    set @strsql=concat(@strsql,',qsn_source=','''',par_update_qsn_source,'''');
  end if; if par_update_qsn_limit is not null then
    set @strsql=concat(@strsql,',qsn_limit_tm=','''',par_update_qsn_limit,'''');
  end if; 

  if par_qsn_type is not null or par_qsn_category is not null or par_qsn_level is not null
    or par_qsn_point is not null or par_qsn_status is not null or par_qsn_source is not null
    or par_qsn_limit is not null or par_qsn_content is not null
    then
    set @strsql=concat(@strsql,' where ');
  end if;

  if par_qsn_type is not null then
    set @strsql=concat(@strsql,'qsn_type=','''',par_qsn_type,'''',' and ');
  end if;

  if par_qsn_category is not null then
    set @strsql=concat(@strsql,'qsn_category=','''',par_qsn_category,'''',' and ');
  end if;if par_qsn_level is not null then
    set @strsql=concat(@strsql,'qsn_level=','''',par_qsn_level,'''',' and ');
  end if;if par_qsn_point is not null then
    set @strsql=concat(@strsql,'qsn_point=','''',par_qsn_point,'''',' and ');
  end if;if par_qsn_status is not null then
    set @strsql=concat(@strsql,'qsn_status=','''',par_qsn_status,'''',' and ');
  end if;if par_qsn_source is not null then
    set @strsql=concat(@strsql,'qsn_source=','''',par_qsn_source,'''',' and ');
  end if;if par_qsn_limit is not null then
    set @strsql=concat(@strsql,'qsn_limit_tm=','''',par_qsn_limit,'''',' and ');
  end if;
      
  if par_qsn_content is not null then
    set @strsql=concat(@strsql,' qsn_content like ','''%',par_qsn_content,'%''',' and ');
  end if; 

  if par_qsn_type is not null or par_qsn_category is not null or par_qsn_level is not null
    or par_qsn_point is not null or par_qsn_status is not null or par_qsn_source is not null
    or par_qsn_limit is not null or par_qsn_content is not null
  then
  set @strsql=substring(@strsql,1,length(@strsql)-4);
  end if;

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_update_batch_select`;
CREATE PROCEDURE  `qsn_update_batch_select`(IN par_qsn_id TEXT, 
IN par_update_qsn_category VARCHAR(20), IN par_update_qsn_level VARCHAR(20), IN par_update_qsn_point VARCHAR(20), 
IN par_update_qsn_status VARCHAR(20), IN par_update_qsn_source VARCHAR(20),IN par_update_qsn_limit VARCHAR(20),IN par_update_user_id int(10))
BEGIN      set @strsql=concat('update t_question  set  update_user_id=',par_update_user_id,',update_tm=sysdate() ');
  if par_update_qsn_category is not null then
    set @strsql=concat(@strsql,',qsn_category=','''',par_update_qsn_category,'''');
  end if; 

  if par_update_qsn_level is not null then
    set @strsql=concat(@strsql,',qsn_level=','''',par_update_qsn_level,'''');
  end if;if par_update_qsn_point is not null then
    set @strsql=concat(@strsql,',qsn_point=','''',par_update_qsn_point,'''');
  end if; if par_update_qsn_status is not null then
    set @strsql=concat(@strsql,',qsn_status=','''',par_update_qsn_status,'''');
  end if; if par_update_qsn_source is not null then
    set @strsql=concat(@strsql,',qsn_source=','''',par_update_qsn_source,'''');
  end if; if par_update_qsn_limit is not null then
    set @strsql=concat(@strsql,',qsn_limit_tm=','''',par_update_qsn_limit,'''');
  end if; set @strsql=concat(@strsql,' where qsn_id in(',par_qsn_id,')');

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_update_compound_qsn_sub_position`;
CREATE PROCEDURE  `qsn_update_compound_qsn_sub_position`(in par_qsn_id char(32),in par_position int(10))
begin
update t_qsn_sub_position
set qsn_position=replace(qsn_position,concat(SUBSTRING_INDEX(qsn_position,'-',1),'-'),concat(par_position,'-'))
where qsn_id =par_qsn_id;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_update_option`;
CREATE PROCEDURE  `qsn_update_option`(IN par_qsn_id CHAR(32),IN par_qsn_sub_id CHAR(32),IN par_qsn_item_id VARCHAR(20), IN par_qsn_item_tag VARCHAR(3), IN par_qsn_type VARCHAR(20), IN par_option_content TEXT, IN par_update_user_id int(10))
BEGIN       
   
    update t_option set qsn_item_tag=par_qsn_item_tag,qsn_type=par_qsn_type,
       option_content=par_option_content,update_tm=sysdate(),update_user_id=par_update_user_id 
    where qsn_id=par_qsn_id and qsn_sub_id=par_qsn_sub_id and qsn_item_id=par_qsn_item_id ;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `qsn_update_question`;
CREATE PROCEDURE  `qsn_update_question`(IN par_qsn_id CHAR(32), IN par_qsn_sub_id CHAR(32),
IN par_qsn_type VARCHAR(20), IN par_qsn_level VARCHAR(20), IN par_qsn_point INTEGER(3), IN par_qsn_time VARCHAR(20),
IN par_qsn_source VARCHAR(20), IN par_qsn_status VARCHAR(20), IN par_qsn_content TEXT,IN par_qsn_content_edit TEXT, IN par_qsn_guide TEXT,
IN par_qsn_category VARCHAR(20), IN par_update_user_id int(10))
BEGIN
   CALL exam_point_update_on_question_update(par_qsn_id, par_qsn_sub_id, par_qsn_point);
   
   update t_question set qsn_type=par_qsn_type,qsn_level=par_qsn_level,qsn_point=par_qsn_point,
   qsn_limit_tm=par_qsn_time,qsn_source=par_qsn_source,qsn_status=par_qsn_status,qsn_content=par_qsn_content,qsn_content_edit=par_qsn_content_edit,
   qsn_guide=par_qsn_guide,qsn_category=par_qsn_category,update_tm=sysdate(),update_user_id=par_update_user_id
   where qsn_id=par_qsn_id and qsn_sub_id=par_qsn_sub_id;
  
  
  
  
  
  
  
        
end



