DROP PROCEDURE IF EXISTS `score_delete`;
CREATE PROCEDURE  `score_delete`(IN par_exam_id CHAR(32), IN par_user_id INTEGER(10),
IN par_papr_id CHAR(32), IN par_exam_times SMALLINT(6))
begin

  SET @strsql=CONCAT('DELETE FROM t_user_exam WHERE exam_id="', par_exam_id,
    '" AND user_id=', par_user_id, ' AND papr_id="', par_papr_id, '" AND exam_times=', par_exam_times);
  prepare stmt from @strsql;
  execute stmt;

  set @strsql=concat('delete from t_user_exam_answer where exam_id = "',par_exam_id,'" AND
    user_id = "',par_user_id,'" AND papr_id = "',par_papr_id,'" AND exam_times = ',par_exam_times);
  prepare stmt from @strsql;
  execute stmt;

  set @strsql=concat('delete from t_user_exam_info where exam_id = "',par_exam_id,'" AND
    user_id = "',par_user_id,'" AND papr_id = "',par_papr_id,'" AND exam_times = ',par_exam_times);
  prepare stmt from @strsql;
  execute stmt;

  deallocate prepare stmt;



end

DROP PROCEDURE IF EXISTS `score_import_data_exists`;
CREATE PROCEDURE  `score_import_data_exists`(IN par_exam_id CHAR(32),
IN par_user_id INT(10), IN par_papr_id CHAR(32), IN par_exam_times SMALLINT(6))
begin


    SET @strsql='SELECT COUNT(*) AS cnt
    FROM t_user_exam AS ue
    WHERE 1=1';

    IF par_exam_id IS NOT NULL AND par_exam_id<>'' THEN
      SET @strsql=CONCAT(@strsql, ' AND ue.exam_id =', '''', par_exam_id, '''');
    END IF;

    IF par_user_id IS NOT NULL AND par_user_id<>'' THEN
      SET @strsql=CONCAT(@strsql, ' AND ue.user_id =', par_user_id);
    END IF;

    IF par_papr_id IS NOT NULL AND par_papr_id<>'' THEN
      SET @strsql=CONCAT(@strsql, ' AND ue.papr_id =', '''', par_papr_id, '''');
    END IF;

    IF par_exam_times IS NOT NULL AND par_exam_times<>'' AND par_exam_times<>0 THEN
      SET @strsql=CONCAT(@strsql, ' AND ue.exam_times =', par_exam_times);
    END IF;

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;



end

DROP PROCEDURE IF EXISTS `score_select`;
CREATE PROCEDURE  `score_select`(IN par_username VARCHAR(20),
IN par_real_name VARCHAR(100), IN par_exam_times INT, IN par_exam_name VARCHAR(1000),IN par_group_id INT(10),
IN par_exam_category_id VARCHAR(20), IN par_exam_begin_tm DATETIME, IN par_exam_end_tm DATETIME,
IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin


    SET @strsql='SELECT ue.*, u.username, u.real_name, e.exam_name, e.exam_begin_tm, e.exam_end_tm, c1.desc_cn, IF(g.group_name="" OR g.group_name IS NULL, "None", g.group_name) AS group_name
    FROM t_user_exam AS ue
    LEFT JOIN t_user AS u ON ue.user_id=u.user_id
    LEFT JOIN t_exam AS e ON ue.exam_id=e.exam_id
    LEFT JOIN t_common_cde AS c1 ON e.exam_category=c1.c_cde
    LEFT JOIN t_user_group AS ug ON ue.user_id=ug.user_id
    LEFT JOIN t_group AS g ON ug.group_id=g.group_id
    WHERE 1=1';

    IF par_username IS NOT NULL AND par_username<>'' THEN
      SET @strsql=CONCAT(@strsql, ' AND u.username LIKE "', par_username, '%"');
    END IF;

    IF par_real_name IS NOT NULL AND par_real_name<>'' THEN
      SET @strsql=CONCAT(@strsql, ' AND u.real_name LIKE "', par_real_name, '%"');
    END IF;

    IF par_exam_times IS NOT NULL AND par_exam_times<>'' AND par_exam_times<>0 THEN
      SET @strsql=CONCAT(@strsql, ' AND ue.exam_times =', par_exam_times);
    END IF;

    IF par_exam_name IS NOT NULL AND par_exam_name<>'' THEN
      SET @strsql=CONCAT(@strsql, ' AND e.exam_name LIKE "', par_exam_name, '%"');
    END IF;

    IF par_group_id IS NOT NULL AND par_group_id<>'' AND par_group_id<>0 THEN
      SET @strsql=CONCAT(@strsql, ' AND g.group_id=', par_group_id);
    END IF;

    IF par_exam_category_id IS NOT NULL AND par_exam_category_id<>'' THEN
      SET @strsql=CONCAT(@strsql, ' AND e.exam_category=', par_exam_category_id);
    END IF;

    IF par_exam_begin_tm IS NOT NULL AND par_exam_begin_tm <> '' AND par_exam_end_tm IS NOT NULL AND par_exam_end_tm <> '' THEN
      SET @strsql=CONCAT(@strsql, ' AND e.exam_begin_tm>=', '''', par_exam_begin_tm, '''', ' AND e.exam_end_tm<=', '''', par_exam_end_tm ,'''');
    END IF;

  call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

  prepare stmt from @mysql;
  execute stmt;
  deallocate prepare stmt;



end

DROP PROCEDURE IF EXISTS `score_update`;
CREATE PROCEDURE  `score_update`(IN par_exam_id CHAR(32), IN par_user_id INT(10),
IN par_papr_id CHAR(32), IN par_exam_times SMALLINT(6), IN par_user_exam_scoring FLOAT)
begin

  UPDATE t_user_exam
  SET user_exam_scoring = par_user_exam_scoring
  WHERE exam_id=par_exam_id AND user_id=par_user_id AND papr_id=par_papr_id AND exam_times=par_exam_times;



end



