DROP PROCEDURE IF EXISTS `session_delete`;
CREATE PROCEDURE  `session_delete`(IN par_session_id char(12),IN par_ip varchar(15))
begin
  set @strsql=concat('delete from t_session where ip=','''',par_ip,'''',' and sid=','''',par_session_id,'''');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `session_init`;
CREATE PROCEDURE  `session_init`(IN par_session_id char(12), IN par_ip varchar(15),
IN par_last_activity int (10),in par_exam_time int(10),IN par_user_id int(10),in par_username varchar(20),in par_admin_flg tinyint(1),out par_invalid tinyint(1))
begin

  select user_id,role_value into @uid,@role from t_session where sid=par_session_id ;
  if @uid is null then
    if @uid !=0 then
      insert into t_session(sid,ip,user_id,username,last_activity,exam_time)
      values(par_session_id,par_ip,par_user_id,par_username,unix_timestamp(sysdate()),par_exam_time);
    else
      if par_username is not null then
        insert into t_session(sid,ip,user_id,username,last_activity,exam_time)
        values(par_session_id,par_ip,par_user_id,(select username from t_user where user_id=par_user_id),unix_timestamp(sysdate()),par_exam_time);
      else
        insert into t_session(sid,ip,user_id,username,last_activity,exam_time)
        values(par_session_id,par_ip,par_user_id,par_username,unix_timestamp(sysdate()),par_exam_time);
      end if;
    end if;
    delete from t_session where username=par_username and exam_id is not null and sid !=par_session_id;
    set par_invalid=1;
  else
     if par_admin_flg =1 then
       select user_id into @u from t_session where sid=par_session_id and last_activity < (select unix_timestamp(sysdate()) - (select cast(s.setting_value as UNSIGNED)*60 from t_setting s where s.user_id=0 and s.setting_name='online_admin_clear_time'));
     else
       select user_id into @u from t_session where sid=par_session_id and last_activity < (select unix_timestamp(sysdate()) - (select cast(s.setting_value as UNSIGNED)*60 from t_setting s where s.user_id=0 and s.setting_name='online_clear_time'))
       and (exam_time*60+exam_start_tm)<unix_timestamp(sysdate());
     end if;

     if @u is not null or @u !='' then
         set par_invalid=0;
         delete from t_session where sid=par_session_id;
     else
         set par_invalid=1;
         update t_session set last_activity=unix_timestamp(sysdate()) where sid=par_session_id and ip=par_ip;
     end if;
  end if;

  delete from t_session where sid !=par_session_id
  and last_activity < (select unix_timestamp(sysdate()) - (select cast(s.setting_value as UNSIGNED)*60 from t_setting s where s.user_id=0 and s.setting_name='online_admin_clear_time'));

  delete from t_session where sid !=par_session_id
  and last_activity < (select unix_timestamp(sysdate()) - (select cast(s.setting_value as UNSIGNED)*60 from t_setting s where s.user_id=0 and s.setting_name='online_clear_time'))
  and (exam_time*60+exam_start_tm)<unix_timestamp(sysdate());

  delete from t_session where sid !=par_session_id and role_value is null and exam_time is null and exam_id is not null
  and hour(TIMEDIFF(sysdate(),from_unixtime(exam_start_tm)))>8;

  call monitor_exam_clear();


  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `session_online_count`;
CREATE PROCEDURE  `session_online_count`()
begin

  select count(*) online_count from t_session where user_id !=0;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `session_select`;
CREATE PROCEDURE  `session_select`(IN par_session_id char(12),IN par_ip varchar(15))
begin
  set @strsql=concat('select ip,user_id,username,exam_time,security_code,last_activity,role_value,role_group
  from t_session where ip=','''',par_ip,'''',' and sid=','''',par_session_id,'''');

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;

  
  
        
end

DROP PROCEDURE IF EXISTS `session_select_online_info`;
CREATE PROCEDURE  `session_select_online_info`(in par_session_id varchar(16),in par_ip varchar(15)
,IN par_user_id int(10),in par_username varchar(20))
begin

    set @strsql=concat('select ip,username,user_id,sid from t_session where 1=1 ');

    if par_session_id is not null then
        set @strsql=concat(@strsql,' and sid=','''',par_session_id,'''');
    end if;

    if par_user_id is not null then
        set @strsql=concat(@strsql,' and user_id=',par_user_id);
    end if;

    if par_username is not null then
            set @strsql=concat(@strsql,' and username=','''',par_username,'''');
    end if;

    if par_ip is not null then
            set @strsql=concat(@strsql,' and ip=','''',par_ip,'''');
    end if;

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `session_select_role_group`;
CREATE PROCEDURE  `session_select_role_group`(IN par_session_id char(12),IN par_ip varchar(15))
begin
  set @strsql=concat('select role_group from t_session where sid=','''',par_session_id,'''',' and ip=','''',par_ip,'''');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `session_update`;
CREATE PROCEDURE  `session_update`(IN par_session_id char(12),IN par_ip varchar(15),
IN par_session_value varchar(1000),IN par_session_key varchar(1000),IN par_arr_length int(10))
begin

    declare cur_string varchar(1000);
    declare i int(8) default 0;

    select exam_start_tm into @exam_tm from t_session where sid=par_session_id and ip=par_ip;

    set @strsql=concat('update t_session set ');

  repeat set i = i + 1;
    set cur_string=substring_index(substring_index(par_session_key, ',', i), ',', -1);

    if cur_string ='last_activity' then
        set @strsql=concat(@strsql,'last_activity=',unix_timestamp(sysdate()),',');
    elseif cur_string='exam_time' then
      if substring_index(substring_index(par_session_value, ',', i), ',', -1) ='' then
        set @strsql=concat(@strsql,'exam_time=null',',');
      else
        set @exam_time=substring_index(substring_index(par_session_value, ',', i), ',', -1);
        set @strsql=concat(@strsql,'exam_time=',@exam_time,',');
      end if;
    elseif cur_string='exam_id' then
        set @strsql=concat(@strsql,'exam_id=','''',substring_index(substring_index(par_session_value, ',', i), ',', -1),'''',',');
      elseif cur_string='user_id' then
        set @strsql=concat(@strsql,'user_id=',substring_index(substring_index(par_session_value, ',', i), ',', -1),',');
      elseif cur_string='username' then
        set @strsql=concat(@strsql,'username=','''',substring_index(substring_index(par_session_value, ',', i), ',', -1),'''',',');
    elseif cur_string='exam_start_tm' then
     set @t=substring_index(substring_index(par_session_value, ',', i), ',', -1);
     if @t !=0 then
        set @strsql=concat(@strsql,'exam_start_tm=unix_timestamp(sysdate()),');
     else
        set @strsql=concat(@strsql,'exam_start_tm=0',',');
     end if;
    end if;
    until i >= par_arr_length end repeat;

  set @strsql=substring(@strsql from 1 for char_length(@strsql)-1);

  set @strsql=concat(@strsql,' where ip=','''',par_ip,'''',' and sid=','''',par_session_id,'''');
  
  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `session_update_role`;
CREATE PROCEDURE  `session_update_role`(IN par_session_id char(12),
IN par_ip varchar(15),IN par_role_value varchar(4000),IN par_role_group varchar(4000),IN par_last_activity int(10))
begin

  set @strsql=concat('update t_session set role_value=','''',par_role_value,'''',',last_activity=',par_last_activity,
                                 ',role_group=','''',par_role_group,'''',' where ip=','''',par_ip,'''',' and sid=','''',par_session_id,'''');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `session_update_security_code`;
CREATE PROCEDURE  `session_update_security_code`(IN par_session_id char(12),
IN par_ip varchar(15),IN par_security_code varchar(15),IN par_last_activity int(10))
begin

  set @strsql=concat('update t_session set security_code=','''',par_security_code,'''',',last_activity=',par_last_activity,
                                ' where ip=','''',par_ip,'''',' and sid=','''',par_session_id,'''');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `session_validate_login`;
CREATE PROCEDURE  `session_validate_login`(in par_username varchar(20),
IN par_user_id int(10),in par_ip varchar(20))
begin

    if par_user_id is not null then
      select count(*) into @cnt from t_session where user_id=par_user_id and role_value is null;
    else
          select count(*) into @cnt from t_session where username=par_username and role_value is null;
    end if;

    if @cnt=0 then
      select @cnt cnt;
    else
      if par_user_id is not null then
        select count(*) into @cnt from t_session where user_id=par_user_id and role_value is null and ip=par_ip;
      else
        select count(*) into @cnt from t_session where username=par_username and role_value is null and ip=par_ip;
      end if;

      if @cnt=0 then
         select 2 cnt;
      else
         select @cnt cnt;
      end if;
    end if;

  
  
  
  
  
  
        
end



