DROP PROCEDURE IF EXISTS `setting_select`;
CREATE PROCEDURE  `setting_select`(IN par_user_id int(10),in par_setting_name varchar(64),
in par_category_pname varchar(64),in par_category_name varchar(64))
begin
    
    if par_user_id is not null then
        select count(*) into @ucount from t_setting where user_id=par_user_id;
    end if;
    
    set @strsql='select trim(s.setting_value) setting_value,s.setting_name,category_pname,category_name,c.desc_cn setting_des
                      from t_setting s left join t_common_cde c on c.c_cde=s.setting_value where ';

    if par_setting_name is not null then
        set @strsql=concat(@strsql,'s.setting_name like ','''',par_setting_name,'%''',' and ');
    end if;

    if par_category_pname is not null then
        set @strsql=concat(@strsql,'s.category_pname=','''',par_category_pname,'''',' and ');
    end if;
    
    if par_category_name is not null then
        set @strsql=concat(@strsql,'s.category_name=','''',par_category_name,'''',' and ');
    end if;

  if par_user_id is not null then
        if @ucount !=0 then
            set @strsql=concat(@strsql,'s.user_id=',par_user_id);
        else
            set @strsql=concat(@strsql,'s.user_id=0');
        end if;
  else
    set @strsql=substring(@strsql from 1 for length(@strsql)-4);
  end if;

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
    
end

DROP PROCEDURE IF EXISTS `setting_select_category`;
CREATE PROCEDURE  `setting_select_category`(in par_category_name varchar(64))
begin

    set @strsql=concat('select s.category_name,trim(s.setting_value) setting_value,s.setting_tag,s.setting_name,s.setting_desc,c.desc_cn
                    from t_setting s left join t_common_cde c on c.c_cde=s.setting_value
                    where user_id=0 and category_pname in(',par_category_name,')');
  
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
    
end

DROP PROCEDURE IF EXISTS `setting_select_user_category`;
CREATE PROCEDURE  `setting_select_user_category`(IN par_user_id int(10),in par_category_name varchar(64))
begin
  declare mycnt tinyint;

  select count(*) into mycnt from t_setting  where user_id=par_user_id and category_pname=par_category_name;

    if mycnt !=0 then
        set @strsql=concat('select s.category_name,trim(s.setting_value) setting_value,s.setting_name,s.setting_desc,c.desc_cn
                        from t_setting s left join t_common_cde c on c.c_cde=s.setting_value
                        where category_pname in(','''',par_category_name,'''',') and s.user_id=',par_user_id);
    else
        set @strsql=concat('select s.category_name,trim(s.setting_value) setting_value,s.setting_name,s.setting_desc,c.desc_cn
                        from t_setting s left join t_common_cde c on c.c_cde=s.setting_value
                        where user_id=0 and category_pname in(','''',par_category_name,'''',')');
  end if;
 
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
    
end

DROP PROCEDURE IF EXISTS `setting_update`;
CREATE PROCEDURE  `setting_update`(IN par_arr_length INT(8),
IN par_user_id int(10),IN par_update_user_id int(10),IN par_arr_name text,IN par_arr_value text)
BEGIN
  DECLARE i INT(8) DEFAULT 0;
  REPEAT SET i = i + 1;
    update  t_setting set setting_value=SUBSTRING_INDEX(SUBSTRING_INDEX(par_arr_value, ',', i), ',', -1),
      update_tm=sysdate(),update_user_id=par_update_user_id
            where setting_name=SUBSTRING_INDEX(SUBSTRING_INDEX(par_arr_name, ',', i), ',', -1) and user_id=par_user_id;
  UNTIL i >= par_arr_length END REPEAT;
  
  
  
  
  
  
  
    
end

DROP PROCEDURE IF EXISTS `setting_user_update`;
CREATE PROCEDURE  `setting_user_update`(IN par_arr_length INT(8),
IN par_user_id int(10),IN par_category_pname varchar(64),IN par_category_name varchar(64),IN par_arr_name text,IN par_arr_value text)
BEGIN

  DECLARE i INT(8) DEFAULT 0;
  DECLARE sname varchar(64) DEFAULT null;
  DECLARE svalue varchar(64) DEFAULT null;
  DECLARE sdesc varchar(4000) DEFAULT null;select count(*) into @cnt from t_setting where user_id=par_user_id and category_name=par_category_name ;if @cnt != 0 then
      REPEAT SET i = i + 1;
        update  t_setting set setting_value=SUBSTRING_INDEX(SUBSTRING_INDEX(par_arr_value, ',', i), ',', -1),
          update_tm=sysdate(),update_user_id=par_user_id
                where setting_name=SUBSTRING_INDEX(SUBSTRING_INDEX(par_arr_name, ',', i), ',', -1) and user_id=par_user_id;
    
      UNTIL i >= par_arr_length END REPEAT;
  else
        REPEAT SET i = i + 1;
            set sname=SUBSTRING_INDEX(SUBSTRING_INDEX(par_arr_name, ',', i), ',', -1);
            set svalue=SUBSTRING_INDEX(SUBSTRING_INDEX(par_arr_value, ',', i), ',', -1);
            select s.setting_desc into sdesc from t_setting s where s.user_id=0 and s.setting_name=sname;

            insert into  t_setting(user_id,category_pname,category_name,setting_name,setting_value,setting_desc,create_tm,create_user_id)
            values(par_user_id,par_category_pname,par_category_name,sname,svalue,sdesc,sysdate(),par_user_id);
        UNTIL i >= par_arr_length END REPEAT;
  end if;

  
  
  
  
  
  
    
end



