DROP TABLE IF EXISTS `t_question`;
CREATE TABLE `t_question` (
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_level` varchar(20) DEFAULT NULL,
  `qsn_limit_tm` time DEFAULT '00:03:00',
  `qsn_point` float NOT NULL DEFAULT '0',
  `qsn_source` varchar(20) DEFAULT NULL,
  `qsn_status` varchar(20) DEFAULT NULL,
  `qsn_type` varchar(20) DEFAULT NULL,
  `qsn_content` text,
  `qsn_content_edit` text,
  `qsn_option_count` smallint(4) DEFAULT NULL,
  `qsn_guide` text,
  `qsn_category` varchar(20) DEFAULT NULL,
  `qsn_expire` date DEFAULT NULL,
  `create_tm` datetime NOT NULL,
  `create_user_id` int(10) NOT NULL,
  `update_tm` datetime DEFAULT NULL,
  `update_user_id` int(10) DEFAULT NULL,
  `qsn_sub_flg` char(1) DEFAULT NULL,
  PRIMARY KEY (`qsn_id`,`qsn_sub_id`),
  KEY `index_qsn_category` (`qsn_category`),
  KEY `index_qsn_type` (`qsn_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_question_import`;
CREATE TABLE `t_question_import` (
  `qsn_id` char(32) NOT NULL,
  `qsn_sub_id` char(32) NOT NULL,
  `qsn_level` varchar(20) DEFAULT NULL,
  `qsn_limit_tm` time DEFAULT '00:03:00',
  `qsn_point` float NOT NULL DEFAULT '0',
  `qsn_source` varchar(20) DEFAULT NULL,
  `qsn_status` varchar(20) DEFAULT NULL,
  `qsn_type` varchar(20) DEFAULT NULL,
  `qsn_content` text,
  `qsn_content_edit` text,
  `qsn_option_count` smallint(4) DEFAULT NULL,
  `qsn_guide` text,
  `qsn_category` varchar(20) DEFAULT NULL,
  `qsn_expire` date DEFAULT NULL,
  `create_tm` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `create_user_id` int(10) NOT NULL,
  `update_tm` datetime DEFAULT NULL,
  `update_user_id` int(10) DEFAULT NULL,
  `qsn_sub_flg` char(1) DEFAULT NULL,
  PRIMARY KEY (`qsn_id`,`qsn_sub_id`),
  KEY `index_qsn_category` (`qsn_category`),
  KEY `index_qsn_type` (`qsn_type`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;



