DROP PROCEDURE IF EXISTS `usr_add_examinfo`;
CREATE PROCEDURE  `usr_add_examinfo`(IN par_sid varchar(50),IN par_user_id int(10), IN par_exam_id CHAR(32), IN par_papr_id CHAR(32), IN par_exam_total_tm VARCHAR(20), IN par_answer TEXT)
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

    select max(t.exam_times) into @nt from t_user_exam t
    where t.user_id=par_user_id and t.papr_id=par_papr_id and t.exam_id=par_exam_id;
    select case when @nt is null then 1 else @nt+1 end into @cnt;

    if par_answer !='' then
        set @strsql=concat('insert into t_user_exam_answer(user_id,exam_id,papr_id,exam_times,qsn_id,qsn_sub_id,qsn_item_id,qsn_type_position,qsn_type,user_answer) values ',par_answer);

        prepare stmt from @strsql;
        execute stmt;
        deallocate prepare stmt;
    end if;

    set @mysql2='';

    insert into tmp_usr_add_examinfo_tree(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id and qsn_sub_id !='0';

    set v_row_count := row_count();
    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_usr_add_examinfo_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id, v_level + 1
        , @position := @position+1
        from t_question q inner join tmp_usr_add_examinfo_tree t on q.qsn_id = t.id
        where t.level = v_level and q.qsn_sub_id !='0'  order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

    select exam_blank_flg,exam_cloze_flg,exam_point_type,exam_point into @blank_flg,@cloze_flg,@exam_point_type,@exam_point from t_exam e where e.exam_id=par_exam_id;

    set @mysql='
    insert into t_user_exam_info(user_id,exam_id,papr_id,exam_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.exam_id,r.papr_id,r.exam_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case ';
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,case ');
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring');
    set @mysql=concat(@mysql,' from (
    select count(*) qsn_item_count,tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    from t_user_exam_answer tq
    where  tq.user_id=','''',par_user_id,'''',' and tq.exam_id=','''',par_exam_id,'''',' and tq.papr_id=','''',par_papr_id,'''',' and tq.exam_times=',@cnt,'
    and tq.qsn_type in(','''','010101','''',',','''','010103','''',',','''','010105','''',',','''','010106','''',',','''','010107','''',')
    group by tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    ) t1 left join ( ');
    set @mysql=concat(@mysql,'select count(*) right_count,t.qsn_id,t.qsn_sub_id,t.qsn_type,t.qsn_type_position from t_user_exam_answer t
    join t_answer a2 on a2.qsn_id = t.qsn_id and a2.qsn_sub_id = t.qsn_sub_id and t.user_answer = a2.qsn_answer and a2.qsn_item_id = t.qsn_item_id and t.qsn_type !=\'010102\'
    where t.user_id=','''',par_user_id,'''',' and t.exam_id=','''',par_exam_id,'''',
    'and  t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.qsn_type in(','''','010101','''',',','''','010103','''',',','''','010105','''',',','''','010106','''',',','''','010107','''',')
    group by t.user_id,t.exam_id,t.papr_id,t.exam_times,t.qsn_id,t.qsn_sub_id,t.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @exam_point_type='030202' then
        set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                     from tmp_usr_add_examinfo_tree t, t_question r, t_qsn_sub_position s
                    where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
        set @mysql=concat(@mysql,') q');

        set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_examinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

        if par_papr_id is not null then
        set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
        set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
                  from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
        if par_papr_id is not null then
        set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exam_point_type='030201' then
        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

         union
        select r.qsn_id, r.qsn_sub_id, p.qsn_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exam_point_type='030203' then

        select a.papr_qsn_count into @qsn_count
        from t_exam e join t_exam_papr p on e.exam_id=p.exam_id and e.exam_id=par_exam_id
        join t_paper a on a.papr_id=p.papr_id;
        set @q_point=round(@exam_point/@qsn_count,2);

        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
         union
        select r.qsn_id, r.qsn_sub_id, @q_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst join t_user_exam_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id and r.exam_times=',@cnt
    ,' and r.exam_id =','''',par_exam_id,'''',' and r.papr_id =','''',par_papr_id,'''',' and r.user_id=',par_user_id);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    set @mysql='insert into t_user_exam_info(user_id,exam_id,papr_id,exam_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.exam_id,r.papr_id,r.exam_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case ';
    set @mysql=concat(@mysql,'when  t1.qsn_right_item_count =t2.right_count and t1.select_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,case ');
    set @mysql=concat(@mysql,'when  t1.qsn_right_item_count =t2.right_count and t1.select_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring');
    set @mysql=concat(@mysql,' from (
  select count(*) qsn_right_item_count,a.qsn_id,a.qsn_sub_id,a.qsn_type,c.select_count
  from t_answer a join (select distinct t.qsn_id,qsn_sub_id,t.user_answer
  from  t_user_exam_answer t    where t.user_id=','''',par_user_id,'''',' and t.exam_id=','''',par_exam_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.qsn_type in(','''','010102','''',')) b  on b.qsn_id=a.qsn_id and b.qsn_sub_id=a.qsn_sub_id and a.qsn_answer=b.user_answer
  join (select count(*) select_count,t.qsn_id,qsn_sub_id
  from  t_user_exam_answer t    where t.user_id=','''',par_user_id,'''',' and t.exam_id=','''',par_exam_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.qsn_type in(','''','010102','''',') group by t.qsn_id,t.qsn_sub_id) c  on c.qsn_id=a.qsn_id and c.qsn_sub_id=a.qsn_sub_id
  group by a.qsn_id,a.qsn_sub_id,a.qsn_type) t1 left join ( ');

    set @mysql=concat(@mysql,'select count(*) right_count,a.qsn_id,a.qsn_sub_id,a.qsn_type
  from t_answer a join (select distinct t.qsn_id,qsn_sub_id
  from t_user_exam_answer t
    where t.user_id=','''',par_user_id,'''',' and t.exam_id=','''',par_exam_id,'''',
    'and  t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.qsn_type in(','''','010102','''',')) b on b.qsn_id=a.qsn_id and b.qsn_sub_id=a.qsn_sub_id
  group by a.qsn_id,a.qsn_sub_id,a.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @exam_point_type='030202' then
        set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                     from tmp_usr_add_examinfo_tree t, t_question r, t_qsn_sub_position s
                    where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
        set @mysql=concat(@mysql,') q');

        set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_examinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

        if par_papr_id is not null then
        set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
        set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
                  from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
        if par_papr_id is not null then
        set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exam_point_type='030201' then
        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

         union
        select r.qsn_id, r.qsn_sub_id, p.qsn_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exam_point_type='030203' then

        select a.papr_qsn_count into @qsn_count
        from t_exam e join t_exam_papr p on e.exam_id=p.exam_id and e.exam_id=par_exam_id
        join t_paper a on a.papr_id=p.papr_id;
        set @q_point=round(@exam_point/@qsn_count,2);

        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
         union
        select r.qsn_id, r.qsn_sub_id, @q_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst join t_user_exam_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id and r.exam_times=',@cnt
    ,' and r.exam_id =','''',par_exam_id,'''',' and r.papr_id =','''',par_papr_id,'''',' and r.user_id=',par_user_id);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;


    set @mysql='insert into t_user_exam_info(user_id,exam_id,papr_id,exam_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.exam_id,r.papr_id,r.exam_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case ';
    if @blank_flg=1 or @cloze_flg=1 then
    set @mysql=concat(@mysql,' when t1.qsn_item_count >t2.right_count>=1 then ','''','2','''');
    end if;
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,case ');
    if @blank_flg=1 or @cloze_flg =1 then
    set @mysql=concat(@mysql,' when t1.qsn_item_count >t2.right_count>=1 then ROUND((tp.qsn_point/t1.qsn_item_count)*t2.right_count,2)');
    end if;
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring');
    set @mysql=concat(@mysql,' from (
    select count(*) qsn_item_count,tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    from t_user_exam_answer tq
    where  tq.user_id=','''',par_user_id,'''',' and tq.exam_id=','''',par_exam_id,'''',' and tq.papr_id=','''',par_papr_id,'''',' and tq.exam_times=',@cnt,'
    and tq.qsn_type in(','''','010104','''',',','''','010108','''',')
    group by tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    ) t1 left join ( ');

    set @mysql=concat(@mysql,'select count(*) right_count,t.qsn_id,t.qsn_sub_id,t.qsn_type,t.qsn_type_position from t_user_exam_answer t
    join t_answer a2 on a2.qsn_id = t.qsn_id and a2.qsn_sub_id = t.qsn_sub_id and t.user_answer = a2.qsn_answer and a2.qsn_item_id = t.qsn_item_id and t.qsn_type !=\'010102\'
    where t.user_id=','''',par_user_id,'''',' and t.exam_id=','''',par_exam_id,'''',
    'and  t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.qsn_type in(','''','010104','''',',','''','010108','''',')
    group by t.user_id,t.exam_id,t.papr_id,t.exam_times,t.qsn_id,t.qsn_sub_id,t.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @exam_point_type='030202' then
    set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                 from tmp_usr_add_examinfo_tree t, t_question r, t_qsn_sub_position s
                where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
    set @mysql=concat(@mysql,') q');

    set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_examinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

    if par_papr_id is not null then
    set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
    set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
              from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
    if par_papr_id is not null then
    set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exam_point_type='030201' then
    set @mysql=concat(@mysql,'left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

    union
    select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
    from (
    select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
    group by p8.pid,p8.id
    union
    select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
    (
    select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    ) pp
    join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

     union
    select r.qsn_id, r.qsn_sub_id, p.qsn_point
    from t_papr_content t
    join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
    join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
    where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exam_point_type='030203' then

    select a.papr_qsn_count into @qsn_count
    from t_exam e join t_exam_papr p on e.exam_id=p.exam_id and e.exam_id=par_exam_id
    join t_paper a on a.papr_id=p.papr_id;
    set @q_point=round(@exam_point/@qsn_count,2);

    set @mysql=concat(@mysql,'left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

    union
    select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
    from (
    select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
    group by p8.pid,p8.id
    union
    select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
    (
    select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    ) pp
    join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
     union
    select r.qsn_id, r.qsn_sub_id, @q_point
    from t_papr_content t
    join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
    join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
    where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst
    join t_user_exam_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id where r.exam_times=',@cnt,' and r.user_id=','''',par_user_id,''''
    ,' and r.exam_id =','''',par_exam_id,'''',' and r.papr_id =','''',par_papr_id,'''');

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    if par_answer !='' then
    set @mysql=concat('
    insert into t_user_exam(user_id,exam_id,papr_id,exam_times,exam_tm,exam_point,user_exam_scoring,exam_total_tm,qsn_count,right_count,part_right_count,error_count,null_count)
    select tst_info.user_id,ex.exam_id,tst_info.papr_id,tst_info.exam_times,sysdate(),
    ex.exam_point,round(tst_info.scoring,2) scoring,','''',par_exam_total_tm,'''',',p.papr_qsn_count
    ,tst_info.right_count,tst_info.part_right_count,tst_info.error_count,(p.papr_qsn_count-tst_info.right_count-tst_info.error_count-tst_info.part_right_count) null_count
    from t_paper p,(
    select sum(info.right_count) right_count,sum(info.part_right_count) part_right_count,sum(info.error_count) error_count,sum(info.scoring) scoring
    ,info.user_id,info.exam_id,info.papr_id,info.exam_times from(
    select count(*) right_count,0 part_right_count,0 error_count,t.user_id,t.exam_id,t.papr_id,t.exam_times,sum(t.scoring) scoring
    from t_user_exam_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.answer_status=1 and t.exam_id=','''',par_exam_id,'''','
    group by t.user_id,t.exam_id,t.papr_id,t.exam_times
    union
    select 0 right_count,0 part_right_count,count(*) error_count,t.user_id,t.exam_id,t.papr_id,t.exam_times,0 scoring
    from t_user_exam_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.answer_status=0 and t.exam_id=','''',par_exam_id,'''','
    group by t.user_id,t.exam_id,t.papr_id,t.exam_times
    union
    select 0 right_count,count(*) part_right_count,0 error_count,t.user_id,t.exam_id,t.papr_id,t.exam_times,sum(t.scoring) scoring
    from t_user_exam_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.answer_status=2 and t.exam_id=','''',par_exam_id,'''');
    if @blank_flg !=1 then
    set @mysql=concat(@mysql,' and t.qsn_type not in(','''','010104','''',')');
    end if;
    if @cloze_flg !=1 THEN
    set @mysql=concat(@mysql,' and t.qsn_type not in(','''','010108','''',')');
    end if;
    set @mysql=concat(@mysql,'group by t.user_id,t.exam_id,t.papr_id,t.exam_times
    ) info
    group by info.user_id,info.exam_id,info.papr_id,info.exam_times
    ) tst_info,t_exam ex
    where
    tst_info.papr_id=p.papr_id and ex.exam_id=tst_info.exam_id');
    else
    set @mysql='insert into t_user_exam(user_id,exam_id,papr_id,exam_times,exam_tm,exam_point,user_exam_scoring,exam_total_tm,qsn_count,right_count,part_right_count,error_count,null_count)';
    set @mysql=concat(@mysql,'select ',par_user_id,',','''',par_exam_id,'''',',','''',par_papr_id,'''',',',@cnt,',sysdate(),ex.exam_point,0,','''',par_exam_total_tm,'''',',p.papr_qsn_count
    ,0 right_count,0 part_right_count,0 error_count,0 null_count from t_paper p
    join t_exam_papr ep on ep.papr_id=p.papr_id
    join t_exam ex on ex.exam_id=ep.exam_id and ex.exam_id=','''',par_exam_id,'''');

    end if;

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
    truncate table tmp_usr_add_examinfo_tree;

    update t_session set exam_time=0,exam_start_tm=0,exam_id=null,exam_cmd=null where user_id=par_user_id and exam_id=par_exam_id and sid=par_sid;

  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_add_exam_answer`;
CREATE PROCEDURE  `usr_add_exam_answer`(IN par_user_id int(10), IN par_exam_id CHAR(32),IN par_papr_id CHAR(32),IN par_exam_total_tm VARCHAR(20),IN par_answer TEXT, IN par_ip_address VARCHAR(15))
begin
    
  select max(t.exam_times) into @nt from t_user_exam t where t.user_id=par_user_id and t.papr_id=par_papr_id and t.exam_id=par_exam_id;
  select case when @nt is null then 1 else @nt+1 end into @cnt;

  if par_answer !='' then
      set @strsql=concat('replace into t_user_exam_answer(user_id,exam_id,papr_id,exam_times,qsn_id,qsn_sub_id,qsn_item_id,qsn_type_position,qsn_type,user_answer) values ',par_answer);
  else
    set @strsql='replace into t_user_exam(user_id,exam_id,papr_id,exam_times,exam_tm,exam_point,user_exam_scoring,exam_total_tm,qsn_count,right_count,part_right_count,error_count,null_count, ip_address)';
    set @strsql=concat(@strsql,'select ',par_user_id,',','''',par_exam_id,'''',',','''',par_papr_id,'''',',',@cnt,',sysdate(),ex.exam_point,0,','''',par_exam_total_tm,'''',',p.papr_qsn_count
    ,0 right_count,0 part_right_count,0 error_count,0 null_count, ','''',par_ip_address,'''',' from t_paper p
    join t_exam_papr ep on ep.papr_id=p.papr_id
    join t_exam ex on ex.exam_id=ep.exam_id and ex.exam_id=','''',par_exam_id,'''');
  end if;

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  delete from t_user_exam_answer_storage where exam_id=par_exam_id and user_id=par_user_id and papr_id=par_papr_id and exam_times=@cnt;
  delete from t_user_exam_storage where exam_id=par_exam_id and user_id=par_user_id and papr_id=par_papr_id and exam_times=@cnt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_add_exam_answer_storage`;
CREATE PROCEDURE  `usr_add_exam_answer_storage`(IN par_user_id int(10), IN par_exam_id CHAR(32),IN par_papr_id CHAR(32),IN par_exam_total_tm VARCHAR(20),IN par_answer TEXT)
begin
    
  select max(t.exam_times) into @nt from t_user_exam t where t.user_id=par_user_id and t.papr_id=par_papr_id and t.exam_id=par_exam_id;

  select case when @nt is null then 1 else @nt+1 end into @cnt;

  select count(*),exam_total_tm into @mycnt,@total_tm from t_user_exam_storage where user_id=par_user_id and papr_id=par_papr_id and exam_id=par_exam_id;

  if @mycnt =0 then
    set @total_tm=par_exam_total_tm;
  else
    set @total_tm=sec_to_time(time_to_sec(@total_tm)+time_to_sec(par_exam_total_tm));
  end if;

  set @strsql=concat('replace into t_user_exam_storage(user_id,exam_id,papr_id,exam_times,exam_total_tm)
  values(',par_user_id,',','''',par_exam_id,'''',',','''',par_papr_id,'''',',',@cnt,',','''',@total_tm,'''',')');

  prepare stmt from @strsql;
    execute stmt;

  if par_answer !='' then
      set @strsql=concat('replace into t_user_exam_answer_storage(user_id,exam_id,papr_id,exam_times,qsn_id,qsn_sub_id,qsn_item_id,qsn_type_position,qsn_type,user_answer) values ',par_answer);

    prepare stmt from @strsql;
    execute stmt;
      deallocate prepare stmt;
  end if;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_add_exam_score`;
CREATE PROCEDURE  `usr_add_exam_score`(IN par_sid varchar(50),IN par_user_id int(10), IN par_exam_id CHAR(32),IN par_papr_id CHAR(32), IN par_exam_total_tm VARCHAR(20))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

    select max(t.exam_times) into @nt from t_user_exam t where t.user_id=par_user_id and t.papr_id=par_papr_id and t.exam_id=par_exam_id;
    select case when @nt is null then 1 else @nt+1 end into @cnt;

    insert into tmp_usr_add_examinfo_tree(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id and qsn_sub_id !='0';

    set v_row_count := row_count();
    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_usr_add_examinfo_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id, v_level + 1
        , @position := @position+1
        from t_question q inner join tmp_usr_add_examinfo_tree t on q.qsn_id = t.id
        where t.level = v_level and q.qsn_sub_id !='0'  order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

    select exam_blank_flg,exam_cloze_flg,exam_point_type,exam_point into @blank_flg,@cloze_flg,@exam_point_type,@exam_point from t_exam e where e.exam_id=par_exam_id;

    set @mysql=concat('insert into t_user_exam_info(user_id,exam_id,papr_id,exam_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.exam_id,r.papr_id,r.exam_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case when  t1.qsn_item_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,
    case when  t1.qsn_item_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring from (
    select count(*) qsn_item_count,tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    from t_user_exam_answer tq  where  tq.user_id=','''',par_user_id,'''',' and tq.exam_id=','''',par_exam_id,'''',' and tq.papr_id=','''',par_papr_id,'''',' and tq.exam_times=',@cnt,'
    and tq.qsn_type in(','''','010101','''',',','''','010103','''',',','''','010105','''',',','''','010106','''',',','''','010107','''',')
    group by tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    ) t1 left join ( select count(*) right_count,t.qsn_id,t.qsn_sub_id,t.qsn_type,t.qsn_type_position from t_user_exam_answer t
    join t_answer a2 on a2.qsn_id = t.qsn_id and a2.qsn_sub_id = t.qsn_sub_id and t.user_answer = a2.qsn_answer and a2.qsn_item_id = t.qsn_item_id and t.qsn_type !=\'010102\'
    where t.user_id=','''',par_user_id,'''',' and t.exam_id=','''',par_exam_id,'''',
    'and  t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.qsn_type in(','''','010101','''',',','''','010103','''',',','''','010105','''',',','''','010106','''',',','''','010107','''',')
    group by t.user_id,t.exam_id,t.papr_id,t.exam_times,t.qsn_id,t.qsn_sub_id,t.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @exam_point_type='030202' then
        set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                     from tmp_usr_add_examinfo_tree t, t_question r, t_qsn_sub_position s
                    where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
        set @mysql=concat(@mysql,') q');

        set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_examinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

        if par_papr_id is not null then
        set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
        set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
                  from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
        if par_papr_id is not null then
        set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');
    elseif @exam_point_type='030201' then
        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

         union
        select r.qsn_id, r.qsn_sub_id, p.qsn_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exam_point_type='030203' then

        select a.papr_qsn_count into @qsn_count
        from t_exam e join t_exam_papr p on e.exam_id=p.exam_id and e.exam_id=par_exam_id
        join t_paper a on a.papr_id=p.papr_id;
        set @q_point=round(@exam_point/@qsn_count,2);

        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
         union
        select r.qsn_id, r.qsn_sub_id, @q_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst join t_user_exam_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id and r.exam_times=',@cnt
    ,' and r.exam_id =','''',par_exam_id,'''',' and r.papr_id =','''',par_papr_id,'''',' and r.user_id=',par_user_id);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    set @mysql='insert into t_user_exam_info(user_id,exam_id,papr_id,exam_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.exam_id,r.papr_id,r.exam_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case ';
    set @mysql=concat(@mysql,'when  t1.qsn_right_item_count =t2.right_count and t1.select_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,case ');
    set @mysql=concat(@mysql,'when  t1.qsn_right_item_count =t2.right_count and t1.select_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring');
    set @mysql=concat(@mysql,' from (
  select count(*) qsn_right_item_count,a.qsn_id,a.qsn_sub_id,a.qsn_type,c.select_count
  from t_answer a join (select distinct t.qsn_id,qsn_sub_id,t.user_answer
  from  t_user_exam_answer t    where t.user_id=','''',par_user_id,'''',' and t.exam_id=','''',par_exam_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.qsn_type in(','''','010102','''',')) b  on b.qsn_id=a.qsn_id and b.qsn_sub_id=a.qsn_sub_id and a.qsn_answer=b.user_answer
  join (select count(*) select_count,t.qsn_id,qsn_sub_id
  from  t_user_exam_answer t    where t.user_id=','''',par_user_id,'''',' and t.exam_id=','''',par_exam_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.qsn_type in(','''','010102','''',') group by t.qsn_id,t.qsn_sub_id) c  on c.qsn_id=a.qsn_id and c.qsn_sub_id=a.qsn_sub_id
  group by a.qsn_id,a.qsn_sub_id,a.qsn_type) t1 left join ( ');

    set @mysql=concat(@mysql,'select count(*) right_count,a.qsn_id,a.qsn_sub_id,a.qsn_type
  from t_answer a join (select distinct t.qsn_id,qsn_sub_id
  from t_user_exam_answer t where t.user_id=','''',par_user_id,'''',' and t.exam_id=','''',par_exam_id,'''','and  t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.qsn_type in(','''','010102','''',')) b on b.qsn_id=a.qsn_id and b.qsn_sub_id=a.qsn_sub_id
  group by a.qsn_id,a.qsn_sub_id,a.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @exam_point_type='030202' then
        set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                     from tmp_usr_add_examinfo_tree t, t_question r, t_qsn_sub_position s
                    where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
        set @mysql=concat(@mysql,') q');

        set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_examinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

        if par_papr_id is not null then
        set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
        set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
                  from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
        if par_papr_id is not null then
        set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exam_point_type='030201' then
        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

         union
        select r.qsn_id, r.qsn_sub_id, p.qsn_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exam_point_type='030203' then

        select a.papr_qsn_count into @qsn_count
        from t_exam e join t_exam_papr p on e.exam_id=p.exam_id and e.exam_id=par_exam_id
        join t_paper a on a.papr_id=p.papr_id;
        set @q_point=round(@exam_point/@qsn_count,2);

        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
         union
        select r.qsn_id, r.qsn_sub_id, @q_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst join t_user_exam_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id and r.exam_times=',@cnt
    ,' and r.exam_id =','''',par_exam_id,'''',' and r.papr_id =','''',par_papr_id,'''',' and r.user_id=',par_user_id);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    set @mysql='insert into t_user_exam_info(user_id,exam_id,papr_id,exam_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.exam_id,r.papr_id,r.exam_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case ';
    if @blank_flg=1 or @cloze_flg=1 then
    set @mysql=concat(@mysql,' when t1.qsn_item_count >t2.right_count>=1 then ','''','2','''');
    end if;
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,case ');
    if @blank_flg=1 or @cloze_flg =1 then
    set @mysql=concat(@mysql,' when t1.qsn_item_count >t2.right_count>=1 then ROUND((tp.qsn_point/t1.qsn_item_count)*t2.right_count,2)');
    end if;
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring');
    set @mysql=concat(@mysql,' from (
    select count(*) qsn_item_count,tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    from t_user_exam_answer tq
    where  tq.user_id=','''',par_user_id,'''',' and tq.exam_id=','''',par_exam_id,'''',' and tq.papr_id=','''',par_papr_id,'''',' and tq.exam_times=',@cnt,'
    and tq.qsn_type in(','''','010104','''',',','''','010108','''',')
    group by tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    ) t1 left join ( ');

    set @mysql=concat(@mysql,'select count(*) right_count,t.qsn_id,t.qsn_sub_id,t.qsn_type,t.qsn_type_position from t_user_exam_answer t
    join t_answer a2 on a2.qsn_id = t.qsn_id and a2.qsn_sub_id = t.qsn_sub_id and t.user_answer = a2.qsn_answer and a2.qsn_item_id = t.qsn_item_id and t.qsn_type !=\'010102\'
    where t.user_id=','''',par_user_id,'''',' and t.exam_id=','''',par_exam_id,'''',
    'and  t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.qsn_type in(','''','010104','''',',','''','010108','''',')
    group by t.user_id,t.exam_id,t.papr_id,t.exam_times,t.qsn_id,t.qsn_sub_id,t.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @exam_point_type='030202' then
    set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                 from tmp_usr_add_examinfo_tree t, t_question r, t_qsn_sub_position s
                where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
    set @mysql=concat(@mysql,') q');

    set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_examinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

    if par_papr_id is not null then
    set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
    set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
              from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
    if par_papr_id is not null then
    set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exam_point_type='030201' then
    set @mysql=concat(@mysql,'left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

    union
    select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
    from (
    select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
    group by p8.pid,p8.id
    union
    select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
    (
    select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    ) pp
    join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

     union
    select r.qsn_id, r.qsn_sub_id, p.qsn_point
    from t_papr_content t
    join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
    join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
    where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exam_point_type='030203' then

    select a.papr_qsn_count into @qsn_count
    from t_exam e join t_exam_papr p on e.exam_id=p.exam_id and e.exam_id=par_exam_id
    join t_paper a on a.papr_id=p.papr_id;
    set @q_point=round(@exam_point/@qsn_count,2);

    set @mysql=concat(@mysql,'left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

    union
    select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
    from (
    select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    )p7 join tmp_usr_add_examinfo_tree p8 on p8.id=p7.qsn_id
    group by p8.pid,p8.id
    union
    select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
    (
    select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_examinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    ) pp
    join tmp_usr_add_examinfo_tree p3  on p3.pid=pp.qsn_sub_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_examinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
     union
    select r.qsn_id, r.qsn_sub_id, @q_point
    from t_papr_content t
    join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
    join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
    where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst
    join t_user_exam_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id where r.exam_times=',@cnt,' and r.user_id=','''',par_user_id,''''
    ,' and r.exam_id =','''',par_exam_id,'''',' and r.papr_id =','''',par_papr_id,'''');

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    set @mysql=concat('
    insert into t_user_exam(user_id,exam_id,papr_id,exam_times,exam_tm,exam_point,user_exam_scoring,exam_total_tm,qsn_count,right_count,part_right_count,error_count,null_count)
    select tst_info.user_id,ex.exam_id,tst_info.papr_id,tst_info.exam_times,sysdate(),
    ex.exam_point,round(tst_info.scoring,2) scoring,','''',par_exam_total_tm,'''',',p.papr_qsn_count
    ,tst_info.right_count,tst_info.part_right_count,tst_info.error_count,(p.papr_qsn_count-tst_info.right_count-tst_info.error_count-tst_info.part_right_count) null_count
    from t_paper p,(
    select sum(info.right_count) right_count,sum(info.part_right_count) part_right_count,sum(info.error_count) error_count,sum(info.scoring) scoring
    ,info.user_id,info.exam_id,info.papr_id,info.exam_times from(
    select count(*) right_count,0 part_right_count,0 error_count,t.user_id,t.exam_id,t.papr_id,t.exam_times,sum(t.scoring) scoring
    from t_user_exam_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.answer_status=1 and t.exam_id=','''',par_exam_id,'''','
    group by t.user_id,t.exam_id,t.papr_id,t.exam_times
    union
    select 0 right_count,0 part_right_count,count(*) error_count,t.user_id,t.exam_id,t.papr_id,t.exam_times,0 scoring
    from t_user_exam_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.answer_status=0 and t.exam_id=','''',par_exam_id,'''','
    group by t.user_id,t.exam_id,t.papr_id,t.exam_times
    union
    select 0 right_count,count(*) part_right_count,0 error_count,t.user_id,t.exam_id,t.papr_id,t.exam_times,sum(t.scoring) scoring
    from t_user_exam_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exam_times=',@cnt,'
    and t.answer_status=2 and t.exam_id=','''',par_exam_id,'''');
    if @blank_flg !=1 then
    set @mysql=concat(@mysql,' and t.qsn_type not in(','''','010104','''',')');
    end if;
    if @cloze_flg !=1 THEN
    set @mysql=concat(@mysql,' and t.qsn_type not in(','''','010108','''',')');
    end if;
    set @mysql=concat(@mysql,'group by t.user_id,t.exam_id,t.papr_id,t.exam_times
    ) info
    group by info.user_id,info.exam_id,info.papr_id,info.exam_times
    ) tst_info,t_exam ex
    where
    tst_info.papr_id=p.papr_id and ex.exam_id=tst_info.exam_id');

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
    truncate table tmp_usr_add_examinfo_tree;

    update t_session set exam_time=0,exam_start_tm=0,exam_id=null,exam_cmd=null where user_id=par_user_id and exam_id=par_exam_id and sid=par_sid;


  
  
        
end

DROP PROCEDURE IF EXISTS `usr_add_exam_score2`;
CREATE PROCEDURE  `usr_add_exam_score2`(IN par_sid varchar(50),IN par_user_id int(10), IN par_exam_id CHAR(32),IN par_papr_id CHAR(32), IN par_user_exam_info text ,IN par_user_exam varchar(500))
begin

    set @mysql=concat('replace into t_user_exam_info(user_id,exam_id,papr_id,exam_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
                       values ',par_user_exam_info);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;


    set @mysql=concat('replace into t_user_exam(user_id,exam_id,papr_id,exam_times,exam_tm,exam_point,user_exam_scoring,exam_total_tm,qsn_count,right_count,part_right_count,error_count,null_count) values ',par_user_exam);
    
    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    update t_session set exam_time=0,exam_start_tm=0,exam_id=null,exam_cmd=null where user_id=par_user_id and exam_id=par_exam_id and sid=par_sid;


  
  
        
end

DROP PROCEDURE IF EXISTS `usr_add_exerciseinfo`;
CREATE PROCEDURE  `usr_add_exerciseinfo`(IN par_sid varchar(50),IN par_user_id INT(10), IN par_exercise_id CHAR(32), IN par_papr_id CHAR(32), IN par_exercise_total_tm VARCHAR(20), IN par_answer TEXT)
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

    select max(t.exercise_times) into @nt from t_user_exercise t
    where t.user_id=par_user_id and t.papr_id=par_papr_id and t.exercise_id=par_exercise_id;
    select case when @nt is null then 1 else @nt+1 end into @cnt;

    if par_answer !='' then
        set @strsql=concat('insert into t_user_exercise_answer(user_id,exercise_id,papr_id,exercise_times,qsn_id,qsn_sub_id,qsn_item_id,qsn_type_position,qsn_type,user_answer) values ',par_answer);

        prepare stmt from @strsql;
        execute stmt;
        deallocate prepare stmt;
    end if;

    set @mysql2='';

    insert into tmp_usr_add_exerciseinfo_tree(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id and qsn_sub_id !='0';

    set v_row_count := row_count();
    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_usr_add_exerciseinfo_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id, v_level + 1
        , @position := @position+1
        from t_question q inner join tmp_usr_add_exerciseinfo_tree t on q.qsn_id = t.id
        where t.level = v_level and q.qsn_sub_id !='0'  order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

    select exercise_blank_flg,exercise_cloze_flg,exercise_point_type,exercise_point into @blank_flg,@cloze_flg,@exercise_point_type,@exercise_point from t_exercise e where e.exercise_id=par_exercise_id;
    
    set @mysql='';
    set @mysql=concat('
    insert into t_user_exercise_info(user_id,exercise_id,papr_id,exercise_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.exercise_id,r.papr_id,r.exercise_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case ');
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,case ');
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring');
    set @mysql=concat(@mysql,' from (
    select count(*) qsn_item_count,tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    from t_user_exercise_answer tq
    where  tq.user_id=','''',par_user_id,'''',' and tq.exercise_id=','''',par_exercise_id,'''',' and tq.papr_id=','''',par_papr_id,'''',' and tq.exercise_times=',@cnt,'
    and tq.qsn_type in(','''','010101','''',',','''','010103','''',',','''','010105','''',',','''','010106','''',',','''','010107','''',')
    group by tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    ) t1 left join ( ');
    set @mysql=concat(@mysql,'select count(*) right_count,t.qsn_id,t.qsn_sub_id,t.qsn_type,t.qsn_type_position from t_user_exercise_answer t 
    join t_answer a2 on a2.qsn_id = t.qsn_id and a2.qsn_sub_id = t.qsn_sub_id and t.user_answer = a2.qsn_answer and a2.qsn_item_id = t.qsn_item_id and t.qsn_type !=\'010102\'
    where t.user_id=','''',par_user_id,'''',' and t.exercise_id=','''',par_exercise_id,'''',
    'and  t.papr_id=','''',par_papr_id,'''',' and t.exercise_times=',@cnt,'
    and t.qsn_type in(','''','010101','''',',','''','010103','''',',','''','010105','''',',','''','010106','''',',','''','010107','''',')
    group by t.user_id,t.exercise_id,t.papr_id,t.exercise_times,t.qsn_id,t.qsn_sub_id,t.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @exercise_point_type='030202' then
        set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                     from tmp_usr_add_exerciseinfo_tree t, t_question r, t_qsn_sub_position s
                    where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
        set @mysql=concat(@mysql,') q');

        set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_exerciseinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

        if par_papr_id is not null then
        set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
        set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
                  from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
        if par_papr_id is not null then
        set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exercise_point_type='030201' then
        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_exerciseinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_exerciseinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

         union
        select r.qsn_id, r.qsn_sub_id, p.qsn_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exercise_point_type='030203' then

        select a.papr_qsn_count into @qsn_count
        from t_exercise e join t_exercise_papr p on e.exercise_id=p.exercise_id and e.exercise_id=par_exercise_id
        join t_paper a on a.papr_id=p.papr_id;
        set @q_point=round(@exercise_point/@qsn_count,2);

        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_exerciseinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_exerciseinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
         union
        select r.qsn_id, r.qsn_sub_id, @q_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst join t_user_exercise_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id and r.exercise_times=',@cnt
    ,' and r.exercise_id =','''',par_exercise_id,'''',' and r.papr_id =','''',par_papr_id,'''',' and r.user_id=',par_user_id);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    set @mysql='';
    set @mysql=concat('
    insert into t_user_exercise_info(user_id,exercise_id,papr_id,exercise_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.exercise_id,r.papr_id,r.exercise_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case ');
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,case ');
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring');
    set @mysql=concat(@mysql,' from (
    select count(*) qsn_item_count,tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    from t_user_exercise_answer tq
    where  tq.user_id=','''',par_user_id,'''',' and tq.exercise_id=','''',par_exercise_id,'''',' and tq.papr_id=','''',par_papr_id,'''',' and tq.exercise_times=',@cnt,'
    and tq.qsn_type in(','''','010102','''',')
    group by tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    ) t1 left join ( ');
    set @mysql=concat(@mysql,'select count(*) right_count,t.qsn_id,t.qsn_sub_id,t.qsn_type,t.qsn_type_position from t_user_exercise_answer t 
    join t_answer a on a.qsn_id = t.qsn_id and a.qsn_sub_id = t.qsn_sub_id and t.qsn_type=\'010102\' and t.user_answer = a.qsn_answer
    where t.user_id=','''',par_user_id,'''',' and t.exercise_id=','''',par_exercise_id,'''',
    'and  t.papr_id=','''',par_papr_id,'''',' and t.exercise_times=',@cnt,'
    and t.qsn_type in(','''','010102','''',')
    group by t.user_id,t.exercise_id,t.papr_id,t.exercise_times,t.qsn_id,t.qsn_sub_id,t.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @exercise_point_type='030202' then
        set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                     from tmp_usr_add_exerciseinfo_tree t, t_question r, t_qsn_sub_position s
                    where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
        set @mysql=concat(@mysql,') q');

        set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_exerciseinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

        if par_papr_id is not null then
        set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
        set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
                  from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
        if par_papr_id is not null then
        set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exercise_point_type='030201' then
        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_exerciseinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_exerciseinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

         union
        select r.qsn_id, r.qsn_sub_id, p.qsn_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exercise_point_type='030203' then

        select a.papr_qsn_count into @qsn_count
        from t_exercise e join t_exercise_papr p on e.exercise_id=p.exercise_id and e.exercise_id=par_exercise_id
        join t_paper a on a.papr_id=p.papr_id;
        set @q_point=round(@exercise_point/@qsn_count,2);

        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_exerciseinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_exerciseinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
         union
        select r.qsn_id, r.qsn_sub_id, @q_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst join t_user_exercise_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id and r.exercise_times=',@cnt
    ,' and r.exercise_id =','''',par_exercise_id,'''',' and r.papr_id =','''',par_papr_id,'''',' and r.user_id=',par_user_id);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;




    set @mysql='';
    set @mysql=CONCAT('
    insert into t_user_exercise_info(user_id,exercise_id,papr_id,exercise_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.exercise_id,r.papr_id,r.exercise_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case ');
    if @blank_flg=1 or @cloze_flg=1 then
    set @mysql=concat(@mysql,' when t1.qsn_item_count >t2.right_count>=1 then ','''','2','''');
    end if;
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,case ');
    if @blank_flg=1 or @cloze_flg =1 then
    set @mysql=concat(@mysql,' when t1.qsn_item_count >t2.right_count>=1 then ROUND((tp.qsn_point/t1.qsn_item_count)*t2.right_count,2)');
    end if;
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring');
    set @mysql=concat(@mysql,' from (
    select count(*) qsn_item_count,tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    from t_user_exercise_answer tq
    where  tq.user_id=','''',par_user_id,'''',' and tq.exercise_id=','''',par_exercise_id,'''',' and tq.papr_id=','''',par_papr_id,'''',' and tq.exercise_times=',@cnt,'
    and tq.qsn_type in(','''','010104','''',',','''','010108','''',')
    group by tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    ) t1 left join ( ');

    set @mysql=concat(@mysql,'select count(*) right_count,t.qsn_id,t.qsn_sub_id,t.qsn_type,t.qsn_type_position from t_user_exercise_answer t
    join t_answer a2 on a2.qsn_id = t.qsn_id and a2.qsn_sub_id = t.qsn_sub_id and t.user_answer = a2.qsn_answer and a2.qsn_item_id = t.qsn_item_id and t.qsn_type !=\'010102\'
    where t.user_id=','''',par_user_id,'''',' and t.exercise_id=','''',par_exercise_id,'''',
    'and  t.papr_id=','''',par_papr_id,'''',' and t.exercise_times=',@cnt,'
    and t.qsn_type in(','''','010104','''',',','''','010108','''',')
    group by t.user_id,t.exercise_id,t.papr_id,t.exercise_times,t.qsn_id,t.qsn_sub_id,t.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @exercise_point_type='030202' then
    set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                 from tmp_usr_add_exerciseinfo_tree t, t_question r, t_qsn_sub_position s
                where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
    set @mysql=concat(@mysql,') q');

    set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_exerciseinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

    if par_papr_id is not null then
    set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
    set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
              from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
    if par_papr_id is not null then
    set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exercise_point_type='030201' then
    set @mysql=concat(@mysql,'left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

    union
    select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
    from (
    select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    )p7 join tmp_usr_add_exerciseinfo_tree p8 on p8.id=p7.qsn_id
    group by p8.pid,p8.id
    union
    select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
    (
    select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    ) pp
    join tmp_usr_add_exerciseinfo_tree p3  on p3.pid=pp.qsn_sub_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

     union
    select r.qsn_id, r.qsn_sub_id, p.qsn_point
    from t_papr_content t
    join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
    join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
    where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @exercise_point_type='030203' then

    select a.papr_qsn_count into @qsn_count
    from t_exercise e join t_exercise_papr p on e.exercise_id=p.exercise_id and e.exercise_id=par_exercise_id
    join t_paper a on a.papr_id=p.papr_id;
    set @q_point=round(@exercise_point/@qsn_count,2);

    set @mysql=concat(@mysql,'left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

    union
    select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
    from (
    select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    )p7 join tmp_usr_add_exerciseinfo_tree p8 on p8.id=p7.qsn_id
    group by p8.pid,p8.id
    union
    select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
    (
    select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_exerciseinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    ) pp
    join tmp_usr_add_exerciseinfo_tree p3  on p3.pid=pp.qsn_sub_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_exerciseinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
     union
    select r.qsn_id, r.qsn_sub_id, @q_point
    from t_papr_content t
    join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
    join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
    where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst
    join t_user_exercise_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id where r.exercise_times=',@cnt,' and r.user_id=','''',par_user_id,''''
    ,' and r.exercise_id =','''',par_exercise_id,'''',' and r.papr_id =','''',par_papr_id,'''');

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    if par_answer !='' then
    set @mysql='';
    set @mysql=concat(@mysql,'
    insert into t_user_exercise(user_id,exercise_id,papr_id,exercise_times,exercise_tm,exercise_point,user_exercise_scoring,exercise_total_tm,qsn_count,right_count,part_right_count,error_count,null_count)
    select tst_info.user_id,ex.exercise_id,tst_info.papr_id,tst_info.exercise_times,sysdate(),
    ex.exercise_point,round(tst_info.scoring,2) scoring,','''',par_exercise_total_tm,'''',',p.papr_qsn_count
    ,tst_info.right_count,tst_info.part_right_count,tst_info.error_count,(p.papr_qsn_count-tst_info.right_count-tst_info.error_count-tst_info.part_right_count) null_count
    from t_paper p,(
    select sum(info.right_count) right_count,sum(info.part_right_count) part_right_count,sum(info.error_count) error_count,sum(info.scoring) scoring
    ,info.user_id,info.exercise_id,info.papr_id,info.exercise_times from(
    select count(*) right_count,0 part_right_count,0 error_count,t.user_id,t.exercise_id,t.papr_id,t.exercise_times,sum(t.scoring) scoring
    from t_user_exercise_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exercise_times=',@cnt,'
    and t.answer_status=1 and t.exercise_id=','''',par_exercise_id,'''','
    group by t.user_id,t.exercise_id,t.papr_id,t.exercise_times
    union
    select 0 right_count,0 part_right_count,count(*) error_count,t.user_id,t.exercise_id,t.papr_id,t.exercise_times,0 scoring
    from t_user_exercise_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exercise_times=',@cnt,'
    and t.answer_status=0 and t.exercise_id=','''',par_exercise_id,'''','
    group by t.user_id,t.exercise_id,t.papr_id,t.exercise_times
    union
    select 0 right_count,count(*) part_right_count,0 error_count,t.user_id,t.exercise_id,t.papr_id,t.exercise_times,sum(t.scoring) scoring
    from t_user_exercise_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.exercise_times=',@cnt,'
    and t.answer_status=2 and t.exercise_id=','''',par_exercise_id,'''');
    if @blank_flg !=1 then
    set @mysql=concat(@mysql,' and t.qsn_type not in(','''','010104','''',')');
    end if;
    if @cloze_flg !=1 THEN
    set @mysql=concat(@mysql,' and t.qsn_type not in(','''','010108','''',')');
    end if;
    set @mysql=concat(@mysql,'group by t.user_id,t.exercise_id,t.papr_id,t.exercise_times
    ) info
    group by info.user_id,info.exercise_id,info.papr_id,info.exercise_times
    ) tst_info,t_exercise ex
    where
    tst_info.papr_id=p.papr_id and ex.exercise_id=tst_info.exercise_id');
    else
    set @mysql='';
    set @mysql=concat('insert into t_user_exercise(user_id,exercise_id,papr_id,exercise_times,exercise_tm,exercise_point,user_exercise_scoring,exercise_total_tm,qsn_count,right_count,part_right_count,error_count,null_count)');
    set @mysql=concat(@mysql,'select ',par_user_id,',','''',par_exercise_id,'''',',','''',par_papr_id,'''',',',@cnt,',sysdate(),ex.exercise_point,0,','''',par_exercise_total_tm,'''',',p.papr_qsn_count
    ,0 right_count,0 part_right_count,0 error_count,0 null_count from t_paper p
    join t_exercise_papr ep on ep.papr_id=p.papr_id
    join t_exercise ex on ex.exercise_id=ep.exercise_id and ex.exercise_id=','''',par_exercise_id,'''');

    end if;

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
    truncate table tmp_usr_add_exerciseinfo_tree;

    update t_session set exercise_time=0,exercise_start_tm=0,exercise_id=null,exercise_cmd=null where user_id=par_user_id and exercise_id=par_exercise_id and sid=par_sid;
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_add_homeworkinfo`;
CREATE PROCEDURE  `usr_add_homeworkinfo`(IN par_sid varchar(50),IN par_user_id INT(10), IN par_homework_id CHAR(32), IN par_papr_id CHAR(32), IN par_homework_total_tm VARCHAR(20), IN par_answer TEXT)
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

    select max(t.homework_times) into @nt from t_user_homework t
    where t.user_id=par_user_id and t.papr_id=par_papr_id and t.homework_id=par_homework_id;
    select case when @nt is null then 1 else @nt+1 end into @cnt;

    if par_answer !='' then
        set @strsql=concat('insert into t_user_homework_answer(user_id,homework_id,papr_id,homework_times,qsn_id,qsn_sub_id,qsn_item_id,qsn_type_position,qsn_type,user_answer) values ',par_answer);

        prepare stmt from @strsql;
        execute stmt;
        deallocate prepare stmt;
    end if;

    set @mysql2='';

    insert into tmp_usr_add_homeworkinfo_tree(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id and qsn_sub_id !='0';

    set v_row_count := row_count();
    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_usr_add_homeworkinfo_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id, v_level + 1
        , @position := @position+1
        from t_question q inner join tmp_usr_add_homeworkinfo_tree t on q.qsn_id = t.id
        where t.level = v_level and q.qsn_sub_id !='0'  order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

    select homework_blank_flg,homework_cloze_flg,homework_point_type,homework_point into @blank_flg,@cloze_flg,@homework_point_type,@homework_point from t_homework e where e.homework_id=par_homework_id;
    
    set @mysql='';
    set @mysql=concat('
    insert into t_user_homework_info(user_id,homework_id,papr_id,homework_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.homework_id,r.papr_id,r.homework_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case ');
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,case ');
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring');
    set @mysql=concat(@mysql,' from (
    select count(*) qsn_item_count,tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    from t_user_homework_answer tq
    where  tq.user_id=','''',par_user_id,'''',' and tq.homework_id=','''',par_homework_id,'''',' and tq.papr_id=','''',par_papr_id,'''',' and tq.homework_times=',@cnt,'
    and tq.qsn_type in(','''','010101','''',',','''','010103','''',',','''','010105','''',',','''','010106','''',',','''','010107','''',')
    group by tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    ) t1 left join ( ');
    set @mysql=concat(@mysql,'select count(*) right_count,t.qsn_id,t.qsn_sub_id,t.qsn_type,t.qsn_type_position from t_user_homework_answer t 
    join t_answer a2 on a2.qsn_id = t.qsn_id and a2.qsn_sub_id = t.qsn_sub_id and t.user_answer = a2.qsn_answer and a2.qsn_item_id = t.qsn_item_id and t.qsn_type !=\'010102\'
    where t.user_id=','''',par_user_id,'''',' and t.homework_id=','''',par_homework_id,'''',
    'and  t.papr_id=','''',par_papr_id,'''',' and t.homework_times=',@cnt,'
    and t.qsn_type in(','''','010101','''',',','''','010103','''',',','''','010105','''',',','''','010106','''',',','''','010107','''',')
    group by t.user_id,t.homework_id,t.papr_id,t.homework_times,t.qsn_id,t.qsn_sub_id,t.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @homework_point_type='030202' then
        set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                     from tmp_usr_add_homeworkinfo_tree t, t_question r, t_qsn_sub_position s
                    where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
        set @mysql=concat(@mysql,') q');

        set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_homeworkinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

        if par_papr_id is not null then
        set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
        set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
                  from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
        if par_papr_id is not null then
        set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @homework_point_type='030201' then
        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_homeworkinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_homeworkinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

         union
        select r.qsn_id, r.qsn_sub_id, p.qsn_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @homework_point_type='030203' then

        select a.papr_qsn_count into @qsn_count
        from t_homework e join t_homework_papr p on e.homework_id=p.homework_id and e.homework_id=par_homework_id
        join t_paper a on a.papr_id=p.papr_id;
        set @q_point=round(@homework_point/@qsn_count,2);

        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_homeworkinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_homeworkinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
         union
        select r.qsn_id, r.qsn_sub_id, @q_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst join t_user_homework_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id and r.homework_times=',@cnt
    ,' and r.homework_id =','''',par_homework_id,'''',' and r.papr_id =','''',par_papr_id,'''',' and r.user_id=',par_user_id);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    set @mysql='';
    set @mysql=concat('
    insert into t_user_homework_info(user_id,homework_id,papr_id,homework_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.homework_id,r.papr_id,r.homework_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case ');
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,case ');
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring');
    set @mysql=concat(@mysql,' from (
    select count(*) qsn_item_count,tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    from t_user_homework_answer tq
    where  tq.user_id=','''',par_user_id,'''',' and tq.homework_id=','''',par_homework_id,'''',' and tq.papr_id=','''',par_papr_id,'''',' and tq.homework_times=',@cnt,'
    and tq.qsn_type in(','''','010102','''',')
    group by tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    ) t1 left join ( ');
    set @mysql=concat(@mysql,'select count(*) right_count,t.qsn_id,t.qsn_sub_id,t.qsn_type,t.qsn_type_position from t_user_homework_answer t 
    join t_answer a on a.qsn_id = t.qsn_id and a.qsn_sub_id = t.qsn_sub_id and t.qsn_type=\'010102\' and t.user_answer = a.qsn_answer
    where t.user_id=','''',par_user_id,'''',' and t.homework_id=','''',par_homework_id,'''',
    'and  t.papr_id=','''',par_papr_id,'''',' and t.homework_times=',@cnt,'
    and t.qsn_type in(','''','010102','''',')
    group by t.user_id,t.homework_id,t.papr_id,t.homework_times,t.qsn_id,t.qsn_sub_id,t.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @homework_point_type='030202' then
        set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                     from tmp_usr_add_homeworkinfo_tree t, t_question r, t_qsn_sub_position s
                    where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
        set @mysql=concat(@mysql,') q');

        set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_homeworkinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

        if par_papr_id is not null then
        set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
        set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
                  from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
        if par_papr_id is not null then
        set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
        end if;
        set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @homework_point_type='030201' then
        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_homeworkinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_homeworkinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

         union
        select r.qsn_id, r.qsn_sub_id, p.qsn_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @homework_point_type='030203' then

        select a.papr_qsn_count into @qsn_count
        from t_homework e join t_homework_papr p on e.homework_id=p.homework_id and e.homework_id=par_homework_id
        join t_paper a on a.papr_id=p.papr_id;
        set @q_point=round(@homework_point/@qsn_count,2);

        set @mysql=concat(@mysql,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

        union
        select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
        from (
        select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        )p7 join tmp_usr_add_homeworkinfo_tree p8 on p8.id=p7.qsn_id
        group by p8.pid,p8.id
        union
        select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
        (
        select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
        from (
        select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
        from t_papr_qsn_type p1
        join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
        and p1.papr_id=','''',par_papr_id,'''','
        join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
        ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
        ) pp
        join tmp_usr_add_homeworkinfo_tree p3  on p3.pid=pp.qsn_sub_id
        join (
        select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
         union
        select r.qsn_id, r.qsn_sub_id, @q_point
        from t_papr_content t
        join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
        join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
        where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst join t_user_homework_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id and r.homework_times=',@cnt
    ,' and r.homework_id =','''',par_homework_id,'''',' and r.papr_id =','''',par_papr_id,'''',' and r.user_id=',par_user_id);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;




    set @mysql='';
    set @mysql=CONCAT('
    insert into t_user_homework_info(user_id,homework_id,papr_id,homework_times,qsn_id,qsn_sub_id,qsn_type,qsn_type_position,scoring,answer_status)
    select distinct r.user_id,r.homework_id,r.papr_id,r.homework_times,r.qsn_id,r.qsn_sub_id,r.qsn_type,r.qsn_type_position,rst.scoring,rst.xstate from (
    select t1.qsn_id,t1.qsn_sub_id,t1.qsn_type,case ');
    if @blank_flg=1 or @cloze_flg=1 then
    set @mysql=concat(@mysql,' when t1.qsn_item_count >t2.right_count>=1 then ','''','2','''');
    end if;
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then ','''', '1' ,'''',' else ','''','0','''',' end xstate,case ');
    if @blank_flg=1 or @cloze_flg =1 then
    set @mysql=concat(@mysql,' when t1.qsn_item_count >t2.right_count>=1 then ROUND((tp.qsn_point/t1.qsn_item_count)*t2.right_count,2)');
    end if;
    set @mysql=concat(@mysql,'when  t1.qsn_item_count =t2.right_count then tp.qsn_point else ','''','0','''',' end scoring');
    set @mysql=concat(@mysql,' from (
    select count(*) qsn_item_count,tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    from t_user_homework_answer tq
    where  tq.user_id=','''',par_user_id,'''',' and tq.homework_id=','''',par_homework_id,'''',' and tq.papr_id=','''',par_papr_id,'''',' and tq.homework_times=',@cnt,'
    and tq.qsn_type in(','''','010104','''',',','''','010108','''',')
    group by tq.qsn_id,tq.qsn_sub_id,tq.qsn_type
    ) t1 left join ( ');

    set @mysql=concat(@mysql,'select count(*) right_count,t.qsn_id,t.qsn_sub_id,t.qsn_type,t.qsn_type_position from t_user_homework_answer t
    join t_answer a2 on a2.qsn_id = t.qsn_id and a2.qsn_sub_id = t.qsn_sub_id and t.user_answer = a2.qsn_answer and a2.qsn_item_id = t.qsn_item_id and t.qsn_type !=\'010102\'
    where t.user_id=','''',par_user_id,'''',' and t.homework_id=','''',par_homework_id,'''',
    'and  t.papr_id=','''',par_papr_id,'''',' and t.homework_times=',@cnt,'
    and t.qsn_type in(','''','010104','''',',','''','010108','''',')
    group by t.user_id,t.homework_id,t.papr_id,t.homework_times,t.qsn_id,t.qsn_sub_id,t.qsn_type
    ) t2 on t1.qsn_id=t2.qsn_id and t1.qsn_sub_id=t2.qsn_sub_id and t1.qsn_type=t2.qsn_type ');

    if @homework_point_type='030202' then
    set @mysql=concat(@mysql,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                 from tmp_usr_add_homeworkinfo_tree t, t_question r, t_qsn_sub_position s
                where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id ');
    set @mysql=concat(@mysql,') q');

    set @mysql=concat(@mysql,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_usr_add_homeworkinfo_tree t  join t_papr_content c on t.id = c.qsn_id');

    if par_papr_id is not null then
    set @mysql=concat(@mysql,' where c.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql=concat(@mysql,' ) cc on q.qsn_id =cc.qsn_sub_id');
    set @mysql=concat(@mysql,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
              from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
    if par_papr_id is not null then
    set @mysql=concat(@mysql,' and t.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql=concat(@mysql,' ) tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @homework_point_type='030201' then
    set @mysql=concat(@mysql,'left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

    union
    select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
    from (
    select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    )p7 join tmp_usr_add_homeworkinfo_tree p8 on p8.id=p7.qsn_id
    group by p8.pid,p8.id
    union
    select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
    (
    select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    ) pp
    join tmp_usr_add_homeworkinfo_tree p3  on p3.pid=pp.qsn_sub_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

     union
    select r.qsn_id, r.qsn_sub_id, p.qsn_point
    from t_papr_content t
    join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
    join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
    where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    elseif @homework_point_type='030203' then

    select a.papr_qsn_count into @qsn_count
    from t_homework e join t_homework_papr p on e.homework_id=p.homework_id and e.homework_id=par_homework_id
    join t_paper a on a.papr_id=p.papr_id;
    set @q_point=round(@homework_point/@qsn_count,2);

    set @mysql=concat(@mysql,'left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

    union
    select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
    from (
    select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    )p7 join tmp_usr_add_homeworkinfo_tree p8 on p8.id=p7.qsn_id
    group by p8.pid,p8.id
    union
    select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
    (
    select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_usr_add_homeworkinfo_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    ) pp
    join tmp_usr_add_homeworkinfo_tree p3  on p3.pid=pp.qsn_sub_id
    join (
    select s.qsn_id,count(*) cnt from tmp_usr_add_homeworkinfo_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
     union
    select r.qsn_id, r.qsn_sub_id, @q_point
    from t_papr_content t
    join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
    join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
    where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') tp on tp.qsn_id=t2.qsn_id and tp.qsn_sub_id=t2.qsn_sub_id');

    end if;

    set @mysql=concat(@mysql,') rst
    join t_user_homework_answer r on rst.qsn_id=r.qsn_id and rst.qsn_sub_id=r.qsn_sub_id where r.homework_times=',@cnt,' and r.user_id=','''',par_user_id,''''
    ,' and r.homework_id =','''',par_homework_id,'''',' and r.papr_id =','''',par_papr_id,'''');

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    if par_answer !='' then
    set @mysql='';
    set @mysql=concat(@mysql,'
    insert into t_user_homework(user_id,homework_id,papr_id,homework_times,homework_tm,homework_point,user_homework_scoring,homework_total_tm,qsn_count,right_count,part_right_count,error_count,null_count)
    select tst_info.user_id,ex.homework_id,tst_info.papr_id,tst_info.homework_times,sysdate(),
    ex.homework_point,round(tst_info.scoring,2) scoring,','''',par_homework_total_tm,'''',',p.papr_qsn_count
    ,tst_info.right_count,tst_info.part_right_count,tst_info.error_count,(p.papr_qsn_count-tst_info.right_count-tst_info.error_count-tst_info.part_right_count) null_count
    from t_paper p,(
    select sum(info.right_count) right_count,sum(info.part_right_count) part_right_count,sum(info.error_count) error_count,sum(info.scoring) scoring
    ,info.user_id,info.homework_id,info.papr_id,info.homework_times from(
    select count(*) right_count,0 part_right_count,0 error_count,t.user_id,t.homework_id,t.papr_id,t.homework_times,sum(t.scoring) scoring
    from t_user_homework_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.homework_times=',@cnt,'
    and t.answer_status=1 and t.homework_id=','''',par_homework_id,'''','
    group by t.user_id,t.homework_id,t.papr_id,t.homework_times
    union
    select 0 right_count,0 part_right_count,count(*) error_count,t.user_id,t.homework_id,t.papr_id,t.homework_times,0 scoring
    from t_user_homework_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.homework_times=',@cnt,'
    and t.answer_status=0 and t.homework_id=','''',par_homework_id,'''','
    group by t.user_id,t.homework_id,t.papr_id,t.homework_times
    union
    select 0 right_count,count(*) part_right_count,0 error_count,t.user_id,t.homework_id,t.papr_id,t.homework_times,sum(t.scoring) scoring
    from t_user_homework_info t where
    t.user_id=','''',par_user_id,'''',' and t.papr_id=','''',par_papr_id,'''',' and t.homework_times=',@cnt,'
    and t.answer_status=2 and t.homework_id=','''',par_homework_id,'''');
    if @blank_flg !=1 then
    set @mysql=concat(@mysql,' and t.qsn_type not in(','''','010104','''',')');
    end if;
    if @cloze_flg !=1 THEN
    set @mysql=concat(@mysql,' and t.qsn_type not in(','''','010108','''',')');
    end if;
    set @mysql=concat(@mysql,'group by t.user_id,t.homework_id,t.papr_id,t.homework_times
    ) info
    group by info.user_id,info.homework_id,info.papr_id,info.homework_times
    ) tst_info,t_homework ex
    where
    tst_info.papr_id=p.papr_id and ex.homework_id=tst_info.homework_id');
    else
    set @mysql='';
    set @mysql=concat('insert into t_user_homework(user_id,homework_id,papr_id,homework_times,homework_tm,homework_point,user_homework_scoring,homework_total_tm,qsn_count,right_count,part_right_count,error_count,null_count)');
    set @mysql=concat(@mysql,'select ',par_user_id,',','''',par_homework_id,'''',',','''',par_papr_id,'''',',',@cnt,',sysdate(),ex.homework_point,0,','''',par_homework_total_tm,'''',',p.papr_qsn_count
    ,0 right_count,0 part_right_count,0 error_count,0 null_count from t_paper p
    join t_homework_papr ep on ep.papr_id=p.papr_id
    join t_homework ex on ex.homework_id=ep.homework_id and ex.homework_id=','''',par_homework_id,'''');

    end if;

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
    truncate table tmp_usr_add_homeworkinfo_tree;

    update t_session set homework_time=0,homework_start_tm=0,homework_id=null,homework_cmd=null where user_id=par_user_id and homework_id=par_homework_id and sid=par_sid;
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_check_oldemail`;
CREATE PROCEDURE  `usr_check_oldemail`(IN par_user_id INT(10),
    in par_old_email varchar(50),in par_new_email varchar(50))
begin  
    declare rst varchar(50);
    
    select email into @myemail  from t_user where user_id=par_user_id;      
        
    if @myemail =par_old_email then
        
        select email into @newemail from t_user where email =par_new_email;
        if @newemail is null then
            set rst='';
        else
            set rst='1';
        end if;
    else            
        set rst='2';
    end if;
    
    select rst;
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_exam_get_signup_info`;
CREATE PROCEDURE  `usr_exam_get_signup_info`(IN par_user_id int(10),IN par_exam_id CHAR(32))
begin

    set @strsql=concat('select c.desc_cn verify_status,s.signup_tm,u.real_name,u.username,s.verify_tm
                       from t_exam_user_signup s join t_common_cde c on s.verify_status=c.c_cde
                       left join t_user u on u.user_id=s.verify_user_id
                       where s.user_id=',par_user_id,' and s.exam_id=','''',par_exam_id,'''');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
      
end

DROP PROCEDURE IF EXISTS `usr_exam_info`;
CREATE PROCEDURE  `usr_exam_info`(IN par_user_id INT(10),IN par_exam_id CHAR(32),IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin
    set @strsql=concat('select e.exam_id,e.exam_name,e.exam_begin_tm,e.exam_end_tm,e.exam_total_tm,
    e.exam_publish_result_flg,e.exam_full_screen_flg,e.exam_publish_result_tm,
    DATE_FORMAT(e.create_tm,','''','%Y-%m-%d','''',') create_tm,e.exam_ie_only_flg,e.exam_passing_again_flg,
    e.exam_qsn_random_flg,e.exam_paper_only_one_flg,e.exam_passing_grade,
    c2.desc_cn exam_category,g.group_name exam_create_dep,
    ue.user_exam_scoring, ue.exam_point
    from t_user_exam ue
    left join t_exam e on ue.exam_id = e.exam_id
    left join t_user_group ug on ug.user_id=e.create_user_id
    left join t_group g on g.group_id=ug.group_id
    join t_common_cde c2 on e.exam_category=c2.c_cde

    where ue.exam_id = ','''',par_exam_id,'''','
          and ue.user_id = ',par_user_id,'
          and e.exam_status=','''','030301','''','
     order by e.create_tm desc');

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
    
    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;


  



        
end

DROP PROCEDURE IF EXISTS `usr_exam_sign_up`;
CREATE PROCEDURE  `usr_exam_sign_up`(IN par_user_id int(10),IN par_exam_id VARCHAR(32))
begin

    set @strsql=concat('insert into t_exam_user_signup(exam_id,user_id,signup_tm,verify_status)
                        values(','''',par_exam_id,'''',',',par_user_id,',now(),','''','070203','''',')');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
      
end

DROP PROCEDURE IF EXISTS `usr_get_adminInfo`;
CREATE PROCEDURE  `usr_get_adminInfo`(IN par_admin_name VARCHAR(20), IN par_admin_pwd VARCHAR(50))
BEGIN
   select t.user_id,t.username from t_admin t
   where t.username=par_admin_name and password(par_admin_pwd) =t.pwd;
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_get_adminpwd`;
CREATE PROCEDURE  `usr_get_adminpwd`(IN par_admin_name VARCHAR(20), OUT par_pwd VARCHAR(20))
BEGIN
    select password(t.pwd) into par_pwd from t_admin t
    where t.username=par_admin_name;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_get_exam_begin_time`;
CREATE PROCEDURE  `usr_get_exam_begin_time`(IN par_exam_id CHAR(32))
BEGIN

    select exam_begin_tm,exam_disable_minute from t_exam where exam_id=par_exam_id;
  
  
  
  

  
        
end

DROP PROCEDURE IF EXISTS `usr_get_exam_info`;
CREATE PROCEDURE  `usr_get_exam_info`(
IN par_user_id INT(10), IN par_exam_id CHAR(32), IN par_papr_id CHAR(32), IN par_exam_times INTEGER(10)
)
BEGIN
  if par_exam_times !=0 then
    select user_exam_scoring,right_count,part_right_count,error_count from t_user_exam
    where exam_id=par_exam_id and papr_id=par_papr_id and user_id=par_user_id and exam_times=par_exam_times;
  else
    select user_exam_scoring,right_count,part_right_count,error_count from t_user_exam
    where exam_id=par_exam_id and papr_id=par_papr_id and user_id=par_user_id order by exam_times desc limit 1;
  end if;
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_get_info`;
CREATE PROCEDURE  `usr_get_info`(IN par_email VARCHAR(50),IN par_username varchar(20),IN par_idcard varchar(30),IN par_examcard varchar(30),IN par_user_id INT(10))
begin

    set @strsql=concat('select password(t.pwd) pwd,t.user_id,t.user_id2,t.username,t.nickname,t.real_name,
        t.email,t.status,t.icon,t.introduction,t.gender,t.birthday,t.idcard,t.examcard,t.tel,t.mobiletel,
        t.position,t.reg_ip,t.reg_tm,t.update_tm,t.login_count,t.last_login_tm,t.last_login_ip,t.study_point,t.study_day_answer_point
        from t_user t where 1=1 ');

    if par_email is not null then
        set @strsql=concat(@strsql,' and t.email=','''',par_email,'''');
    end if;

    if par_username is not null then
        set @strsql=concat(@strsql,' and t.username=','''',par_username,'''');
    end if;

    if par_idcard is not null then
        set @strsql=concat(@strsql,' and t.idcard=','''',par_idcard,'''');
    end if;

    if par_examcard is not null then
        set @strsql=concat(@strsql,' and t.examcard=','''',par_examcard,'''');
    end if;

    if par_user_id is not null then
        set @strsql=concat(@strsql,' and t.user_id=',par_user_id);
    end if;

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_get_monitor_status`;
CREATE PROCEDURE  `usr_get_monitor_status`(IN par_session_id char(12))
begin       
        select exam_cmd from t_session where sid=par_session_id;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_get_settinginfo`;
CREATE PROCEDURE  `usr_get_settinginfo`(IN par_user_id int(10),in par_username varchar(20))
begin
  if par_username is null and par_user_id is not null then
       select t.username,t.user_id,t.real_name,t.status,t.icon,t.introduction,t.idcard,t.examcard,t.email,t.login_count,
     t.reg_tm,t.login_count,t.last_login_tm,t.last_login_ip,t.study_point,s.sid
     from t_user t
     join t_session s on t.user_id=s.user_id
       where t.user_id=par_user_id ;
  elseif par_username is not null and par_user_id is null then
       select t.username,t.user_id,t.real_name,t.status,t.icon,t.introduction,t.idcard,t.examcard,t.email,t.login_count,
     t.reg_tm,t.login_count,t.last_login_tm,t.last_login_ip,t.study_point,s.sid
     from t_user t
     join t_session s on t.username=s.username
       where t.username=par_username ;
  else
     select t.username,t.user_id,t.real_name,t.status,t.icon,t.introduction,t.idcard,t.examcard,t.email,t.login_count,
     t.reg_tm,t.login_count,t.last_login_tm,t.last_login_ip,t.study_point,s.sid
     from t_user t
     join t_session s on t.user_id=s.user_id
       where t.user_id=par_user_id ;
  end if;

      
end

DROP PROCEDURE IF EXISTS `usr_login`;
CREATE PROCEDURE  `usr_login`(in par_email varchar(50),in par_login_ip varchar(15))
begin   
    update t_user set last_login_ip=par_login_ip,last_login_tm=sysdate() where email=par_email ;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_register`;
CREATE PROCEDURE  `usr_register`(IN par_username VARCHAR(20),IN par_gender tinyint(1),
IN par_group_id INT(10),IN par_real_name VARCHAR(20),
IN par_password VARCHAR(20), IN par_email VARCHAR(50), IN par_reg_ip VARCHAR(15),IN par_study_point int(10),IN par_session_id char(12)
,IN par_tel VARCHAR(30),IN par_mobiletel VARCHAR(30),IN par_birthday VARCHAR(20),IN par_idcard VARCHAR(30))
begin

  select user_id into @uid from t_user order by user_id desc limit 1;
  set @uid=@uid+1;

  insert into t_user(user_id,username,gender,real_name,pwd,email,reg_ip,reg_tm,study_point,last_login_ip,last_login_tm,tel,mobiletel,idcard,birthday)
  values(@uid,par_username,par_gender,par_real_name,password(par_password),par_email,par_reg_ip,sysdate(),par_study_point,par_reg_ip,sysdate(),par_tel,par_mobiletel,par_idcard,par_birthday);

  insert into t_user_group(user_id,group_id) values(@uid,par_group_id);

  update t_session set username=par_username,user_id=@uid where ip=par_reg_ip and sid=par_session_id;

  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_stat_examinfo`;
CREATE PROCEDURE  `usr_stat_examinfo`(IN par_user_id INT(10))
begin        
set @mycnt = 0;
select e.exam_name,cm.desc_cn exam_category,ue.exam_tm,ue.exam_times,e.exam_point exam_point,e.exam_passing_grade,
ue.user_exam_scoring user_exam_scoring,ue.exam_total_tm,pos.user_exam_position,t1.exam_user_count
,ue.qsn_count,(q1.right_count+q1.part_right_count+q1.error_count) all_qsn_count,q1.right_count,q1.part_right_count,q1.error_count,e.exam_publish_answer_flg,ue.papr_id,ue.user_id
from 
t_user_exam ue join t_exam e on e.exam_id=ue.exam_id  and e.exam_status='030301'
 join (
    select (@mycnt := @mycnt + 1) as user_exam_position,tue.exam_times,tue.user_id,tue.exam_id  from t_user_exam tue 
    group by tue.user_id,tue.exam_times,tue.exam_id order by tue.user_exam_scoring desc  
) pos on ue.user_id=pos.user_id and ue.exam_times=pos.exam_times and pos.exam_id=ue.exam_id
join t_common_cde cm on cm.c_cde=e.exam_category
join (select count(*) exam_user_count,exam_id,papr_id  from t_user_exam group by exam_id,papr_id ) t1 on t1.exam_id=ue.exam_id
 left join (
select ue1.exam_id,ue1.user_id,ue1.exam_times,ue1.papr_id,ue1.error_count,ue1.right_count,ue1.part_right_count
from t_user_exam ue1 ,t_user_exam_info uei where 
ue1.user_id=par_user_id and uei.exam_id=ue1.exam_id and uei.papr_id=ue1.papr_id and uei.user_id=ue1.user_id
and ue1.exam_times=uei.exam_times
group by ue1.exam_id,ue1.user_id,ue1.exam_times,ue1.papr_id
) q1 on q1.exam_id=ue.exam_id and q1.papr_id=ue.papr_id and q1.user_id=ue.user_id and q1.exam_times=ue.exam_times 
where
ue.user_id=par_user_id and e.exam_publish_score_flg !=0 
and e.exam_publish_result_tm <=curdate() ;
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_stat_examinfo2`;
CREATE PROCEDURE  `usr_stat_examinfo2`(in par_page_idx varchar(10),in par_page_size varchar(10))
begin
set @mycnt = 0;
select e.exam_name,e.exam_id,cde.desc_cn exam_category,gp.group_name,gp.group_id,u.real_name,u.user_id,y.exam_times,
               e.exam_user_count,t1.exam_real_user_count,y.user_exam_scoring,
                y.user_exam_position,
               case when e.exam_passing_grade <=y.user_exam_scoring then '1'
               else '0' end exam_status
          from t_exam e
          join (select e2.exam_id, g.group_id,e2.user_id,e2.user_exam_scoring,e2.exam_times,@mycnt := @mycnt + 1 as user_exam_position
                 from t_user_exam e2
                 join t_user_group g on g.user_id = e2.user_id
                   group by e2.exam_id,g.group_id,g.user_id
          order by g.group_id,user_exam_position 
                 ) y on e.exam_id =y.exam_id
          left join (select count(*) exam_real_user_count,
                           ue.exam_id,g.group_id
                      from t_user_exam ue, t_user_group g
                     where g.user_id = ue.user_id
                     group by ue.exam_id, g.group_id) t1 on t1.exam_id =y.exam_id and t1.group_id =y.group_id
          join t_common_cde cde on cde.c_cde = e.exam_category
          join t_group gp on gp.group_id = y.group_id
          join t_user u on u.user_id=y.user_id
        group by e.exam_name,cde.c_cde,y.exam_times,gp.group_id,u.user_id ;
          
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_update_adminpwd`;
CREATE PROCEDURE  `usr_update_adminpwd`(IN par_uname VARCHAR(20), IN par_pwd VARCHAR(20))
BEGIN
   update t_admin t set t.password=par_pwd where t.username=par_uname;
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_update_admin_login_info`;
CREATE PROCEDURE  `usr_update_admin_login_info`(in par_session_id char(12),in par_username varchar(20)
,in par_login_ip varchar(20),in par_role_value varchar(4000),in par_role_group varchar(4000))
begin

    update t_admin set last_login_ip=par_login_ip,last_login_tm=sysdate(),
    login_count=if(isnull(login_count),1,login_count+1) where username=par_username;

    update t_session set user_id=(select user_id from t_user where username=par_username),role_value=par_role_value,
                                       role_group=par_role_group,last_activity=unix_timestamp(sysdate())
    where sid=par_session_id;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_update_baseinfo`;
CREATE PROCEDURE  `usr_update_baseinfo`(IN par_user_id INT(10), IN par_icon VARCHAR(255), IN par_introduction VARCHAR(500))
begin  
if par_introduction is not null or  par_icon is not null then
    set @strsql=concat('update t_user set ');

    if par_icon is not null then
        set @strsql=concat(@strsql,'icon=','''',par_icon,'''',',');
    end if;

  if par_introduction is not null then
        set @strsql=concat(@strsql,'introduction=','''',par_introduction,'''',',');
    end if;

    set @strsql=substr(@strsql,1,char_length(@strsql)-1);

    set @strsql=concat(@strsql,' where user_id=',par_user_id);

    prepare stmt from @strsql;  
    execute stmt;
    deallocate prepare stmt;
end if;
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_update_email`;
CREATE PROCEDURE  `usr_update_email`(IN par_user_id INT(10),
     in par_new_email varchar(50))
begin  
    update t_user set email=par_new_email where user_id=par_user_id;        
    
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_update_login_info`;
CREATE PROCEDURE  `usr_update_login_info`(in par_username varchar(20),
in par_email varchar(20),in par_idcard varchar(20),in par_examcard varchar(20)
,in par_login_ip varchar(20),in par_study_point int(10),IN par_session_id char(12))
begin

if par_email is not null then
    select username into @uname from t_user where email=par_email;
elseif par_idcard is not null then
    select username into @uname from t_user where idcard=par_idcard;
elseif par_examcard is not null then
    select username into @uname from t_user where examcard=par_examcard;
elseif par_username is not null then
    set @uname=par_username;
end if;

if par_study_point !=0 then
  select last_login_tm into @login_tm from t_user where username=@uname;
  select datediff(sysdate(),@login_tm) into @d_tm;

  if @d_tm =0 then
      update t_user set last_login_ip=par_login_ip,last_login_tm=sysdate(),login_count=if(isnull(login_count),1,login_count+1) where username=@uname;
  else
    update t_user set last_login_ip=par_login_ip,study_point=study_point+par_study_point,last_login_tm=sysdate(),login_count=if(isnull(login_count),1,login_count+1) where username=@uname;
  end if;
else
  update t_user set last_login_ip=par_login_ip,last_login_tm=sysdate(),login_count=if(isnull(login_count),1,login_count+1) where username=@uname;
end if;

update t_user set study_day_answer_point=0 where username=@uname;

update t_session set username=@uname,user_id=(select user_id from t_user where username=@uname) where sid=par_session_id;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_update_pwd`;
CREATE PROCEDURE  `usr_update_pwd`(IN par_user_id INT(10),in par_username varchar(20),
in par_email varchar(50),in par_idcard varchar(30),in par_examcard varchar(30),in par_new_pwd varchar(20))
begin
  set @strsql=concat('update t_user set pwd=password(','''',par_new_pwd,'''',') where ');

  if par_user_id is not null then
    set @strsql=concat(@strsql,' user_id=',par_user_id);
  elseif par_email is not null then
    set @strsql=concat(@strsql,' email=','''',par_email,'''');
  elseif par_idcard is not null then
    set @strsql=concat(@strsql,' idcard=','''',par_idcard,'''');
  elseif par_examcard is not null then
    set @strsql=concat(@strsql,' examcard=','''',par_examcard,'''');
  elseif par_username is not null then
    set @strsql=concat(@strsql,' username=','''',par_username,'''');
  end if;
  
  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_validate_email`;
CREATE PROCEDURE  `usr_validate_email`(in par_email varchar(50))
begin   
    select email from t_user where email=par_email;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_validate_examcard`;
CREATE PROCEDURE  `usr_validate_examcard`(in par_examcard varchar(30))
begin
    select examcard from t_user where examcard=par_examcard;

  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_validate_idcard`;
CREATE PROCEDURE  `usr_validate_idcard`(in par_idcard varchar(30))
begin
    select idcard from t_user where idcard=par_idcard;

  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_validate_pwd`;
CREATE PROCEDURE  `usr_validate_pwd`(IN par_email VARCHAR(50),
in par_username varchar(20), IN par_user_id INT(10),IN par_idcard VARCHAR(30),IN par_examcard VARCHAR(30),in par_password varchar(50),
in par_login_ip varchar(15),in par_session_id varchar(20),in par_last_activity int(10))
begin
    if par_email is not null then
        select password(pwd),user_id,real_name,username,icon,idcard,examcard into @pwd,@uid,@rname,@uname,@icon,@idcard,@examcard from t_user where email=par_email and password(par_password)=pwd;
    else
        if par_user_id is not null then
              select password(pwd),user_id,real_name,username,icon,idcard,examcard into @pwd,@uid,@rname,@uname,@icon,@idcard,@examcard from t_user where user_id=par_user_id and password(par_password)=pwd;
        else
            if par_username is not null then
                select password(pwd),user_id,real_name,username,icon,idcard,examcard into @pwd,@uid,@rname,@uname,@icon,@idcard,@examcard from t_user where username=par_username and password(par_password)=pwd;
            else
                if par_examcard is not null then
                    select password(pwd),user_id,real_name,username,icon,idcard,examcard into @pwd,@uid,@rname,@uname,@icon,@idcard,@examcard from t_user where examcard=par_examcard and password(par_password)=pwd;
                else
                    if par_idcard is not null then
                        select pwd,user_id,real_name,username,icon,idcard,examcard into @pwd,@uid,@rname,@uname,@icon,@idcard,@examcard from t_user where idcard=par_idcard and password(par_password)=pwd;                    
                    end if;
                end if;
            end if;
        end if;
    end if;

  if @uid is not null then
    select @uid user_id,@rname real_name,@uname username,@icon icon,@idcard idcard,@examcard examcard;
  else
    select null;
  end if;

  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `usr_validate_username`;
CREATE PROCEDURE  `usr_validate_username`(in par_username varchar(20))
begin   

    select username from t_user where username=par_username;
  
  
  
  
  
  
        
end



