DROP PROCEDURE IF EXISTS `exam_add`;
CREATE PROCEDURE  `exam_add`(IN `par_exam_id` CHAR(32), IN `par_exam_name` VARCHAR(1000), IN `par_exam_notice` TEXT, IN `par_exam_status` VARCHAR(20), IN `par_exam_category` VARCHAR(20), IN `par_exam_time_consistency_flg` TINYINT(1), IN `par_exam_total_tm` INTEGER(10), IN `par_exam_begin_tm` DATETIME, IN `par_exam_end_tm` DATETIME, IN `par_exam_mode` VARCHAR(20), IN `par_exam_times` INTEGER(11), IN `par_exam_point_type` VARCHAR(20), IN `par_exam_point` INTEGER(11), IN `par_exam_passing_grade` INTEGER(11), IN `par_exam_blank_flg` TINYINT(1), IN `par_exam_cloze_flg` TINYINT(1), IN `par_exam_manual` TINYINT(1), IN `par_exam_publish_score_flg` TINYINT(1), IN `par_exam_publish_answer_flg` TINYINT(1), IN `par_exam_publish_result_flg` TINYINT(1), IN `par_exam_full_screen` TINYINT(1), IN `par_exam_disable_paste` TINYINT(1), IN `par_exam_disable_mouse_right_btn` TINYINT(1), IN `par_exam_all_person` TINYINT(1), IN `par_publish_result_tm` VARCHAR(20), IN `par_exam_submit_display_result` TINYINT(1), IN `par_exam_ie_only` TINYINT(1), IN `par_exam_paper_only_one_flg` TINYINT(1), IN `par_exam_passing_again_flg` TINYINT(1), IN `par_exam_qsn_random_flg` TINYINT(1), IN `par_exam_user_verify_flg` TINYINT(1), IN `par_exam_user_signup_flg` TINYINT(1),IN `par_exam_disabled_monitor_flg` TINYINT(1), IN `par_exam_recovery_flg` TINYINT(1), IN `par_exam_recovery_val` INTEGER(10), IN `par_create_user_id` int(10), IN `par_group_id` TEXT, IN `par_exclude_user_id` TEXT, IN `par_exam_allow_ip` TEXT)
begin
  if par_group_id !=-1 then
    call exam_stat_user_count(par_group_id,par_exclude_user_id,@par_row_count);
  else
    select count(*) into @par_row_count from t_user;
  end if;

  if par_exam_point_type ='030203' then
    set @papr_point=par_exam_point;
  else
    set @papr_point=0;
  end if;

  insert into t_exam(exam_id,exam_name,exam_notice,exam_status,exam_category,exam_time_consistency_flg,exam_total_tm,exam_begin_tm,exam_end_tm,exam_mode,
              exam_times,exam_point_type,exam_point,exam_passing_grade,exam_blank_flg,exam_cloze_flg,exam_manual,exam_publish_score_flg,
              exam_publish_answer_flg,exam_publish_result_flg,exam_all_person,exam_publish_result_tm,exam_user_count,create_user_id,create_tm,
              exam_full_screen_flg,exam_mouse_right_flg,exam_disable_paste_flg,exam_submit_display_result,exam_ie_only_flg,
              exam_paper_only_one_flg,exam_passing_again_flg,exam_qsn_random_flg,exam_user_verify_flg,exam_user_signup_flg,exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,exam_allow_ip)
  values(par_exam_id,par_exam_name,par_exam_notice,par_exam_status,par_exam_category,par_exam_time_consistency_flg,par_exam_total_tm,par_exam_begin_tm,par_exam_end_tm,
        par_exam_mode,par_exam_times,par_exam_point_type,@papr_point,par_exam_passing_grade,par_exam_blank_flg,par_exam_cloze_flg,par_exam_manual,
        par_exam_publish_score_flg,par_exam_publish_answer_flg,par_exam_publish_result_flg,par_exam_all_person,par_publish_result_tm,@par_row_count,
        par_create_user_id,sysdate(),par_exam_full_screen,par_exam_disable_paste,par_exam_disable_mouse_right_btn,par_exam_submit_display_result,par_exam_ie_only
        ,par_exam_paper_only_one_flg,par_exam_passing_again_flg,par_exam_qsn_random_flg,par_exam_user_verify_flg,par_exam_user_signup_flg,
        par_exam_disabled_monitor_flg,par_exam_recovery_flg,par_exam_recovery_val,par_exam_allow_ip);
    
end

DROP PROCEDURE IF EXISTS `exam_add_paper_answer`;
CREATE PROCEDURE  `exam_add_paper_answer`(IN par_exam_id char(32),IN par_papr_id CHAR(32),IN par_exam_point_type VARCHAR(20), IN par_exam_point INTEGER(10), IN par_create_user_id int(10))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

    set @sql=concat('delete from t_exam_papr_answer where exam_id=','''',par_exam_id,'''',' and papr_id=','''',par_papr_id,'''');

    prepare stmt from @sql;
    execute stmt;
    deallocate prepare stmt;

    set @mysql2='';

    insert into tmp_exam_papr_answer(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id and qsn_sub_id !='0';

    set v_row_count := row_count();

    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_exam_papr_answer(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_exam_papr_answer t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;

    
if par_exam_point_type='030202' then
    set @mysql2=concat(@mysql2,' join (select r.qsn_id,r.qsn_sub_id,r.qsn_point
                            from t_question r join t_papr_content s on
                            r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id and s.papr_id=','''',par_papr_id,'''',' ) r on r.qsn_id=x.qsn_id and r.qsn_sub_id=x.qsn_sub_id and x.papr_id=','''',par_papr_id,'''');

elseif par_exam_point_type='030201' then
    set @mysql2=concat(@mysql2,' join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (select round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_exam_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_exam_papr_answer t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

    union
    select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
    from (
    select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_exam_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_exam_papr_answer t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    )p7 join tmp_exam_papr_answer p8 on p8.id=p7.qsn_id
    group by p8.pid,p8.id
    union
    select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
    (
    select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_exam_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_exam_papr_answer t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    ) pp
    join tmp_exam_papr_answer p3  on p3.pid=pp.qsn_sub_id
    join (
    select s.qsn_id,count(*) cnt from tmp_exam_papr_answer t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

    union
         select r.qsn_id, r.qsn_sub_id, p.qsn_point
       from t_papr_content t
       join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type=p.qsn_type and t.qsn_type_position=p.qsn_type_position
       join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
       where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') r on r.qsn_id=x.qsn_id and r.qsn_sub_id=x.qsn_sub_id and x.papr_id=','''',par_papr_id,'''');

elseif par_exam_point_type='030203' then
    select a.papr_qsn_count into @qsn_count  from t_exam e join t_exam_papr p on e.exam_id=p.exam_id and e.exam_id=par_exam_id
    join t_paper a on a.papr_id=p.papr_id;
    set @q_point=round(par_exam_point/@qsn_count,2);

    set @mysql2=concat(@mysql2,' join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_exam_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_exam_papr_answer t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

    union
    select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
    from (
    select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_exam_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_exam_papr_answer t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    )p7 join tmp_exam_papr_answer p8 on p8.id=p7.qsn_id
    group by p8.pid,p8.id
    union
    select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
    (
    select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
    from (
    select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
    from t_papr_qsn_type p1
    join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
    and p1.papr_id=','''',par_papr_id,'''','
    join tmp_exam_papr_answer p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
    join (
    select s.qsn_id,count(*) cnt from tmp_exam_papr_answer t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
    ) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
    ) pp
    join tmp_exam_papr_answer p3  on p3.pid=pp.qsn_sub_id
    join (
    select s.qsn_id,count(*) cnt from tmp_exam_papr_answer t,t_qsn_sub_position s
        where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
                 union
                select r.qsn_id, r.qsn_sub_id, @q_point
       from t_papr_content t
       join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type=p.qsn_type and t.qsn_type_position=p.qsn_type_position
       join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
       where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') r on r.qsn_id=x.qsn_id and r.qsn_sub_id=x.qsn_sub_id and x.papr_id=','''',par_papr_id,'''');

end if;



set @mysql=concat('insert into t_exam_papr_answer(exam_id,papr_id,qsn_id,qsn_sub_id,qsn_item_id,qsn_item_count,qsn_type,qsn_type_position,qsn_position,qsn_point,qsn_answer,create_user_id,create_tm)');

set @mysql=concat(@mysql,'select ','''',par_exam_id,'''',',','''',par_papr_id,'''',',','x.qsn_id,x.qsn_sub_id,x.qsn_item_id,b.qsn_item_count,x.qsn_type,x.qsn_type_position,x.qsn_position,r.qsn_point,a.qsn_answer,',par_create_user_id,',sysdate()
  from (select tp.papr_id,tp.qsn_id,tp.qsn_sub_id,tp.qsn_item_id,tp.qsn_type,tp.qsn_type_position,tp.qsn_position,tp.create_tm from (
select t.papr_id,q.qsn_id,q.qsn_sub_id,
               case
                 when o.qsn_item_id is null then
                  1
                 else
                  o.qsn_item_id
               end qsn_item_id,
               p.qsn_type,');
              set @mysql= concat(@mysql,'p.qsn_type_position');
              set @mysql=concat(@mysql,',c.qsn_position,q.create_tm
          from t_paper t
          join t_exam_papr ep on ep.papr_id=t.papr_id
          join t_exam e on e.exam_id=ep.exam_id and
          e.exam_id=','''',par_exam_id,'''','
          join t_papr_qsn_type p on t.papr_id = p.papr_id
          join t_papr_content c on p.papr_id = c.papr_id
                               and p.qsn_type = c.qsn_type
                               and c.qsn_type_position = p.qsn_type_position
          join t_question q on c.qsn_id = q.qsn_id
                           and c.qsn_sub_id = q.qsn_sub_id
          left join t_option o on o.qsn_id = q.qsn_id and o.qsn_sub_id=q.qsn_sub_id and o.qsn_type=q.qsn_type
          where t.papr_id=','''',par_papr_id,'''','
           ) tp  ');
          set @mysql=concat(@mysql,' union
        select y.papr_id,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_item_id,
               y.qsn_type,');
          set @mysql= concat(@mysql,'y.qsn_type_position,y.qsn_position,');
          set @mysql=concat(@mysql,'y.create_tm
               from (select
											 cc.papr_id,			   
                       q.qsn_id,
                       q.qsn_sub_id,
                       case
                         when o.qsn_item_id is null then
                          1
                         else
                          o.qsn_item_id
                       end qsn_item_id,
                       q.qsn_type,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_exam_papr_answer t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id) q
                  left join (select c.qsn_type_position,c.qsn_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_exam_papr_answer t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                  left join t_option o on q.qsn_id = o.qsn_id and q.qsn_sub_id=o.qsn_sub_id and o.qsn_type=q.qsn_type
                left join (select distinct t1.qsn_id
            , case when t1.qsn_id is not null then 1 else 0 end flg from t_qsn_sub_position t1
            join tmp_exam_papr_answer t2 on t2.id=t1.qsn_id
             ) sp on sp.qsn_id=q.qsn_sub_id and q.qsn_type in(\'010105\',\'010106\')
                 where cc.qsn_type_position is not null) y');
    set @mysql=concat(@mysql,'  union
        select y.papr_id,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_item_id,
               y.qsn_type,
               tm.qsn_type_position,
               tm.qsn_position,
               y.create_tm
          from (select cc.papr_id,
                       q.qsn_id,
                       q.qsn_sub_id,
                       null qsn_item_id,
                       q.qsn_type,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm                       
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_exam_papr_answer t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                           and not exists(select o.qsn_id from t_option o where o.qsn_id=t.pid and o.qsn_sub_id=t.id and o.qsn_type=r.qsn_type)
                           ) q
                  left join (select c.qsn_type_position,
				  												 c.papr_id,
                                   c.qsn_sub_id
                              from tmp_exam_papr_answer t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =cc.qsn_sub_id) y,');
        set @mysql=concat(@mysql,'(
               select n.qsn_sub_id,
                       concat(c1.qsn_type_position,
                              \'-\',
                              q1.qsn_id,
                              \'-\',
                              s1.qsn_position,
                              \'-\',
                              s2.qsn_position) as qsn_type_position,
                       c1.qsn_position,
                       q1.create_tm
                  from t_question q1
                  join (select q.qsn_id, q.qsn_sub_id
                         from (select r.qsn_id,
                                      r.qsn_sub_id,
                                      r.qsn_type,
                                      s.qsn_position
                                 from tmp_exam_papr_answer          t,
                                      t_question         r,
                                      t_qsn_sub_position s
                                where t.pid = r.qsn_id
                                  and t.id = r.qsn_sub_id
                                  and r.qsn_id = s.qsn_id
                                  and r.qsn_sub_id = s.qsn_sub_id) q
                         left join (select c.qsn_type_position,
                                          c.qsn_sub_id
                                     from tmp_exam_papr_answer t
                                     join t_papr_content c on t.id = c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                                     cc.qsn_sub_id
                        where cc.qsn_type_position is null) n on n.qsn_id =
                                                                 q1.qsn_sub_id
                  join t_papr_content c1 on c1.qsn_sub_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
                  join t_qsn_sub_position s1 on s1.qsn_id = q1.qsn_id
                                            and s1.qsn_sub_id = n.qsn_id
                  join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id');
        set @mysql=concat(@mysql,' union
					select n.qsn_sub_id,
					c1.qsn_type_position,
					c1.qsn_position,q1.create_tm
					from t_question q1 join (
					select q.qsn_id,q.qsn_sub_id
					from (
						select r.qsn_id,r.qsn_sub_id,r.qsn_type,s.qsn_position
						from tmp_exam_papr_answer t,t_question r,t_qsn_sub_position s
						where t.pid=r.qsn_id and t.id=r.qsn_sub_id and r.qsn_id=s.qsn_id and r.qsn_sub_id=s.qsn_sub_id) q
						left join
						(select c.qsn_type_position,c.qsn_sub_id from tmp_exam_papr_answer t
						join t_papr_content c on t.id=c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id=cc.qsn_sub_id
					   join t_option o on o.qsn_id=q.qsn_id and o.qsn_sub_id=q.qsn_sub_id and o.qsn_type=q.qsn_type
						) n on n.qsn_id=q1.qsn_sub_id
						join t_papr_content c1 on c1.qsn_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
					left join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id
									  ) tm
							 where y.qsn_sub_id = tm.qsn_sub_id

							 ) x ');

set @mysql=concat(@mysql,' join (
select t.qsn_id,t.qsn_sub_id,t.qsn_answer,t.qsn_item_id
from t_answer t
join t_papr_content pc
on pc.qsn_id=t.qsn_id and pc.qsn_sub_id=t.qsn_sub_id and pc.papr_id=','''',par_papr_id,'''',' group by t.qsn_id,t.qsn_sub_id,t.qsn_item_id
union
select t.qsn_id,t.qsn_sub_id,t.qsn_answer,t.qsn_item_id
from  tmp_exam_papr_answer m join  t_answer t
on m.id=t.qsn_sub_id and m.pid=t.qsn_id
group by t.qsn_id,t.qsn_sub_id,t.qsn_item_id
) a on a.qsn_id = x.qsn_id and a.qsn_sub_id = x.qsn_sub_id and a.qsn_item_id=x.qsn_item_id ');

set @mysql=concat(@mysql,' join (select t.qsn_id,t.qsn_sub_id,count(t.qsn_item_id) qsn_item_count
from t_answer t  join t_papr_content pc
on pc.qsn_id=t.qsn_id and pc.qsn_sub_id=t.qsn_sub_id and pc.papr_id=','''',par_papr_id,'''',' group by t.qsn_id,t.qsn_sub_id
union
select t.qsn_id,t.qsn_sub_id,count(t.qsn_item_id) qsn_item_count
from (select distinct id,pid from tmp_exam_papr_answer) m join  t_answer t
on m.id=t.qsn_sub_id and m.pid=t.qsn_id
group by t.qsn_id,t.qsn_sub_id
) b on b.qsn_id=x.qsn_id and b.qsn_sub_id=x.qsn_sub_id ');

set @mysql=concat(@mysql,@mysql2);
prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;

truncate table tmp_exam_papr_answer;
 
  
        
end

DROP PROCEDURE IF EXISTS `exam_analysis_scoring`;
CREATE PROCEDURE  `exam_analysis_scoring`(in par_exam_name varchar (200),
in par_exam_category varchar (20),IN par_exam_group_id int(10),IN par_exam_group_pid int(10),
in par_exam_bgn_tm varchar (20),in par_exam_end_tm varchar (20),
in par_page_idx int(10),in par_page_size int(10))
begin
  declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

    if par_exam_group_id is not null and par_exam_group_pid is not null then

        insert into tmp_exam_analysis_scoring_group_tree(id,pid, level,position)
        values (par_exam_group_id,par_exam_group_pid,v_level,v_position);

        set v_row_count := row_count();
        while v_row_count != 0 do
            set @position := 0;
            insert into tmp_exam_analysis_scoring_group_tree(id,pid,level,position)
            select g.group_id,g.group_pid
            , v_level + 1
            , @position := @position+1
            from t_group g
            inner join tmp_exam_analysis_scoring_group_tree t
            on g.group_pid = t.id
            where t.level = v_level and g.group_id !='0'
            order by g.group_id;

            set v_row_count := row_count();
            set v_level := v_level + 1;
        end while;

    end if;
    
  set @group=par_exam_group_id;

    set @strsql=concat('select
      e.exam_name,e.exam_id,cde.desc_cn exam_category,case when e.exam_all_person =1 and @group is null then e.exam_user_count-1 else
    (select count(*) from t_user_group where group_id=@group) end exam_user_count,y.exam_times,
      case when e.exam_all_person =1 and @group is null then t1.exam_real_user_count else t_1.exam_real_user_count end exam_real_user_count,
    case when e.exam_all_person =1 and @group is null then t1.exam_real_user_count-IF(f.passing_count IS NULL,0, f.passing_count) else t_1.exam_real_user_count-IF(f_1.passing_count IS NULL,0, f_1.passing_count) end fail_count,
      case when e.exam_all_person =1 and @group is null then IF(f.passing_count IS NULL,0, f.passing_count) else IF(f_1.passing_count IS NULL,0, f_1.passing_count) end passing_count,
    case when e.exam_all_person =1 and @group is null then round(t2.max_scoring,2) else round(t_2.max_scoring,2) end max_scoring,
    case when e.exam_all_person =1 and @group is null then round(t3.min_scoring,2) else round(t_3.min_scoring,2) end min_scoring,
    case when e.exam_all_person =1 and @group is null then round(t4.avg_scoring,2) else round(t_4.avg_scoring,2) end avg_scoring,
      case when e.exam_all_person =1 and @group is null then concat(round(IF(f.passing_count IS NULL,0, f.passing_count)/t1.exam_real_user_count*100,2),\'%\')
    else concat(round(IF(f_1.passing_count IS NULL,0, f_1.passing_count)/t_1.exam_real_user_count*100,2),\'%\') end passing_rate
      ,case when e.exam_all_person =1 and @group is null then \'all\' else gp.group_name end group_name from t_exam e ');

    set @strsql=concat(@strsql,' join(
     select distinct e2.exam_id,g.group_id,e2.exam_times from
     t_user_exam e2 join t_user_group g on g.user_id=e2.user_id ');

    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

    set @strsql=concat(@strsql,' ) y on e.exam_id=y.exam_id ');
    set @strsql=concat(@strsql,' left join(select count(*) exam_real_user_count,ue.exam_id,ue.exam_times from t_user_exam ue
                            join t_exam e on e.exam_id=ue.exam_id
                            group by ue.exam_id,ue.exam_times) t1 on t1.exam_id = y.exam_id and t1.exam_times=y.exam_times');

 set @strsql=concat(@strsql,' left join (select count(*) exam_real_user_count,ue.exam_id,g.group_id,ue.exam_times
                            from t_user_exam ue
                            join t_user_group g on g.user_id=ue.user_id
                            join t_exam e on e.exam_id=ue.exam_id ');

    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

    set @strsql=concat(@strsql,' group by ue.exam_id,ue.exam_times,g.group_id) t_1 on t_1.exam_id = y.exam_id and t_1.group_id=y.group_id and t_1.exam_times=y.exam_times ');

    set @strsql=concat(@strsql,' left join( select  count(*) passing_count,ei.exam_id,ei.exam_times
    from t_user_exam ei join t_exam ei2
      on ei.exam_id=ei2.exam_id and ei2.exam_passing_grade <=ei.user_exam_scoring
    group by ei.exam_id,ei.exam_times) f on f.exam_id=y.exam_id and f.exam_times=y.exam_times ');

  set @strsql=concat(@strsql,' left join (select  count(*) passing_count,ei.exam_id,g.group_id,ei.exam_times
    from t_user_exam ei join t_exam ei2
      on ei.exam_id=ei2.exam_id and ei2.exam_passing_grade <=ei.user_exam_scoring
      join t_user_group g on g.user_id=ei.user_id ');

    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

  set @strsql=concat(@strsql,'group by ei.exam_id,g.group_id,ei.exam_times) f_1 on f_1.exam_id=y.exam_id and y.group_id=f_1.group_id and f_1.exam_times=y.exam_times ');

    set @strsql=concat(@strsql,' left join (select max(e3.user_exam_scoring) max_scoring,e3.exam_id,e3.exam_times
  from t_user_exam e3
  join t_user_group g on g.user_id=e3.user_id and g.user_id=e3.user_id
  group by e3.exam_id,e3.exam_times) t2 on t2.exam_id=y.exam_id and t2.exam_times=y.exam_times ');

  set @strsql=concat(@strsql,' left join (select max(e3.user_exam_scoring) max_scoring,e3.exam_id,g.group_id,e3.exam_times
    from t_user_exam e3
  join t_user_group g on g.user_id=e3.user_id and g.user_id=e3.user_id');

    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

    set @strsql=concat(@strsql,' group by e3.exam_id,g.group_id,e3.exam_times) t_2
    on t_2.exam_id=y.exam_id and t_2.group_id=y.group_id and t_2.exam_times=y.exam_times ');

    set @strsql=concat(@strsql,' left join (select min(e4.user_exam_scoring) min_scoring,e4.exam_id,e4.exam_times
  from t_user_exam e4 join t_user_group g on g.user_id=e4.user_id
  group by e4.exam_id,e4.exam_times) t3
  on t3.exam_id=y.exam_id and t3.exam_times=y.exam_times ');

  set @strsql=concat(@strsql,' left join (select min(e4.user_exam_scoring) min_scoring,e4.exam_id,g.group_id,e4.exam_times
    from t_user_exam e4
  join t_user_group g on g.user_id=e4.user_id');

    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

    set @strsql=concat(@strsql,' group by e4.exam_id,g.group_id,e4.exam_times) t_3
  on t_3.exam_id=y.exam_id and t_3.group_id=y.group_id and t_3.exam_times=y.exam_times ');

    set @strsql=concat(@strsql,' left join (select avg(e5.user_exam_scoring) avg_scoring,e5.exam_id,e5.exam_times
  from t_user_exam e5
  group by e5.exam_id,e5.exam_times) t4
  on t4.exam_id=y.exam_id and t4.exam_times=y.exam_times ');

  set @strsql=concat(@strsql,' left join (select avg(e5.user_exam_scoring) avg_scoring,e5.exam_id,g.group_id,e5.exam_times
    from t_user_exam e5 join t_user_group g on g.user_id=e5.user_id ');

    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

    set @strsql=concat(@strsql,' group by e5.exam_id,g.group_id,e5.exam_times) t_4
  on t_4.exam_id=y.exam_id and y.group_id=t_4.group_id and t_4.exam_times=y.exam_times');

    set @strsql=concat(@strsql,' join t_common_cde cde on cde.c_cde=e.exam_category join t_group gp on gp.group_id=y.group_id ');
    set @strsql=concat(@strsql,' where ');

    if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
        set @strsql=concat(@strsql,' e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''',' and ');
    end if;

    if par_exam_category is not null then
        set @strsql=concat(@strsql,' e.exam_category=','''',par_exam_category,'''',' and ');
    end if;

    if par_exam_name is not null then
        set @strsql=concat(@strsql,' e.exam_name like ','''',par_exam_name,'%''');
    end if;

    if par_exam_bgn_tm is null and par_exam_end_tm is null and par_exam_category is null and par_exam_name is null then
        set @strsql=substr(@strsql,1,length(@strsql)-6);
    else
        if par_exam_name is null then
                set @strsql=substr(@strsql,1,length(@strsql)-4);
        end if;
    end if;

  set @strsql=concat(@strsql,' group by e.exam_name,y.exam_times');

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

    if par_exam_group_id is not null and par_exam_group_pid is not null then
    truncate table tmp_exam_analysis_scoring_group_tree;
  end if;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_analysis_scoring_fail_user`;
CREATE PROCEDURE  `exam_analysis_scoring_fail_user`(
in par_exam_id char (32),in par_exam_times integer (10),IN par_exam_group_id int(10),in par_page_idx integer(10),in par_page_size integer(10)
)
begin
    set @strsql=concat('SELECT t.user_id,u.username,u.real_name,t.user_exam_scoring,e.exam_passing_grade,g.group_name
                                    FROM t_user_exam t
                                    join t_exam e on e.exam_id=t.exam_id
                                    join t_user_group ug on ug.user_id=t.user_id
                                    left join t_group g on g.group_id=ug.group_id
                                    join t_user u on u.user_id=t.user_id
                                    where   t.user_exam_scoring <e.exam_passing_grade and t.exam_id=','''',par_exam_id,'''',' and t.exam_times=',par_exam_times);

  if par_exam_group_id is not null then
      set @strsql=concat(@strsql,' and g.group_id=',par_exam_group_id);
  end if;

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_analysis_scoring_passing_user`;
CREATE PROCEDURE  `exam_analysis_scoring_passing_user`(
in par_exam_id char (32),in par_exam_times integer (10),IN par_exam_group_id int(10),in par_page_idx integer(10),in par_page_size integer(10)
)
begin
    set @strsql=concat('SELECT t.user_id,u.username,u.real_name,t.user_exam_scoring,e.exam_passing_grade,g.group_name
                                    FROM t_user_exam t
                                    join t_exam e on e.exam_id=t.exam_id
                                    join t_user_group ug on ug.user_id=t.user_id
                                    left join t_group g on g.group_id=ug.group_id
                                    join t_user u on u.user_id=t.user_id
                                    where   t.user_exam_scoring >=e.exam_passing_grade and t.exam_id=','''',par_exam_id,'''',' and t.exam_times=',par_exam_times);

  if par_exam_group_id is not null then
      set @strsql=concat(@strsql,' and g.group_id=',par_exam_group_id);
  end if;

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_analysis_scoring_range`;
CREATE PROCEDURE  `exam_analysis_scoring_range`(
in par_exam_name varchar (200),in par_exam_category varchar (20),
in par_exam_group_flg varchar(20),
IN par_exam_group_id int(10),
in par_exam_bgn_tm varchar (20),in par_exam_end_tm varchar (20),in par_page_idx int(10),in par_page_size int(10)
)
begin

set @strsql=concat(' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times,
                        concat(\'0-\',e.exam_passing_grade-(e.exam_point*0.1)) range1,null range2
                      ,null range3,null range4,null range5,null range6
                     ,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');

set @strsql=concat(@strsql,',c.desc_cn exam_category');

if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;

set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');

if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;

if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where 0<=ue.user_exam_scoring and ue.user_exam_scoring<=e.exam_passing_grade-(e.exam_point*0.1)');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,' group by e.exam_name,p.papr_name,ue.exam_times ');

set @strsql=concat(@strsql,' union ');

set @strsql=concat(@strsql,' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times,
                        null range1,
                      concat(e.exam_passing_grade-(e.exam_point*0.2),\'-\',e.exam_passing_grade-(e.exam_point*0.1)) range2
                      ,null range3,null range4,null range5,null range6
                     ,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');

set @strsql=concat(@strsql,',c.desc_cn exam_category');

if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;

set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');

if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;

if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where 0<=ue.user_exam_scoring and ue.user_exam_scoring<=e.exam_passing_grade-(e.exam_point*0.2)');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,' group by e.exam_name,p.papr_name,ue.exam_times ');

set @strsql=concat(@strsql,' union ');
set @strsql=concat(@strsql,' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times
,null range1
,null range2
,concat(e.exam_passing_grade,\'-\',e.exam_passing_grade+(e.exam_point*0.1)) range3
,null range4
,null range5
,null range6

,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');
set @strsql=concat(@strsql,',c.desc_cn exam_category');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;
set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where e.exam_passing_grade<=ue.user_exam_scoring
and ue.user_exam_scoring <=e.exam_passing_grade+(e.exam_point*0.1)');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,' group by e.exam_name,p.papr_name,ue.exam_times ');
set @strsql=concat(@strsql,' union ');
set @strsql=concat(@strsql,' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times
,null range1
,null range2
,null range3
,concat(e.exam_passing_grade+(e.exam_point*0.1),\'-\',e.exam_passing_grade+(e.exam_point*0.2)) range4
,null range5
,null range6

,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');
set @strsql=concat(@strsql,',c.desc_cn exam_category');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;
set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where e.exam_passing_grade+(e.exam_point*0.1)<=ue.user_exam_scoring
and ue.user_exam_scoring <=e.exam_passing_grade+(e.exam_point*0.2) ');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,'group by e.exam_name,p.papr_name,ue.exam_times ');
set @strsql=concat(@strsql,' union ');
set @strsql=concat(@strsql,' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times
,null range1
,null range2
,null range3
,null range4
,concat(e.exam_passing_grade+(e.exam_point*0.2),\'-\',e.exam_passing_grade+(e.exam_point*0.3)) range5
,null range6

,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');
set @strsql=concat(@strsql,',c.desc_cn exam_category');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;
set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where e.exam_passing_grade+(e.exam_point*0.2)<=ue.user_exam_scoring
and ue.user_exam_scoring <=e.exam_passing_grade+(e.exam_point*0.3)');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,'group by e.exam_name,p.papr_name,ue.exam_times ');
set @strsql=concat(@strsql,' union ');
set @strsql=concat(@strsql,' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times
,null range1
,null range2
,null range3
,null range4
,null range5
,concat(e.exam_passing_grade+(e.exam_point*0.3),\'-\',e.exam_point) range6
,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');
set @strsql=concat(@strsql,',c.desc_cn exam_category');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;
set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where e.exam_passing_grade+(e.exam_point*0.3)<=ue.user_exam_scoring
and ue.user_exam_scoring <=e.exam_point ');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,'group by e.exam_name,p.papr_name,ue.exam_times ');
call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_analysis_scoring_real_user`;
CREATE PROCEDURE  `exam_analysis_scoring_real_user`(
in par_exam_id char (32),in par_exam_times integer (10),IN par_exam_group_id int(10),in par_page_idx integer(10),in par_page_size integer(10)
)
begin
  set @strsql=concat(' select u.user_id,u.username,u.real_name,g.group_name,ue.exam_times,p.papr_name from t_user u
                  join t_user_exam ue on ue.user_id=u.user_id',' and ue.exam_times=',par_exam_times,'
                  join t_user_group ug on ug.user_id=u.user_id
                  join t_paper p on p.papr_id=ue.papr_id
                  left join t_group g on g.group_id=ug.group_id
                  join t_exam e on e.exam_id=ue.exam_id and e.exam_id=','''',par_exam_id,'''');

  if par_exam_group_id is not null then
      set @strsql=concat(@strsql,' and g.group_id=',par_exam_group_id);
  end if;

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
 
    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_analysis_scoring_user`;
CREATE PROCEDURE  `exam_analysis_scoring_user`(in par_exam_id char (32),IN par_exam_group_id int(10),in par_page_idx integer(10),in par_page_size integer(10))
begin
    set @strsql=concat(' select u.user_id,u.username,u.real_name,g.group_name from t_user u
                                      left join t_user_group ug on ug.user_id=u.user_id
                                      left join t_group g on g.group_id=ug.group_id
                                      left join t_exam_group eg on eg.group_id=g.group_id
                    and eg.exam_id=','''',par_exam_id,'''',
    ' where not exists(select * from t_exam_exclude_user eeu where eeu.exam_id=eg.exam_id and u.user_id=eeu.user_id) and u.user_id !=1');

  if par_exam_group_id is not null then
      set @strsql=concat(@strsql,' and g.group_id=',par_exam_group_id);
  end if;
                                                                            
  call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

  prepare stmt from @mysql;
  execute stmt;
  deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_analysis_user_scoring`;
CREATE PROCEDURE  `exam_analysis_user_scoring`(in par_exam_name varchar (200),in par_user_name varchar(20),
in par_group_flg tinyint(1),
in par_exam_category varchar(20),IN par_exam_group_id int(10),IN par_exam_group_pid int(10),in par_exam_bgn_tm varchar(40),in par_exam_end_tm varchar(40),in par_page_idx int(10),in par_page_size int(10)
)
begin

    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

    if par_exam_group_id is not null and par_exam_group_pid is not null then

        insert into tmp_exam_analysis_user_scoring_tree(id,pid, level,position)
        values (par_exam_group_id,par_exam_group_pid,v_level,v_position);

        set v_row_count := row_count();
        while v_row_count != 0 do
            set @position := 0;
            insert into tmp_exam_analysis_user_scoring_tree(id,pid,level,position)
            select g.group_id,g.group_pid
            , v_level + 1
            , @position := @position+1
            from t_group g
            inner join tmp_exam_analysis_user_scoring_tree t  on g.group_pid = t.id     where t.level = v_level and g.group_id !='0' order by g.group_id;
            
            set v_row_count := row_count();
            set v_level := v_level + 1;
        end while;
    end if;

if par_group_flg !=0 then
    set @strsql=concat('select (select count(*) from t_user_exam u,t_user_group ug where u.exam_id=x.exam_id
            and u.exam_times=x.exam_times and u.user_id=ug.user_id and ug.group_id=x.group_id and u.user_exam_scoring>x.user_exam_scoring)+1 pos');
else
    set @strsql=concat(' select (select count( distinct u.user_exam_scoring) from t_user_exam u where u.exam_id=x.exam_id and u.exam_times=x.exam_times
                                and u.user_exam_scoring>x.user_exam_scoring)+1 pos');
end if;

set @strsql=concat(@strsql,', x.* from (');
set @strsql=concat(@strsql,'select e.exam_name,y.exam_tm,e.exam_begin_tm,e.exam_end_tm,e.exam_id,cde.desc_cn exam_category,gp.group_name,gp.group_id,u.real_name,u.user_id,y.exam_times,
               y.papr_id,case when e.exam_all_person =1 then e.exam_user_count -1 else e.exam_user_count end exam_user_count,t1.exam_real_user_count,y.user_exam_scoring,
               case when e.exam_passing_grade <=y.user_exam_scoring then \'1\' else \'0\' end exam_status,',par_group_flg ,' group_flg
          from t_exam e
          join (select e2.exam_id,e2.exam_tm,g.group_id,e2.user_id,e2.user_exam_scoring,e2.exam_times,e2.papr_id
                 from t_user_exam e2 left join t_user_group g on g.user_id = e2.user_id ');

if par_exam_group_id is not null then
        set @strsql=concat(@strsql,' join tmp_exam_analysis_user_scoring_tree t on t.id=g.group_id ');
end if;

set @strsql=concat(@strsql,' ) y on e.exam_id=y.exam_id ');
set @strsql=concat(@strsql,' left join (select count(*) exam_real_user_count, ue.exam_id,ue.exam_times,ue.papr_id from t_user_exam ue');
set @strsql=concat(@strsql,' group by ue.exam_id,ue.exam_times) t1 on t1.exam_id = y.exam_id and t1.exam_times=y.exam_times ');
set @strsql=concat(@strsql,' join t_common_cde cde on cde.c_cde = e.exam_category join t_group gp on gp.group_id = y.group_id ');
set @strsql=concat(@strsql,' join t_user u on u.user_id=y.user_id ');

if par_user_name is not null then
        set @strsql=concat(@strsql,' and u.real_name like ','''',par_user_name,'%''');
end if;

set @strsql=concat(@strsql,' where ');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''',' and ');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' e.exam_category=','''',par_exam_category,'''',' and ');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' e.exam_name like ','''',par_exam_name,'%''');
end if;
if par_exam_bgn_tm is null and par_exam_end_tm is null and par_exam_category is null and par_exam_name is null  then
    set @strsql=substr(@strsql,1,length(@strsql)-6);
else
    if par_exam_name is null then
            set @strsql=substr(@strsql,1,length(@strsql)-4);
    end if;
end if;
set @strsql=concat(@strsql,' group by y.exam_id,y.exam_times,y.user_id order by y.exam_id ,y.exam_times ,y.user_exam_scoring ) x');
if par_group_flg !=0 then
        set @strsql=concat(@strsql,' group by x.exam_id,x.exam_times,x.group_id,x.user_id desc');
end if;

call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
set @mysql=concat('select t1.* from (',@mysql,') t1 order by t1.exam_id,t1.exam_times,t1.pos');

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_exam_analysis_user_scoring_tree;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_delete`;
CREATE PROCEDURE  `exam_delete`(in par_exam_id text)
begin     
   set @strsql=concat('delete from t_exam where exam_id in ',par_exam_id);
       
   prepare stmt from @strsql;  
   execute stmt;
   deallocate prepare stmt;    
   
   set @strsql=concat('delete from t_exam_marker where exam_id in ',par_exam_id);
   prepare stmt from @strsql;  
   execute stmt;
   deallocate prepare stmt;    
   
   set @strsql=concat('delete from t_exam_exclude_user where exam_id in ',par_exam_id);
   prepare stmt from @strsql;  
   execute stmt;
   deallocate prepare stmt;    
   
   set @strsql=concat('delete from t_exam_group where exam_id in ',par_exam_id);
   prepare stmt from @strsql;  
   execute stmt;
   deallocate prepare stmt;    
   
   set @strsql=concat('delete from t_exam_papr where exam_id in ',par_exam_id);
   prepare stmt from @strsql;  
   execute stmt;
   deallocate prepare stmt;    
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_exclude_user_add`;
CREATE PROCEDURE  `exam_exclude_user_add`(IN par_value TEXT)
begin    
    set @mysql=concat('insert into t_exam_exclude_user(exam_id,user_id,papr_id) values',par_value);
    
    prepare stmt from @mysql;
    execute stmt;
    DEALLOCATE prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_exclude_user_delete`;
CREATE PROCEDURE  `exam_exclude_user_delete`(IN par_exam_id CHAR(32))
begin      
   set @strsql=concat('delete from t_exam_exclude_user where exam_id = ','''',par_exam_id,'''');
       
   prepare stmt from @strsql;  
   execute stmt;
   deallocate prepare stmt; 
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_export_analysis_scoring`;
CREATE PROCEDURE  `exam_export_analysis_scoring`(in par_exam_name varchar (200),
in par_exam_category varchar (20),IN par_exam_group_id int(10),IN par_exam_group_pid int(10),in par_exam_bgn_tm varchar (20),in par_exam_end_tm varchar (20))
begin
  declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

    if par_exam_group_id is not null and par_exam_group_pid is not null then

        insert into tmp_exam_analysis_scoring_group_tree(id,pid, level,position)
        values (par_exam_group_id,par_exam_group_pid,v_level,v_position);

        set v_row_count := row_count();
        while v_row_count != 0 do
            set @position := 0;
            insert into tmp_exam_analysis_scoring_group_tree(id,pid,level,position)
            select g.group_id,g.group_pid
            , v_level + 1
            , @position := @position+1
            from t_group g
            inner join tmp_exam_analysis_scoring_group_tree t  on g.group_pid = t.id    where t.level = v_level and g.group_id !='0' order by g.group_id;
            
            set v_row_count := row_count();
            set v_level := v_level + 1;
        end while;

    end if;
    
    set @group=par_exam_group_id;

    set @strsql=concat('select
      e.exam_name,e.exam_id,cde.desc_cn exam_category,case when e.exam_all_person =1 and @group is null then e.exam_user_count else
    (select count(*) from t_user_group where group_id=@group) end exam_user_count,y.exam_times,
      case when e.exam_all_person =1 and @group is null then t1.exam_real_user_count else t_1.exam_real_user_count end exam_real_user_count,
    case when e.exam_all_person =1 and @group is null then t1.exam_real_user_count-f.passing_count else t_1.exam_real_user_count-f_1.passing_count end fail_count,
      case when e.exam_all_person =1 and @group is null then f.passing_count else f_1.passing_count end passing_count,
    case when e.exam_all_person =1 and @group is null then round(t2.max_scoring,2) else round(t_2.max_scoring,2) end max_scoring,
    case when e.exam_all_person =1 and @group is null then round(t3.min_scoring,2) else round(t_3.min_scoring,2) end min_scoring,
    case when e.exam_all_person =1 and @group is null then round(t4.avg_scoring,2) else round(t_4.avg_scoring,2) end avg_scoring,
      case when e.exam_all_person =1 and @group is null then concat(round(f.passing_count/t1.exam_real_user_count*100,2),\'%\')
    else concat(round(f_1.passing_count/t_1.exam_real_user_count*100,2),\'%\') end passing_rate
      ,case when e.exam_all_person =1 and @group is null then \'all\' else gp.group_name end group_name from t_exam e ');

    set @strsql=concat(@strsql,' join(
     select distinct e2.exam_id,g.group_id,e2.exam_times from
     t_user_exam e2 join t_user_group g on g.user_id=e2.user_id ');
     
    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

    set @strsql=concat(@strsql,' ) y on e.exam_id=y.exam_id ');
    set @strsql=concat(@strsql,' left join(select count(*) exam_real_user_count,ue.exam_id,ue.exam_times from t_user_exam ue
                            join t_exam e on e.exam_id=ue.exam_id
                            group by ue.exam_id,ue.exam_times) t1 on t1.exam_id = y.exam_id and t1.exam_times=y.exam_times');

 set @strsql=concat(@strsql,' left join (select count(*) exam_real_user_count,ue.exam_id,g.group_id,ue.exam_times
                            from t_user_exam ue
                            join t_user_group g on g.user_id=ue.user_id
                            join t_exam e on e.exam_id=ue.exam_id ');

    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

    set @strsql=concat(@strsql,' group by ue.exam_id,ue.exam_times,g.group_id) t_1 on t_1.exam_id = y.exam_id and t_1.group_id=y.group_id and t_1.exam_times=y.exam_times ');

    set @strsql=concat(@strsql,' left join( select  count(*) passing_count,ei.exam_id,ei.exam_times
    from t_user_exam ei join t_exam ei2
      on ei.exam_id=ei2.exam_id and ei2.exam_passing_grade <=ei.user_exam_scoring
    group by ei.exam_id,ei.exam_times) f on f.exam_id=y.exam_id and f.exam_times=y.exam_times ');

  set @strsql=concat(@strsql,' left join (select  count(*) passing_count,ei.exam_id,g.group_id,ei.exam_times
    from t_user_exam ei join t_exam ei2
      on ei.exam_id=ei2.exam_id and ei2.exam_passing_grade <=ei.user_exam_scoring
      join t_user_group g on g.user_id=ei.user_id ');

    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

  set @strsql=concat(@strsql,'group by ei.exam_id,g.group_id,ei.exam_times) f_1 on f_1.exam_id=y.exam_id and y.group_id=f_1.group_id and f_1.exam_times=y.exam_times ');

    set @strsql=concat(@strsql,' left join (select max(e3.user_exam_scoring) max_scoring,e3.exam_id,e3.exam_times
  from t_user_exam e3
  join t_user_group g on g.user_id=e3.user_id and g.user_id=e3.user_id
  group by e3.exam_id,e3.exam_times) t2 on t2.exam_id=y.exam_id and t2.exam_times=y.exam_times ');

  set @strsql=concat(@strsql,' left join (select max(e3.user_exam_scoring) max_scoring,e3.exam_id,g.group_id,e3.exam_times
    from t_user_exam e3
  join t_user_group g on g.user_id=e3.user_id and g.user_id=e3.user_id');

    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

    set @strsql=concat(@strsql,' group by e3.exam_id,g.group_id,e3.exam_times) t_2
    on t_2.exam_id=y.exam_id and t_2.group_id=y.group_id and t_2.exam_times=y.exam_times ');

    set @strsql=concat(@strsql,' left join (select min(e4.user_exam_scoring) min_scoring,e4.exam_id,e4.exam_times
  from t_user_exam e4 join t_user_group g on g.user_id=e4.user_id
  group by e4.exam_id,e4.exam_times) t3
  on t3.exam_id=y.exam_id and t3.exam_times=y.exam_times ');

  set @strsql=concat(@strsql,' left join (select min(e4.user_exam_scoring) min_scoring,e4.exam_id,g.group_id,e4.exam_times
    from t_user_exam e4
  join t_user_group g on g.user_id=e4.user_id');

    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

    set @strsql=concat(@strsql,' group by e4.exam_id,g.group_id,e4.exam_times) t_3
  on t_3.exam_id=y.exam_id and t_3.group_id=y.group_id and t_3.exam_times=y.exam_times ');

    set @strsql=concat(@strsql,' left join (select avg(e5.user_exam_scoring) avg_scoring,e5.exam_id,e5.exam_times
  from t_user_exam e5
  group by e5.exam_id,e5.exam_times) t4
  on t4.exam_id=y.exam_id and t4.exam_times=y.exam_times ');

  set @strsql=concat(@strsql,' left join (select avg(e5.user_exam_scoring) avg_scoring,e5.exam_id,g.group_id,e5.exam_times
    from t_user_exam e5 join t_user_group g on g.user_id=e5.user_id ');

    if par_exam_group_id is not null then
            set @strsql=concat(@strsql,' join tmp_exam_analysis_scoring_group_tree t on t.id=g.group_id ');
    end if;

    set @strsql=concat(@strsql,' group by e5.exam_id,g.group_id,e5.exam_times) t_4
  on t_4.exam_id=y.exam_id and y.group_id=t_4.group_id and t_4.exam_times=y.exam_times');

    set @strsql=concat(@strsql,' join t_common_cde cde on cde.c_cde=e.exam_category join t_group gp on gp.group_id=y.group_id ');
    set @strsql=concat(@strsql,' where ');

    if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
        set @strsql=concat(@strsql,' e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''',' and ');
    end if;

    if par_exam_category is not null then
        set @strsql=concat(@strsql,' e.exam_category=','''',par_exam_category,'''',' and ');
    end if;

    if par_exam_name is not null then
        set @strsql=concat(@strsql,' e.exam_name like ','''',par_exam_name,'%''');
    end if;

    if par_exam_bgn_tm is null and par_exam_end_tm is null and par_exam_category is null and par_exam_name is null then
        set @strsql=substr(@strsql,1,length(@strsql)-6);
    else
        if par_exam_name is null then
                set @strsql=substr(@strsql,1,length(@strsql)-4);
        end if;
    end if;

    set @strsql=concat(@strsql,' group by e.exam_name,y.exam_times');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  truncate table tmp_exam_analysis_scoring_group_tree;
    
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_export_analysis_scoring_range`;
CREATE PROCEDURE  `exam_export_analysis_scoring_range`(
in par_exam_name varchar (200),in par_exam_category varchar (20),
in par_exam_group_flg varchar(20),IN par_exam_group_id int(10),
in par_exam_bgn_tm varchar (20),in par_exam_end_tm varchar (20))
begin

set @strsql=concat(' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times,
                        concat(\'0-\',e.exam_passing_grade-(e.exam_point*0.1)) range1,null range2
                      ,null range3,null range4,null range5,null range6
                     ,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');

set @strsql=concat(@strsql,',c.desc_cn exam_category');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;

set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');

if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;

if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where 0<=ue.user_exam_scoring and ue.user_exam_scoring<=e.exam_passing_grade-(e.exam_point*0.1)');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,' group by e.exam_name,p.papr_name,ue.exam_times ');

set @strsql=concat(@strsql,' union ');

set @strsql=concat(@strsql,' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times,
                        null range1,
                      concat(e.exam_passing_grade-(e.exam_point*0.2),\'-\',e.exam_passing_grade-(e.exam_point*0.1)) range2
                      ,null range3,null range4,null range5,null range6
                     ,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');

set @strsql=concat(@strsql,',c.desc_cn exam_category');

if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;

set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');

if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;

if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where 0<=ue.user_exam_scoring and ue.user_exam_scoring<=e.exam_passing_grade-(e.exam_point*0.2)');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,' group by e.exam_name,p.papr_name,ue.exam_times ');

set @strsql=concat(@strsql,' union ');
set @strsql=concat(@strsql,' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times
,null range1
,null range2
,concat(e.exam_passing_grade,\'-\',e.exam_passing_grade+(e.exam_point*0.1)) range3
,null range4
,null range5
,null range6

,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');
set @strsql=concat(@strsql,',c.desc_cn exam_category');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;
set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where e.exam_passing_grade<=ue.user_exam_scoring
and ue.user_exam_scoring <=e.exam_passing_grade+(e.exam_point*0.1)');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,' group by e.exam_name,p.papr_name,ue.exam_times ');
set @strsql=concat(@strsql,' union ');
set @strsql=concat(@strsql,' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times
,null range1
,null range2
,null range3
,concat(e.exam_passing_grade+(e.exam_point*0.1),\'-\',e.exam_passing_grade+(e.exam_point*0.2)) range4
,null range5
,null range6

,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');
set @strsql=concat(@strsql,',c.desc_cn exam_category');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;
set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where e.exam_passing_grade+(e.exam_point*0.1)<=ue.user_exam_scoring
and ue.user_exam_scoring <=e.exam_passing_grade+(e.exam_point*0.2) ');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,'group by e.exam_name,p.papr_name,ue.exam_times ');
set @strsql=concat(@strsql,' union ');
set @strsql=concat(@strsql,' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times
,null range1
,null range2
,null range3
,null range4
,concat(e.exam_passing_grade+(e.exam_point*0.2),\'-\',e.exam_passing_grade+(e.exam_point*0.3)) range5
,null range6

,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');
set @strsql=concat(@strsql,',c.desc_cn exam_category');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;
set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where e.exam_passing_grade+(e.exam_point*0.2)<=ue.user_exam_scoring
and ue.user_exam_scoring <=e.exam_passing_grade+(e.exam_point*0.3)');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,'group by e.exam_name,p.papr_name,ue.exam_times ');
set @strsql=concat(@strsql,' union ');
set @strsql=concat(@strsql,' select count(*) cnt,e.exam_name,p.papr_name,ue.exam_times
,null range1
,null range2
,null range3
,null range4
,null range5
,concat(e.exam_passing_grade+(e.exam_point*0.3),\'-\',e.exam_point) range6
,concat(round(count(*)/u_cnt.sum_cnt,2)*100,\'%\') rate');
set @strsql=concat(@strsql,',c.desc_cn exam_category');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,',g.group_name');
end if;
set @strsql=concat(@strsql,' from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id
join t_paper p on ue.papr_id=p.papr_id
join (
select distinct count(*) sum_cnt,
exam_id,papr_id,exam_times
from t_user_exam
group by exam_id,papr_id,exam_times
) u_cnt on u_cnt.exam_id=ue.exam_id and u_cnt.papr_id=ue.papr_id and u_cnt.exam_times=ue.exam_times ');
if par_exam_group_flg is not null then
    set @strsql=concat(@strsql,' join t_user_group ug on ug.user_id=ue.user_id join t_group g on g.group_id=ug.group_id ');
end if;
if par_exam_group_id is not null then
    set @strsql=concat(@strsql,' and g.group_id=','''',par_exam_group_id,'''');
end if;
set @strsql=concat(@strsql,' join t_common_cde c on c.c_cde=e.exam_category ');
set @strsql=concat(@strsql,' where e.exam_passing_grade+(e.exam_point*0.3)<=ue.user_exam_scoring
and ue.user_exam_scoring <=e.exam_point ');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' and e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' and e.exam_name like ','''',par_exam_name,'%''');
end if;
set @strsql=concat(@strsql,'group by e.exam_name,p.papr_name,ue.exam_times ');

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_export_analysis_user_scoring`;
CREATE PROCEDURE  `exam_export_analysis_user_scoring`(in par_exam_name varchar (200),in par_user_name varchar(20),
in par_group_flg tinyint(1),
in par_exam_category varchar (20),IN par_exam_group_id int(10),IN par_exam_group_pid int(10),
in par_exam_bgn_tm varchar (40),in par_exam_end_tm varchar (40))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
    
    if par_exam_group_id is not null and par_exam_group_pid is not null then

        insert into tmp_exam_analysis_user_scoring_tree(id,pid, level,position)
        values (par_exam_group_id,par_exam_group_pid,v_level,v_position);

        set v_row_count := row_count();
        while v_row_count != 0 do
            set @position := 0;
            insert into tmp_exam_analysis_user_scoring_tree(id,pid,level,position)
            select g.group_id,g.group_pid
            , v_level + 1
            , @position := @position+1
            from t_group g
            inner join tmp_exam_analysis_user_scoring_tree t  on g.group_pid = t.id     where t.level = v_level and g.group_id !='0' order by g.group_id;
            
            set v_row_count := row_count();
            set v_level := v_level + 1;
        end while;
    end if;

if par_group_flg !=0 then   
    set @strsql=concat('select (select count(*) from t_user_exam u,t_user_group ug where u.exam_id=x.exam_id
            and u.exam_times=x.exam_times and u.user_id=ug.user_id and ug.group_id=x.group_id and u.user_exam_scoring>x.user_exam_scoring)+1 pos');
else
    set @strsql=concat(' select (select count( distinct u.user_exam_scoring) from t_user_exam u where u.exam_id=x.exam_id and u.exam_times=x.exam_times
                                and u.user_exam_scoring>x.user_exam_scoring)+1 pos');
end if;

set @strsql=concat(@strsql,', x.* from (');
set @strsql=concat(@strsql,'select e.exam_name,e.exam_begin_tm,e.exam_end_tm,e.exam_id,cde.desc_cn exam_category,gp.group_name,gp.group_id,u.real_name,u.user_id,y.exam_times,
               t1.papr_id,case when e.exam_all_person =1 then e.exam_user_count -1 else e.exam_user_count end exam_user_count,t1.exam_real_user_count,y.user_exam_scoring,
               case when e.exam_passing_grade <=y.user_exam_scoring then \'1\' else \'0\' end exam_status,',par_group_flg ,' group_flg
          from t_exam e
          join (select e2.exam_id, g.group_id,e2.user_id,e2.user_exam_scoring,e2.exam_times
                 from t_user_exam e2 join t_user_group g on g.user_id = e2.user_id ');
                 
if par_exam_group_id is not null then
        set @strsql=concat(@strsql,' join tmp_exam_analysis_user_scoring_tree t on t.id=g.group_id ');
end if;

set @strsql=concat(@strsql,' ) y on e.exam_id=y.exam_id ');
set @strsql=concat(@strsql,' left join (select count(*) exam_real_user_count, ue.exam_id,ue.exam_times,ue.papr_id from t_user_exam ue');
set @strsql=concat(@strsql,' group by ue.exam_id,ue.exam_times) t1 on t1.exam_id = y.exam_id and t1.exam_times=y.exam_times ');
set @strsql=concat(@strsql,' join t_common_cde cde on cde.c_cde = e.exam_category join t_group gp on gp.group_id = y.group_id ');
set @strsql=concat(@strsql,' join t_user u on u.user_id=y.user_id ');

if par_user_name is not null then
        set @strsql=concat(@strsql,' and u.real_name like ','''',par_user_name,'%''');
end if;

set @strsql=concat(@strsql,' where ');
if par_exam_bgn_tm is not null and par_exam_end_tm is not null then
    set @strsql=concat(@strsql,' e.exam_begin_tm between ','''',par_exam_bgn_tm,'''',' and ','''',par_exam_end_tm,'''',' and ');
end if;
if par_exam_category is not null then
    set @strsql=concat(@strsql,' e.exam_category=','''',par_exam_category,'''',' and ');
end if;
if par_exam_name is not null then
    set @strsql=concat(@strsql,' e.exam_name like ','''',par_exam_name,'%''');
end if;
if par_exam_bgn_tm is null and par_exam_end_tm is null and par_exam_category is null and par_exam_name is null  then
    set @strsql=substr(@strsql,1,length(@strsql)-6);
else
    if par_exam_name is null then
            set @strsql=substr(@strsql,1,length(@strsql)-4);
    end if;
end if;
set @strsql=concat(@strsql,' group by y.exam_id,y.exam_times,y.user_id order by y.exam_id ,y.exam_times ,y.user_exam_scoring ) x');
if par_group_flg !=0 then
        set @strsql=concat(@strsql,' group by x.exam_id,x.exam_times,x.group_id,x.user_id desc');
end if;

prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_exam_analysis_user_scoring_tree;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_group_add`;
CREATE PROCEDURE  `exam_group_add`(IN par_value TEXT)
begin   
  set @strsql=concat('insert into t_exam_group(exam_id,group_id,group_pid,papr_id) values ',par_value);prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_group_delete`;
CREATE PROCEDURE  `exam_group_delete`(IN par_exam_id CHAR(32))
begin   
    
  set @strsql=concat('delete from t_exam_group where exam_id = ','''',par_exam_id,'''');
       
   prepare stmt from @strsql;  
   execute stmt;
   deallocate prepare stmt;    
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_marker_add`;
CREATE PROCEDURE  `exam_marker_add`(IN par_value TEXT)
begin  
                           
    set @mysql=concat('insert into t_exam_marker(exam_id,user_id) values',par_value);
    prepare stmt from @mysql;
    execute stmt;
    DEALLOCATE prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_marker_delete`;
CREATE PROCEDURE  `exam_marker_delete`(IN par_exam_id CHAR(32))
begin     
   set @strsql=concat('delete from t_exam_marker where exam_id = ','''',par_exam_id,'''');
       
   prepare stmt from @strsql;  
   execute stmt;
   deallocate prepare stmt;     

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_marker_delete_one`;
CREATE PROCEDURE  `exam_marker_delete_one`(IN par_exam_id CHAR(32),IN par_exam_marker int(10))
begin
   set @strsql=concat('delete from t_exam_marker where exam_id = ','''',par_exam_id,'''',' and user_id=',par_exam_marker);
   
   prepare stmt from @strsql;
   execute stmt;
   deallocate prepare stmt;

  select count(*) into @cnt from t_exam_marker where exam_id=par_exam_id;

  if @cnt =0 then
    update t_exam set exam_manual =0 where exam_id=par_exam_id;
  end if;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_mark_edit_data`;
CREATE PROCEDURE  `exam_mark_edit_data`(IN par_exam_id CHAR(32),IN par_user_id int(10))
BEGIN
select distinct p.papr_name,null exam_point,p.papr_id,null qsn_label_id,null qsn_label,null qsn_type,null desc_cn,null exam_times
from t_exam_papr e join t_paper p on p.papr_id=e.papr_id and e.exam_id=par_exam_id
join t_exam_marker m on m.exam_id=e.exam_id and m.user_id=par_user_id
union all
select distinct null papr_name,null exam_point,e.papr_id,
concat(t.qsn_type,'_',t.qsn_type_position) qsn_label_id,t.qsn_type_title qsn_label,null qsn_type,null desc_cn,null exam_times
from t_exam_papr e join t_papr_qsn_type t on t.papr_id=e.papr_id and e.exam_id=par_exam_id
join t_exam_marker m on m.exam_id=e.exam_id and m.user_id=par_user_id
union all
select distinct null papr_name,null exam_point,e.papr_id,null qsn_label_id,null qsn_label,c.qsn_type,cde.desc_cn,null exam_times
from t_exam_papr e join t_papr_content c on c.papr_id=e.papr_id and e.exam_id=par_exam_id
join t_common_cde cde on cde.c_cde=c.qsn_type
join t_exam_marker m on m.exam_id=e.exam_id and m.user_id=par_user_id
union all
select distinct null papr_name,null exam_point,null papr_id,null qsn_label_id,null qsn_label,null qsn_type,null desc_cn,u.exam_times
from t_exam e join t_user_exam u on e.exam_id=par_exam_id and e.exam_id=u.exam_id
join t_exam_marker m on m.exam_id=e.exam_id and m.user_id=par_user_id
union all
select distinct null papr_name,e.exam_point,null papr_id,null qsn_label_id,null qsn_label,null qsn_type,null desc_cn,null exam_times
from t_exam e
join t_exam_marker m on m.exam_id=e.exam_id and m.user_id=par_user_id and m.exam_id=par_exam_id;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_mark_search`;
CREATE PROCEDURE  `exam_mark_search`(IN par_exam_category CHAR(32),IN par_search_flg TINYINT,
IN par_user_id int(10), IN par_exam_begin_tm varchar(20), IN par_exam_end_tm varchar(20),
IN par_exam_name VARCHAR(1000),IN par_page_idx INTEGER(11), IN par_page_size INTEGER(11))
begin

  set @strsql=concat('select e.exam_id,e.exam_name,e.exam_begin_tm,e.exam_end_tm,e.exam_total_tm,
  c2.desc_cn exam_category,count(*) exam_users_count
  from t_exam e,t_common_cde c2,t_exam_marker m,t_user_exam u
    where e.exam_category=c2.c_cde and m.exam_id=e.exam_id and e.exam_id=u.exam_id and u.exam_times=1 and e.exam_status=','''','030301','''');
    if par_search_flg =1 then
        set @strsql=concat(@strsql,' and m.user_id =',par_user_id);
    elseif par_search_flg =2 then
        set @strsql=concat(@strsql,' and m.user_id in(select user_id
                                            from t_user_group ug where group_id in(select group_id from t_user_group
                                        where user_id=',par_user_id,'))');
    end if;

    if par_exam_category is not null then
        set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
    end if;

    if par_exam_begin_tm is not null and par_exam_begin_tm  is not null then
        set @strsql=concat(@strsql,' and e.exam_end_tm between ','''',par_exam_begin_tm,'''',' and ','''',par_exam_end_tm,'''');
    end if;

    if par_exam_name is not null then
        set @strsql=concat(@strsql,' and e.exam_name like ','''%',par_exam_name,'%''');
    end if;

    set @strsql=concat(@strsql,' group by e.exam_id,e.exam_name,e.exam_begin_tm,e.exam_end_tm,e.exam_total_tm,c2.desc_cn order by e.create_tm desc');

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
  
    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_paper_add`;
CREATE PROCEDURE  `exam_paper_add`(IN par_value TEXT, in par_exam_id CHAR(32),in par_exam_point_type VARCHAR(20))
begin             
    set @strsql=concat('insert into t_exam_papr(exam_id,papr_id) value ',par_value);
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
      
    select papr_id into @papr_id from t_exam_papr where exam_id=par_exam_id limit 1;          

    if par_exam_point_type ='030201' THEN
        select sum(x.q_point) into @papr_point  from (
        select (typ.qsn_point*b.cnt) q_point,typ.qsn_type,typ.qsn_type_position from t_papr_qsn_type typ left join (
        select count(*) cnt,c.qsn_type,c.qsn_type_position from  t_papr_content c where c.papr_id=@papr_id
        group by c.qsn_type,c.qsn_type_position) b on b.qsn_type=typ.qsn_type and b.qsn_type_position=typ.qsn_type_position  where typ.papr_id=@papr_id
        group by typ.qsn_type,typ.qsn_type_position) x;
    update t_exam set exam_point =@papr_point where exam_id=par_exam_id;
   
    ELSEIF par_exam_point_type ='030202' THEN
        select sum(q.qsn_point) into @papr_point from  t_papr_content c join t_question q on q.qsn_id=c.qsn_id where c.papr_id=@papr_id;        
        update t_exam set exam_point =@papr_point where exam_id=par_exam_id;
    end if;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_paper_delete`;
CREATE PROCEDURE  `exam_paper_delete`( in par_exam_id char(32))
begin             
          set @strsql=concat('delete from t_exam_papr where exam_id=','''',par_exam_id,'''');
          prepare stmt from @strsql;
          execute stmt;
          deallocate prepare stmt;   
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_papr_answer_clear`;
CREATE PROCEDURE  `exam_papr_answer_clear`()
begin       
   
   delete from t_exam_papr_answer  
   where exam_id in(select  exam_id from t_exam where  sysdate() > DATE_ADD((exam_end_tm),INTERVAL 24 HOUR)) ;

  
  
        
end

DROP PROCEDURE IF EXISTS `exam_papr_search`;
CREATE PROCEDURE  `exam_papr_search`(IN `par_papr_name` VARCHAR(200), IN `par_papr_status` VARCHAR(10), IN `par_papr_begin_point` INTEGER(10), IN `par_papr_end_point` INTEGER(10), IN `par_qsn_begin_count` INTEGER(10), IN `par_qsn_end_count` INTEGER(10), IN `par_papr_category` VARCHAR(10), IN `par_papr_des` VARCHAR(4000), IN `par_search_flg` TINYINT, IN `par_user_id` int(10), IN `par_page_idx` INTEGER(10), IN `par_page_size` INTEGER(10))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

  declare mysql text;

    set @strsql='';
    set @strsql=concat('select t.papr_id,t.papr_name,c3.desc_cn papr_type,c1.desc_cn papr_category,
                                c2.desc_cn papr_status,t.papr_point,t.papr_qsn_count
                        from t_paper t join t_common_cde c1 on t.papr_category=c1.c_cde
                            join t_common_cde c2 on t.papr_status=c2.c_cde
                            join t_common_cde c3 on t.papr_type=c3.c_cde ');

    if par_search_flg =1 then
      set @strsql=concat(@strsql,' where t.create_user_id =',par_user_id);
    elseif par_search_flg =2 then
    	select g.group_id,g.group_pid into @gid,@gpid
    	from t_admin_group_user ug join t_group g on g.group_id=ug.group_id
   	where ug.user_id=par_user_id;

      insert into tmp_exam_papr_group_tree(id,pid, level,position)
      values (@gid,@gpid,v_level,v_position);

      set v_row_count := row_count();

      while v_row_count != 0 do
          set @position := 0;
          insert into tmp_exam_papr_group_tree(id,pid,level,position)
          select g.group_id,g.group_pid,v_level + 1,@position := @position+1
          from t_group g inner join tmp_exam_papr_group_tree t on g.group_pid = t.id
          where t.level = v_level and g.group_id !='0' order by g.group_id;

          set v_row_count := row_count();
          set v_level := v_level + 1;
    end while;

        set @strsql=concat(@strsql,' where t.create_user_id in(select user_id
        from t_admin_group_user ag join (select distinct id,pid from tmp_exam_papr_group_tree) t1 on t1.id=ag.group_id)');
  else
    set @strsql=concat(@strsql,' where 1=1 ');
    end if;

    if par_papr_name is not null then
       set @strsql=concat(@strsql,' and t.papr_name like ','''%',par_papr_name,'%''');
    end if;

    if par_papr_status is not null then
        set @strsql=concat(@strsql,' and t.papr_status=','''',par_papr_status,'''');
    end if;

    if par_papr_begin_point is not null and par_papr_end_point is not null then
        set @strsql=concat(@strsql,' and t.papr_point between ',par_papr_begin_point,' and ',par_papr_end_point);
    end if;

    if par_qsn_begin_count is not null and par_qsn_end_count is not null then
        set @strsql=concat(@strsql,'  and t.papr_qsn_count between ',par_qsn_begin_count,' and ',par_qsn_end_count);
    end if;

    if par_papr_category is not null then
        set @strsql=concat(@strsql,' and t.papr_category=','''',par_papr_category,'''');
    end if;

    if par_papr_des is not null then
        set @strsql=concat(@strsql,' and t.papr_des like ','''%',par_papr_des,'%''');
    end if;

  set @strsql=concat(@strsql,' and exists(select * from t_papr_content pc where pc.papr_id=t.papr_id) ');
  set @strsql=concat(@strsql,' order by t.create_tm desc');

    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

  if par_search_flg =2 then
    truncate table tmp_exam_papr_group_tree;
  end if;
  
  
  
  
  
  
  
  
      
end

DROP PROCEDURE IF EXISTS `exam_papr_select_qsn_point`;
CREATE PROCEDURE  `exam_papr_select_qsn_point`(IN par_papr_id text)
begin
    
    set @strsql=concat('select p.papr_id,p.papr_name,sum(q.qsn_point) qpoint from t_papr_content c join t_paper p on p.papr_id=c.papr_id
    join t_question q on q.qsn_id=c.qsn_id and q.qsn_sub_id=c.qsn_sub_id where p.papr_id in ',par_papr_id,' group by p.papr_id,p.papr_name');
 
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt; 
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_point_update_on_question_update`;
CREATE PROCEDURE  `exam_point_update_on_question_update`(
  IN par_qsn_id CHAR(32),
  IN par_qsn_sub_id CHAR(32),
  IN par_qsn_point INT(3)
)
BEGIN 

DECLARE int_old_qsn_point INT(3);
DECLARE str_exam_ids TEXT;
DECLARE int_cnt INT(3);
DECLARE int_exam_point INT(10);


SELECT qsn_point INTO int_old_qsn_point
FROM t_question
WHERE qsn_id = par_qsn_id AND qsn_sub_id = par_qsn_sub_id;


SELECT GROUP_CONCAT(DISTINCT e.exam_id SEPARATOR '","') AS exam_ids INTO str_exam_ids
FROM t_papr_content AS pc
LEFT JOIN t_paper AS p ON pc.papr_id = p.papr_id
LEFT JOIN t_exam_papr AS ep ON p.papr_id = ep.papr_id
LEFT JOIN t_exam AS e ON ep.exam_id = e.exam_id
WHERE
  pc.qsn_id = par_qsn_id AND
  pc.qsn_sub_id = par_qsn_sub_id AND
  NOT EXISTS(SELECT exam_id FROM t_user_exam_answer AS uea WHERE uea.exam_id=e.exam_id AND uea.qsn_id=par_qsn_id AND uea.qsn_sub_id=par_qsn_sub_id)
GROUP BY pc.qsn_id, pc.qsn_sub_id;

IF str_exam_ids IS NOT NULL THEN
  SET str_exam_ids = CONCAT('"', str_exam_ids, '"');
ELSE
  SET str_exam_ids = CONCAT('""');
END IF;


SET @strsql = CONCAT('UPDATE t_exam
SET exam_point = IF(exam_point - ', int_old_qsn_point, ' + ', par_qsn_point, ' <= 0, 0, exam_point - ', int_old_qsn_point, ' + ', par_qsn_point, ')',
' WHERE exam_id IN (', str_exam_ids, ') AND exam_point_type="030202"');


prepare stmt from @strsql;
execute stmt;
deallocate prepare stmt;


end

DROP PROCEDURE IF EXISTS `exam_purview_judge`;
CREATE PROCEDURE  `exam_purview_judge`(IN par_user_id int(10),in par_exam_id char(32))
begin

  set @strsql_1=concat('select exam_all_person,exam_end_tm,exam_begin_tm,exam_times,exam_user_signup_flg
                      into @person,@end_tm,@begin_tm,@tims,@signup from t_exam e where e.exam_id =','''',par_exam_id,'''');

  set @strsql_2=concat('select count(*),exam_total_tm into @cnt,@exam_total_tm from t_user_exam_storage
                      where user_id=','''',par_user_id,'''',' and exam_id=','''',par_exam_id,'''');

  prepare stmt1 from @strsql_1;
  prepare stmt2 from @strsql_2;
  execute stmt1;
  execute stmt2;
  deallocate prepare stmt1;
  deallocate prepare stmt2;

  if @signup =1 then
    select verify_status into @v_stu  from t_exam_user_signup e where e.exam_id =par_exam_id and e.user_id=par_user_id;
  end if;
  
   if @person =0 then       
        if @v_stu != '070201' then               
           set @mysql='select 1 nouser from dual';  
        else 
           select count(*) into @id  from t_exam_group e join t_user_group g on e.group_id=g.group_id  where e.exam_id =par_exam_id and g.user_id=par_user_id;
           if  @v_stu='070201' then
            set @id=1;
           end if;
        end if;
            
            if  @id is null or @id =0 then
              
                set @mysql='select 1 nouser from dual';
            else
              if sysdate() <=@end_tm and sysdate() >= @begin_tm  then
                       select max(exam_times) into @mytimes from t_user_exam ue where ue.exam_id=par_exam_id  and ue.user_id=par_user_id ;
                       if @mytimes is null then
                          set @mytimes=0;
                       end if;

                       if @tims is null then
                           if @mytimes =0 then
                             if @cnt =0 then
                               set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,null exam_remaining_tm,e.exam_mode,e.exam_point_type,e.exam_point,0 exam_times,date_format(e.create_tm,','''','%y-%m-%d','''',') create_tm,e.exam_allow_ip  
                               from t_exam e  left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                               join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\'');
                               
                                if @signup !=1 then
                                    set @mysql=concat(' join t_exam_group g on g.exam_id=epapr.exam_id and epapr.papr_id=g.papr_id 
                                                                    where not exists(select papr_id from  t_exam_exclude_user exd where
                                                              exd.user_id =','''',par_user_id,'''',' and exd.exam_id=','''',par_exam_id,'''',') 
                                                              and e.exam_id=','''',par_exam_id,'''');   
                                else 
                                    set @mysql=concat(@mysql,' where e.exam_id=','''',par_exam_id,'''');                                
                                end if;
                                
                             else
                               set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,exam_total_tm*60-time_to_sec(','''',@exam_total_tm,'''',') exam_remaining_tm,e.exam_mode,e.exam_point_type,e.exam_point,0 exam_times,date_format(e.create_tm,','''','%y-%m-%d','''',') create_tm,e.exam_allow_ip  
                               from t_exam e  left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                               join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\'');
                               
                                if @signup !=1 then
                                    set @mysql=concat(' join t_exam_group g on g.exam_id=epapr.exam_id and epapr.papr_id=g.papr_id where not exists(select papr_id from  t_exam_exclude_user exd where
                                                              exd.user_id =','''',par_user_id,'''',' and exd.exam_id=','''',par_exam_id,'''',') 
                                                              and e.exam_id=','''',par_exam_id,'''');   
                                else 
                                    set @mysql=concat(@mysql,' where e.exam_id=','''',par_exam_id,'''');                                
                                end if;
                                
                             end if;
                           else
                             if @cnt = 0 then
                               set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,null exam_remaining_tm,e.exam_mode,e.exam_point_type,e.exam_point,',@mytimes,' exam_times,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip  
                               from t_exam e  left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                               join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\'');
                               
                               if @signup !=1 then
                                    set @mysql=concat(' join t_exam_group g on g.exam_id=epapr.exam_id and epapr.papr_id=g.papr_id where not exists(select papr_id from  t_exam_exclude_user exd where
                                                              exd.user_id =','''',par_user_id,'''',' and exd.exam_id=','''',par_exam_id,'''',') 
                                                              and e.exam_id=','''',par_exam_id,'''');   
                                else 
                                    set @mysql=concat(@mysql,' where e.exam_id=','''',par_exam_id,'''');                                
                                end if;
                                
                             else
                               set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,exam_total_tm*60-time_to_sec(','''',@exam_total_tm,'''',') exam_remaining_tm,e.exam_mode,e.exam_point_type,e.exam_point,',@mytimes,' exam_times,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip  
                               from t_exam e  left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                               join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\'');
                               
                                if @signup !=1 then
                                    set @mysql=concat(' join t_exam_group g on g.exam_id=epapr.exam_id and epapr.papr_id=g.papr_id where not exists(select papr_id from  t_exam_exclude_user exd where
                                                              exd.user_id =','''',par_user_id,'''',' and exd.exam_id=','''',par_exam_id,'''',') 
                                                              and e.exam_id=','''',par_exam_id,'''');   
                                else 
                                    set @mysql=concat(@mysql,' where e.exam_id=','''',par_exam_id,'''');                                
                                end if; 
                             end if;
                           end if;
                           if @signup !=1 then
                                set @mysql=concat(@mysql,'and exists(select group_id from
                                 t_user_group ug where ug.group_id=g.group_id and ug.user_id=',par_user_id,')');
                            end if;
                       else
                            if @tims > @mytimes then
                              if @mytimes =0 then
                                if @cnt = 0 then
                                  set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,null exam_remaining_tm,0 exam_times,e.exam_mode,e.exam_point_type,e.exam_point,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip  
                                  from t_exam e  left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                                  join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\''); 
                                     if @signup !=1 then
                                        set @mysql=concat(' join t_exam_group g on g.exam_id=epapr.exam_id and epapr.papr_id=g.papr_id where not exists(select papr_id from  t_exam_exclude_user exd where
                                                                  exd.user_id =','''',par_user_id,'''',' and exd.exam_id=','''',par_exam_id,'''',') 
                                                                  and e.exam_id=','''',par_exam_id,'''');   
                                    else 
                                        set @mysql=concat(@mysql,' where e.exam_id=','''',par_exam_id,'''');                                
                                    end if;
                                else
                                  set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,exam_total_tm*60-time_to_sec(','''',@exam_total_tm,'''',') exam_remaining_tm,0 exam_times,e.exam_mode,e.exam_point_type,e.exam_point,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip  
                                  from t_exam e  left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                                  join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\'');
                                    if @signup !=1 then
                                        set @mysql=concat(' join t_exam_group g on g.exam_id=epapr.exam_id and epapr.papr_id=g.papr_id where not exists(select papr_id from  t_exam_exclude_user exd where
                                                                  exd.user_id =','''',par_user_id,'''',' and exd.exam_id=','''',par_exam_id,'''',') 
                                                                  and e.exam_id=','''',par_exam_id,'''');   
                                    else 
                                        set @mysql=concat(@mysql,' where e.exam_id=','''',par_exam_id,'''');                                
                                    end if;
                                end if;
                              else
                                if @cnt = 0 then
                                  set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,null exam_remaining_tm,',@mytimes,' exam_times,e.exam_mode,e.exam_point_type,e.exam_point,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip  
                                  from t_exam e  left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                                  join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\'');
                                    if @signup !=1 then
                                        set @mysql=concat(' join t_exam_group g on g.exam_id=epapr.exam_id and epapr.papr_id=g.papr_id where not exists(select papr_id from  t_exam_exclude_user exd where
                                                                  exd.user_id =','''',par_user_id,'''',' and exd.exam_id=','''',par_exam_id,'''',') 
                                                                  and e.exam_id=','''',par_exam_id,'''');   
                                    else 
                                        set @mysql=concat(@mysql,' where e.exam_id=','''',par_exam_id,'''');                                
                                    end if;                                                              
                                else
                                  set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,exam_total_tm*60-time_to_sec(','''',@exam_total_tm,'''',') exam_remaining_tm,',@mytimes,' exam_times,e.exam_mode,e.exam_point_type,e.exam_point,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip  
                                  from t_exam e  left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                                  join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\'');
                                    if @signup !=1 then
                                        set @mysql=concat(' join t_exam_group g on g.exam_id=epapr.exam_id and epapr.papr_id=g.papr_id where not exists(select papr_id from  t_exam_exclude_user exd where
                                                                  exd.user_id =','''',par_user_id,'''',' and exd.exam_id=','''',par_exam_id,'''',') 
                                                                  and e.exam_id=','''',par_exam_id,'''');   
                                    else 
                                        set @mysql=concat(@mysql,' where e.exam_id=','''',par_exam_id,'''');                                
                                    end if;                                   
                                  
                                end if;
                              end if;
                                if @signup !=1 then
                                    set @mysql=concat(@mysql,'and exists(select group_id from
                                 t_user_group ug where ug.group_id=g.group_id and ug.user_id=',par_user_id,')');
                                end if;
                            else
                              set @mysql='select @tims maxtimes from dual';
                            end if;
                      end if;
                    else
                      if sysdate()<@begin_tm then
                          set @mysql='select @begin_tm nobegin from dual';
                      else
                        if sysdate() >@end_tm then
                          set @mysql='select @end_tm theend from dual';
                        end if;
                      end if;
                   end if;
            end if;     
    else
          if sysdate()<= @end_tm and sysdate() >=@begin_tm  then
                select max(exam_times) into @mytimes from t_user_exam ue where ue.exam_id=par_exam_id  and ue.user_id=par_user_id ;
                      if @mytimes is null then
                        set @mytimes=0;
                      end if;
                      if @tims is null then
                        if @mytimes =0 then
                          if @cnt = 0 then
                            set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,null exam_remaining_tm,e.exam_mode,e.exam_point_type,e.exam_point,0 exam_times,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip 
                            from t_exam e left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                            join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\' where  e.exam_id=','''',par_exam_id,'''');
                          else
                            set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,exam_total_tm*60-time_to_sec(','''',@exam_total_tm,'''',') exam_remaining_tm,e.exam_mode,e.exam_point_type,e.exam_point,0 exam_times,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip 
                            from t_exam e left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                            join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\' where  e.exam_id=','''',par_exam_id,'''');
                          end if;
                        else
                          if @cnt = 0 then
                            set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,null exam_remaining_tm,e.exam_mode,e.exam_point_type,e.exam_point,',@mytimes,' exam_times,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip 
                            from t_exam e left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                            join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\' where  e.exam_id=','''',par_exam_id,'''');
                          else
                            set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,exam_total_tm*60-time_to_sec(','''',@exam_total_tm,'''',') exam_remaining_tm,e.exam_mode,e.exam_point_type,e.exam_point,',@mytimes,' exam_times,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip 
                            from t_exam e left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                            join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\' where  e.exam_id=','''',par_exam_id,'''');
                          end if;
                        end if;
                      else
                        if @tims > @mytimes then
                          if @mytimes =0 then
                            if @cnt = 0 then
                              set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,null exam_remaining_tm,0 exam_times,e.exam_mode,e.exam_point_type,e.exam_point,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip 
                              from t_exam e left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                              join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\' where  e.exam_id=','''',par_exam_id,'''');
                            else
                              set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,exam_total_tm*60-time_to_sec(','''',@exam_total_tm,'''',') exam_remaining_tm,0 exam_times,e.exam_mode,e.exam_point_type,e.exam_point,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip 
                              from t_exam e left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                              join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\' where  e.exam_id=','''',par_exam_id,'''');
                            end if;
                          else
                            if @cnt = 0 then
                              set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,null exam_remaining_tm,',@mytimes,' exam_times,e.exam_mode,e.exam_point_type,e.exam_point,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip 
                              from t_exam e left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                              join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\' where  e.exam_id=','''',par_exam_id,'''');
                            else
                              set @mysql=concat('select e.exam_id,e.exam_begin_tm,e.exam_end_tm,e.exam_time_consistency_flg,e.exam_disable_monitor_flg,exam_recovery_flg,exam_recovery_time,epapr.papr_id,e.exam_total_tm,exam_total_tm*60-time_to_sec(','''',@exam_total_tm,'''',') exam_remaining_tm,',@mytimes,' exam_times,e.exam_mode,e.exam_point_type,e.exam_point,date_format(e.create_tm,','''','%y-%m-%d','''',')create_tm,e.exam_allow_ip 
                              from t_exam e left join t_exam_papr epapr on e.exam_id=epapr.exam_id 
                              join t_paper p on p.papr_id=epapr.papr_id and p.papr_status=\'020101\' where  e.exam_id=','''',par_exam_id,'''');
                            end if;
                          end if;
                        else
                          set @mysql='select @tims maxtimes from dual';
                        end if;
                    end if;
          else
            if sysdate()<@begin_tm then
              set @mysql='select @begin_tm nobegin from dual';
            else
              if sysdate() >@end_tm then
                set @mysql='select @end_tm theend from dual';
              end if;
            end if;
          end if;
    end if;

  prepare stmt from @mysql;
  execute stmt;
  deallocate prepare stmt;

        
end

DROP PROCEDURE IF EXISTS `exam_search`;
CREATE PROCEDURE  `exam_search`(IN par_exam_category varchar(20), IN par_exam_begin_tm varchar(20),
IN par_exam_end_tm varchar(20), IN par_exam_name VARCHAR(1000), in par_exam_status VARCHAR(20),
IN par_search_flg TINYINT,IN par_user_id int(10),
IN par_page_idx INTEGER(11), IN par_page_size INTEGER(11))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;

  set @strsql='select e.exam_id,e.exam_name,c3.desc_cn exam_status,e.exam_point,e.exam_begin_tm,
    e.exam_end_tm,e.exam_total_tm,c2.desc_cn exam_category
    from t_exam e join t_common_cde c2 on e.exam_category=c2.c_cde
    join t_common_cde c3 on e.exam_status=c3.c_cde
    join t_user uu on e.create_user_id=uu.user_id ';

  if par_search_flg =1 then
    set @strsql=concat(@strsql,' where e.create_user_id =',par_user_id);
  elseif par_search_flg =2 then
    select g.group_id,g.group_pid into @gid,@gpid
    from t_admin_group_user ug join t_group g on g.group_id=ug.group_id
    where ug.user_id=par_user_id;

    insert into tmp_exam_group_tree(id,pid, level,position)
    values (@gid,@gpid,v_level,v_position);

    set v_row_count := row_count();

    while v_row_count != 0 do
          set @position := 0;
          insert into tmp_exam_group_tree(id,pid,level,position)
          select g.group_id,g.group_pid,v_level + 1,@position := @position+1
          from t_group g inner join tmp_exam_group_tree t on g.group_pid = t.id
          where t.level = v_level and g.group_id !='0' order by g.group_id;

          set v_row_count := row_count();
          set v_level := v_level + 1;
    end while;

    set @strsql=concat(@strsql,' where e.create_user_id in(select user_id
        from t_admin_group_user ag join (select distinct id,pid from tmp_exam_group_tree) t1 on t1.id=ag.group_id)');
  else
    set @strsql=concat(@strsql,' where 1=1 ');
  end if;

    if par_exam_category is not null then
        set @strsql=concat(@strsql,' and e.exam_category=','''',par_exam_category,'''');
    end if;
    if par_exam_begin_tm is not null and par_exam_begin_tm  is not null then
        set @strsql=concat(@strsql,' and e.exam_end_tm between ','''',par_exam_begin_tm,'''',' and ','''',par_exam_end_tm,'''');
    end if;
    if par_exam_name is not null then
        set @strsql=concat(@strsql,' and e.exam_name like ','''%',par_exam_name,'%''');
    end if;
    if par_exam_status is not null then
        set @strsql=concat(@strsql,' and e.exam_status= ','''',par_exam_status,'''');
    end if;
    set @strsql=concat(@strsql,' order by e.create_tm desc');
    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
  
    prepare stmt from @mysql;
    execute stmt;
    deallocate prepare stmt;

  if par_search_flg =2 then
     truncate table tmp_exam_group_tree;
  end if;

  
  
  
  
  
  
  
      
end

DROP PROCEDURE IF EXISTS `exam_search_user_signup`;
CREATE PROCEDURE  `exam_search_user_signup`(IN `par_exam_name` VARCHAR(1000), IN `par_username` VARCHAR(50), IN `par_real_name` VARCHAR(100), IN `par_exam_category` VARCHAR(20), IN `par_verify_status` VARCHAR(20), IN `par_signup_begin_date` VARCHAR(50), IN `par_signup_end_date` VARCHAR(50), IN `par_page_idx` INT, IN `par_page_size` INT)
BEGIN
	set @strsql='select c1.desc_cn verify_status,s.verify_tm,e.exam_name,u.real_name,
              u.username,u1.real_name verify_real_name,u1.username verify_username,s.signup_tm,s.user_id,s.exam_id
							from t_exam_user_signup s
              join  t_exam e on e.exam_id=s.exam_id
							join t_common_cde c1 on s.verify_status=c1.c_cde
							join t_user u on u.user_id=s.user_id
							left join t_user u1 on u1.user_id=s.verify_user_id where 1=1 ';

  if par_exam_name is not null then
		set @strsql=concat(@strsql,' and e.exam_name like ','''%',par_exam_name,'%''');
	end if;

	if par_username is not null then
		set @strsql=concat(@strsql,' and u.username like ','''%',par_username,'%''');
	end if;

	if par_real_name is not null then
		set @strsql=concat(@strsql,' and u.real_name like ','''%',par_real_name,'%''');
	end if;

	if par_exam_category is not null then
		set @strsql=concat(@strsql,' and e.exam_category= ','''',par_exam_category,'''');
	end if;

	if par_verify_status is not null then
		set @strsql=concat(@strsql,' and s.verify_status =','''',par_exam_category,'''');
	end if;

	if par_signup_begin_date is not null and par_signup_end_date is not null then
		set @strsql=concat(@strsql,' and s.signup_tm between ',par_signup_begin_date,' and ',par_signup_end_date);
	end if;

	call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);

  prepare stmt from @mysql;
  execute stmt;
  deallocate prepare stmt;
	
      
end

DROP PROCEDURE IF EXISTS `exam_select_exam_answer`;
CREATE PROCEDURE  `exam_select_exam_answer`(IN par_exam_id CHAR(32),IN par_papr_id CHAR(32))
begin

    set @strsql=concat('select exam_id, papr_id, qsn_id, qsn_sub_id, qsn_item_id,qsn_item_count, qsn_type, qsn_type_position, qsn_position, qsn_point, qsn_answer
									      from t_exam_papr_answer where exam_id= ','''',par_exam_id,'''',' and papr_id=','''',par_papr_id,'''');

    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  
  
        
end

DROP PROCEDURE IF EXISTS `exam_select_exam_info`;
CREATE PROCEDURE  `exam_select_exam_info`(in par_exam_id char(32))
begin

set @strsql=concat('select e.exam_id,e.exam_category exam_category_id,e.exam_time_consistency_flg,c.desc_cn exam_category_name,e.exam_name,e.exam_notice,
    e.exam_begin_tm,e.exam_end_tm,e.exam_total_tm,e.exam_mode,e.exam_times,e.exam_point_type,
    e.exam_point,e.exam_passing_grade,e.exam_blank_flg,e.exam_cloze_flg,e.exam_publish_score_flg,e.exam_publish_answer_flg,e.exam_publish_result_flg,
    e.exam_manual,e.exam_publish_result_tm,e.exam_all_person,e.exam_user_count,
    e.exam_full_screen_flg,e.exam_mouse_right_flg,e.exam_disable_paste_flg,
    e.exam_submit_display_result,e.exam_ie_only_flg,e.exam_disable_monitor_flg,
    e.exam_paper_only_one_flg,e.exam_passing_again_flg,e.exam_qsn_random_flg,
    e.exam_recovery_flg,e.exam_recovery_time,e.exam_allow_ip
    from t_exam e left join t_common_cde c on e.exam_category=c.c_cde
    where e.exam_id=','''',par_exam_id,'''');
   
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;
    
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_select_mark_info`;
CREATE PROCEDURE  `exam_select_mark_info`(
IN par_exam_id CHAR(32),IN par_papr_id CHAR(32),IN par_exam_times INTEGER(10),
IN par_qsn_label_type VARCHAR(20),IN par_qsn_label_position INTEGER(10), IN par_qsn_type VARCHAR(20),
IN par_qsn_answer VARCHAR(4000),IN par_qsn_content VARCHAR(4000))
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
  declare v_point_type varchar(20);

  set @mysql2='';
  select exam_point_type,exam_point into @v_point_type,@exam_point from t_exam e where e.exam_id=par_exam_id;

if @v_point_type='030202' then
    set @mysql2=concat(@mysql2,' left join (select q.qsn_id,q.qsn_sub_id,q.qsn_point from (select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_point
                           from tmp_exam_select_mark_info_tree t, t_question r, t_qsn_sub_position s
                          where t.pid = r.qsn_id and t.id = r.qsn_sub_id and r.qsn_id = s.qsn_id and r.qsn_sub_id = s.qsn_sub_id) q');

    set @mysql2=concat(@mysql2,' left join (select c.qsn_type_position, c.papr_id, c.qsn_sub_id from tmp_exam_select_mark_info_tree t  join t_papr_content c on t.id = c.qsn_id');

    if par_papr_id is not null then
        set @mysql2=concat(@mysql2,' where c.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql2=concat(@mysql2,' ) cc on q.qsn_id =cc.qsn_sub_id');
    set @mysql2=concat(@mysql2,' union select r.qsn_id,r.qsn_sub_id,r.qsn_point
                        from t_papr_content t, t_question r where t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id ');
    if par_papr_id is not null then
        set @mysql2=concat(@mysql2,' and t.papr_id=','''',par_papr_id,'''');
    end if;
    set @mysql2=concat(@mysql2,') r on r.qsn_id=x.qsn_id and r.qsn_sub_id=x.qsn_sub_id');
elseif @v_point_type='030201' then
set @mysql2=concat(@mysql2,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_exam_select_mark_info_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_exam_select_mark_info_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

union
select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
from (
select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_exam_select_mark_info_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_exam_select_mark_info_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
)p7 join tmp_exam_select_mark_info_tree p8 on p8.id=p7.qsn_id
group by p8.pid,p8.id
union
select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
(
select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(p1.qsn_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_exam_select_mark_info_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_exam_select_mark_info_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
) pp
join tmp_exam_select_mark_info_tree p3  on p3.pid=pp.qsn_sub_id
join (
select s.qsn_id,count(*) cnt from tmp_exam_select_mark_info_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid

             union
            select r.qsn_id, r.qsn_sub_id, p.qsn_point
   from t_papr_content t
   join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
   join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
   where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') r on r.qsn_id=x.qsn_id and r.qsn_sub_id=x.qsn_sub_id');
   
elseif @v_point_type='030203' then
    select a.papr_qsn_count into @qsn_count
    from t_exam e join t_exam_papr p on e.exam_id=p.exam_id and e.exam_id=par_exam_id
    join t_paper a on a.papr_id=p.papr_id;

    set @q_point=round(@exam_point/@qsn_count,2);

set @mysql2=concat(@mysql2,' left join (select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_exam_select_mark_info_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_exam_select_mark_info_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id

union
select p8.pid qsn_id,p8.id qsn_sub_id,sum(p7.qsn_point) qsn_point
from (
select p6.qsn_sub_id,p6.qsn_id,p5.qsn_point
from (
select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_exam_select_mark_info_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_exam_select_mark_info_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
)p7 join tmp_exam_select_mark_info_tree p8 on p8.id=p7.qsn_id
group by p8.pid,p8.id
union
select p3.pid qsn_id,p3.id qsn_sub_id,round(pp.qsn_point/p4.cnt,2) qsn_point from
(
select p6.qsn_id,p6.qsn_sub_id,p5.qsn_point
from (
select  round(@q_point/p4.cnt,2) qsn_point,p3.id qsn_sub_id,p3.pid qsn_id
from t_papr_qsn_type p1
join t_papr_content p2 on p2.papr_id=p1.papr_id and p2.qsn_type_position=p1.qsn_type_position
and p1.papr_id=','''',par_papr_id,'''','
join tmp_exam_select_mark_info_tree p3  on p3.id=p2.qsn_sub_id and p3.pid=p2.qsn_id
join (
select s.qsn_id,count(*) cnt from tmp_exam_select_mark_info_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id  group by s.qsn_id) p4 on p4.qsn_id=p3.id
) p5 join t_question p6 on p5.qsn_sub_id=p6.qsn_id
) pp
join tmp_exam_select_mark_info_tree p3  on p3.pid=pp.qsn_sub_id
join (
select s.qsn_id,count(*) cnt from tmp_exam_select_mark_info_tree t,t_qsn_sub_position s
    where t.pid = s.qsn_id  and t.id = s.qsn_sub_id and t.level=\'3\' group by s.qsn_id) p4 on p4.qsn_id=p3.pid
             union
            select r.qsn_id, r.qsn_sub_id, @q_point
   from t_papr_content t
   join t_papr_qsn_type p on t.papr_id=p.papr_id and t.qsn_type_position=p.qsn_type_position
   join t_question r on t.qsn_id = r.qsn_id and t.qsn_sub_id = r.qsn_sub_id
   where t.papr_id = ','''',par_papr_id,'''',' and t.qsn_sub_id=\'0\'',') r on r.qsn_id=x.qsn_id and r.qsn_sub_id=x.qsn_sub_id');

end if;
    
    insert into tmp_exam_select_mark_info_tree(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id;

    set v_row_count := row_count();

    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_exam_select_mark_info_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_exam_select_mark_info_tree t on q.qsn_id = t.id
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;
   
set @mysql='';
set @mysql=concat(@mysql,'select 
       x.qsn_id,
       x.qsn_sub_id,
       r.qsn_point,
       x.qsn_content,
       x.qsn_guide,
       x.option_content,
       x.qsn_item_tag,
       x.qsn_item_id,
       x.qsn_item_sub_id,
       x.qsn_type,
       x.qsn_type_title,
       x.qsn_type_label,
       x.qsn_type_position,
       x.pos,
       x.create_tm,
       x.sub_qsn_flg         
  from (
  select
tp.papr_name,tp.papr_des,
               tp.papr_status,
               tp.exam_point,
               tp.exam_total_tm,
               tp.papr_qsn_count,
               tp.qsn_id,
               tp.qsn_sub_id,
               tp.qsn_content,
               tp.qsn_guide,
               tp.option_content,
               tp.qsn_item_tag,
               tp.qsn_item_id,
               tp.qsn_item_sub_id,
               tp.qsn_type,
               tp.qsn_type_title,
               tp.qsn_type_label,
               tp.qsn_type_position,
               tp.pos,
               tp.create_tm,
           NULL sub_qsn_flg from (
select t.papr_name,t.papr_des,
               t.papr_status,
               e.exam_point,
               e.exam_total_tm,
               t.papr_qsn_count,
               q.qsn_id,
               q.qsn_sub_id,
               q.qsn_content,
               q.qsn_guide,
               o.option_content,
               o.qsn_item_tag,
               case
                 when o.qsn_item_id is null then
                  1
                 else
                  o.qsn_item_id
               end qsn_item_id,
               o.qsn_item_sub_id,
               p.qsn_type,
               p.qsn_type_title,p.qsn_type_label,');
              set @mysql= concat(@mysql,'concat(p.qsn_type_position,\'-\',q.qsn_sub_id)');
              set @mysql=concat(@mysql,' qsn_type_position,
               p.qsn_type_position pos,
               q.create_tm
          from t_paper t
          join t_exam_papr ep on ep.papr_id=t.papr_id
          join t_exam e on e.exam_id=ep.exam_id and
          e.exam_id=','''',par_exam_id,'''','
          join t_papr_qsn_type p on t.papr_id = p.papr_id
          join t_papr_content c on p.papr_id = c.papr_id
                               and p.qsn_type = c.qsn_type
                               and c.qsn_type_position = p.qsn_type_position
          join t_question q on c.qsn_id = q.qsn_id
                           and c.qsn_sub_id = q.qsn_sub_id
          left join t_option o on o.qsn_id = q.qsn_id and o.qsn_sub_id=q.qsn_sub_id and o.qsn_type=q.qsn_type
          where t.papr_id=','''',par_papr_id,'''','
           ) tp  ');
          set @mysql=concat(@mysql,' union
        select y.papr_name,y.papr_des,
               y.papr_status,
               y.exam_point,
               y.exam_total_tm,
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.qsn_guide,
               y.option_content,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,y.qsn_type_label,');
          set @mysql= concat(@mysql,'concat(y.qsn_type_position,\'-\',y.qsn_id,\'-\',y.qsn_position) qsn_type_position,');
          set @mysql=concat(@mysql,'y.qsn_type_position pos,
               y.create_tm
               ,y.flg sub_qsn_flg
               from (select null papr_name,null papr_des,
                       null papr_status,
                       null exam_point,
                       null exam_total_tm,
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       o.option_content,
                       o.qsn_item_tag,
                       case
                         when o.qsn_item_id is null then
                          1
                         else
                          o.qsn_item_id
                       end qsn_item_id,
                       o.qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm
                    ,sp.flg
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_guide,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_exam_select_mark_info_tree t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id) q
                  left join (select c.qsn_type_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_exam_select_mark_info_tree t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                  left join t_option o on q.qsn_id = o.qsn_id and q.qsn_sub_id=o.qsn_sub_id and o.qsn_type=q.qsn_type
                left join (select distinct t1.qsn_id
            , case when t1.qsn_id is not null then 1 else 0 end flg from t_qsn_sub_position t1
            join tmp_exam_select_mark_info_tree t2 on t2.id=t1.qsn_id
             ) sp on sp.qsn_id=q.qsn_sub_id and q.qsn_type in(\'010105\',\'010106\')
                 where cc.qsn_type_position is not null) y');
    set @mysql=concat(@mysql,'  union
        select y.papr_name,y.papr_des,
               y.papr_status,
               y.exam_point,
               y.exam_total_tm,
               y.papr_qsn_count,
               y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
               y.qsn_guide,
               y.option_content,
               y.qsn_item_tag,
               y.qsn_item_id,
               y.qsn_item_sub_id,
               y.qsn_type,
               y.qsn_type_title,y.qsn_type_label,
               tm.qsn_type_position,
               tm.pos,
               y.create_tm
               ,NULL sub_qsn_flg
          from (select null papr_name,null papr_des,
                       null papr_status,
                       null exam_point,
                       null exam_total_tm,
                       null papr_qsn_count,
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                       q.qsn_guide,
                       null option_content,
                       null qsn_item_tag,
                       null qsn_item_id,
                       null qsn_item_sub_id,
                       q.qsn_type,
                       null qsn_type_title,null qsn_type_label,
                       cc.qsn_type_position,
                       q.qsn_position,
                       q.create_tm                       
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               t.id,
                               r.qsn_content,
                               r.qsn_guide,
                               r.qsn_type,
                               s.qsn_position,
                               r.create_tm
                          from tmp_exam_select_mark_info_tree t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                           and not exists(select o.qsn_id from t_option o where o.qsn_id=t.pid and o.qsn_sub_id=t.id and o.qsn_type=r.qsn_type)
                           ) q
                  left join (select c.qsn_type_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_exam_select_mark_info_tree t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =cc.qsn_sub_id) y,');
        set @mysql=concat(@mysql,'(
               select n.qsn_sub_id,
                       concat(c1.qsn_type_position,
                              \'-\',
                              q1.qsn_id,
                              \'-\',
                              s1.qsn_position,
                              \'-\',
                              s2.qsn_position) as qsn_type_position,
                       c1.qsn_type_position pos,
                       q1.create_tm
                  from t_question q1
                  join (select q.qsn_id, q.qsn_sub_id
                         from (select r.qsn_id,
                                      r.qsn_sub_id,
                                      t.id,
                                      r.qsn_content,
                                      r.qsn_type,
                                      s.qsn_position
                                 from tmp_exam_select_mark_info_tree          t,
                                      t_question         r,
                                      t_qsn_sub_position s
                                where t.pid = r.qsn_id
                                  and t.id = r.qsn_sub_id
                                  and r.qsn_id = s.qsn_id
                                  and r.qsn_sub_id = s.qsn_sub_id) q
                         left join (select c.qsn_type_position,
                                          c.papr_id,
                                          c.qsn_sub_id
                                     from tmp_exam_select_mark_info_tree t
                                     join t_papr_content c on t.id = c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                                     cc.qsn_sub_id
                        where cc.qsn_type_position is null) n on n.qsn_id =
                                                                 q1.qsn_sub_id
                  join t_papr_content c1 on c1.qsn_sub_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
                  join t_qsn_sub_position s1 on s1.qsn_id = q1.qsn_id
                                            and s1.qsn_sub_id = n.qsn_id
                  join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id');
                  
        set @mysql=concat(@mysql,' union
select n.qsn_sub_id,
concat(c1.qsn_type_position,\'-\',q1.qsn_sub_id,\'-\',s2.qsn_position,\'-1\') as qsn_type_position,
c1.qsn_type_position pos,q1.create_tm
from t_question q1 join (
select q.qsn_id,q.qsn_sub_id
from
    (
    select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_content,r.qsn_type,s.qsn_position
    from tmp_exam_select_mark_info_tree t,t_question r,t_qsn_sub_position s
    where t.pid=r.qsn_id and t.id=r.qsn_sub_id and r.qsn_id=s.qsn_id and r.qsn_sub_id=s.qsn_sub_id) q
    left join
    (select c.qsn_type_position,c.papr_id,c.qsn_sub_id  from tmp_exam_select_mark_info_tree t
    join t_papr_content c on t.id=c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id=cc.qsn_sub_id
   join t_option o on o.qsn_id=q.qsn_id and o.qsn_sub_id=q.qsn_sub_id and o.qsn_type=q.qsn_type
    ) n on n.qsn_id=q1.qsn_sub_id
    join t_papr_content c1 on c1.qsn_id=q1.qsn_id and c1.qsn_sub_id=q1.qsn_sub_id and c1.papr_id=','''',par_papr_id,'''','
left join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id
                  ) tm
         where y.qsn_sub_id = tm.qsn_sub_id

         ) x ');

set @mysql=concat(@mysql,@mysql2);

set @mysql =concat(@mysql,' where ');

if  par_qsn_label_position is not null then
    set @mysql=concat(@mysql,' x.qsn_type_position = ',par_qsn_label_position,' and ');
end if;

if par_qsn_type is not null and par_qsn_type !='010107' then
    set @mysql=concat(@mysql,' x.qsn_type= ','''',par_qsn_type,'''',' and x.qsn_type_title is not null and ');
end if;

if par_qsn_content is not null then
    set @mysql=concat(@mysql,' x.qsn_content like ','''%',par_qsn_content,'%''',' and ');
end if;

set @mysql=concat(@mysql, ' 1=1 ');

set @mysql=concat(@mysql,' group by x.qsn_id,x.qsn_sub_id,r.qsn_point,x.qsn_content,x.qsn_item_id,
       x.qsn_item_sub_id,x.option_content,x.qsn_item_tag,x.qsn_type,x.qsn_type_title,x.qsn_type_position,
       x.pos,x.create_tm,x.sub_qsn_flg');

set @mysql=concat(@mysql,' order by x.pos,x.qsn_type_position');

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_exam_select_mark_info_tree;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_select_mark_qsn_type`;
CREATE PROCEDURE  `exam_select_mark_qsn_type`(IN par_papr_id CHAR(32))
BEGIN

select qsn_type_position qsn_type_title_id,qsn_type_title,null qsn_type,null qsn_type_name from t_papr_qsn_type 
where papr_id=par_papr_id
union
select null,null,p.qsn_type,c.desc_cn qsn_type_name from t_papr_qsn_type p
join t_common_cde c on c.c_cde=p.qsn_type
where papr_id=par_papr_id;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_select_mark_question`;
CREATE PROCEDURE  `exam_select_mark_question`(IN par_exam_id CHAR(32),IN par_papr_id CHAR(32),
IN par_qsn_label_type VARCHAR(20),IN par_qsn_label_position INTEGER(10), IN par_qsn_type VARCHAR(20),
IN par_group_id int(10), IN par_user_name varchar(20), IN par_exam_times INTEGER(10),
IN par_qsn_answer VARCHAR(4000),IN par_qsn_content VARCHAR(4000)
)
begin
    declare v_level int unsigned default 0;
    declare v_position int unsigned default 1;
    declare v_row_count int unsigned default 0;
    declare v_point_type varchar(20);
    set @mysql2='';

    insert into tmp_exam_select_mark_question_tree(id,pid, level,position)
    select qsn_id,qsn_sub_id,v_level,v_position from t_papr_content
    where papr_id=par_papr_id and qsn_sub_id !='0';
    set v_row_count := row_count();
    while v_row_count != 0 DO
        set @position := 0;
        insert into tmp_exam_select_mark_question_tree(id,pid,level,position)
        select q.qsn_sub_id,q.qsn_id
        , v_level + 1
        , @position := @position+1
        from t_question q
        inner join tmp_exam_select_mark_question_tree t on q.qsn_id = t.id             
        where t.level = v_level
        and q.qsn_sub_id !='0'
        order by q.qsn_sub_id;
        set v_row_count := row_count();
        set v_level := v_level + 1;
    end while;
   
set @mysql='';
set @mysql=concat(@mysql,'select x.qsn_id,x.qsn_sub_id,      
       x.qsn_content,      
       x.qsn_type_position
  from (
  select
           tp.qsn_id,
           tp.qsn_sub_id,
           tp.qsn_content,  
             tp.qsn_type,   
           tp.qsn_type_position
          from (
select q.qsn_id,
           q.qsn_sub_id,
           q.qsn_content,p.qsn_type,');
              set @mysql= concat(@mysql,'concat(p.qsn_type_position,\'-\',q.qsn_sub_id)');
              set @mysql=concat(@mysql,' qsn_type_position              
          from t_paper t
          join t_exam_papr ep on ep.papr_id=t.papr_id
          join t_exam e on e.exam_id=ep.exam_id and
          e.exam_id=','''',par_exam_id,'''','
          join t_papr_qsn_type p on t.papr_id = p.papr_id
          join t_papr_content c on p.papr_id = c.papr_id
                               and p.qsn_type = c.qsn_type
                               and c.qsn_type_position = p.qsn_type_position
          join t_question q on c.qsn_id = q.qsn_id and c.qsn_sub_id = q.qsn_sub_id         
          where t.papr_id=','''',par_papr_id,'''','
           ) tp  ');
          set @mysql=concat(@mysql,' union
        select y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
                         y.qsn_type,
              ');
          set @mysql= concat(@mysql,'concat(y.qsn_type_position,\'-\',y.qsn_id,\'-\',y.qsn_position) qsn_type_position');
          set @mysql=concat(@mysql,'
               from (select 
                       q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                                         q.qsn_type,
                                         q.qsn_position,
                       cc.qsn_type_position 
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               r.qsn_content,                              
                               s.qsn_position,
                                                         r.qsn_type
                          from tmp_exam_select_mark_question_tree t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id) q
                  left join (select c.qsn_type_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_exam_select_mark_question_tree t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                             cc.qsn_sub_id
                 where cc.qsn_type_position is not null) y');
    set @mysql=concat(@mysql,'  union
        select y.qsn_id,
               y.qsn_sub_id,
               y.qsn_content,
                         y.qsn_type,
               tm.qsn_type_position
          from (select q.qsn_id,
                       q.qsn_sub_id,
                       q.qsn_content,
                                         q.qsn_type,
                       cc.qsn_type_position             
                  from (select r.qsn_id,
                               r.qsn_sub_id,
                               r.qsn_content,
                                                         r.qsn_type
                          from tmp_exam_select_mark_question_tree t, t_question r, t_qsn_sub_position s
                         where t.pid = r.qsn_id
                           and t.id = r.qsn_sub_id
                           and r.qsn_id = s.qsn_id
                           and r.qsn_sub_id = s.qsn_sub_id
                           and not exists(select o.qsn_id from t_option o where o.qsn_id=t.pid and o.qsn_sub_id=t.id)
                           ) q
                  left join (select c.qsn_type_position,
                                   c.papr_id,
                                   c.qsn_sub_id
                              from tmp_exam_select_mark_question_tree t
                              join t_papr_content c on t.id = c.qsn_id
                             where c.papr_id =','''',par_papr_id,'''',') cc on q.qsn_id =cc.qsn_sub_id) y,');
        set @mysql=concat(@mysql,'(
               select n.qsn_sub_id,
                       concat(c1.qsn_type_position,
                              \'-\',
                              q1.qsn_id,
                              \'-\',
                              s1.qsn_position,
                              \'-\',
                              s2.qsn_position) as qsn_type_position
                  from t_question q1
                  join (select q.qsn_id, q.qsn_sub_id
                         from (select r.qsn_id,
                                      r.qsn_sub_id,
                                      r.qsn_content
                                 from tmp_exam_select_mark_question_tree          t,
                                      t_question         r,
                                      t_qsn_sub_position s
                                where t.pid = r.qsn_id
                                  and t.id = r.qsn_sub_id
                                  and r.qsn_id = s.qsn_id
                                  and r.qsn_sub_id = s.qsn_sub_id) q
                         left join (select c.qsn_type_position,
                                          c.papr_id,
                                          c.qsn_sub_id
                                     from tmp_exam_select_mark_question_tree t
                                     join t_papr_content c on t.id = c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id =
                                                                                     cc.qsn_sub_id
                        where cc.qsn_type_position is null) n on n.qsn_id =q1.qsn_sub_id
                                    join t_papr_content c1 on c1.qsn_sub_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
                  join t_qsn_sub_position s1 on s1.qsn_id = q1.qsn_id
                                            and s1.qsn_sub_id = n.qsn_id
                  join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id');
                  
        set @mysql=concat(@mysql,' union
select n.qsn_sub_id,
concat(c1.qsn_type_position,\'-\',q1.qsn_sub_id,\'-\',s2.qsn_position,\'-1\') as qsn_type_position
from t_question q1 join (
select q.qsn_id,q.qsn_sub_id
from
    (
    select r.qsn_id,r.qsn_sub_id,t.id,r.qsn_content,r.qsn_type,s.qsn_position
    from tmp_exam_select_mark_question_tree t,t_question r,t_qsn_sub_position s
    where t.pid=r.qsn_id and t.id=r.qsn_sub_id and r.qsn_id=s.qsn_id and r.qsn_sub_id=s.qsn_sub_id) q
    left join
    (select c.qsn_type_position,c.papr_id,c.qsn_sub_id  from tmp_exam_select_mark_question_tree t
    join t_papr_content c on t.id=c.qsn_id and c.papr_id=','''',par_papr_id,'''',') cc on q.qsn_id=cc.qsn_sub_id
   join t_option o on o.qsn_id=q.qsn_id and o.qsn_sub_id=q.qsn_sub_id
    ) n on n.qsn_id=q1.qsn_sub_id
    join t_papr_content c1 on c1.qsn_id=q1.qsn_id and c1.papr_id=','''',par_papr_id,'''','
left join t_qsn_sub_position s2 on s2.qsn_sub_id = n.qsn_sub_id
                  ) tm
         where y.qsn_sub_id = tm.qsn_sub_id
         ) x  left join t_user_exam_info uei  on uei.papr_id=','''',par_papr_id,'''',' and uei.qsn_id=x.qsn_id
         and uei.exam_times=',par_exam_times,'
         and uei.qsn_sub_id=x.qsn_sub_id');

set @mysql=concat(@mysql,' left join t_user us on us.user_id=uei.user_id ');

if par_user_name is not null then
    set @mysql=concat(@mysql,' join t_user usr on usr.user_id=uei.user_id  and usr.real_name=','''',par_user_name,'''');
end if;      
 
if par_group_id is not null then
    set @mysql=concat(@mysql,' join t_user_group ug on ug.user_id=uei.user_id and ug.group_id=',par_group_id);
end if;
                 
set @mysql=concat(@mysql,' left join (
select t.qsn_id,t.qsn_sub_id,group_concat(t.qsn_answer SEPARATOR \'__\') qsn_answer
from t_answer t
left join t_papr_content pc
on pc.qsn_id=t.qsn_id and pc.qsn_sub_id=t.qsn_sub_id and pc.papr_id=','''',par_papr_id,'''',' group by t.qsn_id,t.qsn_sub_id
) a on a.qsn_id = x.qsn_id and a.qsn_sub_id = x.qsn_sub_id');

set @mysql=concat(@mysql,' join t_user_exam ue on ue.exam_id=','''',par_exam_id,'''',' and ue.exam_times=',par_exam_times);

if par_user_name is not null then
    set @mysql=concat(@mysql,'join t_user use on use.user_id=ue.user_id and use.real_name=',par_user_name);
end if;

set @mysql=concat(@mysql,' left join (select t.qsn_id,t.qsn_sub_id,t.user_id,t.qsn_item_id,group_concat(t.user_answer SEPARATOR \'__\') user_answer
               from t_user_exam_answer t ');
               
if par_user_name is not null then
    set @mysql=concat(@mysql,'join t_user use on use.user_id=t.user_id and use.real_name=',par_user_name);
end if;            
               
set @mysql=concat(@mysql,' where t.papr_id= ','''',par_papr_id,'''',' and t.exam_id=','''',par_exam_id,'''',' and t.exam_times=',par_exam_times,
               ' group by t.qsn_id, t.qsn_sub_id, t.user_id) ua on ua.qsn_id =x.qsn_id and ua.qsn_sub_id =x.qsn_sub_id');

set @mysql =concat(@mysql,' where ');

if par_qsn_label_type is not null then
     set @mysql=concat(@mysql,' x.qsn_type= ','''',par_qsn_label_type,'''',' and ');
end if;

if  par_qsn_label_position is not null then
    set @mysql=concat(@mysql,' x.qsn_type_position like ','''',par_qsn_label_position,'%''',' and ');
end if;

if par_qsn_type is not null then
    set @mysql=concat(@mysql,' x.qsn_type= ','''',par_qsn_type,'''',' and ');
end if;

if par_qsn_content is not null then
    set @mysql=concat(@mysql,' x.qsn_content like ','''%',par_qsn_content,'%''',' and ');
end if;

if par_user_answer is not null then
    set @mysql=concat(@mysql,' ua.user_answer like ','''%',par_user_answer,'%''',' and ');
end if;

if par_qsn_answer is not null then
    set @mysql=concat(@mysql,' a.qsn_answer like ','''%',par_qsn_answer,'%''', ' and ');
end if;

set @mysql=concat(@mysql, ' 1=1');

set @mysql=concat(@mysql,' group by x.qsn_id,x.qsn_sub_id,x.qsn_type_position');
       
set @mysql=concat(@mysql,' order by x.qsn_type_position');

prepare stmt from @mysql;
execute stmt;
deallocate prepare stmt;
truncate table tmp_exam_select_mark_question_tree;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_select_mark_user`;
CREATE PROCEDURE  `exam_select_mark_user`(IN par_exam_id CHAR(32))
begin
  select distinct ru.user_id,u.username,u.real_name
    from t_role_user ru join t_role r on r.role_id=ru.role_id
    join t_user u on u.user_id=ru.user_id
    where role_value like '%060305%' and not exists(select m.user_id from t_exam_marker m where m.exam_id=par_exam_id and
  m.user_id=ru.user_id);
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_select_mark_user_qsn`;
CREATE PROCEDURE  `exam_select_mark_user_qsn`(
IN par_exam_id CHAR(32),IN par_papr_id CHAR(32),IN par_qsn_id CHAR(32),IN par_qsn_sub_id CHAR(32),
IN par_group_id int(10), IN par_user_name varchar(20), IN par_exam_times INTEGER(10),
IN par_user_answer VARCHAR(4000),IN par_qsn_answer VARCHAR(4000),IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin

set @mysql='';
set @mysql=concat(@mysql,'select uei.user_id,uei.qsn_id,
       uei.qsn_sub_id,
       a.qsn_answer,ua.user_answer,
       uei.answer_status,uei.scoring,
       uei.remark,us.real_name marker_name,uei.mark_tm
         from  t_user_exam_info uei
            left join t_user us on us.user_id=uei.marker_id
    ');

set @mysql=concat(@mysql,' join t_user uss on uss.user_id=uei.user_id ');

if par_user_name is not null then
    set @mysql=concat(@mysql,' and uss.real_name=','''',par_user_name,'''');
end if;

if par_group_id is not null then
    set @mysql=concat(@mysql,' join t_user_group ug on ug.user_id=uei.user_id and ug.group_id=',par_group_id);
end if;

set @mysql=concat(@mysql,' left join (select t.qsn_id,t.qsn_sub_id,t.user_id,t.qsn_item_id,group_concat(t.user_answer SEPARATOR \'__\') user_answer
               from t_user_exam_answer t ');

if par_user_name is not null then
    set @mysql=concat(@mysql,' join t_user ue on ue.user_id=t.user_id and ue.real_name=','''',par_user_name,'''');
end if;

set @mysql=concat(@mysql,' where t.papr_id= ','''',par_papr_id,'''',' and t.exam_id=','''',par_exam_id,'''',' and t.exam_times=',par_exam_times,
                ' and t.qsn_id =','''',par_qsn_id,'''',' and t.qsn_sub_id =','''',par_qsn_sub_id,'''');

if par_user_answer is not null then
  set @mysql=concat(@mysql,' and t.user_answer like ','''%',par_user_answer,'%''');
end if;

set @mysql=concat(@mysql,' group by t.qsn_id,t.qsn_sub_id, t.user_id) ua on ua.qsn_id =uei.qsn_id and ua.qsn_sub_id =uei.qsn_sub_id and ua.user_id=uei.user_id');

set @mysql=concat(@mysql,' join (
        select t.qsn_id,t.qsn_sub_id,group_concat(t.qsn_answer SEPARATOR \'__\') qsn_answer
        from t_answer t
        left join t_papr_content pc
        on pc.qsn_id=t.qsn_id and pc.qsn_sub_id=t.qsn_sub_id and pc.papr_id=','''',par_papr_id,'''','
    where t.qsn_id=','''',par_qsn_id,'''',' and t.qsn_sub_id=','''',par_qsn_sub_id,'''');

if par_qsn_answer is not null then
  set @mysql=concat(@mysql,' and t.qsn_answer like ','''%',par_qsn_answer,'%''');
end if;

set @mysql=concat(@mysql,' group by t.qsn_id,t.qsn_sub_id) a on a.qsn_id =uei.qsn_id and a.qsn_sub_id =uei.qsn_sub_id');

set @mysql =concat(@mysql,' where uei.papr_id=','''',par_papr_id,'''','
    and uei.exam_times=',par_exam_times,' and uei.exam_id=','''',par_exam_id,'''', ' group by uei.user_id');

call pdo_pagination(@mysql,par_page_idx,par_page_size,@mysql2);

prepare stmt from @mysql2;
execute stmt;
deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_select_mgr_edit`;
CREATE PROCEDURE  `exam_select_mgr_edit`(in par_exam_id char(32))
begin

set @strsql=concat('select e.exam_id,e.exam_category exam_category_id,e.exam_time_consistency_flg,c.desc_cn exam_category_name,e.exam_name,e.exam_notice,
    e.exam_begin_tm,e.exam_end_tm,e.exam_total_tm,e.exam_mode,e.exam_times,e.exam_point_type,
    e.exam_point,e.exam_passing_grade,e.exam_blank_flg,e.exam_cloze_flg,e.exam_publish_score_flg,e.exam_publish_answer_flg,e.exam_publish_result_flg,
    e.exam_manual,e.exam_publish_result_tm,e.exam_all_person,u.user_id,u.real_name,e.exam_user_count,
    e.exam_full_screen_flg,e.exam_mouse_right_flg,e.exam_disable_paste_flg,
    e.exam_submit_display_result,e.exam_ie_only_flg,e.exam_disable_monitor_flg,
    e.exam_paper_only_one_flg,e.exam_passing_again_flg,e.exam_qsn_random_flg,
    e.exam_recovery_flg,e.exam_recovery_time,g.group_name exam_create_dep,
    e.exam_allow_ip,e.exam_user_verify_flg,e.exam_user_signup_flg
    from t_exam e left join t_common_cde c on e.exam_category=c.c_cde
    left join t_exam_marker ec on e.exam_id=ec.exam_id
    left join t_user u on u.user_id=ec.user_id
    join t_user_group u1 on u1.user_id=e.create_user_id
    join t_group g on g.group_id=u1.group_id
    where e.exam_id=','''',par_exam_id,'''');
   
    prepare stmt from @strsql;
    execute stmt;
    deallocate prepare stmt;

  
  
  
  
  
    
    
end

DROP PROCEDURE IF EXISTS `exam_select_mgr_list`;
CREATE PROCEDURE  `exam_select_mgr_list`(IN par_page_idx INTEGER(10), IN par_page_size INTEGER(10))
begin
    set @strsql=concat('select e.exam_id,e.exam_name,c3.desc_cn exam_status,e.exam_begin_tm,e.exam_end_tm,e.exam_total_tm,c2.desc_cn exam_category  from t_exam e,t_common_cde c2,t_common_cde c3 
    where  e.exam_category=c2.c_cde and e.exam_status=c3.c_cde order by e.create_tm desc'); 
      
    call pdo_pagination(@strsql,par_page_idx,par_page_size,@mysql);
               
    prepare stmt from @mysql;  
    execute stmt;
    deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_select_publish_paper`;
CREATE PROCEDURE  `exam_select_publish_paper`(in par_exam_id char(32))
begin                               
    set @mysql=concat('select epapr.papr_id,e.exam_total_tm,e.exam_mode,e.exam_point_type,e.exam_point,date_format(e.create_tm,','''','%Y-%m-%d','''',') create_tm from t_exam e join t_exam_papr epapr on e.exam_id=epapr.exam_id  where  e.exam_id=','''',par_exam_id,'''');  
    prepare stmt from @mysql;  
    execute stmt;   
    deallocate prepare stmt;        
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_select_user`;
CREATE PROCEDURE  `exam_select_user`(in par_exam_id char(32))
begin
    set @strsql=concat('select e.group_id,e.group_pid,p.group_name,e.papr_id
,u.real_name,u.user_id from t_exam_group e
    join t_group p on p.group_id=e.group_id
    left join t_user_group r on e.group_id=r.group_id
    join t_user u on r.user_id=u.user_id
    join t_exam_exclude_user ex on ex.user_id=r.user_id ',' and e.exam_id=ex.exam_id where  e.exam_id =','''',par_exam_id,'''');

set @strsql=concat(@strsql,' union select e.group_id,e.group_pid,p.group_name,e.papr_id
  ,'''' real_name, '''' user_id
    from t_exam_group e
    join t_group p on p.group_id=e.group_id
    where e.exam_id =','''',par_exam_id,'''','and not exists(select u.group_id from t_exam_exclude_user x
  join t_user_group u on u.user_id=x.user_id
    where  x.exam_id=','''',par_exam_id,'''',' and e.group_id=u.group_id)');
    
    prepare stmt from @strsql;  
    execute stmt;
    deallocate prepare stmt;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_select_user_answer`;
CREATE PROCEDURE  `exam_select_user_answer`(in par_exam_id char(32),in par_papr_id char(32),IN par_user_id int(10),in par_exam_times int(10))
begin

	if par_exam_times is not null then
		set @exam_times=par_exam_times;
	else
		select exam_times into @exam_times from t_user_exam_answer where exam_id=par_exam_id and papr_id=par_papr_id and user_id=par_user_id order by exam_times desc limit 1;
	end if;

	set @strsql=concat('select e.user_id,e.exam_id,e.papr_id,e.qsn_id,e.qsn_sub_id,e.qsn_item_id,e.qsn_type,e.qsn_type_position,e.user_answer,u.qsn_item_count
				from t_user_exam_answer e
        join (select count(*) qsn_item_count,ue.user_id,ue.exam_id,ue.papr_id,ue.qsn_id,ue.qsn_sub_id,ue.exam_times from t_user_exam_answer ue where
        ue.exam_id=','''',par_exam_id,'''',' and ue.papr_id=','''',par_papr_id,'''',' and ue.exam_times=',@exam_times,' and ue.user_id=',par_user_id,'
        group by ue.user_id,ue.exam_id,ue.exam_times,ue.papr_id,ue.qsn_id,ue.qsn_sub_id
        ) u on u.exam_id=e.exam_id and u.user_id=e.user_id and u.papr_id=e.papr_id and u.exam_times=e.exam_times and u.qsn_id=e.qsn_id and u.qsn_sub_id=e.qsn_sub_id
        where e.exam_id=','''',par_exam_id,'''',' and e.papr_id=','''',par_papr_id,'''',' and e.user_id=',par_user_id,' and e.exam_times=',@exam_times);

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;

end

DROP PROCEDURE IF EXISTS `exam_status_update`;
CREATE PROCEDURE  `exam_status_update`(IN par_exam_id text, 
IN par_exam_status VARCHAR(20),IN par_update_user_id int(10))
begin  
        
   set @strsql=concat('update t_exam set exam_status=','''',par_exam_status,'''',',update_user_id=',par_update_user_id,',update_tm=sysdate() where exam_id in (',par_exam_id,')');

  prepare stmt from @strsql;  
  execute stmt;
  deallocate prepare stmt;
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_stat_user_count`;
CREATE PROCEDURE  `exam_stat_user_count`( in par_group_id  text,in par_exclude_user_id text,out par_row_count integer(10))
begin
      declare cnt int(10) default 0;
      set @strsql=concat('select count(*) into @cnt from t_user_group u  inner join t_group g on u.group_id=g.group_id  where g.group_id in (',par_group_id,')');
      if par_exclude_user_id !='' && par_exclude_user_id is not null then
          set @strsql=concat(@strsql,' and not exists(select user_id from t_user_group where user_id in (',par_exclude_user_id,') and user_id=u.user_id)');
      end if;
      
      prepare stmt from @strsql;
      execute stmt;
      deallocate prepare stmt;

    if @cnt is null then
      set par_row_count=0;
    else
      set par_row_count=@cnt;
    end if;
 
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_update`;
CREATE PROCEDURE  `exam_update`(IN par_exam_id CHAR(32), IN par_exam_name VARCHAR(1000),IN par_exam_notice TEXT,
IN par_exam_status VARCHAR(20),IN par_exam_category VARCHAR(20),IN par_exam_time_consistency_flg TINYINT(1), IN par_exam_total_tm INTEGER(10), IN par_exam_begin_tm DATETIME,
IN par_exam_end_tm DATETIME, IN par_exam_mode VARCHAR(20), IN par_exam_times INTEGER(11), 
IN par_exam_point_type VARCHAR(20), IN par_exam_point INTEGER(11), IN par_exam_passing_grade INTEGER(11), 
IN par_exam_blank_flg TINYINT(1), IN par_exam_cloze_flg TINYINT(1), IN par_exam_manual TINYINT(1),
IN par_exam_publish_score_flg TINYINT(1), IN par_exam_publish_answer_flg TINYINT(1), IN par_exam_publish_result_flg TINYINT(1),
IN par_exam_full_screen TINYINT(1), IN par_exam_disable_paste TINYINT(1),IN par_exam_disable_mouse_right_btn TINYINT(1),
IN par_exam_all_person TINYINT(1), IN par_publish_result_tm VARCHAR(20),
IN par_exam_submit_display_result TINYINT(1),IN par_exam_ie_only TINYINT(1),
IN par_exam_paper_only_one_flg TINYINT(1),IN par_exam_passing_again_flg TINYINT(1),
IN par_exam_qsn_random_flg TINYINT(1),IN par_exam_user_verify_flg TINYINT(1),IN par_exam_user_signup_flg TINYINT(1),IN par_exam_disable_monitor_flg TINYINT(1),
IN par_exam_recovery_flg TINYINT(1),IN par_exam_recovery_val INTEGER(10),
IN par_update_user_id int(10),
IN par_group_id TEXT, IN par_exclude_user_id TEXT,IN par_exam_allow_ip TEXT)
begin
	if par_group_id !=-1 then
		call exam_stat_user_count(par_group_id,par_exclude_user_id,@par_row_count);
	else
		select count(*) into @par_row_count from t_user;
	end if;

	if par_exam_point_type ='030203' THEN
		set @papr_point=par_exam_point;
	else
		set @papr_point=0;
	end if;


	set @strsql=concat('update t_exam set exam_name=','''',par_exam_name,'''');

	if par_exam_status is not null then  
    	set @strsql=concat(@strsql,',exam_status=','''',par_exam_status,'''');
	end if;
	
	if par_exam_notice is not null then  
    	set @strsql=concat(@strsql,',exam_notice=','''',par_exam_notice,'''');
	end if;
	
	if par_exam_category is not null then  
    	set @strsql=concat(@strsql,',exam_category=','''',par_exam_category,'''');
	end if;
	
	if par_exam_time_consistency_flg is not null then  
    	set @strsql=concat(@strsql,',exam_time_consistency_flg=',par_exam_time_consistency_flg);
	end if;
	
	if par_exam_total_tm is not null then  
    	set @strsql=concat(@strsql,',exam_total_tm=',par_exam_total_tm);
	end if;
	
	if par_exam_begin_tm is not null then  
    	set @strsql=concat(@strsql,',exam_begin_tm=','''',par_exam_begin_tm,'''');
	end if;
	
	if par_exam_end_tm is not null then  
    	set @strsql=concat(@strsql,',exam_end_tm=','''',par_exam_end_tm,'''');
	end if;
	
	if par_exam_mode is not null then  
    	set @strsql=concat(@strsql,',exam_mode=','''',par_exam_mode,'''');
	end if;
	
	if par_exam_times is not null then  
    	set @strsql=concat(@strsql,',exam_times=',par_exam_times);
	end if;
	
	if par_exam_point_type is not null then  
    	set @strsql=concat(@strsql,',exam_point_type=','''',par_exam_point_type,'''');
	end if;
	
	if par_exam_point is not null then  
    	set @strsql=concat(@strsql,',exam_point=',par_exam_point);
	end if;
	
	if par_exam_passing_grade is not null then  
    	set @strsql=concat(@strsql,',exam_passing_grade=',par_exam_passing_grade);
	end if;
	
	if par_exam_blank_flg is not null then  
    	set @strsql=concat(@strsql,',exam_blank_flg=',par_exam_blank_flg);
	end if;
	
	if par_exam_cloze_flg is not null then  
    	set @strsql=concat(@strsql,',exam_cloze_flg=',par_exam_cloze_flg);
	end if;
	
	if par_exam_manual is not null then  
    	set @strsql=concat(@strsql,',exam_manual=',par_exam_manual);
	end if;
	
	if par_exam_publish_score_flg is not null then  
    	set @strsql=concat(@strsql,',exam_publish_score_flg=',par_exam_publish_score_flg);
	end if;
	
	if par_exam_publish_answer_flg is not null then  
    	set @strsql=concat(@strsql,',exam_publish_answer_flg=',par_exam_publish_answer_flg);
	end if;
	
	if par_exam_publish_result_flg is not null then  
    	set @strsql=concat(@strsql,',exam_publish_result_flg=',par_exam_publish_result_flg);
	end if;
	
	if par_exam_all_person is not null then  
    	set @strsql=concat(@strsql,',exam_all_person=',par_exam_all_person);
	end if;
	
	if par_publish_result_tm is not null then  
    	set @strsql=concat(@strsql,',exam_publish_result_tm=','''',par_publish_result_tm,'''');
	end if;
	
    set @strsql=concat(@strsql,',exam_user_count=',@par_row_count);
	
	if par_update_user_id is not null then  
    	set @strsql=concat(@strsql,',update_user_id=','''',par_update_user_id,'''');
	end if;
	
    set @strsql=concat(@strsql,',update_tm=sysdate()');
	
	if par_exam_full_screen is not null then  
    	set @strsql=concat(@strsql,',exam_full_screen_flg=',par_exam_full_screen);
	end if;

	if par_exam_disable_paste is not null then  
    	set @strsql=concat(@strsql,',exam_disable_paste_flg=',par_exam_disable_paste);
	end if;

	if par_exam_disable_mouse_right_btn is not null then  
    	set @strsql=concat(@strsql,',exam_mouse_right_flg=',par_exam_disable_mouse_right_btn);
	end if;

	if par_exam_submit_display_result is not null then  
    	set @strsql=concat(@strsql,',exam_submit_display_result=',par_exam_submit_display_result);
	end if;

	if par_exam_ie_only is not null then  
    	set @strsql=concat(@strsql,',exam_ie_only_flg=',par_exam_ie_only);
	end if;

	if par_exam_paper_only_one_flg is not null then  
    	set @strsql=concat(@strsql,',exam_paper_only_one_flg=',par_exam_paper_only_one_flg);
	end if;

	if par_exam_passing_again_flg is not null then  
    	set @strsql=concat(@strsql,',exam_passing_again_flg=',par_exam_passing_again_flg);
	end if;
	
	if par_exam_qsn_random_flg is not null then  
    	set @strsql=concat(@strsql,',exam_qsn_random_flg=',par_exam_qsn_random_flg);
	end if;
	
	if par_exam_user_verify_flg is not null then  
    	set @strsql=concat(@strsql,',exam_user_verify_flg=',par_exam_user_verify_flg);
	end if;
	
	if par_exam_user_signup_flg is not null then  
    	set @strsql=concat(@strsql,',exam_user_signup_flg=',par_exam_user_signup_flg);
	end if;
	                                                                                       	
	if par_exam_disable_monitor_flg is not null then  
    	set @strsql=concat(@strsql,',exam_disable_monitor_flg=',par_exam_disable_monitor_flg);
	end if;

	if par_exam_recovery_flg is not null then  
    	set @strsql=concat(@strsql,',exam_recovery_flg=',par_exam_recovery_flg);
	end if;
	
	if par_exam_recovery_val is not null then  
    	set @strsql=concat(@strsql,',exam_recovery_time=',par_exam_recovery_val);
	end if;

	if par_exam_allow_ip is not null then  
    	set @strsql=concat(@strsql,',exam_allow_ip=','''',par_exam_allow_ip,'''');
	end if;

  set @strsql=concat(@strsql,' where exam_id=','''',par_exam_id,'''');

	prepare stmt from @strsql;
	execute stmt;
	deallocate prepare stmt;

	if par_exam_all_person =1 then
		delete from t_exam_group where exam_id=par_exam_id;
	end if;

  
  
  
      
end

DROP PROCEDURE IF EXISTS `exam_update_exam_info`;
CREATE PROCEDURE  `exam_update_exam_info`(IN par_exam_id CHAR(32),IN par_papr_id CHAR(32), IN par_user_id int(10),
IN par_exam_times smallint(6))
begin 
  select
         round(tst_info.scoring, 2) scoring,tst_info.right_count,tst_info.part_right_count
            ,tst_info.error_count,
            (p.papr_qsn_count - tst_info.right_count - tst_info.error_count-tst_info.part_right_count)  into @user_exam_scoring,
          @right_count,
          @part_right_count,
          @error_count,
          @null_count
    from t_paper p,
         (select sum(info.right_count) right_count,
                 sum(info.part_right_count) part_right_count,
                 sum(info.error_count) error_count,
                 sum(info.scoring) scoring,
                 info.user_id,
                 info.exam_id,
                 info.papr_id,
                 info.exam_times
            from (select count(*) right_count,
                         0 part_right_count,
                         0 error_count,
                         t.user_id,
                         t.exam_id,
                         t.papr_id,
                         t.exam_times,
                         sum(t.scoring) scoring
                    from t_user_exam_info t
                   where t.user_id = par_user_id
                     and t.papr_id = par_papr_id
                     and t.exam_times = par_exam_times
                     and t.answer_status = 1
                     and t.exam_id = par_exam_id
                   group by t.user_id, t.exam_id, t.papr_id, t.exam_times
                  union
                  select 0 right_count,
                         0 part_right_count,
                         count(*) error_count,
                         t.user_id,
                         t.exam_id,
                         t.papr_id,
                         t.exam_times,
                         0 scoring
                    from t_user_exam_info t
                   where t.user_id = par_user_id
                     and t.papr_id = par_papr_id
                     and t.exam_times = par_exam_times
                     and t.answer_status = 0
                     and t.exam_id = par_exam_id
                   group by t.user_id, t.exam_id, t.papr_id, t.exam_times
                  union
                  select 0 right_count,
                         count(*) part_right_count,
                         0 error_count,
                         t.user_id,
                         t.exam_id,
                         t.papr_id,
                         t.exam_times,
                         sum(t.scoring) scoring
                    from t_user_exam_info t
                   where t.user_id = par_user_id
                     and t.papr_id = par_papr_id
                     and t.exam_times = par_exam_times
                     and t.answer_status = 2
                     and t.exam_id = par_exam_id
                   group by t.user_id, t.exam_id, t.papr_id, t.exam_times) info
           group by info.user_id,
                    info.exam_id,
                    info.papr_id,
                    info.exam_times) tst_info,
         t_exam ex
   where tst_info.papr_id = p.papr_id
     and ex.exam_id = tst_info.exam_id;

update t_user_exam
set user_exam_scoring=@user_exam_scoring,right_count=@right_count,part_right_count=@part_right_count,
error_count=@error_count,null_count=@null_count
where user_id=par_user_id and exam_id=par_exam_id and exam_times=par_exam_times;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_update_mark_info`;
CREATE PROCEDURE  `exam_update_mark_info`(IN par_papr_id CHAR(32), IN par_user_id int(10),
IN par_qsn_id char(32), IN par_qsn_sub_id VARCHAR(32),
IN par_exam_times smallint(6), IN par_answer_status char(1), IN par_scoring float,
IN par_remark VARCHAR(4000), IN par_marker_id integer(10))
begin
update t_user_exam_info set answer_status=par_answer_status,
scoring=par_scoring,remark=par_remark,marker_id=par_marker_id,
mark_tm=sysdate()
where papr_id=par_papr_id and qsn_id=par_qsn_id
and qsn_sub_id=par_qsn_sub_id and exam_times=par_exam_times and user_id=par_user_id;

  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_user_signup_delete`;
CREATE PROCEDURE  `exam_user_signup_delete`(IN `par_user_id` INT(10),IN `par_exam_id` VARCHAR(32))
BEGIN

	set @strsql=concat('delete from t_exam_user_signup where user_id =',par_user_id,' and exam_id=','''',par_exam_id,'''');

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;
	
      
end

DROP PROCEDURE IF EXISTS `exam_user_signup_verify`;
CREATE PROCEDURE  `exam_user_signup_verify`(IN `par_user_id` INT(10),IN `par_verify_user_id` INT(10),IN `par_exam_id` VARCHAR(32), IN `par_verify_status` VARCHAR(20))
BEGIN

	set @strsql=concat('update t_exam_user_signup set verify_status=','''',par_verify_status,'''',',verify_user_id=',par_verify_user_id,
                      ',verify_tm=now()',
                      ' where user_id =',par_user_id,' and exam_id=','''',par_exam_id,'''');

  prepare stmt from @strsql;
  execute stmt;
  deallocate prepare stmt;
	
      
end

DROP PROCEDURE IF EXISTS `exam_user_validate_one_paper`;
CREATE PROCEDURE  `exam_user_validate_one_paper`(IN par_exam_id CHAR(32),IN par_user_id int(10))
begin   
    
  set @strsql=concat('select count(exam_id) exam_count from t_session where user_id=',par_user_id);
       
   prepare stmt from @strsql;  
   execute stmt;
   deallocate prepare stmt;    
  
  
  
  
  
  
  
        
end

DROP PROCEDURE IF EXISTS `exam_user_validate_passing_again`;
CREATE PROCEDURE  `exam_user_validate_passing_again`(IN par_exam_id CHAR(32),IN par_user_id int(10))
begin

  set @strsql_1=concat('select exam_passing_again_flg into @pass_again from t_exam e where e.exam_id =','''',par_exam_id,'''');

  prepare stmt1 from @strsql_1;
  execute stmt1;
  deallocate prepare stmt1;

  if @pass_again =1 then
      select ue.user_exam_scoring,e.exam_passing_grade into @u_scoring,@e_passing_grade from t_user_exam ue join t_exam e on e.exam_id=ue.exam_id and e.exam_id=par_exam_id and ue.user_id=par_user_id;

      if @u_scoring is not null then
        if @u_scoring >=@e_passing_grade then
          set @mysql='select 1 user_pass from dual';
        else
          set @mysql='select 0 user_pass from dual';
        end if;
      else
        set @mysql='select null user_pass from dual';
      end if;
  else
      set @mysql='select null user_pass from dual';
  end if;
 
  prepare stmt3 from @mysql;
  execute stmt3;
  deallocate prepare stmt3;


  
  
        
end



